/* TeeJee.System.c generated by valac 0.43.91, the Vala compiler
 * generated from TeeJee.System.vala, do not modify */

/*
 * TeeJee.System.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <locale.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))

gboolean tee_jee_system_user_is_admin (void);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gchar* tee_jee_system_get_user_login (void);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gint tee_jee_system_get_user_id (void);
gint tee_jee_system_get_user_id_from_username (const gchar* username);
gint tee_jee_system_get_user_id_effective (void);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gchar* tee_jee_system_get_username (void);
gchar* tee_jee_system_get_username_from_uid (gint user_id);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gchar* tee_jee_system_get_app_path (void);
gchar* tee_jee_system_get_app_dir (void);
gdouble tee_jee_system_get_system_uptime_seconds (void);
gchar* tee_jee_system_get_desktop_name (void);
gint tee_jee_process_helper_get_pid_by_name (const gchar* name);
GeeArrayList* tee_jee_system_list_dir_names (const gchar* path);
static gint __lambda19_ (const gchar* a,
                  const gchar* b);
static gint ___lambda19__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
gint tee_jee_system_get_display_width (void);
gint tee_jee_system_get_display_height (void);
gboolean tee_jee_system_check_internet_connectivity (void);
gboolean tee_jee_system_check_internet_connectivity_test1 (void);
gboolean tee_jee_system_check_internet_connectivity_test2 (void);
gboolean tee_jee_system_shutdown (void);
gboolean tee_jee_system_command_exists (const gchar* command);
gchar* tee_jee_process_helper_get_cmd_path (const gchar* cmd_tool);
gboolean tee_jee_system_xdg_open (const gchar* file,
                                  const gchar* user);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
void tee_jee_logging_log_debug (const gchar* message);
gint tee_jee_process_helper_exec_script_async (const gchar* script);
gboolean tee_jee_system_exo_open_folder (const gchar* dir_path,
                                         gboolean xdg_open_try_first);
gboolean tee_jee_system_exo_open_textfile (const gchar* txt_file);
gboolean tee_jee_system_exo_open_url (const gchar* url);
gboolean tee_jee_system_using_efi_boot (void);
gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
void tee_jee_system_open_terminal_window (const gchar* terminal_emulator,
                                          const gchar* working_dir,
                                          const gchar* script_file_to_execute,
                                          gboolean run_as_admin);
GTimer* tee_jee_system_timer_start (void);
gulong tee_jee_system_timer_elapsed (GTimer* timer,
                                     gboolean stop);
void tee_jee_system_sleep (gint milliseconds);
gchar* tee_jee_system_timer_elapsed_string (GTimer* timer,
                                            gboolean stop);
void tee_jee_system_timer_elapsed_print (GTimer* timer,
                                         gboolean stop);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
void tee_jee_system_set_numeric_locale (const gchar* type);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

gboolean
tee_jee_system_user_is_admin (void)
{
	gboolean result = FALSE;
	gboolean _tmp7_ = FALSE;
	GError* _inner_error0_ = NULL;
	{
		gchar** argv = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar** _tmp2_;
		gint argv_length1;
		gint _argv_size_;
		GPid procId = 0;
		gchar** _tmp3_;
		gint _tmp3__length1;
		GPid _tmp4_ = 0;
#line 40 "Utility/TeeJee.System.vala"
		_tmp0_ = g_strdup ("sleep");
#line 40 "Utility/TeeJee.System.vala"
		_tmp1_ = g_strdup ("10");
#line 40 "Utility/TeeJee.System.vala"
		_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 40 "Utility/TeeJee.System.vala"
		_tmp2_[0] = _tmp0_;
#line 40 "Utility/TeeJee.System.vala"
		_tmp2_[1] = _tmp1_;
#line 40 "Utility/TeeJee.System.vala"
		argv = _tmp2_;
#line 40 "Utility/TeeJee.System.vala"
		argv_length1 = 2;
#line 40 "Utility/TeeJee.System.vala"
		_argv_size_ = argv_length1;
#line 42 "Utility/TeeJee.System.vala"
		_tmp3_ = argv;
#line 42 "Utility/TeeJee.System.vala"
		_tmp3__length1 = argv_length1;
#line 42 "Utility/TeeJee.System.vala"
		g_spawn_async (NULL, _tmp3_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp4_, &_inner_error0_);
#line 42 "Utility/TeeJee.System.vala"
		procId = _tmp4_;
#line 42 "Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 42 "Utility/TeeJee.System.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 166 "TeeJee.System.c"
			goto __catch94_g_error;
		}
#line 45 "Utility/TeeJee.System.vala"
		setpriority (PRIO_PROCESS, (gint) procId, -5);
#line 48 "Utility/TeeJee.System.vala"
		if (getpriority (PRIO_PROCESS, (gint) procId) == -5) {
#line 49 "Utility/TeeJee.System.vala"
			result = TRUE;
#line 49 "Utility/TeeJee.System.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 49 "Utility/TeeJee.System.vala"
			return result;
#line 179 "TeeJee.System.c"
		} else {
#line 51 "Utility/TeeJee.System.vala"
			result = FALSE;
#line 51 "Utility/TeeJee.System.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 51 "Utility/TeeJee.System.vala"
			return result;
#line 187 "TeeJee.System.c"
		}
#line 38 "Utility/TeeJee.System.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 191 "TeeJee.System.c"
	}
	goto __finally94;
	__catch94_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 38 "Utility/TeeJee.System.vala"
		e = _inner_error0_;
#line 38 "Utility/TeeJee.System.vala"
		_inner_error0_ = NULL;
#line 54 "Utility/TeeJee.System.vala"
		_tmp5_ = e;
#line 54 "Utility/TeeJee.System.vala"
		_tmp6_ = _tmp5_->message;
#line 54 "Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 55 "Utility/TeeJee.System.vala"
		result = FALSE;
#line 55 "Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 55 "Utility/TeeJee.System.vala"
		return result;
#line 215 "TeeJee.System.c"
	}
	__finally94:
#line 38 "Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error0_);
#line 38 "Utility/TeeJee.System.vala"
	return _tmp7_;
#line 224 "TeeJee.System.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 248 "TeeJee.System.c"
}

gchar*
tee_jee_system_get_user_login (void)
{
	gchar* result = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	gchar* user_name = NULL;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
#line 66 "Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("echo ${SUDO_USER:-$(whoami)}");
#line 66 "Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 70 "Utility/TeeJee.System.vala"
	_tmp1_ = cmd;
#line 70 "Utility/TeeJee.System.vala"
	_tmp4_ = tee_jee_process_helper_exec_script_sync (_tmp1_, &_tmp2_, &_tmp3_, FALSE, FALSE, TRUE, FALSE);
#line 70 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 70 "Utility/TeeJee.System.vala"
	std_out = _tmp2_;
#line 70 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 70 "Utility/TeeJee.System.vala"
	std_err = _tmp3_;
#line 70 "Utility/TeeJee.System.vala"
	ret_val = _tmp4_;
#line 73 "Utility/TeeJee.System.vala"
	_tmp6_ = std_out;
#line 73 "Utility/TeeJee.System.vala"
	if (_tmp6_ == NULL) {
#line 73 "Utility/TeeJee.System.vala"
		_tmp5_ = TRUE;
#line 291 "TeeJee.System.c"
	} else {
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 73 "Utility/TeeJee.System.vala"
		_tmp7_ = std_out;
#line 73 "Utility/TeeJee.System.vala"
		_tmp8_ = strlen (_tmp7_);
#line 73 "Utility/TeeJee.System.vala"
		_tmp9_ = _tmp8_;
#line 73 "Utility/TeeJee.System.vala"
		_tmp5_ = _tmp9_ == 0;
#line 304 "TeeJee.System.c"
	}
#line 73 "Utility/TeeJee.System.vala"
	if (_tmp5_) {
#line 308 "TeeJee.System.c"
		gchar* _tmp10_;
#line 74 "Utility/TeeJee.System.vala"
		_tmp10_ = g_strdup ("root");
#line 74 "Utility/TeeJee.System.vala"
		_g_free0 (user_name);
#line 74 "Utility/TeeJee.System.vala"
		user_name = _tmp10_;
#line 316 "TeeJee.System.c"
	} else {
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 77 "Utility/TeeJee.System.vala"
		_tmp11_ = std_out;
#line 77 "Utility/TeeJee.System.vala"
		_tmp12_ = string_strip (_tmp11_);
#line 77 "Utility/TeeJee.System.vala"
		_g_free0 (user_name);
#line 77 "Utility/TeeJee.System.vala"
		user_name = _tmp12_;
#line 328 "TeeJee.System.c"
	}
#line 80 "Utility/TeeJee.System.vala"
	result = user_name;
#line 80 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 80 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 80 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 80 "Utility/TeeJee.System.vala"
	return result;
#line 340 "TeeJee.System.c"
}

gint
tee_jee_system_get_user_id (void)
{
	gint result = 0;
	gchar* pkexec_uid = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* sudo_user = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
#line 90 "Utility/TeeJee.System.vala"
	_tmp0_ = g_getenv ("PKEXEC_UID");
#line 90 "Utility/TeeJee.System.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 90 "Utility/TeeJee.System.vala"
	pkexec_uid = _tmp1_;
#line 92 "Utility/TeeJee.System.vala"
	_tmp2_ = pkexec_uid;
#line 92 "Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 365 "TeeJee.System.c"
		const gchar* _tmp3_;
#line 93 "Utility/TeeJee.System.vala"
		_tmp3_ = pkexec_uid;
#line 93 "Utility/TeeJee.System.vala"
		result = atoi (_tmp3_);
#line 93 "Utility/TeeJee.System.vala"
		_g_free0 (pkexec_uid);
#line 93 "Utility/TeeJee.System.vala"
		return result;
#line 375 "TeeJee.System.c"
	}
#line 96 "Utility/TeeJee.System.vala"
	_tmp4_ = g_getenv ("SUDO_USER");
#line 96 "Utility/TeeJee.System.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 96 "Utility/TeeJee.System.vala"
	sudo_user = _tmp5_;
#line 98 "Utility/TeeJee.System.vala"
	_tmp6_ = sudo_user;
#line 98 "Utility/TeeJee.System.vala"
	if (_tmp6_ != NULL) {
#line 387 "TeeJee.System.c"
		const gchar* _tmp7_;
#line 99 "Utility/TeeJee.System.vala"
		_tmp7_ = sudo_user;
#line 99 "Utility/TeeJee.System.vala"
		result = tee_jee_system_get_user_id_from_username (_tmp7_);
#line 99 "Utility/TeeJee.System.vala"
		_g_free0 (sudo_user);
#line 99 "Utility/TeeJee.System.vala"
		_g_free0 (pkexec_uid);
#line 99 "Utility/TeeJee.System.vala"
		return result;
#line 399 "TeeJee.System.c"
	}
#line 102 "Utility/TeeJee.System.vala"
	result = tee_jee_system_get_user_id_effective ();
#line 102 "Utility/TeeJee.System.vala"
	_g_free0 (sudo_user);
#line 102 "Utility/TeeJee.System.vala"
	_g_free0 (pkexec_uid);
#line 102 "Utility/TeeJee.System.vala"
	return result;
#line 409 "TeeJee.System.c"
}

gint
tee_jee_system_get_user_id_effective (void)
{
	gint result = 0;
	gint uid = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 109 "Utility/TeeJee.System.vala"
	uid = -1;
#line 110 "Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("id -u");
#line 110 "Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 112 "Utility/TeeJee.System.vala"
	_tmp1_ = cmd;
#line 112 "Utility/TeeJee.System.vala"
	tee_jee_process_helper_exec_sync (_tmp1_, &_tmp2_, &_tmp3_);
#line 112 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 112 "Utility/TeeJee.System.vala"
	std_out = _tmp2_;
#line 112 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 112 "Utility/TeeJee.System.vala"
	std_err = _tmp3_;
#line 113 "Utility/TeeJee.System.vala"
	_tmp5_ = std_out;
#line 113 "Utility/TeeJee.System.vala"
	if (_tmp5_ != NULL) {
#line 448 "TeeJee.System.c"
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 113 "Utility/TeeJee.System.vala"
		_tmp6_ = std_out;
#line 113 "Utility/TeeJee.System.vala"
		_tmp7_ = strlen (_tmp6_);
#line 113 "Utility/TeeJee.System.vala"
		_tmp8_ = _tmp7_;
#line 113 "Utility/TeeJee.System.vala"
		_tmp4_ = _tmp8_ > 0;
#line 460 "TeeJee.System.c"
	} else {
#line 113 "Utility/TeeJee.System.vala"
		_tmp4_ = FALSE;
#line 464 "TeeJee.System.c"
	}
#line 113 "Utility/TeeJee.System.vala"
	if (_tmp4_) {
#line 468 "TeeJee.System.c"
		const gchar* _tmp9_;
#line 114 "Utility/TeeJee.System.vala"
		_tmp9_ = std_out;
#line 114 "Utility/TeeJee.System.vala"
		uid = atoi (_tmp9_);
#line 474 "TeeJee.System.c"
	}
#line 117 "Utility/TeeJee.System.vala"
	result = uid;
#line 117 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 117 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 117 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 117 "Utility/TeeJee.System.vala"
	return result;
#line 486 "TeeJee.System.c"
}

gchar*
tee_jee_system_get_username (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 124 "Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_system_get_username_from_uid (tee_jee_system_get_user_id ());
#line 124 "Utility/TeeJee.System.vala"
	result = _tmp0_;
#line 124 "Utility/TeeJee.System.vala"
	return result;
#line 500 "TeeJee.System.c"
}

gint
tee_jee_system_get_user_id_from_username (const gchar* username)
{
	gint result = 0;
	gint user_id = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
#line 127 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (username != NULL, 0);
#line 129 "Utility/TeeJee.System.vala"
	user_id = -1;
#line 131 "Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_file_system_file_read ("/etc/passwd");
#line 131 "Utility/TeeJee.System.vala"
	_tmp1_ = _tmp0_;
#line 131 "Utility/TeeJee.System.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, "\n", 0);
#line 131 "Utility/TeeJee.System.vala"
	_tmp4_ = _tmp3_;
#line 131 "Utility/TeeJee.System.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 131 "Utility/TeeJee.System.vala"
	_g_free0 (_tmp1_);
#line 530 "TeeJee.System.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 131 "Utility/TeeJee.System.vala"
		line_collection = _tmp4_;
#line 131 "Utility/TeeJee.System.vala"
		line_collection_length1 = _tmp4__length1;
#line 131 "Utility/TeeJee.System.vala"
		for (line_it = 0; line_it < _tmp4__length1; line_it = line_it + 1) {
#line 542 "TeeJee.System.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 131 "Utility/TeeJee.System.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 131 "Utility/TeeJee.System.vala"
			line = _tmp5_;
#line 549 "TeeJee.System.c"
			{
				gchar** arr = NULL;
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint arr_length1;
				gint _arr_size_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
#line 132 "Utility/TeeJee.System.vala"
				_tmp6_ = line;
#line 132 "Utility/TeeJee.System.vala"
				_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, ":", 0);
#line 132 "Utility/TeeJee.System.vala"
				arr = _tmp8_;
#line 132 "Utility/TeeJee.System.vala"
				arr_length1 = _vala_array_length (_tmp7_);
#line 132 "Utility/TeeJee.System.vala"
				_arr_size_ = arr_length1;
#line 133 "Utility/TeeJee.System.vala"
				_tmp9_ = arr;
#line 133 "Utility/TeeJee.System.vala"
				_tmp9__length1 = arr_length1;
#line 133 "Utility/TeeJee.System.vala"
				if (_tmp9__length1 < 3) {
#line 133 "Utility/TeeJee.System.vala"
					arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 133 "Utility/TeeJee.System.vala"
					_g_free0 (line);
#line 133 "Utility/TeeJee.System.vala"
					continue;
#line 584 "TeeJee.System.c"
				}
#line 134 "Utility/TeeJee.System.vala"
				_tmp10_ = arr;
#line 134 "Utility/TeeJee.System.vala"
				_tmp10__length1 = arr_length1;
#line 134 "Utility/TeeJee.System.vala"
				_tmp11_ = _tmp10_[0];
#line 134 "Utility/TeeJee.System.vala"
				if (g_strcmp0 (_tmp11_, username) == 0) {
#line 594 "TeeJee.System.c"
					gchar** _tmp12_;
					gint _tmp12__length1;
					const gchar* _tmp13_;
#line 135 "Utility/TeeJee.System.vala"
					_tmp12_ = arr;
#line 135 "Utility/TeeJee.System.vala"
					_tmp12__length1 = arr_length1;
#line 135 "Utility/TeeJee.System.vala"
					_tmp13_ = _tmp12_[2];
#line 135 "Utility/TeeJee.System.vala"
					user_id = atoi (_tmp13_);
#line 136 "Utility/TeeJee.System.vala"
					arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 136 "Utility/TeeJee.System.vala"
					_g_free0 (line);
#line 136 "Utility/TeeJee.System.vala"
					break;
#line 612 "TeeJee.System.c"
				}
#line 131 "Utility/TeeJee.System.vala"
				arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 131 "Utility/TeeJee.System.vala"
				_g_free0 (line);
#line 618 "TeeJee.System.c"
			}
		}
#line 131 "Utility/TeeJee.System.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 623 "TeeJee.System.c"
	}
#line 140 "Utility/TeeJee.System.vala"
	result = user_id;
#line 140 "Utility/TeeJee.System.vala"
	return result;
#line 629 "TeeJee.System.c"
}

gchar*
tee_jee_system_get_username_from_uid (gint user_id)
{
	gchar* result = NULL;
	gchar* username = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 145 "Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("");
#line 145 "Utility/TeeJee.System.vala"
	username = _tmp0_;
#line 147 "Utility/TeeJee.System.vala"
	_tmp1_ = tee_jee_file_system_file_read ("/etc/passwd");
#line 147 "Utility/TeeJee.System.vala"
	_tmp2_ = _tmp1_;
#line 147 "Utility/TeeJee.System.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 147 "Utility/TeeJee.System.vala"
	_tmp5_ = _tmp4_;
#line 147 "Utility/TeeJee.System.vala"
	_tmp5__length1 = _vala_array_length (_tmp3_);
#line 147 "Utility/TeeJee.System.vala"
	_g_free0 (_tmp2_);
#line 660 "TeeJee.System.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 147 "Utility/TeeJee.System.vala"
		line_collection = _tmp5_;
#line 147 "Utility/TeeJee.System.vala"
		line_collection_length1 = _tmp5__length1;
#line 147 "Utility/TeeJee.System.vala"
		for (line_it = 0; line_it < _tmp5__length1; line_it = line_it + 1) {
#line 672 "TeeJee.System.c"
			gchar* _tmp6_;
			gchar* line = NULL;
#line 147 "Utility/TeeJee.System.vala"
			_tmp6_ = g_strdup (line_collection[line_it]);
#line 147 "Utility/TeeJee.System.vala"
			line = _tmp6_;
#line 679 "TeeJee.System.c"
			{
				gchar** arr = NULL;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gint arr_length1;
				gint _arr_size_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
#line 148 "Utility/TeeJee.System.vala"
				_tmp7_ = line;
#line 148 "Utility/TeeJee.System.vala"
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, ":", 0);
#line 148 "Utility/TeeJee.System.vala"
				arr = _tmp9_;
#line 148 "Utility/TeeJee.System.vala"
				arr_length1 = _vala_array_length (_tmp8_);
#line 148 "Utility/TeeJee.System.vala"
				_arr_size_ = arr_length1;
#line 149 "Utility/TeeJee.System.vala"
				_tmp10_ = arr;
#line 149 "Utility/TeeJee.System.vala"
				_tmp10__length1 = arr_length1;
#line 149 "Utility/TeeJee.System.vala"
				if (_tmp10__length1 < 3) {
#line 149 "Utility/TeeJee.System.vala"
					arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 149 "Utility/TeeJee.System.vala"
					_g_free0 (line);
#line 149 "Utility/TeeJee.System.vala"
					continue;
#line 714 "TeeJee.System.c"
				}
#line 150 "Utility/TeeJee.System.vala"
				_tmp11_ = arr;
#line 150 "Utility/TeeJee.System.vala"
				_tmp11__length1 = arr_length1;
#line 150 "Utility/TeeJee.System.vala"
				_tmp12_ = _tmp11_[2];
#line 150 "Utility/TeeJee.System.vala"
				if (atoi (_tmp12_) == user_id) {
#line 724 "TeeJee.System.c"
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 151 "Utility/TeeJee.System.vala"
					_tmp13_ = arr;
#line 151 "Utility/TeeJee.System.vala"
					_tmp13__length1 = arr_length1;
#line 151 "Utility/TeeJee.System.vala"
					_tmp14_ = _tmp13_[0];
#line 151 "Utility/TeeJee.System.vala"
					_tmp15_ = g_strdup (_tmp14_);
#line 151 "Utility/TeeJee.System.vala"
					_g_free0 (username);
#line 151 "Utility/TeeJee.System.vala"
					username = _tmp15_;
#line 152 "Utility/TeeJee.System.vala"
					arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 152 "Utility/TeeJee.System.vala"
					_g_free0 (line);
#line 152 "Utility/TeeJee.System.vala"
					break;
#line 747 "TeeJee.System.c"
				}
#line 147 "Utility/TeeJee.System.vala"
				arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 147 "Utility/TeeJee.System.vala"
				_g_free0 (line);
#line 753 "TeeJee.System.c"
			}
		}
#line 147 "Utility/TeeJee.System.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 758 "TeeJee.System.c"
	}
#line 156 "Utility/TeeJee.System.vala"
	result = username;
#line 156 "Utility/TeeJee.System.vala"
	return result;
#line 764 "TeeJee.System.c"
}

gchar*
tee_jee_system_get_app_path (void)
{
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 167 "Utility/TeeJee.System.vala"
		_tmp1_ = g_file_read_link ("/proc/self/exe", &_inner_error0_);
#line 167 "Utility/TeeJee.System.vala"
		_tmp0_ = _tmp1_;
#line 167 "Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 782 "TeeJee.System.c"
			goto __catch95_g_error;
		}
#line 167 "Utility/TeeJee.System.vala"
		_tmp2_ = _tmp0_;
#line 167 "Utility/TeeJee.System.vala"
		_tmp0_ = NULL;
#line 167 "Utility/TeeJee.System.vala"
		result = _tmp2_;
#line 167 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp0_);
#line 167 "Utility/TeeJee.System.vala"
		return result;
#line 795 "TeeJee.System.c"
	}
	goto __finally95;
	__catch95_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 166 "Utility/TeeJee.System.vala"
		e = _inner_error0_;
#line 166 "Utility/TeeJee.System.vala"
		_inner_error0_ = NULL;
#line 170 "Utility/TeeJee.System.vala"
		_tmp3_ = e;
#line 170 "Utility/TeeJee.System.vala"
		_tmp4_ = _tmp3_->message;
#line 170 "Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 171 "Utility/TeeJee.System.vala"
		_tmp5_ = g_strdup ("");
#line 171 "Utility/TeeJee.System.vala"
		result = _tmp5_;
#line 171 "Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 171 "Utility/TeeJee.System.vala"
		return result;
#line 822 "TeeJee.System.c"
	}
	__finally95:
#line 166 "Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 166 "Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error0_);
#line 166 "Utility/TeeJee.System.vala"
	return NULL;
#line 831 "TeeJee.System.c"
}

gchar*
tee_jee_system_get_app_dir (void)
{
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 180 "Utility/TeeJee.System.vala"
		_tmp1_ = g_file_read_link ("/proc/self/exe", &_inner_error0_);
#line 180 "Utility/TeeJee.System.vala"
		_tmp0_ = _tmp1_;
#line 180 "Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 854 "TeeJee.System.c"
			goto __catch96_g_error;
		}
#line 180 "Utility/TeeJee.System.vala"
		_tmp2_ = g_file_new_for_path (_tmp0_);
#line 180 "Utility/TeeJee.System.vala"
		_tmp3_ = _tmp2_;
#line 180 "Utility/TeeJee.System.vala"
		_tmp4_ = g_file_get_parent (_tmp3_);
#line 180 "Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 180 "Utility/TeeJee.System.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 180 "Utility/TeeJee.System.vala"
		_tmp7_ = _tmp6_;
#line 180 "Utility/TeeJee.System.vala"
		_g_object_unref0 (_tmp5_);
#line 180 "Utility/TeeJee.System.vala"
		_g_object_unref0 (_tmp3_);
#line 180 "Utility/TeeJee.System.vala"
		result = _tmp7_;
#line 180 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp0_);
#line 180 "Utility/TeeJee.System.vala"
		return result;
#line 879 "TeeJee.System.c"
	}
	goto __finally96;
	__catch96_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 179 "Utility/TeeJee.System.vala"
		e = _inner_error0_;
#line 179 "Utility/TeeJee.System.vala"
		_inner_error0_ = NULL;
#line 183 "Utility/TeeJee.System.vala"
		_tmp8_ = e;
#line 183 "Utility/TeeJee.System.vala"
		_tmp9_ = _tmp8_->message;
#line 183 "Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp9_, FALSE, FALSE);
#line 184 "Utility/TeeJee.System.vala"
		_tmp10_ = g_strdup ("");
#line 184 "Utility/TeeJee.System.vala"
		result = _tmp10_;
#line 184 "Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 184 "Utility/TeeJee.System.vala"
		return result;
#line 906 "TeeJee.System.c"
	}
	__finally96:
#line 179 "Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 179 "Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error0_);
#line 179 "Utility/TeeJee.System.vala"
	return NULL;
#line 915 "TeeJee.System.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 944 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 945 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 945 "glib-2.0.vapi"
	return result;
#line 928 "TeeJee.System.c"
}

gdouble
tee_jee_system_get_system_uptime_seconds (void)
{
	gdouble result = 0.0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gdouble _tmp15_ = -1.0;
	GError* _inner_error0_ = NULL;
#line 195 "Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("");
#line 195 "Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 946 "TeeJee.System.c"
	{
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		gchar* uptime = NULL;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gdouble secs = 0.0;
		const gchar* _tmp12_;
#line 201 "Utility/TeeJee.System.vala"
		_tmp1_ = g_strdup ("cat /proc/uptime");
#line 201 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 201 "Utility/TeeJee.System.vala"
		cmd = _tmp1_;
#line 202 "Utility/TeeJee.System.vala"
		_tmp2_ = cmd;
#line 202 "Utility/TeeJee.System.vala"
		g_spawn_command_line_sync (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 202 "Utility/TeeJee.System.vala"
		_g_free0 (std_out);
#line 202 "Utility/TeeJee.System.vala"
		std_out = _tmp3_;
#line 202 "Utility/TeeJee.System.vala"
		_g_free0 (std_err);
#line 202 "Utility/TeeJee.System.vala"
		std_err = _tmp4_;
#line 202 "Utility/TeeJee.System.vala"
		ret_val = _tmp5_;
#line 202 "Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 985 "TeeJee.System.c"
			goto __catch97_g_error;
		}
#line 203 "Utility/TeeJee.System.vala"
		_tmp7_ = _tmp6_ = g_strsplit (std_out, " ", 0);
#line 203 "Utility/TeeJee.System.vala"
		_tmp8_ = _tmp7_;
#line 203 "Utility/TeeJee.System.vala"
		_tmp8__length1 = _vala_array_length (_tmp6_);
#line 203 "Utility/TeeJee.System.vala"
		_tmp9_ = _tmp8_[0];
#line 203 "Utility/TeeJee.System.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 203 "Utility/TeeJee.System.vala"
		_tmp11_ = _tmp10_;
#line 203 "Utility/TeeJee.System.vala"
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 203 "Utility/TeeJee.System.vala"
		uptime = _tmp11_;
#line 204 "Utility/TeeJee.System.vala"
		_tmp12_ = uptime;
#line 204 "Utility/TeeJee.System.vala"
		secs = double_parse (_tmp12_);
#line 205 "Utility/TeeJee.System.vala"
		result = secs;
#line 205 "Utility/TeeJee.System.vala"
		_g_free0 (uptime);
#line 205 "Utility/TeeJee.System.vala"
		_g_free0 (std_err);
#line 205 "Utility/TeeJee.System.vala"
		_g_free0 (std_out);
#line 205 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 205 "Utility/TeeJee.System.vala"
		return result;
#line 1020 "TeeJee.System.c"
	}
	goto __finally97;
	__catch97_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 200 "Utility/TeeJee.System.vala"
		e = _inner_error0_;
#line 200 "Utility/TeeJee.System.vala"
		_inner_error0_ = NULL;
#line 208 "Utility/TeeJee.System.vala"
		_tmp13_ = e;
#line 208 "Utility/TeeJee.System.vala"
		_tmp14_ = _tmp13_->message;
#line 208 "Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp14_, FALSE, FALSE);
#line 209 "Utility/TeeJee.System.vala"
		result = (gdouble) 0;
#line 209 "Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 209 "Utility/TeeJee.System.vala"
		_g_free0 (std_err);
#line 209 "Utility/TeeJee.System.vala"
		_g_free0 (std_out);
#line 209 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 209 "Utility/TeeJee.System.vala"
		return result;
#line 1050 "TeeJee.System.c"
	}
	__finally97:
#line 200 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 200 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 200 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 200 "Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 200 "Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error0_);
#line 200 "Utility/TeeJee.System.vala"
	return _tmp15_;
#line 1065 "TeeJee.System.c"
}

gchar*
tee_jee_system_get_desktop_name (void)
{
	gchar* result = NULL;
	gint pid = 0;
	gchar* _tmp7_;
#line 217 "Utility/TeeJee.System.vala"
	pid = -1;
#line 219 "Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("cinnamon");
#line 220 "Utility/TeeJee.System.vala"
	if (pid > 0) {
#line 1080 "TeeJee.System.c"
		gchar* _tmp0_;
#line 221 "Utility/TeeJee.System.vala"
		_tmp0_ = g_strdup ("Cinnamon");
#line 221 "Utility/TeeJee.System.vala"
		result = _tmp0_;
#line 221 "Utility/TeeJee.System.vala"
		return result;
#line 1088 "TeeJee.System.c"
	}
#line 224 "Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("xfdesktop");
#line 225 "Utility/TeeJee.System.vala"
	if (pid > 0) {
#line 1094 "TeeJee.System.c"
		gchar* _tmp1_;
#line 226 "Utility/TeeJee.System.vala"
		_tmp1_ = g_strdup ("Xfce");
#line 226 "Utility/TeeJee.System.vala"
		result = _tmp1_;
#line 226 "Utility/TeeJee.System.vala"
		return result;
#line 1102 "TeeJee.System.c"
	}
#line 229 "Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("lxsession");
#line 230 "Utility/TeeJee.System.vala"
	if (pid > 0) {
#line 1108 "TeeJee.System.c"
		gchar* _tmp2_;
#line 231 "Utility/TeeJee.System.vala"
		_tmp2_ = g_strdup ("LXDE");
#line 231 "Utility/TeeJee.System.vala"
		result = _tmp2_;
#line 231 "Utility/TeeJee.System.vala"
		return result;
#line 1116 "TeeJee.System.c"
	}
#line 234 "Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("gnome-shell");
#line 235 "Utility/TeeJee.System.vala"
	if (pid > 0) {
#line 1122 "TeeJee.System.c"
		gchar* _tmp3_;
#line 236 "Utility/TeeJee.System.vala"
		_tmp3_ = g_strdup ("Gnome");
#line 236 "Utility/TeeJee.System.vala"
		result = _tmp3_;
#line 236 "Utility/TeeJee.System.vala"
		return result;
#line 1130 "TeeJee.System.c"
	}
#line 239 "Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("wingpanel");
#line 240 "Utility/TeeJee.System.vala"
	if (pid > 0) {
#line 1136 "TeeJee.System.c"
		gchar* _tmp4_;
#line 241 "Utility/TeeJee.System.vala"
		_tmp4_ = g_strdup ("Elementary");
#line 241 "Utility/TeeJee.System.vala"
		result = _tmp4_;
#line 241 "Utility/TeeJee.System.vala"
		return result;
#line 1144 "TeeJee.System.c"
	}
#line 244 "Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("unity-panel-service");
#line 245 "Utility/TeeJee.System.vala"
	if (pid > 0) {
#line 1150 "TeeJee.System.c"
		gchar* _tmp5_;
#line 246 "Utility/TeeJee.System.vala"
		_tmp5_ = g_strdup ("Unity");
#line 246 "Utility/TeeJee.System.vala"
		result = _tmp5_;
#line 246 "Utility/TeeJee.System.vala"
		return result;
#line 1158 "TeeJee.System.c"
	}
#line 249 "Utility/TeeJee.System.vala"
	pid = tee_jee_process_helper_get_pid_by_name ("plasma-desktop");
#line 250 "Utility/TeeJee.System.vala"
	if (pid > 0) {
#line 1164 "TeeJee.System.c"
		gchar* _tmp6_;
#line 251 "Utility/TeeJee.System.vala"
		_tmp6_ = g_strdup ("KDE");
#line 251 "Utility/TeeJee.System.vala"
		result = _tmp6_;
#line 251 "Utility/TeeJee.System.vala"
		return result;
#line 1172 "TeeJee.System.c"
	}
#line 254 "Utility/TeeJee.System.vala"
	_tmp7_ = g_strdup ("Unknown");
#line 254 "Utility/TeeJee.System.vala"
	result = _tmp7_;
#line 254 "Utility/TeeJee.System.vala"
	return result;
#line 1180 "TeeJee.System.c"
}

static gint
__lambda19_ (const gchar* a,
             const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
#line 276 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 276 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 277 "Utility/TeeJee.System.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 277 "Utility/TeeJee.System.vala"
	result = _tmp0_ (a, b);
#line 277 "Utility/TeeJee.System.vala"
	return result;
#line 1199 "TeeJee.System.c"
}

static gint
___lambda19__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda19_ ((const gchar*) a, (const gchar*) b);
#line 276 "Utility/TeeJee.System.vala"
	return result;
#line 1211 "TeeJee.System.c"
}

GeeArrayList*
tee_jee_system_list_dir_names (const gchar* path)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GCompareDataFunc entry_compare = NULL;
	gpointer entry_compare_target;
	GDestroyNotify entry_compare_target_destroy_notify;
	GeeArrayList* _tmp19_;
	GCompareDataFunc _tmp20_;
	gpointer _tmp20__target;
	GDestroyNotify _tmp20__target_destroy_notify;
	GError* _inner_error0_ = NULL;
#line 257 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 258 "Utility/TeeJee.System.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 258 "Utility/TeeJee.System.vala"
	list = _tmp0_;
#line 1234 "TeeJee.System.c"
	{
		GFile* f_home = NULL;
		GFile* _tmp1_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileEnumerator* _tmp6_;
		GFileInfo* file = NULL;
#line 262 "Utility/TeeJee.System.vala"
		_tmp1_ = g_file_new_for_path (path);
#line 262 "Utility/TeeJee.System.vala"
		f_home = _tmp1_;
#line 263 "Utility/TeeJee.System.vala"
		_tmp2_ = f_home;
#line 263 "Utility/TeeJee.System.vala"
		_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 263 "Utility/TeeJee.System.vala"
		_tmp4_ = _tmp3_;
#line 263 "Utility/TeeJee.System.vala"
		_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error0_);
#line 263 "Utility/TeeJee.System.vala"
		_tmp6_ = _tmp5_;
#line 263 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp4_);
#line 263 "Utility/TeeJee.System.vala"
		enumerator = _tmp6_;
#line 263 "Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "Utility/TeeJee.System.vala"
			_g_object_unref0 (f_home);
#line 1267 "TeeJee.System.c"
			goto __catch98_g_error;
		}
#line 265 "Utility/TeeJee.System.vala"
		while (TRUE) {
#line 1272 "TeeJee.System.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			gchar* name = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GeeArrayList* _tmp15_;
			const gchar* _tmp16_;
#line 265 "Utility/TeeJee.System.vala"
			_tmp8_ = enumerator;
#line 265 "Utility/TeeJee.System.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 265 "Utility/TeeJee.System.vala"
			_tmp7_ = _tmp9_;
#line 265 "Utility/TeeJee.System.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 265 "Utility/TeeJee.System.vala"
				_g_object_unref0 (file);
#line 265 "Utility/TeeJee.System.vala"
				_g_object_unref0 (enumerator);
#line 265 "Utility/TeeJee.System.vala"
				_g_object_unref0 (f_home);
#line 1298 "TeeJee.System.c"
				goto __catch98_g_error;
			}
#line 265 "Utility/TeeJee.System.vala"
			_tmp10_ = _tmp7_;
#line 265 "Utility/TeeJee.System.vala"
			_tmp7_ = NULL;
#line 265 "Utility/TeeJee.System.vala"
			_g_object_unref0 (file);
#line 265 "Utility/TeeJee.System.vala"
			file = _tmp10_;
#line 265 "Utility/TeeJee.System.vala"
			_tmp11_ = file;
#line 265 "Utility/TeeJee.System.vala"
			if (!(_tmp11_ != NULL)) {
#line 265 "Utility/TeeJee.System.vala"
				_g_object_unref0 (_tmp7_);
#line 265 "Utility/TeeJee.System.vala"
				break;
#line 1317 "TeeJee.System.c"
			}
#line 266 "Utility/TeeJee.System.vala"
			_tmp12_ = file;
#line 266 "Utility/TeeJee.System.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 266 "Utility/TeeJee.System.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 266 "Utility/TeeJee.System.vala"
			name = _tmp14_;
#line 268 "Utility/TeeJee.System.vala"
			_tmp15_ = list;
#line 268 "Utility/TeeJee.System.vala"
			_tmp16_ = name;
#line 268 "Utility/TeeJee.System.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 265 "Utility/TeeJee.System.vala"
			_g_free0 (name);
#line 265 "Utility/TeeJee.System.vala"
			_g_object_unref0 (_tmp7_);
#line 1337 "TeeJee.System.c"
		}
#line 260 "Utility/TeeJee.System.vala"
		_g_object_unref0 (file);
#line 260 "Utility/TeeJee.System.vala"
		_g_object_unref0 (enumerator);
#line 260 "Utility/TeeJee.System.vala"
		_g_object_unref0 (f_home);
#line 1345 "TeeJee.System.c"
	}
	goto __finally98;
	__catch98_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 260 "Utility/TeeJee.System.vala"
		e = _inner_error0_;
#line 260 "Utility/TeeJee.System.vala"
		_inner_error0_ = NULL;
#line 272 "Utility/TeeJee.System.vala"
		_tmp17_ = e;
#line 272 "Utility/TeeJee.System.vala"
		_tmp18_ = _tmp17_->message;
#line 272 "Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 260 "Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 1365 "TeeJee.System.c"
	}
	__finally98:
#line 260 "Utility/TeeJee.System.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 260 "Utility/TeeJee.System.vala"
		_g_object_unref0 (list);
#line 260 "Utility/TeeJee.System.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 260 "Utility/TeeJee.System.vala"
		g_clear_error (&_inner_error0_);
#line 260 "Utility/TeeJee.System.vala"
		return NULL;
#line 1378 "TeeJee.System.c"
	}
#line 276 "Utility/TeeJee.System.vala"
	entry_compare = ___lambda19__gcompare_data_func;
#line 276 "Utility/TeeJee.System.vala"
	entry_compare_target = NULL;
#line 276 "Utility/TeeJee.System.vala"
	entry_compare_target_destroy_notify = NULL;
#line 279 "Utility/TeeJee.System.vala"
	_tmp19_ = list;
#line 279 "Utility/TeeJee.System.vala"
	_tmp20_ = entry_compare;
#line 279 "Utility/TeeJee.System.vala"
	_tmp20__target = entry_compare_target;
#line 279 "Utility/TeeJee.System.vala"
	_tmp20__target_destroy_notify = entry_compare_target_destroy_notify;
#line 279 "Utility/TeeJee.System.vala"
	entry_compare = NULL;
#line 279 "Utility/TeeJee.System.vala"
	entry_compare_target = NULL;
#line 279 "Utility/TeeJee.System.vala"
	entry_compare_target_destroy_notify = NULL;
#line 279 "Utility/TeeJee.System.vala"
	gee_list_sort ((GeeList*) _tmp19_, _tmp20_, _tmp20__target, _tmp20__target_destroy_notify);
#line 281 "Utility/TeeJee.System.vala"
	result = list;
#line 281 "Utility/TeeJee.System.vala"
	(entry_compare_target_destroy_notify == NULL) ? NULL : (entry_compare_target_destroy_notify (entry_compare_target), NULL);
#line 281 "Utility/TeeJee.System.vala"
	entry_compare = NULL;
#line 281 "Utility/TeeJee.System.vala"
	entry_compare_target = NULL;
#line 281 "Utility/TeeJee.System.vala"
	entry_compare_target_destroy_notify = NULL;
#line 281 "Utility/TeeJee.System.vala"
	return result;
#line 1414 "TeeJee.System.c"
}

gint
tee_jee_system_get_display_width (void)
{
	gint result = 0;
	GdkScreen* _tmp0_;
#line 285 "Utility/TeeJee.System.vala"
	_tmp0_ = gdk_screen_get_default ();
#line 285 "Utility/TeeJee.System.vala"
	result = gdk_screen_get_width (_tmp0_);
#line 285 "Utility/TeeJee.System.vala"
	return result;
#line 1428 "TeeJee.System.c"
}

gint
tee_jee_system_get_display_height (void)
{
	gint result = 0;
	GdkScreen* _tmp0_;
#line 289 "Utility/TeeJee.System.vala"
	_tmp0_ = gdk_screen_get_default ();
#line 289 "Utility/TeeJee.System.vala"
	result = gdk_screen_get_height (_tmp0_);
#line 289 "Utility/TeeJee.System.vala"
	return result;
#line 1442 "TeeJee.System.c"
}

gboolean
tee_jee_system_check_internet_connectivity (void)
{
	gboolean result = FALSE;
	gboolean connected = FALSE;
#line 295 "Utility/TeeJee.System.vala"
	connected = FALSE;
#line 296 "Utility/TeeJee.System.vala"
	connected = tee_jee_system_check_internet_connectivity_test1 ();
#line 298 "Utility/TeeJee.System.vala"
	if (connected) {
#line 299 "Utility/TeeJee.System.vala"
		result = connected;
#line 299 "Utility/TeeJee.System.vala"
		return result;
#line 1460 "TeeJee.System.c"
	}
#line 302 "Utility/TeeJee.System.vala"
	if (!connected) {
#line 303 "Utility/TeeJee.System.vala"
		connected = tee_jee_system_check_internet_connectivity_test2 ();
#line 1466 "TeeJee.System.c"
	}
#line 306 "Utility/TeeJee.System.vala"
	result = connected;
#line 306 "Utility/TeeJee.System.vala"
	return result;
#line 1472 "TeeJee.System.c"
}

gboolean
tee_jee_system_check_internet_connectivity_test1 (void)
{
	gboolean result = FALSE;
	gint exit_code = 0;
	gchar* std_err = NULL;
	gchar* std_out = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gint _tmp6_;
#line 310 "Utility/TeeJee.System.vala"
	exit_code = -1;
#line 314 "Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("ping -q -w 1 -c 1 `ip r | grep default | cut -d ' ' -f 3`\n");
#line 314 "Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 315 "Utility/TeeJee.System.vala"
	_tmp1_ = cmd;
#line 315 "Utility/TeeJee.System.vala"
	_tmp2_ = g_strconcat (_tmp1_, "exit $?", NULL);
#line 315 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 315 "Utility/TeeJee.System.vala"
	cmd = _tmp2_;
#line 316 "Utility/TeeJee.System.vala"
	_tmp3_ = cmd;
#line 316 "Utility/TeeJee.System.vala"
	_tmp6_ = tee_jee_process_helper_exec_script_sync (_tmp3_, &_tmp4_, &_tmp5_, FALSE, FALSE, TRUE, FALSE);
#line 316 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 316 "Utility/TeeJee.System.vala"
	std_out = _tmp4_;
#line 316 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 316 "Utility/TeeJee.System.vala"
	std_err = _tmp5_;
#line 316 "Utility/TeeJee.System.vala"
	exit_code = _tmp6_;
#line 318 "Utility/TeeJee.System.vala"
	result = exit_code == 0;
#line 318 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 318 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 318 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 318 "Utility/TeeJee.System.vala"
	return result;
#line 1528 "TeeJee.System.c"
}

gboolean
tee_jee_system_check_internet_connectivity_test2 (void)
{
	gboolean result = FALSE;
	gint exit_code = 0;
	gchar* std_err = NULL;
	gchar* std_out = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gint _tmp6_;
#line 322 "Utility/TeeJee.System.vala"
	exit_code = -1;
#line 326 "Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("ping -q -w 1 -c 1 google.com\n");
#line 326 "Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 327 "Utility/TeeJee.System.vala"
	_tmp1_ = cmd;
#line 327 "Utility/TeeJee.System.vala"
	_tmp2_ = g_strconcat (_tmp1_, "exit $?", NULL);
#line 327 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 327 "Utility/TeeJee.System.vala"
	cmd = _tmp2_;
#line 328 "Utility/TeeJee.System.vala"
	_tmp3_ = cmd;
#line 328 "Utility/TeeJee.System.vala"
	_tmp6_ = tee_jee_process_helper_exec_script_sync (_tmp3_, &_tmp4_, &_tmp5_, FALSE, FALSE, TRUE, FALSE);
#line 328 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 328 "Utility/TeeJee.System.vala"
	std_out = _tmp4_;
#line 328 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 328 "Utility/TeeJee.System.vala"
	std_err = _tmp5_;
#line 328 "Utility/TeeJee.System.vala"
	exit_code = _tmp6_;
#line 330 "Utility/TeeJee.System.vala"
	result = exit_code == 0;
#line 330 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 330 "Utility/TeeJee.System.vala"
	_g_free0 (std_out);
#line 330 "Utility/TeeJee.System.vala"
	_g_free0 (std_err);
#line 330 "Utility/TeeJee.System.vala"
	return result;
#line 1584 "TeeJee.System.c"
}

gboolean
tee_jee_system_shutdown (void)
{
	gboolean result = FALSE;
	gboolean _tmp7_ = FALSE;
	GError* _inner_error0_ = NULL;
	{
		gchar** argv = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gint argv_length1;
		gint _argv_size_;
		GPid procId = 0;
		GPid _tmp4_ = 0;
#line 338 "Utility/TeeJee.System.vala"
		_tmp0_ = g_strdup ("shutdown");
#line 338 "Utility/TeeJee.System.vala"
		_tmp1_ = g_strdup ("-h");
#line 338 "Utility/TeeJee.System.vala"
		_tmp2_ = g_strdup ("now");
#line 338 "Utility/TeeJee.System.vala"
		_tmp3_ = g_new0 (gchar*, 3 + 1);
#line 338 "Utility/TeeJee.System.vala"
		_tmp3_[0] = _tmp0_;
#line 338 "Utility/TeeJee.System.vala"
		_tmp3_[1] = _tmp1_;
#line 338 "Utility/TeeJee.System.vala"
		_tmp3_[2] = _tmp2_;
#line 338 "Utility/TeeJee.System.vala"
		argv = _tmp3_;
#line 338 "Utility/TeeJee.System.vala"
		argv_length1 = 3;
#line 338 "Utility/TeeJee.System.vala"
		_argv_size_ = argv_length1;
#line 340 "Utility/TeeJee.System.vala"
		g_spawn_async (NULL, argv, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp4_, &_inner_error0_);
#line 340 "Utility/TeeJee.System.vala"
		procId = _tmp4_;
#line 340 "Utility/TeeJee.System.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 340 "Utility/TeeJee.System.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 1631 "TeeJee.System.c"
			goto __catch99_g_error;
		}
#line 341 "Utility/TeeJee.System.vala"
		result = TRUE;
#line 341 "Utility/TeeJee.System.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 341 "Utility/TeeJee.System.vala"
		return result;
#line 1640 "TeeJee.System.c"
	}
	goto __finally99;
	__catch99_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 337 "Utility/TeeJee.System.vala"
		e = _inner_error0_;
#line 337 "Utility/TeeJee.System.vala"
		_inner_error0_ = NULL;
#line 344 "Utility/TeeJee.System.vala"
		_tmp5_ = e;
#line 344 "Utility/TeeJee.System.vala"
		_tmp6_ = _tmp5_->message;
#line 344 "Utility/TeeJee.System.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 345 "Utility/TeeJee.System.vala"
		result = FALSE;
#line 345 "Utility/TeeJee.System.vala"
		_g_error_free0 (e);
#line 345 "Utility/TeeJee.System.vala"
		return result;
#line 1664 "TeeJee.System.c"
	}
	__finally99:
#line 337 "Utility/TeeJee.System.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 337 "Utility/TeeJee.System.vala"
	g_clear_error (&_inner_error0_);
#line 337 "Utility/TeeJee.System.vala"
	return _tmp7_;
#line 1673 "TeeJee.System.c"
}

gboolean
tee_jee_system_command_exists (const gchar* command)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 349 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (command != NULL, FALSE);
#line 350 "Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path (command);
#line 350 "Utility/TeeJee.System.vala"
	path = _tmp0_;
#line 351 "Utility/TeeJee.System.vala"
	_tmp2_ = path;
#line 351 "Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 1694 "TeeJee.System.c"
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 351 "Utility/TeeJee.System.vala"
		_tmp3_ = path;
#line 351 "Utility/TeeJee.System.vala"
		_tmp4_ = strlen (_tmp3_);
#line 351 "Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 351 "Utility/TeeJee.System.vala"
		_tmp1_ = _tmp5_ > 0;
#line 1706 "TeeJee.System.c"
	} else {
#line 351 "Utility/TeeJee.System.vala"
		_tmp1_ = FALSE;
#line 1710 "TeeJee.System.c"
	}
#line 351 "Utility/TeeJee.System.vala"
	result = _tmp1_;
#line 351 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 351 "Utility/TeeJee.System.vala"
	return result;
#line 1718 "TeeJee.System.c"
}

gboolean
tee_jee_system_xdg_open (const gchar* file,
                         const gchar* user)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 356 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 356 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (user != NULL, FALSE);
#line 357 "Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path ("xdg-open");
#line 357 "Utility/TeeJee.System.vala"
	path = _tmp0_;
#line 358 "Utility/TeeJee.System.vala"
	_tmp2_ = path;
#line 358 "Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 1742 "TeeJee.System.c"
		const gchar* _tmp3_;
#line 358 "Utility/TeeJee.System.vala"
		_tmp3_ = path;
#line 358 "Utility/TeeJee.System.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 1748 "TeeJee.System.c"
	} else {
#line 358 "Utility/TeeJee.System.vala"
		_tmp1_ = FALSE;
#line 1752 "TeeJee.System.c"
	}
#line 358 "Utility/TeeJee.System.vala"
	if (_tmp1_) {
#line 1756 "TeeJee.System.c"
		gchar* cmd = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		const gchar* _tmp14_;
		gint status = 0;
		const gchar* _tmp15_;
#line 359 "Utility/TeeJee.System.vala"
		_tmp4_ = tee_jee_file_system_escape_single_quote (file);
#line 359 "Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 359 "Utility/TeeJee.System.vala"
		_tmp6_ = g_strdup_printf ("xdg-open '%s'", _tmp5_);
#line 359 "Utility/TeeJee.System.vala"
		_tmp7_ = _tmp6_;
#line 359 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp5_);
#line 359 "Utility/TeeJee.System.vala"
		cmd = _tmp7_;
#line 360 "Utility/TeeJee.System.vala"
		_tmp8_ = strlen (user);
#line 360 "Utility/TeeJee.System.vala"
		_tmp9_ = _tmp8_;
#line 360 "Utility/TeeJee.System.vala"
		if (_tmp9_ > 0) {
#line 1785 "TeeJee.System.c"
			gchar* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
#line 361 "Utility/TeeJee.System.vala"
			_tmp10_ = g_strdup_printf ("pkexec --user %s env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY ", user);
#line 361 "Utility/TeeJee.System.vala"
			_tmp11_ = _tmp10_;
#line 361 "Utility/TeeJee.System.vala"
			_tmp12_ = cmd;
#line 361 "Utility/TeeJee.System.vala"
			_tmp13_ = g_strconcat (_tmp11_, _tmp12_, NULL);
#line 361 "Utility/TeeJee.System.vala"
			_g_free0 (cmd);
#line 361 "Utility/TeeJee.System.vala"
			cmd = _tmp13_;
#line 361 "Utility/TeeJee.System.vala"
			_g_free0 (_tmp11_);
#line 1804 "TeeJee.System.c"
		}
#line 363 "Utility/TeeJee.System.vala"
		_tmp14_ = cmd;
#line 363 "Utility/TeeJee.System.vala"
		tee_jee_logging_log_debug (_tmp14_);
#line 364 "Utility/TeeJee.System.vala"
		_tmp15_ = cmd;
#line 364 "Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp15_);
#line 365 "Utility/TeeJee.System.vala"
		result = status == 0;
#line 365 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 365 "Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 365 "Utility/TeeJee.System.vala"
		return result;
#line 1822 "TeeJee.System.c"
	}
#line 367 "Utility/TeeJee.System.vala"
	result = FALSE;
#line 367 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 367 "Utility/TeeJee.System.vala"
	return result;
#line 1830 "TeeJee.System.c"
}

gboolean
tee_jee_system_exo_open_folder (const gchar* dir_path,
                                gboolean xdg_open_try_first)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gint status = 0;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
#line 370 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 384 "Utility/TeeJee.System.vala"
	if (xdg_open_try_first) {
#line 1850 "TeeJee.System.c"
		gchar* _tmp0_;
		gboolean _tmp1_ = FALSE;
		const gchar* _tmp2_;
#line 386 "Utility/TeeJee.System.vala"
		_tmp0_ = tee_jee_process_helper_get_cmd_path ("xdg-open");
#line 386 "Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 386 "Utility/TeeJee.System.vala"
		path = _tmp0_;
#line 387 "Utility/TeeJee.System.vala"
		_tmp2_ = path;
#line 387 "Utility/TeeJee.System.vala"
		if (_tmp2_ != NULL) {
#line 1864 "TeeJee.System.c"
			const gchar* _tmp3_;
#line 387 "Utility/TeeJee.System.vala"
			_tmp3_ = path;
#line 387 "Utility/TeeJee.System.vala"
			_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 1870 "TeeJee.System.c"
		} else {
#line 387 "Utility/TeeJee.System.vala"
			_tmp1_ = FALSE;
#line 1874 "TeeJee.System.c"
		}
#line 387 "Utility/TeeJee.System.vala"
		if (_tmp1_) {
#line 1878 "TeeJee.System.c"
			gchar* cmd = NULL;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
#line 388 "Utility/TeeJee.System.vala"
			_tmp4_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 388 "Utility/TeeJee.System.vala"
			_tmp5_ = _tmp4_;
#line 388 "Utility/TeeJee.System.vala"
			_tmp6_ = g_strdup_printf ("xdg-open '%s'", _tmp5_);
#line 388 "Utility/TeeJee.System.vala"
			_tmp7_ = _tmp6_;
#line 388 "Utility/TeeJee.System.vala"
			_g_free0 (_tmp5_);
#line 388 "Utility/TeeJee.System.vala"
			cmd = _tmp7_;
#line 389 "Utility/TeeJee.System.vala"
			_tmp8_ = cmd;
#line 389 "Utility/TeeJee.System.vala"
			status = tee_jee_process_helper_exec_script_async (_tmp8_);
#line 390 "Utility/TeeJee.System.vala"
			result = status == 0;
#line 390 "Utility/TeeJee.System.vala"
			_g_free0 (cmd);
#line 390 "Utility/TeeJee.System.vala"
			_g_free0 (path);
#line 390 "Utility/TeeJee.System.vala"
			return result;
#line 1909 "TeeJee.System.c"
		}
	}
#line 394 "Utility/TeeJee.System.vala"
	_tmp9_ = g_strdup ("nemo");
#line 394 "Utility/TeeJee.System.vala"
	_tmp10_ = g_strdup ("nautilus");
#line 394 "Utility/TeeJee.System.vala"
	_tmp11_ = g_strdup ("thunar");
#line 394 "Utility/TeeJee.System.vala"
	_tmp12_ = g_strdup ("pantheon-files");
#line 394 "Utility/TeeJee.System.vala"
	_tmp13_ = g_strdup ("marlin");
#line 394 "Utility/TeeJee.System.vala"
	_tmp14_ = g_new0 (gchar*, 5 + 1);
#line 394 "Utility/TeeJee.System.vala"
	_tmp14_[0] = _tmp9_;
#line 394 "Utility/TeeJee.System.vala"
	_tmp14_[1] = _tmp10_;
#line 394 "Utility/TeeJee.System.vala"
	_tmp14_[2] = _tmp11_;
#line 394 "Utility/TeeJee.System.vala"
	_tmp14_[3] = _tmp12_;
#line 394 "Utility/TeeJee.System.vala"
	_tmp14_[4] = _tmp13_;
#line 1934 "TeeJee.System.c"
	{
		gchar** app_name_collection = NULL;
		gint app_name_collection_length1 = 0;
		gint _app_name_collection_size_ = 0;
		gint app_name_it = 0;
#line 394 "Utility/TeeJee.System.vala"
		app_name_collection = _tmp14_;
#line 394 "Utility/TeeJee.System.vala"
		app_name_collection_length1 = 5;
#line 394 "Utility/TeeJee.System.vala"
		for (app_name_it = 0; app_name_it < 5; app_name_it = app_name_it + 1) {
#line 1946 "TeeJee.System.c"
			gchar* _tmp15_;
			gchar* app_name = NULL;
#line 394 "Utility/TeeJee.System.vala"
			_tmp15_ = g_strdup (app_name_collection[app_name_it]);
#line 394 "Utility/TeeJee.System.vala"
			app_name = _tmp15_;
#line 1953 "TeeJee.System.c"
			{
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gboolean _tmp18_ = FALSE;
				const gchar* _tmp19_;
#line 397 "Utility/TeeJee.System.vala"
				_tmp16_ = app_name;
#line 397 "Utility/TeeJee.System.vala"
				_tmp17_ = tee_jee_process_helper_get_cmd_path (_tmp16_);
#line 397 "Utility/TeeJee.System.vala"
				_g_free0 (path);
#line 397 "Utility/TeeJee.System.vala"
				path = _tmp17_;
#line 398 "Utility/TeeJee.System.vala"
				_tmp19_ = path;
#line 398 "Utility/TeeJee.System.vala"
				if (_tmp19_ != NULL) {
#line 1971 "TeeJee.System.c"
					const gchar* _tmp20_;
#line 398 "Utility/TeeJee.System.vala"
					_tmp20_ = path;
#line 398 "Utility/TeeJee.System.vala"
					_tmp18_ = g_strcmp0 (_tmp20_, "") != 0;
#line 1977 "TeeJee.System.c"
				} else {
#line 398 "Utility/TeeJee.System.vala"
					_tmp18_ = FALSE;
#line 1981 "TeeJee.System.c"
				}
#line 398 "Utility/TeeJee.System.vala"
				if (_tmp18_) {
#line 1985 "TeeJee.System.c"
					gchar* cmd = NULL;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					const gchar* _tmp26_;
#line 399 "Utility/TeeJee.System.vala"
					_tmp21_ = app_name;
#line 399 "Utility/TeeJee.System.vala"
					_tmp22_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 399 "Utility/TeeJee.System.vala"
					_tmp23_ = _tmp22_;
#line 399 "Utility/TeeJee.System.vala"
					_tmp24_ = g_strdup_printf ("%s '%s'", _tmp21_, _tmp23_);
#line 399 "Utility/TeeJee.System.vala"
					_tmp25_ = _tmp24_;
#line 399 "Utility/TeeJee.System.vala"
					_g_free0 (_tmp23_);
#line 399 "Utility/TeeJee.System.vala"
					cmd = _tmp25_;
#line 400 "Utility/TeeJee.System.vala"
					_tmp26_ = cmd;
#line 400 "Utility/TeeJee.System.vala"
					status = tee_jee_process_helper_exec_script_async (_tmp26_);
#line 401 "Utility/TeeJee.System.vala"
					result = status == 0;
#line 401 "Utility/TeeJee.System.vala"
					_g_free0 (cmd);
#line 401 "Utility/TeeJee.System.vala"
					_g_free0 (app_name);
#line 401 "Utility/TeeJee.System.vala"
					app_name_collection = (_vala_array_free (app_name_collection, app_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 401 "Utility/TeeJee.System.vala"
					_g_free0 (path);
#line 401 "Utility/TeeJee.System.vala"
					return result;
#line 2023 "TeeJee.System.c"
				}
#line 394 "Utility/TeeJee.System.vala"
				_g_free0 (app_name);
#line 2027 "TeeJee.System.c"
			}
		}
#line 394 "Utility/TeeJee.System.vala"
		app_name_collection = (_vala_array_free (app_name_collection, app_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2032 "TeeJee.System.c"
	}
#line 405 "Utility/TeeJee.System.vala"
	if (xdg_open_try_first == FALSE) {
#line 2036 "TeeJee.System.c"
		gchar* _tmp27_;
		gboolean _tmp28_ = FALSE;
		const gchar* _tmp29_;
#line 407 "Utility/TeeJee.System.vala"
		_tmp27_ = tee_jee_process_helper_get_cmd_path ("xdg-open");
#line 407 "Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 407 "Utility/TeeJee.System.vala"
		path = _tmp27_;
#line 408 "Utility/TeeJee.System.vala"
		_tmp29_ = path;
#line 408 "Utility/TeeJee.System.vala"
		if (_tmp29_ != NULL) {
#line 2050 "TeeJee.System.c"
			const gchar* _tmp30_;
#line 408 "Utility/TeeJee.System.vala"
			_tmp30_ = path;
#line 408 "Utility/TeeJee.System.vala"
			_tmp28_ = g_strcmp0 (_tmp30_, "") != 0;
#line 2056 "TeeJee.System.c"
		} else {
#line 408 "Utility/TeeJee.System.vala"
			_tmp28_ = FALSE;
#line 2060 "TeeJee.System.c"
		}
#line 408 "Utility/TeeJee.System.vala"
		if (_tmp28_) {
#line 2064 "TeeJee.System.c"
			gchar* cmd = NULL;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			const gchar* _tmp35_;
#line 409 "Utility/TeeJee.System.vala"
			_tmp31_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 409 "Utility/TeeJee.System.vala"
			_tmp32_ = _tmp31_;
#line 409 "Utility/TeeJee.System.vala"
			_tmp33_ = g_strdup_printf ("xdg-open '%s'", _tmp32_);
#line 409 "Utility/TeeJee.System.vala"
			_tmp34_ = _tmp33_;
#line 409 "Utility/TeeJee.System.vala"
			_g_free0 (_tmp32_);
#line 409 "Utility/TeeJee.System.vala"
			cmd = _tmp34_;
#line 410 "Utility/TeeJee.System.vala"
			_tmp35_ = cmd;
#line 410 "Utility/TeeJee.System.vala"
			status = tee_jee_process_helper_exec_script_async (_tmp35_);
#line 411 "Utility/TeeJee.System.vala"
			result = status == 0;
#line 411 "Utility/TeeJee.System.vala"
			_g_free0 (cmd);
#line 411 "Utility/TeeJee.System.vala"
			_g_free0 (path);
#line 411 "Utility/TeeJee.System.vala"
			return result;
#line 2095 "TeeJee.System.c"
		}
	}
#line 415 "Utility/TeeJee.System.vala"
	result = FALSE;
#line 415 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 415 "Utility/TeeJee.System.vala"
	return result;
#line 2104 "TeeJee.System.c"
}

gboolean
tee_jee_system_exo_open_textfile (const gchar* txt_file)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gint status = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
#line 418 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (txt_file != NULL, FALSE);
#line 426 "Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path ("exo-open");
#line 426 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 426 "Utility/TeeJee.System.vala"
	path = _tmp0_;
#line 427 "Utility/TeeJee.System.vala"
	_tmp2_ = path;
#line 427 "Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 2132 "TeeJee.System.c"
		const gchar* _tmp3_;
#line 427 "Utility/TeeJee.System.vala"
		_tmp3_ = path;
#line 427 "Utility/TeeJee.System.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 2138 "TeeJee.System.c"
	} else {
#line 427 "Utility/TeeJee.System.vala"
		_tmp1_ = FALSE;
#line 2142 "TeeJee.System.c"
	}
#line 427 "Utility/TeeJee.System.vala"
	if (_tmp1_) {
#line 2146 "TeeJee.System.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 428 "Utility/TeeJee.System.vala"
		_tmp4_ = tee_jee_file_system_escape_single_quote (txt_file);
#line 428 "Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 428 "Utility/TeeJee.System.vala"
		_tmp6_ = g_strdup_printf ("exo-open '%s'", _tmp5_);
#line 428 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 428 "Utility/TeeJee.System.vala"
		cmd = _tmp6_;
#line 428 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp5_);
#line 429 "Utility/TeeJee.System.vala"
		_tmp7_ = cmd;
#line 429 "Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp7_);
#line 430 "Utility/TeeJee.System.vala"
		result = status == 0;
#line 430 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 430 "Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 430 "Utility/TeeJee.System.vala"
		return result;
#line 2175 "TeeJee.System.c"
	}
#line 433 "Utility/TeeJee.System.vala"
	_tmp8_ = tee_jee_process_helper_get_cmd_path ("gedit");
#line 433 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 433 "Utility/TeeJee.System.vala"
	path = _tmp8_;
#line 434 "Utility/TeeJee.System.vala"
	_tmp10_ = path;
#line 434 "Utility/TeeJee.System.vala"
	if (_tmp10_ != NULL) {
#line 2187 "TeeJee.System.c"
		const gchar* _tmp11_;
#line 434 "Utility/TeeJee.System.vala"
		_tmp11_ = path;
#line 434 "Utility/TeeJee.System.vala"
		_tmp9_ = g_strcmp0 (_tmp11_, "") != 0;
#line 2193 "TeeJee.System.c"
	} else {
#line 434 "Utility/TeeJee.System.vala"
		_tmp9_ = FALSE;
#line 2197 "TeeJee.System.c"
	}
#line 434 "Utility/TeeJee.System.vala"
	if (_tmp9_) {
#line 2201 "TeeJee.System.c"
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 435 "Utility/TeeJee.System.vala"
		_tmp12_ = tee_jee_file_system_escape_single_quote (txt_file);
#line 435 "Utility/TeeJee.System.vala"
		_tmp13_ = _tmp12_;
#line 435 "Utility/TeeJee.System.vala"
		_tmp14_ = g_strdup_printf ("gedit --new-document '%s'", _tmp13_);
#line 435 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 435 "Utility/TeeJee.System.vala"
		cmd = _tmp14_;
#line 435 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp13_);
#line 436 "Utility/TeeJee.System.vala"
		_tmp15_ = cmd;
#line 436 "Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp15_);
#line 437 "Utility/TeeJee.System.vala"
		result = status == 0;
#line 437 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 437 "Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 437 "Utility/TeeJee.System.vala"
		return result;
#line 2230 "TeeJee.System.c"
	}
#line 440 "Utility/TeeJee.System.vala"
	result = FALSE;
#line 440 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 440 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 440 "Utility/TeeJee.System.vala"
	return result;
#line 2240 "TeeJee.System.c"
}

gboolean
tee_jee_system_exo_open_url (const gchar* url)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gint status = 0;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	gchar* _tmp16_;
	gboolean _tmp17_ = FALSE;
	const gchar* _tmp18_;
#line 443 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (url != NULL, FALSE);
#line 451 "Utility/TeeJee.System.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path ("exo-open");
#line 451 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 451 "Utility/TeeJee.System.vala"
	path = _tmp0_;
#line 452 "Utility/TeeJee.System.vala"
	_tmp2_ = path;
#line 452 "Utility/TeeJee.System.vala"
	if (_tmp2_ != NULL) {
#line 2270 "TeeJee.System.c"
		const gchar* _tmp3_;
#line 452 "Utility/TeeJee.System.vala"
		_tmp3_ = path;
#line 452 "Utility/TeeJee.System.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 2276 "TeeJee.System.c"
	} else {
#line 452 "Utility/TeeJee.System.vala"
		_tmp1_ = FALSE;
#line 2280 "TeeJee.System.c"
	}
#line 452 "Utility/TeeJee.System.vala"
	if (_tmp1_) {
#line 2284 "TeeJee.System.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 453 "Utility/TeeJee.System.vala"
		_tmp4_ = g_strconcat ("exo-open \"", url, NULL);
#line 453 "Utility/TeeJee.System.vala"
		_tmp5_ = _tmp4_;
#line 453 "Utility/TeeJee.System.vala"
		_tmp6_ = g_strconcat (_tmp5_, "\"", NULL);
#line 453 "Utility/TeeJee.System.vala"
		_tmp7_ = _tmp6_;
#line 453 "Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp7_);
#line 453 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp7_);
#line 453 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp5_);
#line 454 "Utility/TeeJee.System.vala"
		result = status == 0;
#line 454 "Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 454 "Utility/TeeJee.System.vala"
		return result;
#line 2309 "TeeJee.System.c"
	}
#line 457 "Utility/TeeJee.System.vala"
	_tmp8_ = tee_jee_process_helper_get_cmd_path ("firefox");
#line 457 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 457 "Utility/TeeJee.System.vala"
	path = _tmp8_;
#line 458 "Utility/TeeJee.System.vala"
	_tmp10_ = path;
#line 458 "Utility/TeeJee.System.vala"
	if (_tmp10_ != NULL) {
#line 2321 "TeeJee.System.c"
		const gchar* _tmp11_;
#line 458 "Utility/TeeJee.System.vala"
		_tmp11_ = path;
#line 458 "Utility/TeeJee.System.vala"
		_tmp9_ = g_strcmp0 (_tmp11_, "") != 0;
#line 2327 "TeeJee.System.c"
	} else {
#line 458 "Utility/TeeJee.System.vala"
		_tmp9_ = FALSE;
#line 2331 "TeeJee.System.c"
	}
#line 458 "Utility/TeeJee.System.vala"
	if (_tmp9_) {
#line 2335 "TeeJee.System.c"
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 459 "Utility/TeeJee.System.vala"
		_tmp12_ = g_strconcat ("firefox \"", url, NULL);
#line 459 "Utility/TeeJee.System.vala"
		_tmp13_ = _tmp12_;
#line 459 "Utility/TeeJee.System.vala"
		_tmp14_ = g_strconcat (_tmp13_, "\"", NULL);
#line 459 "Utility/TeeJee.System.vala"
		_tmp15_ = _tmp14_;
#line 459 "Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp15_);
#line 459 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp15_);
#line 459 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp13_);
#line 460 "Utility/TeeJee.System.vala"
		result = status == 0;
#line 460 "Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 460 "Utility/TeeJee.System.vala"
		return result;
#line 2360 "TeeJee.System.c"
	}
#line 463 "Utility/TeeJee.System.vala"
	_tmp16_ = tee_jee_process_helper_get_cmd_path ("chromium-browser");
#line 463 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 463 "Utility/TeeJee.System.vala"
	path = _tmp16_;
#line 464 "Utility/TeeJee.System.vala"
	_tmp18_ = path;
#line 464 "Utility/TeeJee.System.vala"
	if (_tmp18_ != NULL) {
#line 2372 "TeeJee.System.c"
		const gchar* _tmp19_;
#line 464 "Utility/TeeJee.System.vala"
		_tmp19_ = path;
#line 464 "Utility/TeeJee.System.vala"
		_tmp17_ = g_strcmp0 (_tmp19_, "") != 0;
#line 2378 "TeeJee.System.c"
	} else {
#line 464 "Utility/TeeJee.System.vala"
		_tmp17_ = FALSE;
#line 2382 "TeeJee.System.c"
	}
#line 464 "Utility/TeeJee.System.vala"
	if (_tmp17_) {
#line 2386 "TeeJee.System.c"
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 465 "Utility/TeeJee.System.vala"
		_tmp20_ = g_strconcat ("chromium-browser \"", url, NULL);
#line 465 "Utility/TeeJee.System.vala"
		_tmp21_ = _tmp20_;
#line 465 "Utility/TeeJee.System.vala"
		_tmp22_ = g_strconcat (_tmp21_, "\"", NULL);
#line 465 "Utility/TeeJee.System.vala"
		_tmp23_ = _tmp22_;
#line 465 "Utility/TeeJee.System.vala"
		status = tee_jee_process_helper_exec_script_async (_tmp23_);
#line 465 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp23_);
#line 465 "Utility/TeeJee.System.vala"
		_g_free0 (_tmp21_);
#line 466 "Utility/TeeJee.System.vala"
		result = status == 0;
#line 466 "Utility/TeeJee.System.vala"
		_g_free0 (path);
#line 466 "Utility/TeeJee.System.vala"
		return result;
#line 2411 "TeeJee.System.c"
	}
#line 469 "Utility/TeeJee.System.vala"
	result = FALSE;
#line 469 "Utility/TeeJee.System.vala"
	_g_free0 (path);
#line 469 "Utility/TeeJee.System.vala"
	return result;
#line 2419 "TeeJee.System.c"
}

gboolean
tee_jee_system_using_efi_boot (void)
{
	gboolean result = FALSE;
#line 477 "Utility/TeeJee.System.vala"
	result = tee_jee_file_system_dir_exists ("/sys/firmware/efi");
#line 477 "Utility/TeeJee.System.vala"
	return result;
#line 2430 "TeeJee.System.c"
}

void
tee_jee_system_open_terminal_window (const gchar* terminal_emulator,
                                     const gchar* working_dir,
                                     const gchar* script_file_to_execute,
                                     gboolean run_as_admin)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* term = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GQuark _tmp14_ = 0U;
#line 501 "Utility/TeeJee.System.vala"
	static GQuark _tmp13_label0 = 0;
#line 501 "Utility/TeeJee.System.vala"
	static GQuark _tmp13_label1 = 0;
#line 2454 "TeeJee.System.c"
	const gchar* _tmp31_;
	const gchar* _tmp32_;
#line 480 "Utility/TeeJee.System.vala"
	g_return_if_fail (terminal_emulator != NULL);
#line 480 "Utility/TeeJee.System.vala"
	g_return_if_fail (working_dir != NULL);
#line 480 "Utility/TeeJee.System.vala"
	g_return_if_fail (script_file_to_execute != NULL);
#line 486 "Utility/TeeJee.System.vala"
	_tmp0_ = g_strdup ("");
#line 486 "Utility/TeeJee.System.vala"
	cmd = _tmp0_;
#line 487 "Utility/TeeJee.System.vala"
	if (run_as_admin) {
#line 2469 "TeeJee.System.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 488 "Utility/TeeJee.System.vala"
		_tmp1_ = cmd;
#line 488 "Utility/TeeJee.System.vala"
		_tmp2_ = g_strconcat (_tmp1_, "pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY ", NULL);
#line 488 "Utility/TeeJee.System.vala"
		_g_free0 (cmd);
#line 488 "Utility/TeeJee.System.vala"
		cmd = _tmp2_;
#line 2480 "TeeJee.System.c"
	}
#line 491 "Utility/TeeJee.System.vala"
	_tmp3_ = g_strdup (terminal_emulator);
#line 491 "Utility/TeeJee.System.vala"
	term = _tmp3_;
#line 492 "Utility/TeeJee.System.vala"
	_tmp4_ = term;
#line 492 "Utility/TeeJee.System.vala"
	if (!tee_jee_system_command_exists (_tmp4_)) {
#line 2490 "TeeJee.System.c"
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 493 "Utility/TeeJee.System.vala"
		_tmp5_ = g_strdup ("gnome-terminal");
#line 493 "Utility/TeeJee.System.vala"
		_g_free0 (term);
#line 493 "Utility/TeeJee.System.vala"
		term = _tmp5_;
#line 494 "Utility/TeeJee.System.vala"
		_tmp6_ = term;
#line 494 "Utility/TeeJee.System.vala"
		if (!tee_jee_system_command_exists (_tmp6_)) {
#line 2503 "TeeJee.System.c"
			gchar* _tmp7_;
#line 495 "Utility/TeeJee.System.vala"
			_tmp7_ = g_strdup ("xfce4-terminal");
#line 495 "Utility/TeeJee.System.vala"
			_g_free0 (term);
#line 495 "Utility/TeeJee.System.vala"
			term = _tmp7_;
#line 2511 "TeeJee.System.c"
		}
	}
#line 499 "Utility/TeeJee.System.vala"
	_tmp8_ = cmd;
#line 499 "Utility/TeeJee.System.vala"
	_tmp9_ = term;
#line 499 "Utility/TeeJee.System.vala"
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
#line 499 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 499 "Utility/TeeJee.System.vala"
	cmd = _tmp10_;
#line 501 "Utility/TeeJee.System.vala"
	_tmp11_ = term;
#line 501 "Utility/TeeJee.System.vala"
	_tmp12_ = _tmp11_;
#line 501 "Utility/TeeJee.System.vala"
	_tmp14_ = (NULL == _tmp12_) ? 0 : g_quark_from_string (_tmp12_);
#line 501 "Utility/TeeJee.System.vala"
	if ((_tmp14_ == ((0 != _tmp13_label0) ? _tmp13_label0 : (_tmp13_label0 = g_quark_from_static_string ("gnome-terminal")))) || (_tmp14_ == ((0 != _tmp13_label1) ? _tmp13_label1 : (_tmp13_label1 = g_quark_from_static_string ("xfce4-terminal"))))) {
#line 501 "Utility/TeeJee.System.vala"
		switch (0) {
#line 2534 "TeeJee.System.c"
			default:
			{
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp23_;
				gint _tmp24_;
#line 504 "Utility/TeeJee.System.vala"
				_tmp15_ = strlen (working_dir);
#line 504 "Utility/TeeJee.System.vala"
				_tmp16_ = _tmp15_;
#line 504 "Utility/TeeJee.System.vala"
				if (_tmp16_ > 0) {
#line 2547 "TeeJee.System.c"
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 505 "Utility/TeeJee.System.vala"
					_tmp17_ = cmd;
#line 505 "Utility/TeeJee.System.vala"
					_tmp18_ = tee_jee_file_system_escape_single_quote (working_dir);
#line 505 "Utility/TeeJee.System.vala"
					_tmp19_ = _tmp18_;
#line 505 "Utility/TeeJee.System.vala"
					_tmp20_ = g_strdup_printf (" --working-directory='%s'", _tmp19_);
#line 505 "Utility/TeeJee.System.vala"
					_tmp21_ = _tmp20_;
#line 505 "Utility/TeeJee.System.vala"
					_tmp22_ = g_strconcat (_tmp17_, _tmp21_, NULL);
#line 505 "Utility/TeeJee.System.vala"
					_g_free0 (cmd);
#line 505 "Utility/TeeJee.System.vala"
					cmd = _tmp22_;
#line 505 "Utility/TeeJee.System.vala"
					_g_free0 (_tmp21_);
#line 505 "Utility/TeeJee.System.vala"
					_g_free0 (_tmp19_);
#line 2574 "TeeJee.System.c"
				}
#line 507 "Utility/TeeJee.System.vala"
				_tmp23_ = strlen (script_file_to_execute);
#line 507 "Utility/TeeJee.System.vala"
				_tmp24_ = _tmp23_;
#line 507 "Utility/TeeJee.System.vala"
				if (_tmp24_ > 0) {
#line 2582 "TeeJee.System.c"
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
#line 508 "Utility/TeeJee.System.vala"
					_tmp25_ = cmd;
#line 508 "Utility/TeeJee.System.vala"
					_tmp26_ = tee_jee_file_system_escape_single_quote (script_file_to_execute);
#line 508 "Utility/TeeJee.System.vala"
					_tmp27_ = _tmp26_;
#line 508 "Utility/TeeJee.System.vala"
					_tmp28_ = g_strdup_printf (" -e '%s\n; echo Press ENTER to exit... ; read dummy;'", _tmp27_);
#line 508 "Utility/TeeJee.System.vala"
					_tmp29_ = _tmp28_;
#line 508 "Utility/TeeJee.System.vala"
					_tmp30_ = g_strconcat (_tmp25_, _tmp29_, NULL);
#line 508 "Utility/TeeJee.System.vala"
					_g_free0 (cmd);
#line 508 "Utility/TeeJee.System.vala"
					cmd = _tmp30_;
#line 508 "Utility/TeeJee.System.vala"
					_g_free0 (_tmp29_);
#line 508 "Utility/TeeJee.System.vala"
					_g_free0 (_tmp27_);
#line 2609 "TeeJee.System.c"
				}
#line 510 "Utility/TeeJee.System.vala"
				break;
#line 2613 "TeeJee.System.c"
			}
		}
	}
#line 513 "Utility/TeeJee.System.vala"
	_tmp31_ = cmd;
#line 513 "Utility/TeeJee.System.vala"
	tee_jee_logging_log_debug (_tmp31_);
#line 514 "Utility/TeeJee.System.vala"
	_tmp32_ = cmd;
#line 514 "Utility/TeeJee.System.vala"
	tee_jee_process_helper_exec_script_async (_tmp32_);
#line 480 "Utility/TeeJee.System.vala"
	_g_free0 (term);
#line 480 "Utility/TeeJee.System.vala"
	_g_free0 (cmd);
#line 2629 "TeeJee.System.c"
}

GTimer*
tee_jee_system_timer_start (void)
{
	GTimer* result = NULL;
	GTimer* timer = NULL;
	GTimer* _tmp0_;
#line 520 "Utility/TeeJee.System.vala"
	_tmp0_ = g_timer_new ();
#line 520 "Utility/TeeJee.System.vala"
	timer = _tmp0_;
#line 521 "Utility/TeeJee.System.vala"
	g_timer_start (timer);
#line 522 "Utility/TeeJee.System.vala"
	result = timer;
#line 522 "Utility/TeeJee.System.vala"
	return result;
#line 2648 "TeeJee.System.c"
}

gulong
tee_jee_system_timer_elapsed (GTimer* timer,
                              gboolean stop)
{
	gulong result = 0UL;
	gulong microseconds = 0UL;
	gdouble seconds = 0.0;
	gulong _tmp0_ = 0UL;
	gdouble _tmp1_;
#line 525 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (timer != NULL, 0UL);
#line 528 "Utility/TeeJee.System.vala"
	_tmp1_ = g_timer_elapsed (timer, &_tmp0_);
#line 528 "Utility/TeeJee.System.vala"
	microseconds = _tmp0_;
#line 528 "Utility/TeeJee.System.vala"
	seconds = _tmp1_;
#line 529 "Utility/TeeJee.System.vala"
	if (stop) {
#line 530 "Utility/TeeJee.System.vala"
		g_timer_stop (timer);
#line 2672 "TeeJee.System.c"
	}
#line 532 "Utility/TeeJee.System.vala"
	result = (gulong) ((seconds * 1000) + (microseconds / 1000));
#line 532 "Utility/TeeJee.System.vala"
	return result;
#line 2678 "TeeJee.System.c"
}

void
tee_jee_system_sleep (gint milliseconds)
{
#line 536 "Utility/TeeJee.System.vala"
	g_usleep (((gulong) milliseconds) * 1000);
#line 2686 "TeeJee.System.c"
}

gchar*
tee_jee_system_timer_elapsed_string (GTimer* timer,
                                     gboolean stop)
{
	gchar* result = NULL;
	gulong microseconds = 0UL;
	gdouble seconds = 0.0;
	gulong _tmp0_ = 0UL;
	gdouble _tmp1_;
	gchar* _tmp2_;
#line 539 "Utility/TeeJee.System.vala"
	g_return_val_if_fail (timer != NULL, NULL);
#line 542 "Utility/TeeJee.System.vala"
	_tmp1_ = g_timer_elapsed (timer, &_tmp0_);
#line 542 "Utility/TeeJee.System.vala"
	microseconds = _tmp0_;
#line 542 "Utility/TeeJee.System.vala"
	seconds = _tmp1_;
#line 543 "Utility/TeeJee.System.vala"
	if (stop) {
#line 544 "Utility/TeeJee.System.vala"
		g_timer_stop (timer);
#line 2711 "TeeJee.System.c"
	}
#line 546 "Utility/TeeJee.System.vala"
	_tmp2_ = g_strdup_printf ("%.0f ms", (seconds * 1000) + (microseconds / 1000));
#line 546 "Utility/TeeJee.System.vala"
	result = _tmp2_;
#line 546 "Utility/TeeJee.System.vala"
	return result;
#line 2719 "TeeJee.System.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 938 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 938 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 938 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 938 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 938 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 938 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 938 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 938 "glib-2.0.vapi"
	result = _tmp4_;
#line 938 "glib-2.0.vapi"
	return result;
#line 2750 "TeeJee.System.c"
}

void
tee_jee_system_timer_elapsed_print (GTimer* timer,
                                    gboolean stop)
{
	gulong microseconds = 0UL;
	gdouble seconds = 0.0;
	gulong _tmp0_ = 0UL;
	gdouble _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 549 "Utility/TeeJee.System.vala"
	g_return_if_fail (timer != NULL);
#line 552 "Utility/TeeJee.System.vala"
	_tmp1_ = g_timer_elapsed (timer, &_tmp0_);
#line 552 "Utility/TeeJee.System.vala"
	microseconds = _tmp0_;
#line 552 "Utility/TeeJee.System.vala"
	seconds = _tmp1_;
#line 553 "Utility/TeeJee.System.vala"
	if (stop) {
#line 554 "Utility/TeeJee.System.vala"
		g_timer_stop (timer);
#line 2777 "TeeJee.System.c"
	}
#line 556 "Utility/TeeJee.System.vala"
	_tmp2_ = double_to_string (seconds);
#line 556 "Utility/TeeJee.System.vala"
	_tmp3_ = _tmp2_;
#line 556 "Utility/TeeJee.System.vala"
	_tmp4_ = g_strdup_printf ("%s %lu\n", _tmp3_, microseconds);
#line 556 "Utility/TeeJee.System.vala"
	_tmp5_ = _tmp4_;
#line 556 "Utility/TeeJee.System.vala"
	tee_jee_logging_log_msg (_tmp5_, FALSE);
#line 556 "Utility/TeeJee.System.vala"
	_g_free0 (_tmp5_);
#line 556 "Utility/TeeJee.System.vala"
	_g_free0 (_tmp3_);
#line 2793 "TeeJee.System.c"
}

void
tee_jee_system_set_numeric_locale (const gchar* type)
{
#line 560 "Utility/TeeJee.System.vala"
	g_return_if_fail (type != NULL);
#line 561 "Utility/TeeJee.System.vala"
	setlocale (LC_NUMERIC, type);
#line 562 "Utility/TeeJee.System.vala"
	setlocale (LC_COLLATE, type);
#line 563 "Utility/TeeJee.System.vala"
	setlocale (LC_TIME, type);
#line 2807 "TeeJee.System.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

