/* RsyncTask.c generated by valac 0.43.91, the Vala compiler
 * generated from RsyncTask.vala, do not modify */

/*
 * RsyncTask.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;
typedef struct _AsyncTaskPrivate AsyncTaskPrivate;
typedef enum  {
	APP_STATUS_NOT_STARTED,
	APP_STATUS_RUNNING,
	APP_STATUS_PAUSED,
	APP_STATUS_FINISHED,
	APP_STATUS_CANCELLED,
	APP_STATUS_PASSWORD_REQUIRED
} AppStatus;

#define TYPE_APP_STATUS (app_status_get_type ())

#define TYPE_RSYNC_TASK (rsync_task_get_type ())
#define RSYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RSYNC_TASK, RsyncTask))
#define RSYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RSYNC_TASK, RsyncTaskClass))
#define IS_RSYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RSYNC_TASK))
#define IS_RSYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RSYNC_TASK))
#define RSYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RSYNC_TASK, RsyncTaskClass))

typedef struct _RsyncTask RsyncTask;
typedef struct _RsyncTaskClass RsyncTaskClass;
typedef struct _RsyncTaskPrivate RsyncTaskPrivate;
enum  {
	RSYNC_TASK_0_PROPERTY,
	RSYNC_TASK_NUM_PROPERTIES
};
static GParamSpec* rsync_task_properties[RSYNC_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_FILE_ITEM (file_item_get_type ())
#define FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_ITEM, FileItem))
#define FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_ITEM, FileItemClass))
#define IS_FILE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_ITEM))
#define IS_FILE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_ITEM))
#define FILE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_ITEM, FileItemClass))

typedef struct _FileItem FileItem;
typedef struct _FileItemClass FileItemClass;
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
typedef struct _FileItemPrivate FileItemPrivate;

struct _AsyncTask {
	GObject parent_instance;
	AsyncTaskPrivate * priv;
	GDataOutputStream* dos_log;
	gboolean is_terminated;
	GPid child_pid;
	gchar* script_file;
	gchar* working_dir;
	gchar* log_file;
	gboolean background_mode;
	AppStatus status;
	gchar* status_line;
	gint exit_code;
	gchar* error_msg;
	GTimer* timer;
	gdouble progress;
	gdouble percent;
	gint64 prg_count;
	gint64 prg_count_total;
	gint64 prg_bytes;
	gint64 prg_bytes_total;
	gchar* eta;
};

struct _AsyncTaskClass {
	GObjectClass parent_class;
	void (*parse_stdout_line) (AsyncTask* self, const gchar* out_line);
	void (*parse_stderr_line) (AsyncTask* self, const gchar* err_line);
	void (*finish_task) (AsyncTask* self);
};

struct _RsyncTask {
	AsyncTask parent_instance;
	RsyncTaskPrivate * priv;
	gboolean delete_extra;
	gboolean delete_after;
	gboolean delete_excluded;
	gboolean relative;
	gchar* rsync_log_file;
	gchar* exclude_from_file;
	gchar* link_from_path;
	gchar* source_path;
	gchar* dest_path;
	gboolean verbose;
	gboolean io_nice;
	gboolean dry_run;
	GQueue* status_lines;
	gint64 status_line_count;
	gint64 total_size;
	gint64 count_created;
	gint64 count_deleted;
	gint64 count_modified;
	gint64 count_checksum;
	gint64 count_size;
	gint64 count_timestamp;
	gint64 count_permissions;
	gint64 count_owner;
	gint64 count_group;
	gint64 count_unchanged;
	GString* log;
};

struct _RsyncTaskClass {
	AsyncTaskClass parent_class;
};

struct _RsyncTaskPrivate {
	GeeHashMap* regex_list;
};

struct _FileItem {
	GObject parent_instance;
	FileItemPrivate * priv;
	gchar* file_name;
	gchar* file_location;
	gchar* file_path;
	gchar* file_path_prefix;
	GFileType file_type;
	GDateTime* modified;
	gchar* permissions;
	gchar* owner_user;
	gchar* owner_group;
	gchar* content_type;
	gchar* file_status;
	gboolean is_selected;
	gboolean is_symlink;
	gchar* symlink_target;
	gboolean is_archive;
	gboolean is_stale;
	FileItem* parent;
	GeeHashMap* children;
	FileItem* source_archive;
	GObject* tag;
	glong file_count;
	glong dir_count;
	glong file_count_total;
	glong dir_count_total;
	GIcon* icon;
	gboolean is_dummy;
};

struct _FileItemClass {
	GObjectClass parent_class;
};

static gint RsyncTask_private_offset;
static gpointer rsync_task_parent_class = NULL;

GType async_task_get_type (void) G_GNUC_CONST;
GType app_status_get_type (void) G_GNUC_CONST;
GType rsync_task_get_type (void) G_GNUC_CONST;
static void _g_free0_ (gpointer var);
static inline void _g_queue_free__g_free0_ (GQueue* self);
RsyncTask* rsync_task_new (void);
RsyncTask* rsync_task_construct (GType object_type);
AsyncTask* async_task_construct (GType object_type);
static void rsync_task_init_regular_expressions (RsyncTask* self);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
void rsync_task_prepare (RsyncTask* self);
static gchar* rsync_task_build_script (RsyncTask* self);
void tee_jee_logging_log_debug (const gchar* message);
gchar* tee_jee_process_helper_save_bash_script_temp (const gchar* commands,
                                                     const gchar* script_path,
                                                     gboolean force_locale,
                                                     gboolean supress_errors);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* tee_jee_file_system_remove_trailing_slash (const gchar* path);
GType file_item_get_type (void) G_GNUC_CONST;
GeeArrayList* rsync_task_parse_log (RsyncTask* self,
                                    const gchar* log_file_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gint64 tee_jee_file_system_file_line_count (const gchar* file_path);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
FileItem* file_item_new_from_disk_path_with_basic_info (const gchar* _file_path);
FileItem* file_item_construct_from_disk_path_with_basic_info (GType object_type,
                                                              const gchar* _file_path);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean tee_jee_file_system_file_gzip (const gchar* src_file);
void rsync_task_execute (RsyncTask* self);
gboolean async_task_begin (AsyncTask* self);
static void rsync_task_real_parse_stdout_line (AsyncTask* base,
                                        const gchar* out_line);
gboolean rsync_task_update_progress_parse_console_output (RsyncTask* self,
                                                          const gchar* line);
static void rsync_task_real_parse_stderr_line (AsyncTask* base,
                                        const gchar* err_line);
static void rsync_task_real_finish_task (AsyncTask* base);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
gint rsync_task_read_status (RsyncTask* self);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
static void rsync_task_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
rsync_task_get_instance_private (RsyncTask* self)
{
	return G_STRUCT_MEMBER_P (self, RsyncTask_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 52 "Utility/RsyncTask.vala"
	var = (g_free (var), NULL);
#line 268 "RsyncTask.c"
}

static inline void
_g_queue_free__g_free0_ (GQueue* self)
{
#line 52 "Utility/RsyncTask.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_free0_);
#line 276 "RsyncTask.c"
}

RsyncTask*
rsync_task_construct (GType object_type)
{
	RsyncTask * self = NULL;
	GQueue* _tmp0_;
#line 69 "Utility/RsyncTask.vala"
	self = (RsyncTask*) async_task_construct (object_type);
#line 70 "Utility/RsyncTask.vala"
	rsync_task_init_regular_expressions (self);
#line 71 "Utility/RsyncTask.vala"
	_tmp0_ = g_queue_new ();
#line 71 "Utility/RsyncTask.vala"
	(self->status_lines == NULL) ? NULL : (self->status_lines = (_g_queue_free__g_free0_ (self->status_lines), NULL));
#line 71 "Utility/RsyncTask.vala"
	self->status_lines = _tmp0_;
#line 69 "Utility/RsyncTask.vala"
	return self;
#line 296 "RsyncTask.c"
}

RsyncTask*
rsync_task_new (void)
{
#line 69 "Utility/RsyncTask.vala"
	return rsync_task_construct (TYPE_RSYNC_TASK);
#line 304 "RsyncTask.c"
}

static void
rsync_task_init_regular_expressions (RsyncTask* self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 74 "Utility/RsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 75 "Utility/RsyncTask.vala"
	_tmp0_ = self->priv->regex_list;
#line 75 "Utility/RsyncTask.vala"
	if (_tmp0_ != NULL) {
#line 76 "Utility/RsyncTask.vala"
		return;
#line 321 "RsyncTask.c"
	}
#line 79 "Utility/RsyncTask.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_REGEX, (GBoxedCopyFunc) g_regex_ref, (GDestroyNotify) g_regex_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 79 "Utility/RsyncTask.vala"
	_g_object_unref0 (self->priv->regex_list);
#line 79 "Utility/RsyncTask.vala"
	self->priv->regex_list = _tmp1_;
#line 329 "RsyncTask.c"
	{
		GRegex* _tmp2_ = NULL;
		GRegex* _tmp3_;
		GeeHashMap* _tmp4_;
		GRegex* _tmp5_ = NULL;
		GRegex* _tmp6_;
		GeeHashMap* _tmp7_;
		GRegex* _tmp8_ = NULL;
		GRegex* _tmp9_;
		GeeHashMap* _tmp10_;
		GRegex* _tmp11_ = NULL;
		GRegex* _tmp12_;
		GeeHashMap* _tmp13_;
		GRegex* _tmp14_ = NULL;
		GRegex* _tmp15_;
		GeeHashMap* _tmp16_;
		GRegex* _tmp17_ = NULL;
		GRegex* _tmp18_;
		GeeHashMap* _tmp19_;
		GRegex* _tmp20_ = NULL;
		GRegex* _tmp21_;
		GeeHashMap* _tmp22_;
		GRegex* _tmp23_ = NULL;
		GRegex* _tmp24_;
		GeeHashMap* _tmp25_;
		GRegex* _tmp26_ = NULL;
		GRegex* _tmp27_;
		GeeHashMap* _tmp28_;
		GRegex* _tmp29_ = NULL;
		GRegex* _tmp30_;
		GeeHashMap* _tmp31_;
#line 113 "Utility/RsyncTask.vala"
		_tmp3_ = g_regex_new ("([<>ch.*])([.fdLDS])(c|\\+|\\.| )(s|\\+|\\.| )(t|\\+|\\.| )(p|\\+|\\.|" \
" )(o|\\+|\\.| )(g|\\+|\\.| )(u|\\+|\\.| )(a|\\+|\\.| )(x|\\+|\\.| ) (." \
"*)", 0, 0, &_inner_error0_);
#line 113 "Utility/RsyncTask.vala"
		_tmp2_ = _tmp3_;
#line 113 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 367 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 113 "Utility/RsyncTask.vala"
		_tmp4_ = self->priv->regex_list;
#line 113 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, "status", _tmp2_);
#line 116 "Utility/RsyncTask.vala"
		_tmp6_ = g_regex_new ("([<>ch.*])([.fdLDS])[+]{9} (.*)", 0, 0, &_inner_error0_);
#line 116 "Utility/RsyncTask.vala"
		_tmp5_ = _tmp6_;
#line 116 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 382 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 116 "Utility/RsyncTask.vala"
		_tmp7_ = self->priv->regex_list;
#line 116 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, "created", _tmp5_);
#line 119 "Utility/RsyncTask.vala"
		_tmp9_ = g_regex_new ("[0-9\\/]+ [0-9:.]+ \\[[0-9]+\\] ([<>ch.*])([.fdLDS])[+]{9} (.*)", 0, 0, &_inner_error0_);
#line 119 "Utility/RsyncTask.vala"
		_tmp8_ = _tmp9_;
#line 119 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 119 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 399 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 119 "Utility/RsyncTask.vala"
		_tmp10_ = self->priv->regex_list;
#line 119 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, "log-created", _tmp8_);
#line 122 "Utility/RsyncTask.vala"
		_tmp12_ = g_regex_new ("\\*deleting[ \\t]+(.*)", 0, 0, &_inner_error0_);
#line 122 "Utility/RsyncTask.vala"
		_tmp11_ = _tmp12_;
#line 122 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 122 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 122 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 418 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 122 "Utility/RsyncTask.vala"
		_tmp13_ = self->priv->regex_list;
#line 122 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, "deleted", _tmp11_);
#line 125 "Utility/RsyncTask.vala"
		_tmp15_ = g_regex_new ("[0-9\\/]+ [0-9:.]+ \\[[0-9]+\\] \\*deleting[ \\t]+(.*)", 0, 0, &_inner_error0_);
#line 125 "Utility/RsyncTask.vala"
		_tmp14_ = _tmp15_;
#line 125 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 125 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 125 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 125 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 439 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 125 "Utility/RsyncTask.vala"
		_tmp16_ = self->priv->regex_list;
#line 125 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, "log-deleted", _tmp14_);
#line 128 "Utility/RsyncTask.vala"
		_tmp18_ = g_regex_new ("([<>ch.])([.fdLDS])(c|\\+|\\.| )(s|\\+|\\.| )(t|\\+|\\.| )(p|\\+|\\.| " \
")(o|\\+|\\.| )(g|\\+|\\.| )(u|\\+|\\.| )(a|\\+|\\.| )(x|\\+|\\.) (.*)", 0, 0, &_inner_error0_);
#line 128 "Utility/RsyncTask.vala"
		_tmp17_ = _tmp18_;
#line 128 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 128 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 128 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 128 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 128 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 462 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 128 "Utility/RsyncTask.vala"
		_tmp19_ = self->priv->regex_list;
#line 128 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, "modified", _tmp17_);
#line 131 "Utility/RsyncTask.vala"
		_tmp21_ = g_regex_new ("[0-9\\/]+ [0-9:.]+ \\[[0-9]+\\] ([<>ch.])([.fdLDS])(c|\\+|\\.| )(s|\\+" \
"|\\.| )(t|\\+|\\.| )(p|\\+|\\.| )(o|\\+|\\.| )(g|\\+|\\.| )(u|\\+|\\.|" \
" )(a|\\+|\\.| )(x|\\+|\\.) (.*)", 0, 0, &_inner_error0_);
#line 131 "Utility/RsyncTask.vala"
		_tmp20_ = _tmp21_;
#line 131 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp17_);
#line 131 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 131 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 131 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 131 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 131 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 487 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 131 "Utility/RsyncTask.vala"
		_tmp22_ = self->priv->regex_list;
#line 131 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, "log-modified", _tmp20_);
#line 134 "Utility/RsyncTask.vala"
		_tmp24_ = g_regex_new ("([.h])([.fdLDS])[ ]{9} (.*)", 0, 0, &_inner_error0_);
#line 134 "Utility/RsyncTask.vala"
		_tmp23_ = _tmp24_;
#line 134 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp20_);
#line 134 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp17_);
#line 134 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 134 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 134 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 134 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 134 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 514 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 134 "Utility/RsyncTask.vala"
		_tmp25_ = self->priv->regex_list;
#line 134 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, "unchanged", _tmp23_);
#line 137 "Utility/RsyncTask.vala"
		_tmp27_ = g_regex_new ("[0-9\\/]+ [0-9:.]+ \\[[0-9]+\\] ([.h])([.fdLDS])[ ]{9} (.*)", 0, 0, &_inner_error0_);
#line 137 "Utility/RsyncTask.vala"
		_tmp26_ = _tmp27_;
#line 137 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 137 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp23_);
#line 137 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp20_);
#line 137 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp17_);
#line 137 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 137 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 137 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 137 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 137 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 543 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 137 "Utility/RsyncTask.vala"
		_tmp28_ = self->priv->regex_list;
#line 137 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, "log-unchanged", _tmp26_);
#line 140 "Utility/RsyncTask.vala"
		_tmp30_ = g_regex_new ("total size is ([0-9,]+)[ \\t]+speedup is [0-9.]+", 0, 0, &_inner_error0_);
#line 140 "Utility/RsyncTask.vala"
		_tmp29_ = _tmp30_;
#line 140 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp26_);
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp23_);
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp20_);
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp17_);
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp14_);
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp11_);
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp8_);
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp5_);
#line 140 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp2_);
#line 574 "RsyncTask.c"
			goto __catch60_g_error;
		}
#line 140 "Utility/RsyncTask.vala"
		_tmp31_ = self->priv->regex_list;
#line 140 "Utility/RsyncTask.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp31_, "total-size", _tmp29_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp29_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp26_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp23_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp20_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp17_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp14_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp11_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp8_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp5_);
#line 111 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp2_);
#line 601 "RsyncTask.c"
	}
	goto __finally60;
	__catch60_g_error:
	{
		GError* e = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
#line 111 "Utility/RsyncTask.vala"
		e = _inner_error0_;
#line 111 "Utility/RsyncTask.vala"
		_inner_error0_ = NULL;
#line 145 "Utility/RsyncTask.vala"
		_tmp32_ = e;
#line 145 "Utility/RsyncTask.vala"
		_tmp33_ = _tmp32_->message;
#line 145 "Utility/RsyncTask.vala"
		tee_jee_logging_log_error (_tmp33_, FALSE, FALSE);
#line 111 "Utility/RsyncTask.vala"
		_g_error_free0 (e);
#line 621 "RsyncTask.c"
	}
	__finally60:
#line 111 "Utility/RsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "Utility/RsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "Utility/RsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 111 "Utility/RsyncTask.vala"
		return;
#line 632 "RsyncTask.c"
	}
}

void
rsync_task_prepare (RsyncTask* self)
{
	gchar* script_text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GString* _tmp7_;
#line 149 "Utility/RsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 150 "Utility/RsyncTask.vala"
	_tmp0_ = rsync_task_build_script (self);
#line 150 "Utility/RsyncTask.vala"
	script_text = _tmp0_;
#line 152 "Utility/RsyncTask.vala"
	tee_jee_logging_log_debug (script_text);
#line 154 "Utility/RsyncTask.vala"
	_tmp1_ = ((AsyncTask*) self)->script_file;
#line 154 "Utility/RsyncTask.vala"
	_tmp2_ = tee_jee_process_helper_save_bash_script_temp (script_text, _tmp1_, TRUE, FALSE);
#line 154 "Utility/RsyncTask.vala"
	_tmp3_ = _tmp2_;
#line 154 "Utility/RsyncTask.vala"
	_g_free0 (_tmp3_);
#line 155 "Utility/RsyncTask.vala"
	_tmp4_ = ((AsyncTask*) self)->script_file;
#line 155 "Utility/RsyncTask.vala"
	_tmp5_ = g_strdup_printf ("RsyncTask:prepare(): saved: %s", _tmp4_);
#line 155 "Utility/RsyncTask.vala"
	_tmp6_ = _tmp5_;
#line 155 "Utility/RsyncTask.vala"
	tee_jee_logging_log_debug (_tmp6_);
#line 155 "Utility/RsyncTask.vala"
	_g_free0 (_tmp6_);
#line 158 "Utility/RsyncTask.vala"
	self->status_line_count = (gint64) 0;
#line 159 "Utility/RsyncTask.vala"
	self->total_size = (gint64) 0;
#line 161 "Utility/RsyncTask.vala"
	self->count_created = (gint64) 0;
#line 162 "Utility/RsyncTask.vala"
	self->count_deleted = (gint64) 0;
#line 163 "Utility/RsyncTask.vala"
	self->count_modified = (gint64) 0;
#line 164 "Utility/RsyncTask.vala"
	self->count_checksum = (gint64) 0;
#line 165 "Utility/RsyncTask.vala"
	self->count_size = (gint64) 0;
#line 166 "Utility/RsyncTask.vala"
	self->count_timestamp = (gint64) 0;
#line 167 "Utility/RsyncTask.vala"
	self->count_permissions = (gint64) 0;
#line 168 "Utility/RsyncTask.vala"
	self->count_owner = (gint64) 0;
#line 169 "Utility/RsyncTask.vala"
	self->count_group = (gint64) 0;
#line 170 "Utility/RsyncTask.vala"
	self->count_unchanged = (gint64) 0;
#line 172 "Utility/RsyncTask.vala"
	_tmp7_ = g_string_new ("");
#line 172 "Utility/RsyncTask.vala"
	_g_string_free0 (self->log);
#line 172 "Utility/RsyncTask.vala"
	self->log = _tmp7_;
#line 149 "Utility/RsyncTask.vala"
	_g_free0 (script_text);
#line 706 "RsyncTask.c"
}

static gchar*
rsync_task_build_script (RsyncTask* self)
{
	gchar* result = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	const gchar* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	const gchar* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	const gchar* _tmp57_;
	gchar* _tmp58_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
#line 175 "Utility/RsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "Utility/RsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 177 "Utility/RsyncTask.vala"
	cmd = _tmp0_;
#line 179 "Utility/RsyncTask.vala"
	if (self->io_nice) {
#line 758 "RsyncTask.c"
	}
#line 183 "Utility/RsyncTask.vala"
	_tmp1_ = cmd;
#line 183 "Utility/RsyncTask.vala"
	_tmp2_ = g_strconcat (_tmp1_, "rsync -aii", NULL);
#line 183 "Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 183 "Utility/RsyncTask.vala"
	cmd = _tmp2_;
#line 189 "Utility/RsyncTask.vala"
	_tmp3_ = cmd;
#line 189 "Utility/RsyncTask.vala"
	_tmp4_ = g_strconcat (_tmp3_, " --recursive", NULL);
#line 189 "Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 189 "Utility/RsyncTask.vala"
	cmd = _tmp4_;
#line 191 "Utility/RsyncTask.vala"
	if (self->verbose) {
#line 778 "RsyncTask.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 192 "Utility/RsyncTask.vala"
		_tmp5_ = cmd;
#line 192 "Utility/RsyncTask.vala"
		_tmp6_ = g_strconcat (_tmp5_, " --verbose", NULL);
#line 192 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 192 "Utility/RsyncTask.vala"
		cmd = _tmp6_;
#line 789 "RsyncTask.c"
	} else {
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 195 "Utility/RsyncTask.vala"
		_tmp7_ = cmd;
#line 195 "Utility/RsyncTask.vala"
		_tmp8_ = g_strconcat (_tmp7_, " --quiet", NULL);
#line 195 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 195 "Utility/RsyncTask.vala"
		cmd = _tmp8_;
#line 801 "RsyncTask.c"
	}
#line 198 "Utility/RsyncTask.vala"
	if (self->delete_extra) {
#line 805 "RsyncTask.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 199 "Utility/RsyncTask.vala"
		_tmp9_ = cmd;
#line 199 "Utility/RsyncTask.vala"
		_tmp10_ = g_strconcat (_tmp9_, " --delete", NULL);
#line 199 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 199 "Utility/RsyncTask.vala"
		cmd = _tmp10_;
#line 816 "RsyncTask.c"
	}
#line 202 "Utility/RsyncTask.vala"
	if (self->delete_after) {
#line 820 "RsyncTask.c"
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 203 "Utility/RsyncTask.vala"
		_tmp11_ = cmd;
#line 203 "Utility/RsyncTask.vala"
		_tmp12_ = g_strconcat (_tmp11_, " --delete-after", NULL);
#line 203 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 203 "Utility/RsyncTask.vala"
		cmd = _tmp12_;
#line 831 "RsyncTask.c"
	}
#line 206 "Utility/RsyncTask.vala"
	_tmp13_ = cmd;
#line 206 "Utility/RsyncTask.vala"
	_tmp14_ = g_strconcat (_tmp13_, " --force", NULL);
#line 206 "Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 206 "Utility/RsyncTask.vala"
	cmd = _tmp14_;
#line 210 "Utility/RsyncTask.vala"
	_tmp15_ = cmd;
#line 210 "Utility/RsyncTask.vala"
	_tmp16_ = g_strconcat (_tmp15_, " --stats", NULL);
#line 210 "Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 210 "Utility/RsyncTask.vala"
	cmd = _tmp16_;
#line 216 "Utility/RsyncTask.vala"
	if (self->delete_excluded) {
#line 851 "RsyncTask.c"
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 217 "Utility/RsyncTask.vala"
		_tmp17_ = cmd;
#line 217 "Utility/RsyncTask.vala"
		_tmp18_ = g_strconcat (_tmp17_, " --delete-excluded", NULL);
#line 217 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 217 "Utility/RsyncTask.vala"
		cmd = _tmp18_;
#line 862 "RsyncTask.c"
	}
#line 220 "Utility/RsyncTask.vala"
	if (self->dry_run) {
#line 866 "RsyncTask.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 221 "Utility/RsyncTask.vala"
		_tmp19_ = cmd;
#line 221 "Utility/RsyncTask.vala"
		_tmp20_ = g_strconcat (_tmp19_, " --dry-run", NULL);
#line 221 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 221 "Utility/RsyncTask.vala"
		cmd = _tmp20_;
#line 877 "RsyncTask.c"
	}
#line 224 "Utility/RsyncTask.vala"
	_tmp21_ = self->link_from_path;
#line 224 "Utility/RsyncTask.vala"
	_tmp22_ = strlen (_tmp21_);
#line 224 "Utility/RsyncTask.vala"
	_tmp23_ = _tmp22_;
#line 224 "Utility/RsyncTask.vala"
	if (_tmp23_ > 0) {
#line 887 "RsyncTask.c"
		const gchar* _tmp24_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 225 "Utility/RsyncTask.vala"
		_tmp24_ = self->link_from_path;
#line 225 "Utility/RsyncTask.vala"
		if (!g_str_has_suffix (_tmp24_, "/")) {
#line 900 "RsyncTask.c"
			const gchar* _tmp25_;
			gchar* _tmp26_;
#line 226 "Utility/RsyncTask.vala"
			_tmp25_ = self->link_from_path;
#line 226 "Utility/RsyncTask.vala"
			_tmp26_ = g_strdup_printf ("%s/", _tmp25_);
#line 226 "Utility/RsyncTask.vala"
			_g_free0 (self->link_from_path);
#line 226 "Utility/RsyncTask.vala"
			self->link_from_path = _tmp26_;
#line 911 "RsyncTask.c"
		}
#line 229 "Utility/RsyncTask.vala"
		_tmp27_ = cmd;
#line 229 "Utility/RsyncTask.vala"
		_tmp28_ = self->link_from_path;
#line 229 "Utility/RsyncTask.vala"
		_tmp29_ = tee_jee_file_system_escape_single_quote (_tmp28_);
#line 229 "Utility/RsyncTask.vala"
		_tmp30_ = _tmp29_;
#line 229 "Utility/RsyncTask.vala"
		_tmp31_ = g_strdup_printf (" --link-dest='%s'", _tmp30_);
#line 229 "Utility/RsyncTask.vala"
		_tmp32_ = _tmp31_;
#line 229 "Utility/RsyncTask.vala"
		_tmp33_ = g_strconcat (_tmp27_, _tmp32_, NULL);
#line 229 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 229 "Utility/RsyncTask.vala"
		cmd = _tmp33_;
#line 229 "Utility/RsyncTask.vala"
		_g_free0 (_tmp32_);
#line 229 "Utility/RsyncTask.vala"
		_g_free0 (_tmp30_);
#line 935 "RsyncTask.c"
	}
#line 232 "Utility/RsyncTask.vala"
	_tmp34_ = self->rsync_log_file;
#line 232 "Utility/RsyncTask.vala"
	_tmp35_ = strlen (_tmp34_);
#line 232 "Utility/RsyncTask.vala"
	_tmp36_ = _tmp35_;
#line 232 "Utility/RsyncTask.vala"
	if (_tmp36_ > 0) {
#line 945 "RsyncTask.c"
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
#line 233 "Utility/RsyncTask.vala"
		_tmp37_ = cmd;
#line 233 "Utility/RsyncTask.vala"
		_tmp38_ = self->rsync_log_file;
#line 233 "Utility/RsyncTask.vala"
		_tmp39_ = tee_jee_file_system_escape_single_quote (_tmp38_);
#line 233 "Utility/RsyncTask.vala"
		_tmp40_ = _tmp39_;
#line 233 "Utility/RsyncTask.vala"
		_tmp41_ = g_strdup_printf (" --log-file='%s'", _tmp40_);
#line 233 "Utility/RsyncTask.vala"
		_tmp42_ = _tmp41_;
#line 233 "Utility/RsyncTask.vala"
		_tmp43_ = g_strconcat (_tmp37_, _tmp42_, NULL);
#line 233 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 233 "Utility/RsyncTask.vala"
		cmd = _tmp43_;
#line 233 "Utility/RsyncTask.vala"
		_g_free0 (_tmp42_);
#line 233 "Utility/RsyncTask.vala"
		_g_free0 (_tmp40_);
#line 975 "RsyncTask.c"
	}
#line 236 "Utility/RsyncTask.vala"
	_tmp44_ = self->exclude_from_file;
#line 236 "Utility/RsyncTask.vala"
	_tmp45_ = strlen (_tmp44_);
#line 236 "Utility/RsyncTask.vala"
	_tmp46_ = _tmp45_;
#line 236 "Utility/RsyncTask.vala"
	if (_tmp46_ > 0) {
#line 985 "RsyncTask.c"
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gboolean _tmp54_ = FALSE;
#line 237 "Utility/RsyncTask.vala"
		_tmp47_ = cmd;
#line 237 "Utility/RsyncTask.vala"
		_tmp48_ = self->exclude_from_file;
#line 237 "Utility/RsyncTask.vala"
		_tmp49_ = tee_jee_file_system_escape_single_quote (_tmp48_);
#line 237 "Utility/RsyncTask.vala"
		_tmp50_ = _tmp49_;
#line 237 "Utility/RsyncTask.vala"
		_tmp51_ = g_strdup_printf (" --exclude-from='%s'", _tmp50_);
#line 237 "Utility/RsyncTask.vala"
		_tmp52_ = _tmp51_;
#line 237 "Utility/RsyncTask.vala"
		_tmp53_ = g_strconcat (_tmp47_, _tmp52_, NULL);
#line 237 "Utility/RsyncTask.vala"
		_g_free0 (cmd);
#line 237 "Utility/RsyncTask.vala"
		cmd = _tmp53_;
#line 237 "Utility/RsyncTask.vala"
		_g_free0 (_tmp52_);
#line 237 "Utility/RsyncTask.vala"
		_g_free0 (_tmp50_);
#line 239 "Utility/RsyncTask.vala"
		if (self->delete_extra) {
#line 239 "Utility/RsyncTask.vala"
			_tmp54_ = self->delete_excluded;
#line 1020 "RsyncTask.c"
		} else {
#line 239 "Utility/RsyncTask.vala"
			_tmp54_ = FALSE;
#line 1024 "RsyncTask.c"
		}
#line 239 "Utility/RsyncTask.vala"
		if (_tmp54_) {
#line 1028 "RsyncTask.c"
			const gchar* _tmp55_;
			gchar* _tmp56_;
#line 240 "Utility/RsyncTask.vala"
			_tmp55_ = cmd;
#line 240 "Utility/RsyncTask.vala"
			_tmp56_ = g_strconcat (_tmp55_, " --delete-excluded", NULL);
#line 240 "Utility/RsyncTask.vala"
			_g_free0 (cmd);
#line 240 "Utility/RsyncTask.vala"
			cmd = _tmp56_;
#line 1039 "RsyncTask.c"
		}
	}
#line 244 "Utility/RsyncTask.vala"
	_tmp57_ = self->source_path;
#line 244 "Utility/RsyncTask.vala"
	_tmp58_ = tee_jee_file_system_remove_trailing_slash (_tmp57_);
#line 244 "Utility/RsyncTask.vala"
	_g_free0 (self->source_path);
#line 244 "Utility/RsyncTask.vala"
	self->source_path = _tmp58_;
#line 246 "Utility/RsyncTask.vala"
	_tmp59_ = self->dest_path;
#line 246 "Utility/RsyncTask.vala"
	_tmp60_ = tee_jee_file_system_remove_trailing_slash (_tmp59_);
#line 246 "Utility/RsyncTask.vala"
	_g_free0 (self->dest_path);
#line 246 "Utility/RsyncTask.vala"
	self->dest_path = _tmp60_;
#line 248 "Utility/RsyncTask.vala"
	_tmp61_ = cmd;
#line 248 "Utility/RsyncTask.vala"
	_tmp62_ = self->source_path;
#line 248 "Utility/RsyncTask.vala"
	_tmp63_ = tee_jee_file_system_escape_single_quote (_tmp62_);
#line 248 "Utility/RsyncTask.vala"
	_tmp64_ = _tmp63_;
#line 248 "Utility/RsyncTask.vala"
	_tmp65_ = g_strdup_printf (" '%s/'", _tmp64_);
#line 248 "Utility/RsyncTask.vala"
	_tmp66_ = _tmp65_;
#line 248 "Utility/RsyncTask.vala"
	_tmp67_ = g_strconcat (_tmp61_, _tmp66_, NULL);
#line 248 "Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 248 "Utility/RsyncTask.vala"
	cmd = _tmp67_;
#line 248 "Utility/RsyncTask.vala"
	_g_free0 (_tmp66_);
#line 248 "Utility/RsyncTask.vala"
	_g_free0 (_tmp64_);
#line 250 "Utility/RsyncTask.vala"
	_tmp68_ = cmd;
#line 250 "Utility/RsyncTask.vala"
	_tmp69_ = self->dest_path;
#line 250 "Utility/RsyncTask.vala"
	_tmp70_ = tee_jee_file_system_escape_single_quote (_tmp69_);
#line 250 "Utility/RsyncTask.vala"
	_tmp71_ = _tmp70_;
#line 250 "Utility/RsyncTask.vala"
	_tmp72_ = g_strdup_printf (" '%s/'", _tmp71_);
#line 250 "Utility/RsyncTask.vala"
	_tmp73_ = _tmp72_;
#line 250 "Utility/RsyncTask.vala"
	_tmp74_ = g_strconcat (_tmp68_, _tmp73_, NULL);
#line 250 "Utility/RsyncTask.vala"
	_g_free0 (cmd);
#line 250 "Utility/RsyncTask.vala"
	cmd = _tmp74_;
#line 250 "Utility/RsyncTask.vala"
	_g_free0 (_tmp73_);
#line 250 "Utility/RsyncTask.vala"
	_g_free0 (_tmp71_);
#line 252 "Utility/RsyncTask.vala"
	result = cmd;
#line 252 "Utility/RsyncTask.vala"
	return result;
#line 1106 "RsyncTask.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 1130 "RsyncTask.c"
}

GeeArrayList*
rsync_task_parse_log (RsyncTask* self,
                      const gchar* log_file_path)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* log_file = NULL;
	gchar* _tmp1_;
	GDataOutputStream* dos_changes = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_;
	GDataOutputStream* _tmp195_;
	GError* _inner_error0_ = NULL;
#line 255 "Utility/RsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 255 "Utility/RsyncTask.vala"
	g_return_val_if_fail (log_file_path != NULL, NULL);
#line 257 "Utility/RsyncTask.vala"
	_tmp0_ = gee_array_list_new (TYPE_FILE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 257 "Utility/RsyncTask.vala"
	list = _tmp0_;
#line 259 "Utility/RsyncTask.vala"
	_tmp1_ = g_strdup (log_file_path);
#line 259 "Utility/RsyncTask.vala"
	log_file = _tmp1_;
#line 260 "Utility/RsyncTask.vala"
	dos_changes = NULL;
#line 262 "Utility/RsyncTask.vala"
	_tmp2_ = log_file;
#line 262 "Utility/RsyncTask.vala"
	if (!g_str_has_suffix (_tmp2_, "-changes")) {
#line 1168 "RsyncTask.c"
		gchar* log_file_changes = NULL;
		gchar* _tmp3_;
		const gchar* _tmp4_;
#line 264 "Utility/RsyncTask.vala"
		_tmp3_ = g_strconcat (log_file_path, "-changes", NULL);
#line 264 "Utility/RsyncTask.vala"
		log_file_changes = _tmp3_;
#line 266 "Utility/RsyncTask.vala"
		_tmp4_ = log_file_changes;
#line 266 "Utility/RsyncTask.vala"
		if (tee_jee_file_system_file_exists (_tmp4_)) {
#line 1180 "RsyncTask.c"
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 268 "Utility/RsyncTask.vala"
			_tmp5_ = log_file_changes;
#line 268 "Utility/RsyncTask.vala"
			_tmp6_ = g_strdup (_tmp5_);
#line 268 "Utility/RsyncTask.vala"
			_g_free0 (log_file);
#line 268 "Utility/RsyncTask.vala"
			log_file = _tmp6_;
#line 1191 "RsyncTask.c"
		} else {
			{
				GFile* file = NULL;
				const gchar* _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
				GFileOutputStream* file_stream = NULL;
				GFile* _tmp11_;
				GFileOutputStream* _tmp12_;
				GFileOutputStream* _tmp13_;
				GDataOutputStream* _tmp14_;
#line 273 "Utility/RsyncTask.vala"
				_tmp7_ = log_file_changes;
#line 273 "Utility/RsyncTask.vala"
				_tmp8_ = g_file_new_for_path (_tmp7_);
#line 273 "Utility/RsyncTask.vala"
				file = _tmp8_;
#line 274 "Utility/RsyncTask.vala"
				_tmp9_ = file;
#line 274 "Utility/RsyncTask.vala"
				if (g_file_query_exists (_tmp9_, NULL)) {
#line 1213 "RsyncTask.c"
					GFile* _tmp10_;
#line 275 "Utility/RsyncTask.vala"
					_tmp10_ = file;
#line 275 "Utility/RsyncTask.vala"
					g_file_delete (_tmp10_, NULL, &_inner_error0_);
#line 275 "Utility/RsyncTask.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 275 "Utility/RsyncTask.vala"
						_g_object_unref0 (file);
#line 1223 "RsyncTask.c"
						goto __catch61_g_error;
					}
				}
#line 277 "Utility/RsyncTask.vala"
				_tmp11_ = file;
#line 277 "Utility/RsyncTask.vala"
				_tmp12_ = g_file_create (_tmp11_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 277 "Utility/RsyncTask.vala"
				file_stream = _tmp12_;
#line 277 "Utility/RsyncTask.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "Utility/RsyncTask.vala"
					_g_object_unref0 (file);
#line 1237 "RsyncTask.c"
					goto __catch61_g_error;
				}
#line 278 "Utility/RsyncTask.vala"
				_tmp13_ = file_stream;
#line 278 "Utility/RsyncTask.vala"
				_tmp14_ = g_data_output_stream_new ((GOutputStream*) _tmp13_);
#line 278 "Utility/RsyncTask.vala"
				_g_object_unref0 (dos_changes);
#line 278 "Utility/RsyncTask.vala"
				dos_changes = _tmp14_;
#line 272 "Utility/RsyncTask.vala"
				_g_object_unref0 (file_stream);
#line 272 "Utility/RsyncTask.vala"
				_g_object_unref0 (file);
#line 1252 "RsyncTask.c"
			}
			goto __finally61;
			__catch61_g_error:
			{
				GError* e = NULL;
				GError* _tmp15_;
				const gchar* _tmp16_;
#line 272 "Utility/RsyncTask.vala"
				e = _inner_error0_;
#line 272 "Utility/RsyncTask.vala"
				_inner_error0_ = NULL;
#line 281 "Utility/RsyncTask.vala"
				_tmp15_ = e;
#line 281 "Utility/RsyncTask.vala"
				_tmp16_ = _tmp15_->message;
#line 281 "Utility/RsyncTask.vala"
				tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 272 "Utility/RsyncTask.vala"
				_g_error_free0 (e);
#line 1272 "RsyncTask.c"
			}
			__finally61:
#line 272 "Utility/RsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "Utility/RsyncTask.vala"
				_g_free0 (log_file_changes);
#line 272 "Utility/RsyncTask.vala"
				_g_object_unref0 (dos_changes);
#line 272 "Utility/RsyncTask.vala"
				_g_free0 (log_file);
#line 272 "Utility/RsyncTask.vala"
				_g_object_unref0 (list);
#line 272 "Utility/RsyncTask.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 272 "Utility/RsyncTask.vala"
				g_clear_error (&_inner_error0_);
#line 272 "Utility/RsyncTask.vala"
				return NULL;
#line 1291 "RsyncTask.c"
			}
		}
#line 262 "Utility/RsyncTask.vala"
		_g_free0 (log_file_changes);
#line 1296 "RsyncTask.c"
	}
#line 286 "Utility/RsyncTask.vala"
	tee_jee_logging_log_debug ("RsyncTask: parse_log()");
#line 287 "Utility/RsyncTask.vala"
	_tmp17_ = log_file;
#line 287 "Utility/RsyncTask.vala"
	_tmp18_ = g_strdup_printf ("log_file = %s", _tmp17_);
#line 287 "Utility/RsyncTask.vala"
	_tmp19_ = _tmp18_;
#line 287 "Utility/RsyncTask.vala"
	tee_jee_logging_log_debug (_tmp19_);
#line 287 "Utility/RsyncTask.vala"
	_g_free0 (_tmp19_);
#line 289 "Utility/RsyncTask.vala"
	((AsyncTask*) self)->prg_count = (gint64) 0;
#line 290 "Utility/RsyncTask.vala"
	_tmp20_ = log_file;
#line 290 "Utility/RsyncTask.vala"
	((AsyncTask*) self)->prg_count_total = tee_jee_file_system_file_line_count (_tmp20_);
#line 1316 "RsyncTask.c"
	{
		gchar* line = NULL;
		GFile* file = NULL;
		const gchar* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GFileInputStream* _tmp29_ = NULL;
		GFile* _tmp30_;
		GFileInputStream* _tmp31_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp32_;
		gchar* item_path = NULL;
		gchar* _tmp33_;
		gchar* item_disk_path = NULL;
		gchar* _tmp34_;
		gchar* item_status = NULL;
		gchar* _tmp35_;
		gchar* item_basepath = NULL;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
#line 294 "Utility/RsyncTask.vala"
		_tmp21_ = log_file;
#line 294 "Utility/RsyncTask.vala"
		_tmp22_ = g_file_new_for_path (_tmp21_);
#line 294 "Utility/RsyncTask.vala"
		file = _tmp22_;
#line 295 "Utility/RsyncTask.vala"
		_tmp23_ = file;
#line 295 "Utility/RsyncTask.vala"
		if (!g_file_query_exists (_tmp23_, NULL)) {
#line 1349 "RsyncTask.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
#line 296 "Utility/RsyncTask.vala"
			_tmp24_ = log_file;
#line 296 "Utility/RsyncTask.vala"
			_tmp25_ = g_strdup_printf (": %s", _tmp24_);
#line 296 "Utility/RsyncTask.vala"
			_tmp26_ = _tmp25_;
#line 296 "Utility/RsyncTask.vala"
			_tmp27_ = g_strconcat (_ ("File not found"), _tmp26_, NULL);
#line 296 "Utility/RsyncTask.vala"
			_tmp28_ = _tmp27_;
#line 296 "Utility/RsyncTask.vala"
			tee_jee_logging_log_error (_tmp28_, FALSE, FALSE);
#line 296 "Utility/RsyncTask.vala"
			_g_free0 (_tmp28_);
#line 296 "Utility/RsyncTask.vala"
			_g_free0 (_tmp26_);
#line 297 "Utility/RsyncTask.vala"
			result = list;
#line 297 "Utility/RsyncTask.vala"
			_g_object_unref0 (file);
#line 297 "Utility/RsyncTask.vala"
			_g_free0 (line);
#line 297 "Utility/RsyncTask.vala"
			_g_object_unref0 (dos_changes);
#line 297 "Utility/RsyncTask.vala"
			_g_free0 (log_file);
#line 297 "Utility/RsyncTask.vala"
			return result;
#line 1383 "RsyncTask.c"
		}
#line 300 "Utility/RsyncTask.vala"
		_tmp30_ = file;
#line 300 "Utility/RsyncTask.vala"
		_tmp31_ = g_file_read (_tmp30_, NULL, &_inner_error0_);
#line 300 "Utility/RsyncTask.vala"
		_tmp29_ = _tmp31_;
#line 300 "Utility/RsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 300 "Utility/RsyncTask.vala"
			_g_object_unref0 (file);
#line 300 "Utility/RsyncTask.vala"
			_g_free0 (line);
#line 1397 "RsyncTask.c"
			goto __catch62_g_error;
		}
#line 300 "Utility/RsyncTask.vala"
		_tmp32_ = g_data_input_stream_new ((GInputStream*) _tmp29_);
#line 300 "Utility/RsyncTask.vala"
		dis = _tmp32_;
#line 302 "Utility/RsyncTask.vala"
		_tmp33_ = g_strdup ("");
#line 302 "Utility/RsyncTask.vala"
		item_path = _tmp33_;
#line 303 "Utility/RsyncTask.vala"
		_tmp34_ = g_strdup ("");
#line 303 "Utility/RsyncTask.vala"
		item_disk_path = _tmp34_;
#line 304 "Utility/RsyncTask.vala"
		_tmp35_ = g_strdup ("");
#line 304 "Utility/RsyncTask.vala"
		item_status = _tmp35_;
#line 306 "Utility/RsyncTask.vala"
		_tmp36_ = tee_jee_file_system_file_parent (log_file_path);
#line 306 "Utility/RsyncTask.vala"
		_tmp37_ = _tmp36_;
#line 306 "Utility/RsyncTask.vala"
		_tmp38_ = tee_jee_file_system_path_combine (_tmp37_, "localhost");
#line 306 "Utility/RsyncTask.vala"
		_tmp39_ = _tmp38_;
#line 306 "Utility/RsyncTask.vala"
		_g_free0 (_tmp37_);
#line 306 "Utility/RsyncTask.vala"
		item_basepath = _tmp39_;
#line 308 "Utility/RsyncTask.vala"
		while (TRUE) {
#line 1430 "RsyncTask.c"
			gchar* _tmp40_ = NULL;
			GDataInputStream* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			const gchar* _tmp44_;
			gint64 _tmp45_;
			const gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
			gboolean _tmp51_;
			gchar* _tmp52_;
			GMatchInfo* match = NULL;
			gboolean _tmp53_ = FALSE;
			GeeHashMap* _tmp54_;
			gpointer _tmp55_;
			GRegex* _tmp56_;
			const gchar* _tmp57_;
			GMatchInfo* _tmp58_ = NULL;
			gboolean _tmp59_;
			gboolean _tmp60_;
			gboolean _tmp176_ = FALSE;
			gboolean _tmp177_ = FALSE;
			const gchar* _tmp178_;
			gint _tmp179_;
			gint _tmp180_;
#line 308 "Utility/RsyncTask.vala"
			_tmp41_ = dis;
#line 308 "Utility/RsyncTask.vala"
			_tmp42_ = g_data_input_stream_read_line (_tmp41_, NULL, NULL, &_inner_error0_);
#line 308 "Utility/RsyncTask.vala"
			_tmp40_ = _tmp42_;
#line 308 "Utility/RsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "Utility/RsyncTask.vala"
				_g_free0 (item_basepath);
#line 308 "Utility/RsyncTask.vala"
				_g_free0 (item_status);
#line 308 "Utility/RsyncTask.vala"
				_g_free0 (item_disk_path);
#line 308 "Utility/RsyncTask.vala"
				_g_free0 (item_path);
#line 308 "Utility/RsyncTask.vala"
				_g_object_unref0 (dis);
#line 308 "Utility/RsyncTask.vala"
				_g_object_unref0 (_tmp29_);
#line 308 "Utility/RsyncTask.vala"
				_g_object_unref0 (file);
#line 308 "Utility/RsyncTask.vala"
				_g_free0 (line);
#line 1482 "RsyncTask.c"
				goto __catch62_g_error;
			}
#line 308 "Utility/RsyncTask.vala"
			_tmp43_ = _tmp40_;
#line 308 "Utility/RsyncTask.vala"
			_tmp40_ = NULL;
#line 308 "Utility/RsyncTask.vala"
			_g_free0 (line);
#line 308 "Utility/RsyncTask.vala"
			line = _tmp43_;
#line 308 "Utility/RsyncTask.vala"
			_tmp44_ = line;
#line 308 "Utility/RsyncTask.vala"
			if (!(_tmp44_ != NULL)) {
#line 308 "Utility/RsyncTask.vala"
				_g_free0 (_tmp40_);
#line 308 "Utility/RsyncTask.vala"
				break;
#line 1501 "RsyncTask.c"
			}
#line 310 "Utility/RsyncTask.vala"
			_tmp45_ = ((AsyncTask*) self)->prg_count;
#line 310 "Utility/RsyncTask.vala"
			((AsyncTask*) self)->prg_count = _tmp45_ + 1;
#line 312 "Utility/RsyncTask.vala"
			_tmp46_ = line;
#line 312 "Utility/RsyncTask.vala"
			_tmp47_ = string_strip (_tmp46_);
#line 312 "Utility/RsyncTask.vala"
			_tmp48_ = _tmp47_;
#line 312 "Utility/RsyncTask.vala"
			_tmp49_ = strlen (_tmp48_);
#line 312 "Utility/RsyncTask.vala"
			_tmp50_ = _tmp49_;
#line 312 "Utility/RsyncTask.vala"
			_tmp51_ = _tmp50_ == 0;
#line 312 "Utility/RsyncTask.vala"
			_g_free0 (_tmp48_);
#line 312 "Utility/RsyncTask.vala"
			if (_tmp51_) {
#line 312 "Utility/RsyncTask.vala"
				_g_free0 (_tmp40_);
#line 312 "Utility/RsyncTask.vala"
				continue;
#line 1527 "RsyncTask.c"
			}
#line 314 "Utility/RsyncTask.vala"
			_tmp52_ = g_strdup ("");
#line 314 "Utility/RsyncTask.vala"
			_g_free0 (item_path);
#line 314 "Utility/RsyncTask.vala"
			item_path = _tmp52_;
#line 317 "Utility/RsyncTask.vala"
			_tmp54_ = self->priv->regex_list;
#line 317 "Utility/RsyncTask.vala"
			_tmp55_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp54_, "created");
#line 317 "Utility/RsyncTask.vala"
			_tmp56_ = (GRegex*) _tmp55_;
#line 317 "Utility/RsyncTask.vala"
			_tmp57_ = line;
#line 317 "Utility/RsyncTask.vala"
			_tmp59_ = g_regex_match (_tmp56_, _tmp57_, 0, &_tmp58_);
#line 317 "Utility/RsyncTask.vala"
			_g_match_info_unref0 (match);
#line 317 "Utility/RsyncTask.vala"
			match = _tmp58_;
#line 317 "Utility/RsyncTask.vala"
			_tmp60_ = _tmp59_;
#line 317 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp56_);
#line 317 "Utility/RsyncTask.vala"
			if (_tmp60_) {
#line 317 "Utility/RsyncTask.vala"
				_tmp53_ = TRUE;
#line 1557 "RsyncTask.c"
			} else {
				GeeHashMap* _tmp61_;
				gpointer _tmp62_;
				GRegex* _tmp63_;
				const gchar* _tmp64_;
				GMatchInfo* _tmp65_ = NULL;
				gboolean _tmp66_;
#line 318 "Utility/RsyncTask.vala"
				_tmp61_ = self->priv->regex_list;
#line 318 "Utility/RsyncTask.vala"
				_tmp62_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp61_, "log-created");
#line 318 "Utility/RsyncTask.vala"
				_tmp63_ = (GRegex*) _tmp62_;
#line 318 "Utility/RsyncTask.vala"
				_tmp64_ = line;
#line 318 "Utility/RsyncTask.vala"
				_tmp66_ = g_regex_match (_tmp63_, _tmp64_, 0, &_tmp65_);
#line 318 "Utility/RsyncTask.vala"
				_g_match_info_unref0 (match);
#line 318 "Utility/RsyncTask.vala"
				match = _tmp65_;
#line 318 "Utility/RsyncTask.vala"
				_tmp53_ = _tmp66_;
#line 318 "Utility/RsyncTask.vala"
				_g_regex_unref0 (_tmp63_);
#line 1583 "RsyncTask.c"
			}
#line 317 "Utility/RsyncTask.vala"
			if (_tmp53_) {
#line 1587 "RsyncTask.c"
				GDataOutputStream* _tmp67_;
				GMatchInfo* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
				gchar** _tmp75_;
				gchar** _tmp76_;
				gchar** _tmp77_;
				gint _tmp77__length1;
				const gchar* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
#line 320 "Utility/RsyncTask.vala"
				_tmp67_ = dos_changes;
#line 320 "Utility/RsyncTask.vala"
				if (_tmp67_ != NULL) {
#line 1603 "RsyncTask.c"
					GDataOutputStream* _tmp68_;
					const gchar* _tmp69_;
					gchar* _tmp70_;
					gchar* _tmp71_;
#line 321 "Utility/RsyncTask.vala"
					_tmp68_ = dos_changes;
#line 321 "Utility/RsyncTask.vala"
					_tmp69_ = line;
#line 321 "Utility/RsyncTask.vala"
					_tmp70_ = g_strdup_printf ("%s\n", _tmp69_);
#line 321 "Utility/RsyncTask.vala"
					_tmp71_ = _tmp70_;
#line 321 "Utility/RsyncTask.vala"
					g_data_output_stream_put_string (_tmp68_, _tmp71_, NULL, &_inner_error0_);
#line 321 "Utility/RsyncTask.vala"
					_g_free0 (_tmp71_);
#line 321 "Utility/RsyncTask.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 321 "Utility/RsyncTask.vala"
						_g_match_info_unref0 (match);
#line 321 "Utility/RsyncTask.vala"
						_g_free0 (_tmp40_);
#line 321 "Utility/RsyncTask.vala"
						_g_free0 (item_basepath);
#line 321 "Utility/RsyncTask.vala"
						_g_free0 (item_status);
#line 321 "Utility/RsyncTask.vala"
						_g_free0 (item_disk_path);
#line 321 "Utility/RsyncTask.vala"
						_g_free0 (item_path);
#line 321 "Utility/RsyncTask.vala"
						_g_object_unref0 (dis);
#line 321 "Utility/RsyncTask.vala"
						_g_object_unref0 (_tmp29_);
#line 321 "Utility/RsyncTask.vala"
						_g_object_unref0 (file);
#line 321 "Utility/RsyncTask.vala"
						_g_free0 (line);
#line 1642 "RsyncTask.c"
						goto __catch62_g_error;
					}
				}
#line 326 "Utility/RsyncTask.vala"
				_tmp72_ = match;
#line 326 "Utility/RsyncTask.vala"
				_tmp73_ = g_match_info_fetch (_tmp72_, 3);
#line 326 "Utility/RsyncTask.vala"
				_tmp74_ = _tmp73_;
#line 326 "Utility/RsyncTask.vala"
				_tmp76_ = _tmp75_ = g_strsplit (_tmp74_, " -> ", 0);
#line 326 "Utility/RsyncTask.vala"
				_tmp77_ = _tmp76_;
#line 326 "Utility/RsyncTask.vala"
				_tmp77__length1 = _vala_array_length (_tmp75_);
#line 326 "Utility/RsyncTask.vala"
				_tmp78_ = _tmp77_[0];
#line 326 "Utility/RsyncTask.vala"
				_tmp79_ = string_strip (_tmp78_);
#line 326 "Utility/RsyncTask.vala"
				_g_free0 (item_path);
#line 326 "Utility/RsyncTask.vala"
				item_path = _tmp79_;
#line 326 "Utility/RsyncTask.vala"
				_tmp77_ = (_vala_array_free (_tmp77_, _tmp77__length1, (GDestroyNotify) g_free), NULL);
#line 326 "Utility/RsyncTask.vala"
				_g_free0 (_tmp74_);
#line 334 "Utility/RsyncTask.vala"
				_tmp80_ = g_strdup ("created");
#line 334 "Utility/RsyncTask.vala"
				_g_free0 (item_status);
#line 334 "Utility/RsyncTask.vala"
				item_status = _tmp80_;
#line 1676 "RsyncTask.c"
			} else {
				gboolean _tmp81_ = FALSE;
				GeeHashMap* _tmp82_;
				gpointer _tmp83_;
				GRegex* _tmp84_;
				const gchar* _tmp85_;
				GMatchInfo* _tmp86_ = NULL;
				gboolean _tmp87_;
				gboolean _tmp88_;
#line 336 "Utility/RsyncTask.vala"
				_tmp82_ = self->priv->regex_list;
#line 336 "Utility/RsyncTask.vala"
				_tmp83_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp82_, "log-deleted");
#line 336 "Utility/RsyncTask.vala"
				_tmp84_ = (GRegex*) _tmp83_;
#line 336 "Utility/RsyncTask.vala"
				_tmp85_ = line;
#line 336 "Utility/RsyncTask.vala"
				_tmp87_ = g_regex_match (_tmp84_, _tmp85_, 0, &_tmp86_);
#line 336 "Utility/RsyncTask.vala"
				_g_match_info_unref0 (match);
#line 336 "Utility/RsyncTask.vala"
				match = _tmp86_;
#line 336 "Utility/RsyncTask.vala"
				_tmp88_ = _tmp87_;
#line 336 "Utility/RsyncTask.vala"
				_g_regex_unref0 (_tmp84_);
#line 336 "Utility/RsyncTask.vala"
				if (_tmp88_) {
#line 336 "Utility/RsyncTask.vala"
					_tmp81_ = TRUE;
#line 1708 "RsyncTask.c"
				} else {
					GeeHashMap* _tmp89_;
					gpointer _tmp90_;
					GRegex* _tmp91_;
					const gchar* _tmp92_;
					GMatchInfo* _tmp93_ = NULL;
					gboolean _tmp94_;
#line 337 "Utility/RsyncTask.vala"
					_tmp89_ = self->priv->regex_list;
#line 337 "Utility/RsyncTask.vala"
					_tmp90_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp89_, "deleted");
#line 337 "Utility/RsyncTask.vala"
					_tmp91_ = (GRegex*) _tmp90_;
#line 337 "Utility/RsyncTask.vala"
					_tmp92_ = line;
#line 337 "Utility/RsyncTask.vala"
					_tmp94_ = g_regex_match (_tmp91_, _tmp92_, 0, &_tmp93_);
#line 337 "Utility/RsyncTask.vala"
					_g_match_info_unref0 (match);
#line 337 "Utility/RsyncTask.vala"
					match = _tmp93_;
#line 337 "Utility/RsyncTask.vala"
					_tmp81_ = _tmp94_;
#line 337 "Utility/RsyncTask.vala"
					_g_regex_unref0 (_tmp91_);
#line 1734 "RsyncTask.c"
				}
#line 336 "Utility/RsyncTask.vala"
				if (_tmp81_) {
#line 1738 "RsyncTask.c"
					GDataOutputStream* _tmp95_;
					GMatchInfo* _tmp100_;
					gchar* _tmp101_;
					gchar* _tmp102_;
					gchar** _tmp103_;
					gchar** _tmp104_;
					gchar** _tmp105_;
					gint _tmp105__length1;
					const gchar* _tmp106_;
					gchar* _tmp107_;
					gchar* _tmp108_;
#line 341 "Utility/RsyncTask.vala"
					_tmp95_ = dos_changes;
#line 341 "Utility/RsyncTask.vala"
					if (_tmp95_ != NULL) {
#line 1754 "RsyncTask.c"
						GDataOutputStream* _tmp96_;
						const gchar* _tmp97_;
						gchar* _tmp98_;
						gchar* _tmp99_;
#line 342 "Utility/RsyncTask.vala"
						_tmp96_ = dos_changes;
#line 342 "Utility/RsyncTask.vala"
						_tmp97_ = line;
#line 342 "Utility/RsyncTask.vala"
						_tmp98_ = g_strdup_printf ("%s\n", _tmp97_);
#line 342 "Utility/RsyncTask.vala"
						_tmp99_ = _tmp98_;
#line 342 "Utility/RsyncTask.vala"
						g_data_output_stream_put_string (_tmp96_, _tmp99_, NULL, &_inner_error0_);
#line 342 "Utility/RsyncTask.vala"
						_g_free0 (_tmp99_);
#line 342 "Utility/RsyncTask.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "Utility/RsyncTask.vala"
							_g_match_info_unref0 (match);
#line 342 "Utility/RsyncTask.vala"
							_g_free0 (_tmp40_);
#line 342 "Utility/RsyncTask.vala"
							_g_free0 (item_basepath);
#line 342 "Utility/RsyncTask.vala"
							_g_free0 (item_status);
#line 342 "Utility/RsyncTask.vala"
							_g_free0 (item_disk_path);
#line 342 "Utility/RsyncTask.vala"
							_g_free0 (item_path);
#line 342 "Utility/RsyncTask.vala"
							_g_object_unref0 (dis);
#line 342 "Utility/RsyncTask.vala"
							_g_object_unref0 (_tmp29_);
#line 342 "Utility/RsyncTask.vala"
							_g_object_unref0 (file);
#line 342 "Utility/RsyncTask.vala"
							_g_free0 (line);
#line 1793 "RsyncTask.c"
							goto __catch62_g_error;
						}
					}
#line 345 "Utility/RsyncTask.vala"
					_tmp100_ = match;
#line 345 "Utility/RsyncTask.vala"
					_tmp101_ = g_match_info_fetch (_tmp100_, 1);
#line 345 "Utility/RsyncTask.vala"
					_tmp102_ = _tmp101_;
#line 345 "Utility/RsyncTask.vala"
					_tmp104_ = _tmp103_ = g_strsplit (_tmp102_, " -> ", 0);
#line 345 "Utility/RsyncTask.vala"
					_tmp105_ = _tmp104_;
#line 345 "Utility/RsyncTask.vala"
					_tmp105__length1 = _vala_array_length (_tmp103_);
#line 345 "Utility/RsyncTask.vala"
					_tmp106_ = _tmp105_[0];
#line 345 "Utility/RsyncTask.vala"
					_tmp107_ = string_strip (_tmp106_);
#line 345 "Utility/RsyncTask.vala"
					_g_free0 (item_path);
#line 345 "Utility/RsyncTask.vala"
					item_path = _tmp107_;
#line 345 "Utility/RsyncTask.vala"
					_tmp105_ = (_vala_array_free (_tmp105_, _tmp105__length1, (GDestroyNotify) g_free), NULL);
#line 345 "Utility/RsyncTask.vala"
					_g_free0 (_tmp102_);
#line 347 "Utility/RsyncTask.vala"
					_tmp108_ = g_strdup ("deleted");
#line 347 "Utility/RsyncTask.vala"
					_g_free0 (item_status);
#line 347 "Utility/RsyncTask.vala"
					item_status = _tmp108_;
#line 1827 "RsyncTask.c"
				} else {
					gboolean _tmp109_ = FALSE;
					GeeHashMap* _tmp110_;
					gpointer _tmp111_;
					GRegex* _tmp112_;
					const gchar* _tmp113_;
					GMatchInfo* _tmp114_ = NULL;
					gboolean _tmp115_;
					gboolean _tmp116_;
#line 349 "Utility/RsyncTask.vala"
					_tmp110_ = self->priv->regex_list;
#line 349 "Utility/RsyncTask.vala"
					_tmp111_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp110_, "modified");
#line 349 "Utility/RsyncTask.vala"
					_tmp112_ = (GRegex*) _tmp111_;
#line 349 "Utility/RsyncTask.vala"
					_tmp113_ = line;
#line 349 "Utility/RsyncTask.vala"
					_tmp115_ = g_regex_match (_tmp112_, _tmp113_, 0, &_tmp114_);
#line 349 "Utility/RsyncTask.vala"
					_g_match_info_unref0 (match);
#line 349 "Utility/RsyncTask.vala"
					match = _tmp114_;
#line 349 "Utility/RsyncTask.vala"
					_tmp116_ = _tmp115_;
#line 349 "Utility/RsyncTask.vala"
					_g_regex_unref0 (_tmp112_);
#line 349 "Utility/RsyncTask.vala"
					if (_tmp116_) {
#line 349 "Utility/RsyncTask.vala"
						_tmp109_ = TRUE;
#line 1859 "RsyncTask.c"
					} else {
						GeeHashMap* _tmp117_;
						gpointer _tmp118_;
						GRegex* _tmp119_;
						const gchar* _tmp120_;
						GMatchInfo* _tmp121_ = NULL;
						gboolean _tmp122_;
#line 350 "Utility/RsyncTask.vala"
						_tmp117_ = self->priv->regex_list;
#line 350 "Utility/RsyncTask.vala"
						_tmp118_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp117_, "log-modified");
#line 350 "Utility/RsyncTask.vala"
						_tmp119_ = (GRegex*) _tmp118_;
#line 350 "Utility/RsyncTask.vala"
						_tmp120_ = line;
#line 350 "Utility/RsyncTask.vala"
						_tmp122_ = g_regex_match (_tmp119_, _tmp120_, 0, &_tmp121_);
#line 350 "Utility/RsyncTask.vala"
						_g_match_info_unref0 (match);
#line 350 "Utility/RsyncTask.vala"
						match = _tmp121_;
#line 350 "Utility/RsyncTask.vala"
						_tmp109_ = _tmp122_;
#line 350 "Utility/RsyncTask.vala"
						_g_regex_unref0 (_tmp119_);
#line 1885 "RsyncTask.c"
					}
#line 349 "Utility/RsyncTask.vala"
					if (_tmp109_) {
#line 1889 "RsyncTask.c"
						GDataOutputStream* _tmp123_;
						GMatchInfo* _tmp128_;
						gchar* _tmp129_;
						gchar* _tmp130_;
						gchar** _tmp131_;
						gchar** _tmp132_;
						gchar** _tmp133_;
						gint _tmp133__length1;
						const gchar* _tmp134_;
						gchar* _tmp135_;
						GMatchInfo* _tmp136_;
						gchar* _tmp137_;
						gchar* _tmp138_;
						gboolean _tmp139_;
#line 354 "Utility/RsyncTask.vala"
						_tmp123_ = dos_changes;
#line 354 "Utility/RsyncTask.vala"
						if (_tmp123_ != NULL) {
#line 1908 "RsyncTask.c"
							GDataOutputStream* _tmp124_;
							const gchar* _tmp125_;
							gchar* _tmp126_;
							gchar* _tmp127_;
#line 355 "Utility/RsyncTask.vala"
							_tmp124_ = dos_changes;
#line 355 "Utility/RsyncTask.vala"
							_tmp125_ = line;
#line 355 "Utility/RsyncTask.vala"
							_tmp126_ = g_strdup_printf ("%s\n", _tmp125_);
#line 355 "Utility/RsyncTask.vala"
							_tmp127_ = _tmp126_;
#line 355 "Utility/RsyncTask.vala"
							g_data_output_stream_put_string (_tmp124_, _tmp127_, NULL, &_inner_error0_);
#line 355 "Utility/RsyncTask.vala"
							_g_free0 (_tmp127_);
#line 355 "Utility/RsyncTask.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "Utility/RsyncTask.vala"
								_g_match_info_unref0 (match);
#line 355 "Utility/RsyncTask.vala"
								_g_free0 (_tmp40_);
#line 355 "Utility/RsyncTask.vala"
								_g_free0 (item_basepath);
#line 355 "Utility/RsyncTask.vala"
								_g_free0 (item_status);
#line 355 "Utility/RsyncTask.vala"
								_g_free0 (item_disk_path);
#line 355 "Utility/RsyncTask.vala"
								_g_free0 (item_path);
#line 355 "Utility/RsyncTask.vala"
								_g_object_unref0 (dis);
#line 355 "Utility/RsyncTask.vala"
								_g_object_unref0 (_tmp29_);
#line 355 "Utility/RsyncTask.vala"
								_g_object_unref0 (file);
#line 355 "Utility/RsyncTask.vala"
								_g_free0 (line);
#line 1947 "RsyncTask.c"
								goto __catch62_g_error;
							}
						}
#line 358 "Utility/RsyncTask.vala"
						_tmp128_ = match;
#line 358 "Utility/RsyncTask.vala"
						_tmp129_ = g_match_info_fetch (_tmp128_, 12);
#line 358 "Utility/RsyncTask.vala"
						_tmp130_ = _tmp129_;
#line 358 "Utility/RsyncTask.vala"
						_tmp132_ = _tmp131_ = g_strsplit (_tmp130_, " -> ", 0);
#line 358 "Utility/RsyncTask.vala"
						_tmp133_ = _tmp132_;
#line 358 "Utility/RsyncTask.vala"
						_tmp133__length1 = _vala_array_length (_tmp131_);
#line 358 "Utility/RsyncTask.vala"
						_tmp134_ = _tmp133_[0];
#line 358 "Utility/RsyncTask.vala"
						_tmp135_ = string_strip (_tmp134_);
#line 358 "Utility/RsyncTask.vala"
						_g_free0 (item_path);
#line 358 "Utility/RsyncTask.vala"
						item_path = _tmp135_;
#line 358 "Utility/RsyncTask.vala"
						_tmp133_ = (_vala_array_free (_tmp133_, _tmp133__length1, (GDestroyNotify) g_free), NULL);
#line 358 "Utility/RsyncTask.vala"
						_g_free0 (_tmp130_);
#line 367 "Utility/RsyncTask.vala"
						_tmp136_ = match;
#line 367 "Utility/RsyncTask.vala"
						_tmp137_ = g_match_info_fetch (_tmp136_, 3);
#line 367 "Utility/RsyncTask.vala"
						_tmp138_ = _tmp137_;
#line 367 "Utility/RsyncTask.vala"
						_tmp139_ = g_strcmp0 (_tmp138_, "c") == 0;
#line 367 "Utility/RsyncTask.vala"
						_g_free0 (_tmp138_);
#line 367 "Utility/RsyncTask.vala"
						if (_tmp139_) {
#line 1987 "RsyncTask.c"
							gchar* _tmp140_;
#line 368 "Utility/RsyncTask.vala"
							_tmp140_ = g_strdup ("checksum");
#line 368 "Utility/RsyncTask.vala"
							_g_free0 (item_status);
#line 368 "Utility/RsyncTask.vala"
							item_status = _tmp140_;
#line 1995 "RsyncTask.c"
						} else {
							GMatchInfo* _tmp141_;
							gchar* _tmp142_;
							gchar* _tmp143_;
							gboolean _tmp144_;
#line 370 "Utility/RsyncTask.vala"
							_tmp141_ = match;
#line 370 "Utility/RsyncTask.vala"
							_tmp142_ = g_match_info_fetch (_tmp141_, 4);
#line 370 "Utility/RsyncTask.vala"
							_tmp143_ = _tmp142_;
#line 370 "Utility/RsyncTask.vala"
							_tmp144_ = g_strcmp0 (_tmp143_, "s") == 0;
#line 370 "Utility/RsyncTask.vala"
							_g_free0 (_tmp143_);
#line 370 "Utility/RsyncTask.vala"
							if (_tmp144_) {
#line 2013 "RsyncTask.c"
								gchar* _tmp145_;
#line 371 "Utility/RsyncTask.vala"
								_tmp145_ = g_strdup ("size");
#line 371 "Utility/RsyncTask.vala"
								_g_free0 (item_status);
#line 371 "Utility/RsyncTask.vala"
								item_status = _tmp145_;
#line 2021 "RsyncTask.c"
							} else {
								GMatchInfo* _tmp146_;
								gchar* _tmp147_;
								gchar* _tmp148_;
								gboolean _tmp149_;
#line 373 "Utility/RsyncTask.vala"
								_tmp146_ = match;
#line 373 "Utility/RsyncTask.vala"
								_tmp147_ = g_match_info_fetch (_tmp146_, 5);
#line 373 "Utility/RsyncTask.vala"
								_tmp148_ = _tmp147_;
#line 373 "Utility/RsyncTask.vala"
								_tmp149_ = g_strcmp0 (_tmp148_, "t") == 0;
#line 373 "Utility/RsyncTask.vala"
								_g_free0 (_tmp148_);
#line 373 "Utility/RsyncTask.vala"
								if (_tmp149_) {
#line 2039 "RsyncTask.c"
									gchar* _tmp150_;
#line 374 "Utility/RsyncTask.vala"
									_tmp150_ = g_strdup ("timestamp");
#line 374 "Utility/RsyncTask.vala"
									_g_free0 (item_status);
#line 374 "Utility/RsyncTask.vala"
									item_status = _tmp150_;
#line 2047 "RsyncTask.c"
								} else {
									GMatchInfo* _tmp151_;
									gchar* _tmp152_;
									gchar* _tmp153_;
									gboolean _tmp154_;
#line 376 "Utility/RsyncTask.vala"
									_tmp151_ = match;
#line 376 "Utility/RsyncTask.vala"
									_tmp152_ = g_match_info_fetch (_tmp151_, 6);
#line 376 "Utility/RsyncTask.vala"
									_tmp153_ = _tmp152_;
#line 376 "Utility/RsyncTask.vala"
									_tmp154_ = g_strcmp0 (_tmp153_, "p") == 0;
#line 376 "Utility/RsyncTask.vala"
									_g_free0 (_tmp153_);
#line 376 "Utility/RsyncTask.vala"
									if (_tmp154_) {
#line 2065 "RsyncTask.c"
										gchar* _tmp155_;
#line 377 "Utility/RsyncTask.vala"
										_tmp155_ = g_strdup ("permissions");
#line 377 "Utility/RsyncTask.vala"
										_g_free0 (item_status);
#line 377 "Utility/RsyncTask.vala"
										item_status = _tmp155_;
#line 2073 "RsyncTask.c"
									} else {
										GMatchInfo* _tmp156_;
										gchar* _tmp157_;
										gchar* _tmp158_;
										gboolean _tmp159_;
#line 379 "Utility/RsyncTask.vala"
										_tmp156_ = match;
#line 379 "Utility/RsyncTask.vala"
										_tmp157_ = g_match_info_fetch (_tmp156_, 7);
#line 379 "Utility/RsyncTask.vala"
										_tmp158_ = _tmp157_;
#line 379 "Utility/RsyncTask.vala"
										_tmp159_ = g_strcmp0 (_tmp158_, "o") == 0;
#line 379 "Utility/RsyncTask.vala"
										_g_free0 (_tmp158_);
#line 379 "Utility/RsyncTask.vala"
										if (_tmp159_) {
#line 2091 "RsyncTask.c"
											gchar* _tmp160_;
#line 380 "Utility/RsyncTask.vala"
											_tmp160_ = g_strdup ("owner");
#line 380 "Utility/RsyncTask.vala"
											_g_free0 (item_status);
#line 380 "Utility/RsyncTask.vala"
											item_status = _tmp160_;
#line 2099 "RsyncTask.c"
										} else {
											GMatchInfo* _tmp161_;
											gchar* _tmp162_;
											gchar* _tmp163_;
											gboolean _tmp164_;
#line 382 "Utility/RsyncTask.vala"
											_tmp161_ = match;
#line 382 "Utility/RsyncTask.vala"
											_tmp162_ = g_match_info_fetch (_tmp161_, 8);
#line 382 "Utility/RsyncTask.vala"
											_tmp163_ = _tmp162_;
#line 382 "Utility/RsyncTask.vala"
											_tmp164_ = g_strcmp0 (_tmp163_, "g") == 0;
#line 382 "Utility/RsyncTask.vala"
											_g_free0 (_tmp163_);
#line 382 "Utility/RsyncTask.vala"
											if (_tmp164_) {
#line 2117 "RsyncTask.c"
												gchar* _tmp165_;
#line 383 "Utility/RsyncTask.vala"
												_tmp165_ = g_strdup ("group");
#line 383 "Utility/RsyncTask.vala"
												_g_free0 (item_status);
#line 383 "Utility/RsyncTask.vala"
												item_status = _tmp165_;
#line 2125 "RsyncTask.c"
											}
										}
									}
								}
							}
						}
					} else {
						GeeHashMap* _tmp166_;
						gpointer _tmp167_;
						GRegex* _tmp168_;
						const gchar* _tmp169_;
						GMatchInfo* _tmp170_ = NULL;
						gboolean _tmp171_;
						gboolean _tmp172_;
#line 386 "Utility/RsyncTask.vala"
						_tmp166_ = self->priv->regex_list;
#line 386 "Utility/RsyncTask.vala"
						_tmp167_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp166_, "log-unchanged");
#line 386 "Utility/RsyncTask.vala"
						_tmp168_ = (GRegex*) _tmp167_;
#line 386 "Utility/RsyncTask.vala"
						_tmp169_ = line;
#line 386 "Utility/RsyncTask.vala"
						_tmp171_ = g_regex_match (_tmp168_, _tmp169_, 0, &_tmp170_);
#line 386 "Utility/RsyncTask.vala"
						_g_match_info_unref0 (match);
#line 386 "Utility/RsyncTask.vala"
						match = _tmp170_;
#line 386 "Utility/RsyncTask.vala"
						_tmp172_ = _tmp171_;
#line 386 "Utility/RsyncTask.vala"
						_g_regex_unref0 (_tmp168_);
#line 386 "Utility/RsyncTask.vala"
						if (_tmp172_) {
#line 2160 "RsyncTask.c"
						} else {
							const gchar* _tmp173_;
							gchar* _tmp174_;
							gchar* _tmp175_;
#line 390 "Utility/RsyncTask.vala"
							_tmp173_ = line;
#line 390 "Utility/RsyncTask.vala"
							_tmp174_ = g_strdup_printf ("not-matched: %s", _tmp173_);
#line 390 "Utility/RsyncTask.vala"
							_tmp175_ = _tmp174_;
#line 390 "Utility/RsyncTask.vala"
							tee_jee_logging_log_debug (_tmp175_);
#line 390 "Utility/RsyncTask.vala"
							_g_free0 (_tmp175_);
#line 2175 "RsyncTask.c"
						}
					}
				}
			}
#line 393 "Utility/RsyncTask.vala"
			_tmp178_ = item_path;
#line 393 "Utility/RsyncTask.vala"
			_tmp179_ = strlen (_tmp178_);
#line 393 "Utility/RsyncTask.vala"
			_tmp180_ = _tmp179_;
#line 393 "Utility/RsyncTask.vala"
			if (_tmp180_ > 0) {
#line 2188 "RsyncTask.c"
				const gchar* _tmp181_;
#line 393 "Utility/RsyncTask.vala"
				_tmp181_ = item_path;
#line 393 "Utility/RsyncTask.vala"
				_tmp177_ = g_strcmp0 (_tmp181_, "/./") != 0;
#line 2194 "RsyncTask.c"
			} else {
#line 393 "Utility/RsyncTask.vala"
				_tmp177_ = FALSE;
#line 2198 "RsyncTask.c"
			}
#line 393 "Utility/RsyncTask.vala"
			if (_tmp177_) {
#line 2202 "RsyncTask.c"
				const gchar* _tmp182_;
#line 393 "Utility/RsyncTask.vala"
				_tmp182_ = item_path;
#line 393 "Utility/RsyncTask.vala"
				_tmp176_ = g_strcmp0 (_tmp182_, "./") != 0;
#line 2208 "RsyncTask.c"
			} else {
#line 393 "Utility/RsyncTask.vala"
				_tmp176_ = FALSE;
#line 2212 "RsyncTask.c"
			}
#line 393 "Utility/RsyncTask.vala"
			if (_tmp176_) {
#line 2216 "RsyncTask.c"
				const gchar* _tmp183_;
				const gchar* _tmp184_;
				gchar* _tmp185_;
				FileItem* item = NULL;
				const gchar* _tmp186_;
				FileItem* _tmp187_;
				FileItem* _tmp188_;
				const gchar* _tmp189_;
				gchar* _tmp190_;
				GeeArrayList* _tmp191_;
				FileItem* _tmp192_;
#line 395 "Utility/RsyncTask.vala"
				_tmp183_ = item_basepath;
#line 395 "Utility/RsyncTask.vala"
				_tmp184_ = item_path;
#line 395 "Utility/RsyncTask.vala"
				_tmp185_ = tee_jee_file_system_path_combine (_tmp183_, _tmp184_);
#line 395 "Utility/RsyncTask.vala"
				_g_free0 (item_disk_path);
#line 395 "Utility/RsyncTask.vala"
				item_disk_path = _tmp185_;
#line 397 "Utility/RsyncTask.vala"
				_tmp186_ = item_disk_path;
#line 397 "Utility/RsyncTask.vala"
				_tmp187_ = file_item_new_from_disk_path_with_basic_info (_tmp186_);
#line 397 "Utility/RsyncTask.vala"
				item = _tmp187_;
#line 398 "Utility/RsyncTask.vala"
				_tmp188_ = item;
#line 398 "Utility/RsyncTask.vala"
				_tmp189_ = item_status;
#line 398 "Utility/RsyncTask.vala"
				_tmp190_ = g_strdup (_tmp189_);
#line 398 "Utility/RsyncTask.vala"
				_g_free0 (_tmp188_->file_status);
#line 398 "Utility/RsyncTask.vala"
				_tmp188_->file_status = _tmp190_;
#line 399 "Utility/RsyncTask.vala"
				_tmp191_ = list;
#line 399 "Utility/RsyncTask.vala"
				_tmp192_ = item;
#line 399 "Utility/RsyncTask.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp191_, _tmp192_);
#line 393 "Utility/RsyncTask.vala"
				_g_object_unref0 (item);
#line 2262 "RsyncTask.c"
			}
#line 308 "Utility/RsyncTask.vala"
			_g_match_info_unref0 (match);
#line 308 "Utility/RsyncTask.vala"
			_g_free0 (_tmp40_);
#line 2268 "RsyncTask.c"
		}
#line 292 "Utility/RsyncTask.vala"
		_g_free0 (item_basepath);
#line 292 "Utility/RsyncTask.vala"
		_g_free0 (item_status);
#line 292 "Utility/RsyncTask.vala"
		_g_free0 (item_disk_path);
#line 292 "Utility/RsyncTask.vala"
		_g_free0 (item_path);
#line 292 "Utility/RsyncTask.vala"
		_g_object_unref0 (dis);
#line 292 "Utility/RsyncTask.vala"
		_g_object_unref0 (_tmp29_);
#line 292 "Utility/RsyncTask.vala"
		_g_object_unref0 (file);
#line 292 "Utility/RsyncTask.vala"
		_g_free0 (line);
#line 2286 "RsyncTask.c"
	}
	goto __finally62;
	__catch62_g_error:
	{
		GError* e = NULL;
		GError* _tmp193_;
		const gchar* _tmp194_;
#line 292 "Utility/RsyncTask.vala"
		e = _inner_error0_;
#line 292 "Utility/RsyncTask.vala"
		_inner_error0_ = NULL;
#line 405 "Utility/RsyncTask.vala"
		_tmp193_ = e;
#line 405 "Utility/RsyncTask.vala"
		_tmp194_ = _tmp193_->message;
#line 405 "Utility/RsyncTask.vala"
		tee_jee_logging_log_error (_tmp194_, FALSE, FALSE);
#line 292 "Utility/RsyncTask.vala"
		_g_error_free0 (e);
#line 2306 "RsyncTask.c"
	}
	__finally62:
#line 292 "Utility/RsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 292 "Utility/RsyncTask.vala"
		_g_object_unref0 (dos_changes);
#line 292 "Utility/RsyncTask.vala"
		_g_free0 (log_file);
#line 292 "Utility/RsyncTask.vala"
		_g_object_unref0 (list);
#line 292 "Utility/RsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 292 "Utility/RsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 292 "Utility/RsyncTask.vala"
		return NULL;
#line 2323 "RsyncTask.c"
	}
#line 408 "Utility/RsyncTask.vala"
	_tmp195_ = dos_changes;
#line 408 "Utility/RsyncTask.vala"
	if (_tmp195_ != NULL) {
#line 2329 "RsyncTask.c"
		gchar* _tmp196_;
		gchar* _tmp197_;
#line 410 "Utility/RsyncTask.vala"
		_tmp196_ = g_strdup_printf ("Archiving: %s", log_file_path);
#line 410 "Utility/RsyncTask.vala"
		_tmp197_ = _tmp196_;
#line 410 "Utility/RsyncTask.vala"
		tee_jee_logging_log_msg (_tmp197_, FALSE);
#line 410 "Utility/RsyncTask.vala"
		_g_free0 (_tmp197_);
#line 411 "Utility/RsyncTask.vala"
		tee_jee_file_system_file_gzip (log_file_path);
#line 2342 "RsyncTask.c"
	}
#line 414 "Utility/RsyncTask.vala"
	tee_jee_logging_log_debug ("RsyncTask: parse_log(): exit");
#line 416 "Utility/RsyncTask.vala"
	result = list;
#line 416 "Utility/RsyncTask.vala"
	_g_object_unref0 (dos_changes);
#line 416 "Utility/RsyncTask.vala"
	_g_free0 (log_file);
#line 416 "Utility/RsyncTask.vala"
	return result;
#line 2354 "RsyncTask.c"
}

void
rsync_task_execute (RsyncTask* self)
{
	AppStatus _tmp0_;
#line 421 "Utility/RsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 423 "Utility/RsyncTask.vala"
	tee_jee_logging_log_debug ("RsyncTask:execute()");
#line 425 "Utility/RsyncTask.vala"
	rsync_task_prepare (self);
#line 433 "Utility/RsyncTask.vala"
	async_task_begin ((AsyncTask*) self);
#line 435 "Utility/RsyncTask.vala"
	_tmp0_ = ((AsyncTask*) self)->status;
#line 435 "Utility/RsyncTask.vala"
	if (_tmp0_ == APP_STATUS_RUNNING) {
#line 2373 "RsyncTask.c"
	}
}

static void
rsync_task_real_parse_stdout_line (AsyncTask* base,
                                   const gchar* out_line)
{
	RsyncTask * self;
#line 441 "Utility/RsyncTask.vala"
	self = (RsyncTask*) base;
#line 441 "Utility/RsyncTask.vala"
	g_return_if_fail (out_line != NULL);
#line 442 "Utility/RsyncTask.vala"
	if (((AsyncTask*) self)->is_terminated) {
#line 443 "Utility/RsyncTask.vala"
		return;
#line 2390 "RsyncTask.c"
	}
#line 446 "Utility/RsyncTask.vala"
	rsync_task_update_progress_parse_console_output (self, out_line);
#line 2394 "RsyncTask.c"
}

static void
rsync_task_real_parse_stderr_line (AsyncTask* base,
                                   const gchar* err_line)
{
	RsyncTask * self;
#line 449 "Utility/RsyncTask.vala"
	self = (RsyncTask*) base;
#line 449 "Utility/RsyncTask.vala"
	g_return_if_fail (err_line != NULL);
#line 450 "Utility/RsyncTask.vala"
	if (((AsyncTask*) self)->is_terminated) {
#line 451 "Utility/RsyncTask.vala"
		return;
#line 2410 "RsyncTask.c"
	}
#line 454 "Utility/RsyncTask.vala"
	rsync_task_update_progress_parse_console_output (self, err_line);
#line 2414 "RsyncTask.c"
}

static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
#line 722 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 723 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, (guint) 0);
#line 723 "glib-2.0.vapi"
	return result;
#line 2427 "RsyncTask.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2449 "RsyncTask.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2453 "RsyncTask.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2459 "RsyncTask.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2463 "RsyncTask.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2467 "RsyncTask.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 2475 "RsyncTask.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2503 "RsyncTask.c"
				goto __catch63_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 2512 "RsyncTask.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2526 "RsyncTask.c"
				goto __catch63_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 2537 "RsyncTask.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 2551 "RsyncTask.c"
	}
	goto __finally63;
	__catch63_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 2565 "RsyncTask.c"
	}
	__finally63:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 2576 "RsyncTask.c"
	}
}

gboolean
rsync_task_update_progress_parse_console_output (RsyncTask* self,
                                                 const gchar* line)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint64 _tmp3_;
	GMatchInfo* match = NULL;
	GeeHashMap* _tmp4_;
	gpointer _tmp5_;
	GRegex* _tmp6_;
	GMatchInfo* _tmp7_ = NULL;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 457 "Utility/RsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 457 "Utility/RsyncTask.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 458 "Utility/RsyncTask.vala"
	if (line == NULL) {
#line 458 "Utility/RsyncTask.vala"
		_tmp0_ = TRUE;
#line 2602 "RsyncTask.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 458 "Utility/RsyncTask.vala"
		_tmp1_ = strlen (line);
#line 458 "Utility/RsyncTask.vala"
		_tmp2_ = _tmp1_;
#line 458 "Utility/RsyncTask.vala"
		_tmp0_ = _tmp2_ == 0;
#line 2612 "RsyncTask.c"
	}
#line 458 "Utility/RsyncTask.vala"
	if (_tmp0_) {
#line 459 "Utility/RsyncTask.vala"
		result = TRUE;
#line 459 "Utility/RsyncTask.vala"
		return result;
#line 2620 "RsyncTask.c"
	}
#line 462 "Utility/RsyncTask.vala"
	_tmp3_ = self->status_line_count;
#line 462 "Utility/RsyncTask.vala"
	self->status_line_count = _tmp3_ + 1;
#line 464 "Utility/RsyncTask.vala"
	if (((AsyncTask*) self)->prg_count_total > ((gint64) 0)) {
#line 465 "Utility/RsyncTask.vala"
		((AsyncTask*) self)->prg_count = self->status_line_count;
#line 466 "Utility/RsyncTask.vala"
		((AsyncTask*) self)->progress = (((AsyncTask*) self)->prg_count * 1.0) / ((AsyncTask*) self)->prg_count_total;
#line 2632 "RsyncTask.c"
	}
#line 479 "Utility/RsyncTask.vala"
	_tmp4_ = self->priv->regex_list;
#line 479 "Utility/RsyncTask.vala"
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, "created");
#line 479 "Utility/RsyncTask.vala"
	_tmp6_ = (GRegex*) _tmp5_;
#line 479 "Utility/RsyncTask.vala"
	_tmp8_ = g_regex_match (_tmp6_, line, 0, &_tmp7_);
#line 479 "Utility/RsyncTask.vala"
	_g_match_info_unref0 (match);
#line 479 "Utility/RsyncTask.vala"
	match = _tmp7_;
#line 479 "Utility/RsyncTask.vala"
	_tmp9_ = _tmp8_;
#line 479 "Utility/RsyncTask.vala"
	_g_regex_unref0 (_tmp6_);
#line 479 "Utility/RsyncTask.vala"
	if (_tmp9_) {
#line 2652 "RsyncTask.c"
		gint64 _tmp10_;
		GMatchInfo* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		GString* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 483 "Utility/RsyncTask.vala"
		_tmp10_ = self->count_created;
#line 483 "Utility/RsyncTask.vala"
		self->count_created = _tmp10_ + 1;
#line 484 "Utility/RsyncTask.vala"
		_tmp11_ = match;
#line 484 "Utility/RsyncTask.vala"
		_tmp12_ = g_match_info_fetch (_tmp11_, 3);
#line 484 "Utility/RsyncTask.vala"
		_tmp13_ = _tmp12_;
#line 484 "Utility/RsyncTask.vala"
		_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, " -> ", 0);
#line 484 "Utility/RsyncTask.vala"
		_tmp16_ = _tmp15_;
#line 484 "Utility/RsyncTask.vala"
		_tmp16__length1 = _vala_array_length (_tmp14_);
#line 484 "Utility/RsyncTask.vala"
		_tmp17_ = _tmp16_[0];
#line 484 "Utility/RsyncTask.vala"
		_tmp18_ = string_strip (_tmp17_);
#line 484 "Utility/RsyncTask.vala"
		_g_free0 (((AsyncTask*) self)->status_line);
#line 484 "Utility/RsyncTask.vala"
		((AsyncTask*) self)->status_line = _tmp18_;
#line 484 "Utility/RsyncTask.vala"
		_tmp16_ = (_vala_array_free (_tmp16_, _tmp16__length1, (GDestroyNotify) g_free), NULL);
#line 484 "Utility/RsyncTask.vala"
		_g_free0 (_tmp13_);
#line 485 "Utility/RsyncTask.vala"
		_tmp19_ = self->log;
#line 485 "Utility/RsyncTask.vala"
		_tmp20_ = g_strconcat (line, "\n", NULL);
#line 485 "Utility/RsyncTask.vala"
		_tmp21_ = _tmp20_;
#line 485 "Utility/RsyncTask.vala"
		g_string_append (_tmp19_, _tmp21_);
#line 485 "Utility/RsyncTask.vala"
		_g_free0 (_tmp21_);
#line 2704 "RsyncTask.c"
	} else {
		GeeHashMap* _tmp22_;
		gpointer _tmp23_;
		GRegex* _tmp24_;
		GMatchInfo* _tmp25_ = NULL;
		gboolean _tmp26_;
		gboolean _tmp27_;
#line 487 "Utility/RsyncTask.vala"
		_tmp22_ = self->priv->regex_list;
#line 487 "Utility/RsyncTask.vala"
		_tmp23_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp22_, "deleted");
#line 487 "Utility/RsyncTask.vala"
		_tmp24_ = (GRegex*) _tmp23_;
#line 487 "Utility/RsyncTask.vala"
		_tmp26_ = g_regex_match (_tmp24_, line, 0, &_tmp25_);
#line 487 "Utility/RsyncTask.vala"
		_g_match_info_unref0 (match);
#line 487 "Utility/RsyncTask.vala"
		match = _tmp25_;
#line 487 "Utility/RsyncTask.vala"
		_tmp27_ = _tmp26_;
#line 487 "Utility/RsyncTask.vala"
		_g_regex_unref0 (_tmp24_);
#line 487 "Utility/RsyncTask.vala"
		if (_tmp27_) {
#line 2730 "RsyncTask.c"
			gint64 _tmp28_;
			GMatchInfo* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar** _tmp32_;
			gchar** _tmp33_;
			gchar** _tmp34_;
			gint _tmp34__length1;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			GString* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 491 "Utility/RsyncTask.vala"
			_tmp28_ = self->count_deleted;
#line 491 "Utility/RsyncTask.vala"
			self->count_deleted = _tmp28_ + 1;
#line 492 "Utility/RsyncTask.vala"
			_tmp29_ = match;
#line 492 "Utility/RsyncTask.vala"
			_tmp30_ = g_match_info_fetch (_tmp29_, 1);
#line 492 "Utility/RsyncTask.vala"
			_tmp31_ = _tmp30_;
#line 492 "Utility/RsyncTask.vala"
			_tmp33_ = _tmp32_ = g_strsplit (_tmp31_, " -> ", 0);
#line 492 "Utility/RsyncTask.vala"
			_tmp34_ = _tmp33_;
#line 492 "Utility/RsyncTask.vala"
			_tmp34__length1 = _vala_array_length (_tmp32_);
#line 492 "Utility/RsyncTask.vala"
			_tmp35_ = _tmp34_[0];
#line 492 "Utility/RsyncTask.vala"
			_tmp36_ = string_strip (_tmp35_);
#line 492 "Utility/RsyncTask.vala"
			_g_free0 (((AsyncTask*) self)->status_line);
#line 492 "Utility/RsyncTask.vala"
			((AsyncTask*) self)->status_line = _tmp36_;
#line 492 "Utility/RsyncTask.vala"
			_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 492 "Utility/RsyncTask.vala"
			_g_free0 (_tmp31_);
#line 493 "Utility/RsyncTask.vala"
			_tmp37_ = self->log;
#line 493 "Utility/RsyncTask.vala"
			_tmp38_ = g_strconcat (line, "\n", NULL);
#line 493 "Utility/RsyncTask.vala"
			_tmp39_ = _tmp38_;
#line 493 "Utility/RsyncTask.vala"
			g_string_append (_tmp37_, _tmp39_);
#line 493 "Utility/RsyncTask.vala"
			_g_free0 (_tmp39_);
#line 2782 "RsyncTask.c"
		} else {
			GeeHashMap* _tmp40_;
			gpointer _tmp41_;
			GRegex* _tmp42_;
			GMatchInfo* _tmp43_ = NULL;
			gboolean _tmp44_;
			gboolean _tmp45_;
#line 495 "Utility/RsyncTask.vala"
			_tmp40_ = self->priv->regex_list;
#line 495 "Utility/RsyncTask.vala"
			_tmp41_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp40_, "unchanged");
#line 495 "Utility/RsyncTask.vala"
			_tmp42_ = (GRegex*) _tmp41_;
#line 495 "Utility/RsyncTask.vala"
			_tmp44_ = g_regex_match (_tmp42_, line, 0, &_tmp43_);
#line 495 "Utility/RsyncTask.vala"
			_g_match_info_unref0 (match);
#line 495 "Utility/RsyncTask.vala"
			match = _tmp43_;
#line 495 "Utility/RsyncTask.vala"
			_tmp45_ = _tmp44_;
#line 495 "Utility/RsyncTask.vala"
			_g_regex_unref0 (_tmp42_);
#line 495 "Utility/RsyncTask.vala"
			if (_tmp45_) {
#line 2808 "RsyncTask.c"
				gint64 _tmp46_;
				GMatchInfo* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar** _tmp50_;
				gchar** _tmp51_;
				gchar** _tmp52_;
				gint _tmp52__length1;
				const gchar* _tmp53_;
				gchar* _tmp54_;
#line 499 "Utility/RsyncTask.vala"
				_tmp46_ = self->count_unchanged;
#line 499 "Utility/RsyncTask.vala"
				self->count_unchanged = _tmp46_ + 1;
#line 500 "Utility/RsyncTask.vala"
				_tmp47_ = match;
#line 500 "Utility/RsyncTask.vala"
				_tmp48_ = g_match_info_fetch (_tmp47_, 3);
#line 500 "Utility/RsyncTask.vala"
				_tmp49_ = _tmp48_;
#line 500 "Utility/RsyncTask.vala"
				_tmp51_ = _tmp50_ = g_strsplit (_tmp49_, " -> ", 0);
#line 500 "Utility/RsyncTask.vala"
				_tmp52_ = _tmp51_;
#line 500 "Utility/RsyncTask.vala"
				_tmp52__length1 = _vala_array_length (_tmp50_);
#line 500 "Utility/RsyncTask.vala"
				_tmp53_ = _tmp52_[0];
#line 500 "Utility/RsyncTask.vala"
				_tmp54_ = string_strip (_tmp53_);
#line 500 "Utility/RsyncTask.vala"
				_g_free0 (((AsyncTask*) self)->status_line);
#line 500 "Utility/RsyncTask.vala"
				((AsyncTask*) self)->status_line = _tmp54_;
#line 500 "Utility/RsyncTask.vala"
				_tmp52_ = (_vala_array_free (_tmp52_, _tmp52__length1, (GDestroyNotify) g_free), NULL);
#line 500 "Utility/RsyncTask.vala"
				_g_free0 (_tmp49_);
#line 2847 "RsyncTask.c"
			} else {
				GeeHashMap* _tmp55_;
				gpointer _tmp56_;
				GRegex* _tmp57_;
				GMatchInfo* _tmp58_ = NULL;
				gboolean _tmp59_;
				gboolean _tmp60_;
#line 502 "Utility/RsyncTask.vala"
				_tmp55_ = self->priv->regex_list;
#line 502 "Utility/RsyncTask.vala"
				_tmp56_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp55_, "modified");
#line 502 "Utility/RsyncTask.vala"
				_tmp57_ = (GRegex*) _tmp56_;
#line 502 "Utility/RsyncTask.vala"
				_tmp59_ = g_regex_match (_tmp57_, line, 0, &_tmp58_);
#line 502 "Utility/RsyncTask.vala"
				_g_match_info_unref0 (match);
#line 502 "Utility/RsyncTask.vala"
				match = _tmp58_;
#line 502 "Utility/RsyncTask.vala"
				_tmp60_ = _tmp59_;
#line 502 "Utility/RsyncTask.vala"
				_g_regex_unref0 (_tmp57_);
#line 502 "Utility/RsyncTask.vala"
				if (_tmp60_) {
#line 2873 "RsyncTask.c"
					gint64 _tmp61_;
					GMatchInfo* _tmp62_;
					gchar* _tmp63_;
					gchar* _tmp64_;
					gchar** _tmp65_;
					gchar** _tmp66_;
					gchar** _tmp67_;
					gint _tmp67__length1;
					const gchar* _tmp68_;
					gchar* _tmp69_;
					GString* _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					GMatchInfo* _tmp73_;
					gchar* _tmp74_;
					gchar* _tmp75_;
					gboolean _tmp76_;
#line 506 "Utility/RsyncTask.vala"
					_tmp61_ = self->count_modified;
#line 506 "Utility/RsyncTask.vala"
					self->count_modified = _tmp61_ + 1;
#line 507 "Utility/RsyncTask.vala"
					_tmp62_ = match;
#line 507 "Utility/RsyncTask.vala"
					_tmp63_ = g_match_info_fetch (_tmp62_, 12);
#line 507 "Utility/RsyncTask.vala"
					_tmp64_ = _tmp63_;
#line 507 "Utility/RsyncTask.vala"
					_tmp66_ = _tmp65_ = g_strsplit (_tmp64_, " -> ", 0);
#line 507 "Utility/RsyncTask.vala"
					_tmp67_ = _tmp66_;
#line 507 "Utility/RsyncTask.vala"
					_tmp67__length1 = _vala_array_length (_tmp65_);
#line 507 "Utility/RsyncTask.vala"
					_tmp68_ = _tmp67_[0];
#line 507 "Utility/RsyncTask.vala"
					_tmp69_ = string_strip (_tmp68_);
#line 507 "Utility/RsyncTask.vala"
					_g_free0 (((AsyncTask*) self)->status_line);
#line 507 "Utility/RsyncTask.vala"
					((AsyncTask*) self)->status_line = _tmp69_;
#line 507 "Utility/RsyncTask.vala"
					_tmp67_ = (_vala_array_free (_tmp67_, _tmp67__length1, (GDestroyNotify) g_free), NULL);
#line 507 "Utility/RsyncTask.vala"
					_g_free0 (_tmp64_);
#line 508 "Utility/RsyncTask.vala"
					_tmp70_ = self->log;
#line 508 "Utility/RsyncTask.vala"
					_tmp71_ = g_strconcat (line, "\n", NULL);
#line 508 "Utility/RsyncTask.vala"
					_tmp72_ = _tmp71_;
#line 508 "Utility/RsyncTask.vala"
					g_string_append (_tmp70_, _tmp72_);
#line 508 "Utility/RsyncTask.vala"
					_g_free0 (_tmp72_);
#line 510 "Utility/RsyncTask.vala"
					_tmp73_ = match;
#line 510 "Utility/RsyncTask.vala"
					_tmp74_ = g_match_info_fetch (_tmp73_, 3);
#line 510 "Utility/RsyncTask.vala"
					_tmp75_ = _tmp74_;
#line 510 "Utility/RsyncTask.vala"
					_tmp76_ = g_strcmp0 (_tmp75_, "c") == 0;
#line 510 "Utility/RsyncTask.vala"
					_g_free0 (_tmp75_);
#line 510 "Utility/RsyncTask.vala"
					if (_tmp76_) {
#line 2941 "RsyncTask.c"
						gint64 _tmp77_;
#line 511 "Utility/RsyncTask.vala"
						_tmp77_ = self->count_checksum;
#line 511 "Utility/RsyncTask.vala"
						self->count_checksum = _tmp77_ + 1;
#line 2947 "RsyncTask.c"
					} else {
						GMatchInfo* _tmp78_;
						gchar* _tmp79_;
						gchar* _tmp80_;
						gboolean _tmp81_;
#line 513 "Utility/RsyncTask.vala"
						_tmp78_ = match;
#line 513 "Utility/RsyncTask.vala"
						_tmp79_ = g_match_info_fetch (_tmp78_, 4);
#line 513 "Utility/RsyncTask.vala"
						_tmp80_ = _tmp79_;
#line 513 "Utility/RsyncTask.vala"
						_tmp81_ = g_strcmp0 (_tmp80_, "s") == 0;
#line 513 "Utility/RsyncTask.vala"
						_g_free0 (_tmp80_);
#line 513 "Utility/RsyncTask.vala"
						if (_tmp81_) {
#line 2965 "RsyncTask.c"
							gint64 _tmp82_;
#line 514 "Utility/RsyncTask.vala"
							_tmp82_ = self->count_size;
#line 514 "Utility/RsyncTask.vala"
							self->count_size = _tmp82_ + 1;
#line 2971 "RsyncTask.c"
						} else {
							GMatchInfo* _tmp83_;
							gchar* _tmp84_;
							gchar* _tmp85_;
							gboolean _tmp86_;
#line 516 "Utility/RsyncTask.vala"
							_tmp83_ = match;
#line 516 "Utility/RsyncTask.vala"
							_tmp84_ = g_match_info_fetch (_tmp83_, 5);
#line 516 "Utility/RsyncTask.vala"
							_tmp85_ = _tmp84_;
#line 516 "Utility/RsyncTask.vala"
							_tmp86_ = g_strcmp0 (_tmp85_, "t") == 0;
#line 516 "Utility/RsyncTask.vala"
							_g_free0 (_tmp85_);
#line 516 "Utility/RsyncTask.vala"
							if (_tmp86_) {
#line 2989 "RsyncTask.c"
								gint64 _tmp87_;
#line 517 "Utility/RsyncTask.vala"
								_tmp87_ = self->count_timestamp;
#line 517 "Utility/RsyncTask.vala"
								self->count_timestamp = _tmp87_ + 1;
#line 2995 "RsyncTask.c"
							} else {
								GMatchInfo* _tmp88_;
								gchar* _tmp89_;
								gchar* _tmp90_;
								gboolean _tmp91_;
#line 519 "Utility/RsyncTask.vala"
								_tmp88_ = match;
#line 519 "Utility/RsyncTask.vala"
								_tmp89_ = g_match_info_fetch (_tmp88_, 6);
#line 519 "Utility/RsyncTask.vala"
								_tmp90_ = _tmp89_;
#line 519 "Utility/RsyncTask.vala"
								_tmp91_ = g_strcmp0 (_tmp90_, "p") == 0;
#line 519 "Utility/RsyncTask.vala"
								_g_free0 (_tmp90_);
#line 519 "Utility/RsyncTask.vala"
								if (_tmp91_) {
#line 3013 "RsyncTask.c"
									gint64 _tmp92_;
#line 520 "Utility/RsyncTask.vala"
									_tmp92_ = self->count_permissions;
#line 520 "Utility/RsyncTask.vala"
									self->count_permissions = _tmp92_ + 1;
#line 3019 "RsyncTask.c"
								} else {
									GMatchInfo* _tmp93_;
									gchar* _tmp94_;
									gchar* _tmp95_;
									gboolean _tmp96_;
#line 522 "Utility/RsyncTask.vala"
									_tmp93_ = match;
#line 522 "Utility/RsyncTask.vala"
									_tmp94_ = g_match_info_fetch (_tmp93_, 7);
#line 522 "Utility/RsyncTask.vala"
									_tmp95_ = _tmp94_;
#line 522 "Utility/RsyncTask.vala"
									_tmp96_ = g_strcmp0 (_tmp95_, "o") == 0;
#line 522 "Utility/RsyncTask.vala"
									_g_free0 (_tmp95_);
#line 522 "Utility/RsyncTask.vala"
									if (_tmp96_) {
#line 3037 "RsyncTask.c"
										gint64 _tmp97_;
#line 523 "Utility/RsyncTask.vala"
										_tmp97_ = self->count_owner;
#line 523 "Utility/RsyncTask.vala"
										self->count_owner = _tmp97_ + 1;
#line 3043 "RsyncTask.c"
									} else {
										GMatchInfo* _tmp98_;
										gchar* _tmp99_;
										gchar* _tmp100_;
										gboolean _tmp101_;
#line 525 "Utility/RsyncTask.vala"
										_tmp98_ = match;
#line 525 "Utility/RsyncTask.vala"
										_tmp99_ = g_match_info_fetch (_tmp98_, 8);
#line 525 "Utility/RsyncTask.vala"
										_tmp100_ = _tmp99_;
#line 525 "Utility/RsyncTask.vala"
										_tmp101_ = g_strcmp0 (_tmp100_, "g") == 0;
#line 525 "Utility/RsyncTask.vala"
										_g_free0 (_tmp100_);
#line 525 "Utility/RsyncTask.vala"
										if (_tmp101_) {
#line 3061 "RsyncTask.c"
											gint64 _tmp102_;
#line 526 "Utility/RsyncTask.vala"
											_tmp102_ = self->count_group;
#line 526 "Utility/RsyncTask.vala"
											self->count_group = _tmp102_ + 1;
#line 3067 "RsyncTask.c"
										} else {
											gint64 _tmp103_;
#line 529 "Utility/RsyncTask.vala"
											_tmp103_ = self->count_unchanged;
#line 529 "Utility/RsyncTask.vala"
											self->count_unchanged = _tmp103_ + 1;
#line 3074 "RsyncTask.c"
										}
									}
								}
							}
						}
					}
				} else {
					GeeHashMap* _tmp104_;
					gpointer _tmp105_;
					GRegex* _tmp106_;
					GMatchInfo* _tmp107_ = NULL;
					gboolean _tmp108_;
					gboolean _tmp109_;
#line 532 "Utility/RsyncTask.vala"
					_tmp104_ = self->priv->regex_list;
#line 532 "Utility/RsyncTask.vala"
					_tmp105_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp104_, "total-size");
#line 532 "Utility/RsyncTask.vala"
					_tmp106_ = (GRegex*) _tmp105_;
#line 532 "Utility/RsyncTask.vala"
					_tmp108_ = g_regex_match (_tmp106_, line, 0, &_tmp107_);
#line 532 "Utility/RsyncTask.vala"
					_g_match_info_unref0 (match);
#line 532 "Utility/RsyncTask.vala"
					match = _tmp107_;
#line 532 "Utility/RsyncTask.vala"
					_tmp109_ = _tmp108_;
#line 532 "Utility/RsyncTask.vala"
					_g_regex_unref0 (_tmp106_);
#line 532 "Utility/RsyncTask.vala"
					if (_tmp109_) {
#line 3106 "RsyncTask.c"
						GMatchInfo* _tmp110_;
						gchar* _tmp111_;
						gchar* _tmp112_;
						gchar* _tmp113_;
						gchar* _tmp114_;
#line 533 "Utility/RsyncTask.vala"
						_tmp110_ = match;
#line 533 "Utility/RsyncTask.vala"
						_tmp111_ = g_match_info_fetch (_tmp110_, 1);
#line 533 "Utility/RsyncTask.vala"
						_tmp112_ = _tmp111_;
#line 533 "Utility/RsyncTask.vala"
						_tmp113_ = string_replace (_tmp112_, ",", "");
#line 533 "Utility/RsyncTask.vala"
						_tmp114_ = _tmp113_;
#line 533 "Utility/RsyncTask.vala"
						self->total_size = int64_parse (_tmp114_);
#line 533 "Utility/RsyncTask.vala"
						_g_free0 (_tmp114_);
#line 533 "Utility/RsyncTask.vala"
						_g_free0 (_tmp112_);
#line 3128 "RsyncTask.c"
					} else {
					}
				}
			}
		}
	}
#line 539 "Utility/RsyncTask.vala"
	result = TRUE;
#line 539 "Utility/RsyncTask.vala"
	_g_match_info_unref0 (match);
#line 539 "Utility/RsyncTask.vala"
	return result;
#line 3141 "RsyncTask.c"
}

static void
rsync_task_real_finish_task (AsyncTask* base)
{
	RsyncTask * self;
	gboolean _tmp0_ = FALSE;
	AppStatus _tmp1_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GString* _tmp6_;
	const gchar* _tmp7_;
#line 542 "Utility/RsyncTask.vala"
	self = (RsyncTask*) base;
#line 544 "Utility/RsyncTask.vala"
	_tmp1_ = ((AsyncTask*) self)->status;
#line 544 "Utility/RsyncTask.vala"
	if (_tmp1_ != APP_STATUS_CANCELLED) {
#line 3161 "RsyncTask.c"
		AppStatus _tmp2_;
#line 544 "Utility/RsyncTask.vala"
		_tmp2_ = ((AsyncTask*) self)->status;
#line 544 "Utility/RsyncTask.vala"
		_tmp0_ = _tmp2_ != APP_STATUS_PASSWORD_REQUIRED;
#line 3167 "RsyncTask.c"
	} else {
#line 544 "Utility/RsyncTask.vala"
		_tmp0_ = FALSE;
#line 3171 "RsyncTask.c"
	}
#line 544 "Utility/RsyncTask.vala"
	if (_tmp0_) {
#line 545 "Utility/RsyncTask.vala"
		((AsyncTask*) self)->status = APP_STATUS_FINISHED;
#line 3177 "RsyncTask.c"
	}
#line 548 "Utility/RsyncTask.vala"
	_tmp3_ = self->rsync_log_file;
#line 548 "Utility/RsyncTask.vala"
	_tmp4_ = g_strconcat (_tmp3_, "-changes", NULL);
#line 548 "Utility/RsyncTask.vala"
	_tmp5_ = _tmp4_;
#line 548 "Utility/RsyncTask.vala"
	_tmp6_ = self->log;
#line 548 "Utility/RsyncTask.vala"
	_tmp7_ = _tmp6_->str;
#line 548 "Utility/RsyncTask.vala"
	tee_jee_file_system_file_write (_tmp5_, _tmp7_);
#line 548 "Utility/RsyncTask.vala"
	_g_free0 (_tmp5_);
#line 3193 "RsyncTask.c"
}

gint
rsync_task_read_status (RsyncTask* self)
{
	gint result = 0;
	gchar* status_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* f = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
#line 551 "Utility/RsyncTask.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 552 "Utility/RsyncTask.vala"
	_tmp0_ = ((AsyncTask*) self)->working_dir;
#line 552 "Utility/RsyncTask.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/status", NULL);
#line 552 "Utility/RsyncTask.vala"
	status_file = _tmp1_;
#line 553 "Utility/RsyncTask.vala"
	_tmp2_ = status_file;
#line 553 "Utility/RsyncTask.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 553 "Utility/RsyncTask.vala"
	f = _tmp3_;
#line 554 "Utility/RsyncTask.vala"
	_tmp4_ = f;
#line 554 "Utility/RsyncTask.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 3225 "RsyncTask.c"
		gchar* txt = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 555 "Utility/RsyncTask.vala"
		_tmp5_ = status_file;
#line 555 "Utility/RsyncTask.vala"
		_tmp6_ = tee_jee_file_system_file_read (_tmp5_);
#line 555 "Utility/RsyncTask.vala"
		txt = _tmp6_;
#line 556 "Utility/RsyncTask.vala"
		_tmp7_ = txt;
#line 556 "Utility/RsyncTask.vala"
		result = atoi (_tmp7_);
#line 556 "Utility/RsyncTask.vala"
		_g_free0 (txt);
#line 556 "Utility/RsyncTask.vala"
		_g_object_unref0 (f);
#line 556 "Utility/RsyncTask.vala"
		_g_free0 (status_file);
#line 556 "Utility/RsyncTask.vala"
		return result;
#line 3248 "RsyncTask.c"
	}
#line 558 "Utility/RsyncTask.vala"
	result = -1;
#line 558 "Utility/RsyncTask.vala"
	_g_object_unref0 (f);
#line 558 "Utility/RsyncTask.vala"
	_g_free0 (status_file);
#line 558 "Utility/RsyncTask.vala"
	return result;
#line 3258 "RsyncTask.c"
}

static void
rsync_task_class_init (RsyncTaskClass * klass,
                       gpointer klass_data)
{
#line 31 "Utility/RsyncTask.vala"
	rsync_task_parent_class = g_type_class_peek_parent (klass);
#line 31 "Utility/RsyncTask.vala"
	g_type_class_adjust_private_offset (klass, &RsyncTask_private_offset);
#line 31 "Utility/RsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stdout_line = (void (*) (AsyncTask*, const gchar*)) rsync_task_real_parse_stdout_line;
#line 31 "Utility/RsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stderr_line = (void (*) (AsyncTask*, const gchar*)) rsync_task_real_parse_stderr_line;
#line 31 "Utility/RsyncTask.vala"
	((AsyncTaskClass *) klass)->finish_task = (void (*) (AsyncTask*)) rsync_task_real_finish_task;
#line 31 "Utility/RsyncTask.vala"
	G_OBJECT_CLASS (klass)->finalize = rsync_task_finalize;
#line 3277 "RsyncTask.c"
}

static void
rsync_task_instance_init (RsyncTask * self,
                          gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 31 "Utility/RsyncTask.vala"
	self->priv = rsync_task_get_instance_private (self);
#line 34 "Utility/RsyncTask.vala"
	self->delete_extra = TRUE;
#line 35 "Utility/RsyncTask.vala"
	self->delete_after = FALSE;
#line 36 "Utility/RsyncTask.vala"
	self->delete_excluded = FALSE;
#line 37 "Utility/RsyncTask.vala"
	self->relative = FALSE;
#line 39 "Utility/RsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 39 "Utility/RsyncTask.vala"
	self->rsync_log_file = _tmp0_;
#line 40 "Utility/RsyncTask.vala"
	_tmp1_ = g_strdup ("");
#line 40 "Utility/RsyncTask.vala"
	self->exclude_from_file = _tmp1_;
#line 41 "Utility/RsyncTask.vala"
	_tmp2_ = g_strdup ("");
#line 41 "Utility/RsyncTask.vala"
	self->link_from_path = _tmp2_;
#line 42 "Utility/RsyncTask.vala"
	_tmp3_ = g_strdup ("");
#line 42 "Utility/RsyncTask.vala"
	self->source_path = _tmp3_;
#line 43 "Utility/RsyncTask.vala"
	_tmp4_ = g_strdup ("");
#line 43 "Utility/RsyncTask.vala"
	self->dest_path = _tmp4_;
#line 44 "Utility/RsyncTask.vala"
	self->verbose = TRUE;
#line 45 "Utility/RsyncTask.vala"
	self->io_nice = TRUE;
#line 46 "Utility/RsyncTask.vala"
	self->dry_run = FALSE;
#line 53 "Utility/RsyncTask.vala"
	self->status_line_count = (gint64) 0;
#line 54 "Utility/RsyncTask.vala"
	self->total_size = (gint64) 0;
#line 3329 "RsyncTask.c"
}

static void
rsync_task_finalize (GObject * obj)
{
	RsyncTask * self;
#line 31 "Utility/RsyncTask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RSYNC_TASK, RsyncTask);
#line 39 "Utility/RsyncTask.vala"
	_g_free0 (self->rsync_log_file);
#line 40 "Utility/RsyncTask.vala"
	_g_free0 (self->exclude_from_file);
#line 41 "Utility/RsyncTask.vala"
	_g_free0 (self->link_from_path);
#line 42 "Utility/RsyncTask.vala"
	_g_free0 (self->source_path);
#line 43 "Utility/RsyncTask.vala"
	_g_free0 (self->dest_path);
#line 49 "Utility/RsyncTask.vala"
	_g_object_unref0 (self->priv->regex_list);
#line 52 "Utility/RsyncTask.vala"
	(self->status_lines == NULL) ? NULL : (self->status_lines = (_g_queue_free__g_free0_ (self->status_lines), NULL));
#line 67 "Utility/RsyncTask.vala"
	_g_string_free0 (self->log);
#line 31 "Utility/RsyncTask.vala"
	G_OBJECT_CLASS (rsync_task_parent_class)->finalize (obj);
#line 3356 "RsyncTask.c"
}

GType
rsync_task_get_type (void)
{
	static volatile gsize rsync_task_type_id__volatile = 0;
	if (g_once_init_enter (&rsync_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RsyncTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rsync_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RsyncTask), 0, (GInstanceInitFunc) rsync_task_instance_init, NULL };
		GType rsync_task_type_id;
		rsync_task_type_id = g_type_register_static (TYPE_ASYNC_TASK, "RsyncTask", &g_define_type_info, 0);
		RsyncTask_private_offset = g_type_add_instance_private (rsync_task_type_id, sizeof (RsyncTaskPrivate));
		g_once_init_leave (&rsync_task_type_id__volatile, rsync_task_type_id);
	}
	return rsync_task_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

