/* TeeJee.Process.c generated by valac 0.43.91, the Vala compiler
 * generated from TeeJee.Process.vala, do not modify */

/*
 * TeeJee.ProcessHelper.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <signal.h>
#include <sys/types.h>
#include <glib/gi18n-lib.h>
#include <sys/time.h>
#include <sys/resource.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

extern gchar* tee_jee_process_helper_TEMP_DIR;
gchar* tee_jee_process_helper_TEMP_DIR = NULL;

void tee_jee_process_helper_init_tmp (const gchar* subdir_name);
gchar* tee_jee_misc_random_string (gint length,
                                   const gchar* charset);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gchar* tee_jee_process_helper_create_temp_subdir (void);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gchar* tee_jee_process_helper_save_bash_script_temp (const gchar* commands,
                                                     const gchar* script_path,
                                                     gboolean force_locale,
                                                     gboolean supress_errors);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
gint tee_jee_process_helper_exec_script_async (const gchar* script);
gchar* tee_jee_process_helper_get_temp_file_path (void);
gint tee_jee_file_system_chmod (const gchar* file,
                                const gchar* permission);
gchar* tee_jee_misc_timestamp_numeric (void);
void tee_jee_process_helper_exec_process_new_session (const gchar* command);
gchar* tee_jee_process_helper_get_cmd_path (const gchar* cmd_tool);
gboolean tee_jee_process_helper_cmd_exists (const gchar* cmd_tool);
gint tee_jee_process_helper_get_pid_by_name (const gchar* name);
gint tee_jee_process_helper_get_pid_by_command (const gchar* cmdline);
void tee_jee_process_helper_get_proc_io_stats (gint pid,
                                               gint64* read_bytes,
                                               gint64* write_bytes);
gboolean tee_jee_process_helper_process_is_running (glong pid);
gboolean tee_jee_process_helper_process_is_running_by_name (const gchar* proc_name);
gint* tee_jee_process_helper_get_process_children (GPid parent_pid,
                                                   gint* result_length1);
static void _vala_array_add3 (gint* * array,
                       int* length,
                       int* size,
                       gint value);
void tee_jee_process_helper_process_quit (GPid process_pid,
                                          gboolean killChildren);
void tee_jee_process_helper_process_kill (GPid process_pid,
                                          gboolean killChildren);
gint tee_jee_process_helper_process_pause (GPid procID);
gint tee_jee_process_helper_process_resume (GPid procID);
void tee_jee_process_helper_process_quit_by_name (const gchar* cmd_name,
                                                  const gchar* cmd_to_match,
                                                  gboolean exact_match);
void tee_jee_logging_log_debug (const gchar* message);
void tee_jee_process_helper_process_set_priority (GPid procID,
                                                  gint prio);
gint tee_jee_process_helper_process_get_priority (GPid procID);
void tee_jee_process_helper_process_set_priority_normal (GPid procID);
void tee_jee_process_helper_process_set_priority_low (GPid procID);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 139 "TeeJee.Process.c"
}

void
tee_jee_process_helper_init_tmp (const gchar* subdir_name)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	const gchar* _tmp14_;
#line 36 "Utility/TeeJee.Process.vala"
	g_return_if_fail (subdir_name != NULL);
#line 39 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_get_tmp_dir ();
#line 39 "Utility/TeeJee.Process.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 39 "Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 39 "Utility/TeeJee.Process.vala"
	_tmp3_ = g_strconcat (_tmp2_, subdir_name, NULL);
#line 39 "Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 39 "Utility/TeeJee.Process.vala"
	_tmp5_ = g_strconcat (_tmp4_, "/", NULL);
#line 39 "Utility/TeeJee.Process.vala"
	_tmp6_ = _tmp5_;
#line 39 "Utility/TeeJee.Process.vala"
	_tmp7_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 39 "Utility/TeeJee.Process.vala"
	_tmp8_ = _tmp7_;
#line 39 "Utility/TeeJee.Process.vala"
	_tmp9_ = g_strconcat (_tmp6_, _tmp8_, NULL);
#line 39 "Utility/TeeJee.Process.vala"
	_g_free0 (tee_jee_process_helper_TEMP_DIR);
#line 39 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_TEMP_DIR = _tmp9_;
#line 39 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp8_);
#line 39 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp6_);
#line 39 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp4_);
#line 39 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 40 "Utility/TeeJee.Process.vala"
	_tmp10_ = tee_jee_process_helper_TEMP_DIR;
#line 40 "Utility/TeeJee.Process.vala"
	tee_jee_file_system_dir_create (_tmp10_, FALSE);
#line 42 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_script_sync ("echo 'ok'", &_tmp11_, &_tmp12_, TRUE, FALSE, TRUE, FALSE);
#line 42 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 42 "Utility/TeeJee.Process.vala"
	std_out = _tmp11_;
#line 42 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 42 "Utility/TeeJee.Process.vala"
	std_err = _tmp12_;
#line 43 "Utility/TeeJee.Process.vala"
	_tmp14_ = std_out;
#line 43 "Utility/TeeJee.Process.vala"
	if (_tmp14_ == NULL) {
#line 43 "Utility/TeeJee.Process.vala"
		_tmp13_ = TRUE;
#line 216 "TeeJee.Process.c"
	} else {
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 43 "Utility/TeeJee.Process.vala"
		_tmp15_ = std_out;
#line 43 "Utility/TeeJee.Process.vala"
		_tmp16_ = string_strip (_tmp15_);
#line 43 "Utility/TeeJee.Process.vala"
		_tmp17_ = _tmp16_;
#line 43 "Utility/TeeJee.Process.vala"
		_tmp13_ = g_strcmp0 (_tmp17_, "ok") != 0;
#line 43 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp17_);
#line 231 "TeeJee.Process.c"
	}
#line 43 "Utility/TeeJee.Process.vala"
	if (_tmp13_) {
#line 235 "TeeJee.Process.c"
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
#line 44 "Utility/TeeJee.Process.vala"
		_tmp18_ = g_get_home_dir ();
#line 44 "Utility/TeeJee.Process.vala"
		_tmp19_ = g_strconcat (_tmp18_, "/.temp/", NULL);
#line 44 "Utility/TeeJee.Process.vala"
		_tmp20_ = _tmp19_;
#line 44 "Utility/TeeJee.Process.vala"
		_tmp21_ = g_strconcat (_tmp20_, subdir_name, NULL);
#line 44 "Utility/TeeJee.Process.vala"
		_tmp22_ = _tmp21_;
#line 44 "Utility/TeeJee.Process.vala"
		_tmp23_ = g_strconcat (_tmp22_, "/", NULL);
#line 44 "Utility/TeeJee.Process.vala"
		_tmp24_ = _tmp23_;
#line 44 "Utility/TeeJee.Process.vala"
		_tmp25_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 44 "Utility/TeeJee.Process.vala"
		_tmp26_ = _tmp25_;
#line 44 "Utility/TeeJee.Process.vala"
		_tmp27_ = g_strconcat (_tmp24_, _tmp26_, NULL);
#line 44 "Utility/TeeJee.Process.vala"
		_g_free0 (tee_jee_process_helper_TEMP_DIR);
#line 44 "Utility/TeeJee.Process.vala"
		tee_jee_process_helper_TEMP_DIR = _tmp27_;
#line 44 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp26_);
#line 44 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp24_);
#line 44 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp22_);
#line 44 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp20_);
#line 45 "Utility/TeeJee.Process.vala"
		_tmp28_ = tee_jee_process_helper_TEMP_DIR;
#line 45 "Utility/TeeJee.Process.vala"
		_tmp29_ = g_strdup_printf ("rm -rf '%s'", _tmp28_);
#line 45 "Utility/TeeJee.Process.vala"
		_tmp30_ = _tmp29_;
#line 45 "Utility/TeeJee.Process.vala"
		tee_jee_process_helper_exec_sync (_tmp30_, NULL, NULL);
#line 45 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp30_);
#line 46 "Utility/TeeJee.Process.vala"
		_tmp31_ = tee_jee_process_helper_TEMP_DIR;
#line 46 "Utility/TeeJee.Process.vala"
		tee_jee_file_system_dir_create (_tmp31_, FALSE);
#line 296 "TeeJee.Process.c"
	}
#line 36 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 36 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 302 "TeeJee.Process.c"
}

gchar*
tee_jee_process_helper_create_temp_subdir (void)
{
	gchar* result = NULL;
	gchar* temp = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 53 "Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 53 "Utility/TeeJee.Process.vala"
	_tmp1_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 53 "Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 53 "Utility/TeeJee.Process.vala"
	_tmp3_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp2_);
#line 53 "Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 53 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 53 "Utility/TeeJee.Process.vala"
	temp = _tmp4_;
#line 54 "Utility/TeeJee.Process.vala"
	tee_jee_file_system_dir_create (temp, FALSE);
#line 55 "Utility/TeeJee.Process.vala"
	result = temp;
#line 55 "Utility/TeeJee.Process.vala"
	return result;
#line 335 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_exec_sync (const gchar* cmd,
                                  gchar* * std_out,
                                  gchar* * std_err)
{
	gchar* _vala_std_out = NULL;
	gchar* _vala_std_err = NULL;
	gint result = 0;
	gint _tmp5_ = -1;
	GError* _inner_error0_ = NULL;
#line 58 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd != NULL, 0);
#line 350 "TeeJee.Process.c"
	{
		gint status = 0;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
#line 66 "Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (cmd, &_tmp0_, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 66 "Utility/TeeJee.Process.vala"
		_g_free0 (_vala_std_out);
#line 66 "Utility/TeeJee.Process.vala"
		_vala_std_out = _tmp0_;
#line 66 "Utility/TeeJee.Process.vala"
		_g_free0 (_vala_std_err);
#line 66 "Utility/TeeJee.Process.vala"
		_vala_std_err = _tmp1_;
#line 66 "Utility/TeeJee.Process.vala"
		status = _tmp2_;
#line 66 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 370 "TeeJee.Process.c"
			goto __catch83_g_error;
		}
#line 67 "Utility/TeeJee.Process.vala"
		result = status;
#line 67 "Utility/TeeJee.Process.vala"
		if (std_out) {
#line 67 "Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 379 "TeeJee.Process.c"
		} else {
#line 67 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 383 "TeeJee.Process.c"
		}
#line 67 "Utility/TeeJee.Process.vala"
		if (std_err) {
#line 67 "Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 389 "TeeJee.Process.c"
		} else {
#line 67 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 393 "TeeJee.Process.c"
		}
#line 67 "Utility/TeeJee.Process.vala"
		return result;
#line 397 "TeeJee.Process.c"
	}
	goto __finally83;
	__catch83_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 64 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 64 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 70 "Utility/TeeJee.Process.vala"
		_tmp3_ = e;
#line 70 "Utility/TeeJee.Process.vala"
		_tmp4_ = _tmp3_->message;
#line 70 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 71 "Utility/TeeJee.Process.vala"
		result = -1;
#line 71 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 71 "Utility/TeeJee.Process.vala"
		if (std_out) {
#line 71 "Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 423 "TeeJee.Process.c"
		} else {
#line 71 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 427 "TeeJee.Process.c"
		}
#line 71 "Utility/TeeJee.Process.vala"
		if (std_err) {
#line 71 "Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 433 "TeeJee.Process.c"
		} else {
#line 71 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 437 "TeeJee.Process.c"
		}
#line 71 "Utility/TeeJee.Process.vala"
		return result;
#line 441 "TeeJee.Process.c"
	}
	__finally83:
#line 64 "Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error0_);
#line 64 "Utility/TeeJee.Process.vala"
	return _tmp5_;
#line 450 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_exec_script_sync (const gchar* script,
                                         gchar* * std_out,
                                         gchar* * std_err,
                                         gboolean supress_errors,
                                         gboolean run_as_admin,
                                         gboolean cleanup_tmp,
                                         gboolean print_to_terminal)
{
	gchar* _vala_std_out = NULL;
	gchar* _vala_std_err = NULL;
	gint result = 0;
	gchar* sh_file = NULL;
	gchar* _tmp0_;
	gchar* sh_file_admin = NULL;
	gchar* _tmp1_;
	gint _tmp43_ = -1;
	GError* _inner_error0_ = NULL;
#line 75 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (script != NULL, 0);
#line 86 "Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_save_bash_script_temp (script, NULL, TRUE, supress_errors);
#line 86 "Utility/TeeJee.Process.vala"
	sh_file = _tmp0_;
#line 87 "Utility/TeeJee.Process.vala"
	_tmp1_ = g_strdup ("");
#line 87 "Utility/TeeJee.Process.vala"
	sh_file_admin = _tmp1_;
#line 89 "Utility/TeeJee.Process.vala"
	if (run_as_admin) {
#line 483 "TeeJee.Process.c"
		gchar* script_admin = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 91 "Utility/TeeJee.Process.vala"
		_tmp2_ = g_strdup ("#!/bin/bash\n");
#line 91 "Utility/TeeJee.Process.vala"
		script_admin = _tmp2_;
#line 92 "Utility/TeeJee.Process.vala"
		_tmp3_ = script_admin;
#line 92 "Utility/TeeJee.Process.vala"
		_tmp4_ = g_strconcat (_tmp3_, "pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY", NULL);
#line 92 "Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 92 "Utility/TeeJee.Process.vala"
		script_admin = _tmp4_;
#line 93 "Utility/TeeJee.Process.vala"
		_tmp5_ = script_admin;
#line 93 "Utility/TeeJee.Process.vala"
		_tmp6_ = sh_file;
#line 93 "Utility/TeeJee.Process.vala"
		_tmp7_ = tee_jee_file_system_escape_single_quote (_tmp6_);
#line 93 "Utility/TeeJee.Process.vala"
		_tmp8_ = _tmp7_;
#line 93 "Utility/TeeJee.Process.vala"
		_tmp9_ = g_strdup_printf (" '%s'", _tmp8_);
#line 93 "Utility/TeeJee.Process.vala"
		_tmp10_ = _tmp9_;
#line 93 "Utility/TeeJee.Process.vala"
		_tmp11_ = g_strconcat (_tmp5_, _tmp10_, NULL);
#line 93 "Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 93 "Utility/TeeJee.Process.vala"
		script_admin = _tmp11_;
#line 93 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp10_);
#line 93 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp8_);
#line 95 "Utility/TeeJee.Process.vala"
		_tmp12_ = sh_file;
#line 95 "Utility/TeeJee.Process.vala"
		_tmp13_ = tee_jee_file_system_file_parent (_tmp12_);
#line 95 "Utility/TeeJee.Process.vala"
		_tmp14_ = _tmp13_;
#line 95 "Utility/TeeJee.Process.vala"
		_tmp15_ = g_build_filename (_tmp14_, "script-admin.sh", NULL);
#line 95 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 95 "Utility/TeeJee.Process.vala"
		sh_file_admin = _tmp15_;
#line 95 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp14_);
#line 97 "Utility/TeeJee.Process.vala"
		_tmp16_ = script_admin;
#line 97 "Utility/TeeJee.Process.vala"
		_tmp17_ = sh_file_admin;
#line 97 "Utility/TeeJee.Process.vala"
		_tmp18_ = tee_jee_process_helper_save_bash_script_temp (_tmp16_, _tmp17_, TRUE, supress_errors);
#line 97 "Utility/TeeJee.Process.vala"
		_tmp19_ = _tmp18_;
#line 97 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp19_);
#line 89 "Utility/TeeJee.Process.vala"
		_g_free0 (script_admin);
#line 563 "TeeJee.Process.c"
	}
	{
		gchar** argv = NULL;
		gchar** _tmp20_;
		gint argv_length1;
		gint _argv_size_;
		gchar** env = NULL;
		gchar** _tmp27_;
		gchar** _tmp28_;
		gint env_length1;
		gint _env_size_;
		gint exit_code = 0;
#line 101 "Utility/TeeJee.Process.vala"
		_tmp20_ = g_new0 (gchar*, 1 + 1);
#line 101 "Utility/TeeJee.Process.vala"
		argv = _tmp20_;
#line 101 "Utility/TeeJee.Process.vala"
		argv_length1 = 1;
#line 101 "Utility/TeeJee.Process.vala"
		_argv_size_ = argv_length1;
#line 102 "Utility/TeeJee.Process.vala"
		if (run_as_admin) {
#line 586 "TeeJee.Process.c"
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
			gchar* _tmp23_;
#line 103 "Utility/TeeJee.Process.vala"
			_tmp21_ = argv;
#line 103 "Utility/TeeJee.Process.vala"
			_tmp21__length1 = argv_length1;
#line 103 "Utility/TeeJee.Process.vala"
			_tmp22_ = sh_file_admin;
#line 103 "Utility/TeeJee.Process.vala"
			_tmp23_ = g_strdup (_tmp22_);
#line 103 "Utility/TeeJee.Process.vala"
			_g_free0 (_tmp21_[0]);
#line 103 "Utility/TeeJee.Process.vala"
			_tmp21_[0] = _tmp23_;
#line 603 "TeeJee.Process.c"
		} else {
			gchar** _tmp24_;
			gint _tmp24__length1;
			const gchar* _tmp25_;
			gchar* _tmp26_;
#line 106 "Utility/TeeJee.Process.vala"
			_tmp24_ = argv;
#line 106 "Utility/TeeJee.Process.vala"
			_tmp24__length1 = argv_length1;
#line 106 "Utility/TeeJee.Process.vala"
			_tmp25_ = sh_file;
#line 106 "Utility/TeeJee.Process.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 106 "Utility/TeeJee.Process.vala"
			_g_free0 (_tmp24_[0]);
#line 106 "Utility/TeeJee.Process.vala"
			_tmp24_[0] = _tmp26_;
#line 621 "TeeJee.Process.c"
		}
#line 109 "Utility/TeeJee.Process.vala"
		_tmp28_ = _tmp27_ = g_get_environ ();
#line 109 "Utility/TeeJee.Process.vala"
		env = _tmp28_;
#line 109 "Utility/TeeJee.Process.vala"
		env_length1 = _vala_array_length (_tmp27_);
#line 109 "Utility/TeeJee.Process.vala"
		_env_size_ = env_length1;
#line 113 "Utility/TeeJee.Process.vala"
		if (print_to_terminal) {
#line 633 "TeeJee.Process.c"
			const gchar* _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
			gchar** _tmp31_;
			gint _tmp31__length1;
			gint _tmp32_ = 0;
#line 115 "Utility/TeeJee.Process.vala"
			_tmp29_ = tee_jee_process_helper_TEMP_DIR;
#line 115 "Utility/TeeJee.Process.vala"
			_tmp30_ = argv;
#line 115 "Utility/TeeJee.Process.vala"
			_tmp30__length1 = argv_length1;
#line 115 "Utility/TeeJee.Process.vala"
			_tmp31_ = env;
#line 115 "Utility/TeeJee.Process.vala"
			_tmp31__length1 = env_length1;
#line 115 "Utility/TeeJee.Process.vala"
			g_spawn_sync (_tmp29_, _tmp30_, _tmp31_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, &_tmp32_, &_inner_error0_);
#line 115 "Utility/TeeJee.Process.vala"
			exit_code = _tmp32_;
#line 115 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "Utility/TeeJee.Process.vala"
				env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 115 "Utility/TeeJee.Process.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 660 "TeeJee.Process.c"
				goto __catch84_g_error;
			}
		} else {
			const gchar* _tmp33_;
			gchar** _tmp34_;
			gint _tmp34__length1;
			gchar** _tmp35_;
			gint _tmp35__length1;
			gchar* _tmp36_ = NULL;
			gchar* _tmp37_ = NULL;
			gint _tmp38_ = 0;
#line 128 "Utility/TeeJee.Process.vala"
			_tmp33_ = tee_jee_process_helper_TEMP_DIR;
#line 128 "Utility/TeeJee.Process.vala"
			_tmp34_ = argv;
#line 128 "Utility/TeeJee.Process.vala"
			_tmp34__length1 = argv_length1;
#line 128 "Utility/TeeJee.Process.vala"
			_tmp35_ = env;
#line 128 "Utility/TeeJee.Process.vala"
			_tmp35__length1 = env_length1;
#line 128 "Utility/TeeJee.Process.vala"
			g_spawn_sync (_tmp33_, _tmp34_, _tmp35_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp36_, &_tmp37_, &_tmp38_, &_inner_error0_);
#line 128 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 128 "Utility/TeeJee.Process.vala"
			_vala_std_out = _tmp36_;
#line 128 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 128 "Utility/TeeJee.Process.vala"
			_vala_std_err = _tmp37_;
#line 128 "Utility/TeeJee.Process.vala"
			exit_code = _tmp38_;
#line 128 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "Utility/TeeJee.Process.vala"
				env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 128 "Utility/TeeJee.Process.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 700 "TeeJee.Process.c"
				goto __catch84_g_error;
			}
		}
#line 140 "Utility/TeeJee.Process.vala"
		if (cleanup_tmp) {
#line 706 "TeeJee.Process.c"
			const gchar* _tmp39_;
#line 141 "Utility/TeeJee.Process.vala"
			_tmp39_ = sh_file;
#line 141 "Utility/TeeJee.Process.vala"
			tee_jee_file_system_file_delete (_tmp39_);
#line 142 "Utility/TeeJee.Process.vala"
			if (run_as_admin) {
#line 714 "TeeJee.Process.c"
				const gchar* _tmp40_;
#line 143 "Utility/TeeJee.Process.vala"
				_tmp40_ = sh_file_admin;
#line 143 "Utility/TeeJee.Process.vala"
				tee_jee_file_system_file_delete (_tmp40_);
#line 720 "TeeJee.Process.c"
			}
		}
#line 147 "Utility/TeeJee.Process.vala"
		result = exit_code;
#line 147 "Utility/TeeJee.Process.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 147 "Utility/TeeJee.Process.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 147 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 147 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file);
#line 147 "Utility/TeeJee.Process.vala"
		if (std_out) {
#line 147 "Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 737 "TeeJee.Process.c"
		} else {
#line 147 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 741 "TeeJee.Process.c"
		}
#line 147 "Utility/TeeJee.Process.vala"
		if (std_err) {
#line 147 "Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 747 "TeeJee.Process.c"
		} else {
#line 147 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 751 "TeeJee.Process.c"
		}
#line 147 "Utility/TeeJee.Process.vala"
		return result;
#line 755 "TeeJee.Process.c"
	}
	goto __finally84;
	__catch84_g_error:
	{
		GError* e = NULL;
#line 100 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 100 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 150 "Utility/TeeJee.Process.vala"
		if (!supress_errors) {
#line 767 "TeeJee.Process.c"
			GError* _tmp41_;
			const gchar* _tmp42_;
#line 151 "Utility/TeeJee.Process.vala"
			_tmp41_ = e;
#line 151 "Utility/TeeJee.Process.vala"
			_tmp42_ = _tmp41_->message;
#line 151 "Utility/TeeJee.Process.vala"
			tee_jee_logging_log_error (_tmp42_, FALSE, FALSE);
#line 776 "TeeJee.Process.c"
		}
#line 153 "Utility/TeeJee.Process.vala"
		result = -1;
#line 153 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 153 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file_admin);
#line 153 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_file);
#line 153 "Utility/TeeJee.Process.vala"
		if (std_out) {
#line 153 "Utility/TeeJee.Process.vala"
			*std_out = _vala_std_out;
#line 790 "TeeJee.Process.c"
		} else {
#line 153 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_out);
#line 794 "TeeJee.Process.c"
		}
#line 153 "Utility/TeeJee.Process.vala"
		if (std_err) {
#line 153 "Utility/TeeJee.Process.vala"
			*std_err = _vala_std_err;
#line 800 "TeeJee.Process.c"
		} else {
#line 153 "Utility/TeeJee.Process.vala"
			_g_free0 (_vala_std_err);
#line 804 "TeeJee.Process.c"
		}
#line 153 "Utility/TeeJee.Process.vala"
		return result;
#line 808 "TeeJee.Process.c"
	}
	__finally84:
#line 100 "Utility/TeeJee.Process.vala"
	_g_free0 (sh_file_admin);
#line 100 "Utility/TeeJee.Process.vala"
	_g_free0 (sh_file);
#line 100 "Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error0_);
#line 100 "Utility/TeeJee.Process.vala"
	return _tmp43_;
#line 821 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_exec_script_async (const gchar* script)
{
	gint result = 0;
	gint _tmp9_ = -1;
	GError* _inner_error0_ = NULL;
#line 157 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (script != NULL, 0);
#line 832 "TeeJee.Process.c"
	{
		gchar* scriptfile = NULL;
		gchar* _tmp0_;
		gchar** argv = NULL;
		gchar** _tmp1_;
		gint argv_length1;
		gint _argv_size_;
		gchar* _tmp2_;
		gchar** env = NULL;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint env_length1;
		gint _env_size_;
		GPid child_pid = 0;
		const gchar* _tmp5_;
		GPid _tmp6_ = 0;
#line 167 "Utility/TeeJee.Process.vala"
		_tmp0_ = tee_jee_process_helper_save_bash_script_temp (script, NULL, TRUE, FALSE);
#line 167 "Utility/TeeJee.Process.vala"
		scriptfile = _tmp0_;
#line 169 "Utility/TeeJee.Process.vala"
		_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 169 "Utility/TeeJee.Process.vala"
		argv = _tmp1_;
#line 169 "Utility/TeeJee.Process.vala"
		argv_length1 = 1;
#line 169 "Utility/TeeJee.Process.vala"
		_argv_size_ = argv_length1;
#line 170 "Utility/TeeJee.Process.vala"
		_tmp2_ = g_strdup (scriptfile);
#line 170 "Utility/TeeJee.Process.vala"
		_g_free0 (argv[0]);
#line 170 "Utility/TeeJee.Process.vala"
		argv[0] = _tmp2_;
#line 172 "Utility/TeeJee.Process.vala"
		_tmp4_ = _tmp3_ = g_get_environ ();
#line 172 "Utility/TeeJee.Process.vala"
		env = _tmp4_;
#line 172 "Utility/TeeJee.Process.vala"
		env_length1 = _vala_array_length (_tmp3_);
#line 172 "Utility/TeeJee.Process.vala"
		_env_size_ = env_length1;
#line 175 "Utility/TeeJee.Process.vala"
		_tmp5_ = tee_jee_process_helper_TEMP_DIR;
#line 175 "Utility/TeeJee.Process.vala"
		g_spawn_async_with_pipes (_tmp5_, argv, env, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp6_, NULL, NULL, NULL, &_inner_error0_);
#line 175 "Utility/TeeJee.Process.vala"
		child_pid = _tmp6_;
#line 175 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 175 "Utility/TeeJee.Process.vala"
			env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 175 "Utility/TeeJee.Process.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 175 "Utility/TeeJee.Process.vala"
			_g_free0 (scriptfile);
#line 889 "TeeJee.Process.c"
			goto __catch85_g_error;
		}
#line 183 "Utility/TeeJee.Process.vala"
		result = 0;
#line 183 "Utility/TeeJee.Process.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 183 "Utility/TeeJee.Process.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 183 "Utility/TeeJee.Process.vala"
		_g_free0 (scriptfile);
#line 183 "Utility/TeeJee.Process.vala"
		return result;
#line 902 "TeeJee.Process.c"
	}
	goto __finally85;
	__catch85_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 165 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 165 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 186 "Utility/TeeJee.Process.vala"
		_tmp7_ = e;
#line 186 "Utility/TeeJee.Process.vala"
		_tmp8_ = _tmp7_->message;
#line 186 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 187 "Utility/TeeJee.Process.vala"
		result = 1;
#line 187 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 187 "Utility/TeeJee.Process.vala"
		return result;
#line 926 "TeeJee.Process.c"
	}
	__finally85:
#line 165 "Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error0_);
#line 165 "Utility/TeeJee.Process.vala"
	return _tmp9_;
#line 935 "TeeJee.Process.c"
}

gchar*
tee_jee_process_helper_save_bash_script_temp (const gchar* commands,
                                              const gchar* script_path,
                                              gboolean force_locale,
                                              gboolean supress_errors)
{
	gchar* result = NULL;
	gchar* sh_path = NULL;
	gchar* _tmp0_;
	GString* script = NULL;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	GString* _tmp5_;
	GString* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GString* _tmp9_;
	GString* _tmp10_;
	GString* _tmp11_;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 191 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (commands != NULL, NULL);
#line 194 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup (script_path);
#line 194 "Utility/TeeJee.Process.vala"
	sh_path = _tmp0_;
#line 199 "Utility/TeeJee.Process.vala"
	_tmp1_ = g_string_new ("");
#line 199 "Utility/TeeJee.Process.vala"
	script = _tmp1_;
#line 200 "Utility/TeeJee.Process.vala"
	_tmp2_ = script;
#line 200 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp2_, "#!/bin/bash\n");
#line 201 "Utility/TeeJee.Process.vala"
	_tmp3_ = script;
#line 201 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp3_, "\n");
#line 202 "Utility/TeeJee.Process.vala"
	if (force_locale) {
#line 981 "TeeJee.Process.c"
		GString* _tmp4_;
#line 203 "Utility/TeeJee.Process.vala"
		_tmp4_ = script;
#line 203 "Utility/TeeJee.Process.vala"
		g_string_append (_tmp4_, "LANG=C\n");
#line 987 "TeeJee.Process.c"
	}
#line 205 "Utility/TeeJee.Process.vala"
	_tmp5_ = script;
#line 205 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp5_, "\n");
#line 206 "Utility/TeeJee.Process.vala"
	_tmp6_ = script;
#line 206 "Utility/TeeJee.Process.vala"
	_tmp7_ = g_strdup_printf ("%s\n", commands);
#line 206 "Utility/TeeJee.Process.vala"
	_tmp8_ = _tmp7_;
#line 206 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp6_, _tmp8_);
#line 206 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp8_);
#line 207 "Utility/TeeJee.Process.vala"
	_tmp9_ = script;
#line 207 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp9_, "\n\nexitCode=$?\n");
#line 208 "Utility/TeeJee.Process.vala"
	_tmp10_ = script;
#line 208 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp10_, "echo ${exitCode} > ${exitCode}\n");
#line 209 "Utility/TeeJee.Process.vala"
	_tmp11_ = script;
#line 209 "Utility/TeeJee.Process.vala"
	g_string_append (_tmp11_, "echo ${exitCode} > status\n");
#line 211 "Utility/TeeJee.Process.vala"
	_tmp13_ = sh_path;
#line 211 "Utility/TeeJee.Process.vala"
	if (_tmp13_ == NULL) {
#line 211 "Utility/TeeJee.Process.vala"
		_tmp12_ = TRUE;
#line 1021 "TeeJee.Process.c"
	} else {
		const gchar* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 211 "Utility/TeeJee.Process.vala"
		_tmp14_ = sh_path;
#line 211 "Utility/TeeJee.Process.vala"
		_tmp15_ = strlen (_tmp14_);
#line 211 "Utility/TeeJee.Process.vala"
		_tmp16_ = _tmp15_;
#line 211 "Utility/TeeJee.Process.vala"
		_tmp12_ = _tmp16_ == 0;
#line 1034 "TeeJee.Process.c"
	}
#line 211 "Utility/TeeJee.Process.vala"
	if (_tmp12_) {
#line 1038 "TeeJee.Process.c"
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 212 "Utility/TeeJee.Process.vala"
		_tmp17_ = tee_jee_process_helper_get_temp_file_path ();
#line 212 "Utility/TeeJee.Process.vala"
		_tmp18_ = _tmp17_;
#line 212 "Utility/TeeJee.Process.vala"
		_tmp19_ = g_strconcat (_tmp18_, ".sh", NULL);
#line 212 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_path);
#line 212 "Utility/TeeJee.Process.vala"
		sh_path = _tmp19_;
#line 212 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp18_);
#line 1054 "TeeJee.Process.c"
	}
	{
		GFile* file = NULL;
		const gchar* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp24_;
		GFileOutputStream* _tmp25_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp26_;
		GDataOutputStream* _tmp27_;
		GDataOutputStream* _tmp28_;
		GString* _tmp29_;
		const gchar* _tmp30_;
		GDataOutputStream* _tmp31_;
		const gchar* _tmp32_;
#line 217 "Utility/TeeJee.Process.vala"
		_tmp20_ = sh_path;
#line 217 "Utility/TeeJee.Process.vala"
		_tmp21_ = g_file_new_for_path (_tmp20_);
#line 217 "Utility/TeeJee.Process.vala"
		file = _tmp21_;
#line 218 "Utility/TeeJee.Process.vala"
		_tmp22_ = file;
#line 218 "Utility/TeeJee.Process.vala"
		if (g_file_query_exists (_tmp22_, NULL)) {
#line 1082 "TeeJee.Process.c"
			GFile* _tmp23_;
#line 219 "Utility/TeeJee.Process.vala"
			_tmp23_ = file;
#line 219 "Utility/TeeJee.Process.vala"
			g_file_delete (_tmp23_, NULL, &_inner_error0_);
#line 219 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 1092 "TeeJee.Process.c"
				goto __catch86_g_error;
			}
		}
#line 221 "Utility/TeeJee.Process.vala"
		_tmp24_ = file;
#line 221 "Utility/TeeJee.Process.vala"
		_tmp25_ = g_file_create (_tmp24_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 221 "Utility/TeeJee.Process.vala"
		file_stream = _tmp25_;
#line 221 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1106 "TeeJee.Process.c"
			goto __catch86_g_error;
		}
#line 222 "Utility/TeeJee.Process.vala"
		_tmp26_ = file_stream;
#line 222 "Utility/TeeJee.Process.vala"
		_tmp27_ = g_data_output_stream_new ((GOutputStream*) _tmp26_);
#line 222 "Utility/TeeJee.Process.vala"
		data_stream = _tmp27_;
#line 223 "Utility/TeeJee.Process.vala"
		_tmp28_ = data_stream;
#line 223 "Utility/TeeJee.Process.vala"
		_tmp29_ = script;
#line 223 "Utility/TeeJee.Process.vala"
		_tmp30_ = _tmp29_->str;
#line 223 "Utility/TeeJee.Process.vala"
		g_data_output_stream_put_string (_tmp28_, _tmp30_, NULL, &_inner_error0_);
#line 223 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (data_stream);
#line 223 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file_stream);
#line 223 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1131 "TeeJee.Process.c"
			goto __catch86_g_error;
		}
#line 224 "Utility/TeeJee.Process.vala"
		_tmp31_ = data_stream;
#line 224 "Utility/TeeJee.Process.vala"
		g_output_stream_close ((GOutputStream*) _tmp31_, NULL, &_inner_error0_);
#line 224 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (data_stream);
#line 224 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file_stream);
#line 224 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 1146 "TeeJee.Process.c"
			goto __catch86_g_error;
		}
#line 227 "Utility/TeeJee.Process.vala"
		_tmp32_ = sh_path;
#line 227 "Utility/TeeJee.Process.vala"
		tee_jee_file_system_chmod (_tmp32_, "u+x");
#line 229 "Utility/TeeJee.Process.vala"
		result = sh_path;
#line 229 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (data_stream);
#line 229 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (file_stream);
#line 229 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 229 "Utility/TeeJee.Process.vala"
		_g_string_free0 (script);
#line 229 "Utility/TeeJee.Process.vala"
		return result;
#line 1165 "TeeJee.Process.c"
	}
	goto __finally86;
	__catch86_g_error:
	{
		GError* e = NULL;
#line 215 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 215 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 232 "Utility/TeeJee.Process.vala"
		if (!supress_errors) {
#line 1177 "TeeJee.Process.c"
			GError* _tmp33_;
			const gchar* _tmp34_;
#line 233 "Utility/TeeJee.Process.vala"
			_tmp33_ = e;
#line 233 "Utility/TeeJee.Process.vala"
			_tmp34_ = _tmp33_->message;
#line 233 "Utility/TeeJee.Process.vala"
			tee_jee_logging_log_error (_tmp34_, FALSE, FALSE);
#line 1186 "TeeJee.Process.c"
		}
#line 215 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 1190 "TeeJee.Process.c"
	}
	__finally86:
#line 215 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "Utility/TeeJee.Process.vala"
		_g_string_free0 (script);
#line 215 "Utility/TeeJee.Process.vala"
		_g_free0 (sh_path);
#line 215 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 215 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 215 "Utility/TeeJee.Process.vala"
		return NULL;
#line 1205 "TeeJee.Process.c"
	}
#line 237 "Utility/TeeJee.Process.vala"
	result = NULL;
#line 237 "Utility/TeeJee.Process.vala"
	_g_string_free0 (script);
#line 237 "Utility/TeeJee.Process.vala"
	_g_free0 (sh_path);
#line 237 "Utility/TeeJee.Process.vala"
	return result;
#line 1215 "TeeJee.Process.c"
}

gchar*
tee_jee_process_helper_get_temp_file_path (void)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GRand* _tmp7_;
	GRand* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
#line 244 "Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 244 "Utility/TeeJee.Process.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 244 "Utility/TeeJee.Process.vala"
	_tmp2_ = _tmp1_;
#line 244 "Utility/TeeJee.Process.vala"
	_tmp3_ = tee_jee_misc_timestamp_numeric ();
#line 244 "Utility/TeeJee.Process.vala"
	_tmp4_ = _tmp3_;
#line 244 "Utility/TeeJee.Process.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 244 "Utility/TeeJee.Process.vala"
	_tmp6_ = _tmp5_;
#line 244 "Utility/TeeJee.Process.vala"
	_tmp7_ = g_rand_new ();
#line 244 "Utility/TeeJee.Process.vala"
	_tmp8_ = _tmp7_;
#line 244 "Utility/TeeJee.Process.vala"
	_tmp9_ = g_strdup_printf ("%u", g_rand_int (_tmp8_));
#line 244 "Utility/TeeJee.Process.vala"
	_tmp10_ = _tmp9_;
#line 244 "Utility/TeeJee.Process.vala"
	_tmp11_ = g_strconcat (_tmp6_, _tmp10_, NULL);
#line 244 "Utility/TeeJee.Process.vala"
	_tmp12_ = _tmp11_;
#line 244 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp10_);
#line 244 "Utility/TeeJee.Process.vala"
	_g_rand_free0 (_tmp8_);
#line 244 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp6_);
#line 244 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp4_);
#line 244 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp2_);
#line 244 "Utility/TeeJee.Process.vala"
	result = _tmp12_;
#line 244 "Utility/TeeJee.Process.vala"
	return result;
#line 1275 "TeeJee.Process.c"
}

void
tee_jee_process_helper_exec_process_new_session (const gchar* command)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 247 "Utility/TeeJee.Process.vala"
	g_return_if_fail (command != NULL);
#line 248 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("setsid %s &", command);
#line 248 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 248 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_script_async (_tmp1_);
#line 248 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 1293 "TeeJee.Process.c"
}

gchar*
tee_jee_process_helper_get_cmd_path (const gchar* cmd_tool)
{
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 254 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd_tool != NULL, NULL);
#line 1303 "TeeJee.Process.c"
	{
		gint exitCode = 0;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gint _tmp4_ = 0;
#line 261 "Utility/TeeJee.Process.vala"
		_tmp0_ = g_strconcat ("which ", cmd_tool, NULL);
#line 261 "Utility/TeeJee.Process.vala"
		_tmp1_ = _tmp0_;
#line 261 "Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_inner_error0_);
#line 261 "Utility/TeeJee.Process.vala"
		_g_free0 (stdout);
#line 261 "Utility/TeeJee.Process.vala"
		stdout = _tmp2_;
#line 261 "Utility/TeeJee.Process.vala"
		_g_free0 (stderr);
#line 261 "Utility/TeeJee.Process.vala"
		stderr = _tmp3_;
#line 261 "Utility/TeeJee.Process.vala"
		exitCode = _tmp4_;
#line 261 "Utility/TeeJee.Process.vala"
		_g_free0 (_tmp1_);
#line 261 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "Utility/TeeJee.Process.vala"
			_g_free0 (stderr);
#line 261 "Utility/TeeJee.Process.vala"
			_g_free0 (stdout);
#line 1337 "TeeJee.Process.c"
			goto __catch87_g_error;
		}
#line 262 "Utility/TeeJee.Process.vala"
		result = stdout;
#line 262 "Utility/TeeJee.Process.vala"
		_g_free0 (stderr);
#line 262 "Utility/TeeJee.Process.vala"
		return result;
#line 1346 "TeeJee.Process.c"
	}
	goto __finally87;
	__catch87_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 258 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 258 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 265 "Utility/TeeJee.Process.vala"
		_tmp5_ = e;
#line 265 "Utility/TeeJee.Process.vala"
		_tmp6_ = _tmp5_->message;
#line 265 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 266 "Utility/TeeJee.Process.vala"
		_tmp7_ = g_strdup ("");
#line 266 "Utility/TeeJee.Process.vala"
		result = _tmp7_;
#line 266 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 266 "Utility/TeeJee.Process.vala"
		return result;
#line 1373 "TeeJee.Process.c"
	}
	__finally87:
#line 258 "Utility/TeeJee.Process.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "Utility/TeeJee.Process.vala"
	g_clear_error (&_inner_error0_);
#line 258 "Utility/TeeJee.Process.vala"
	return NULL;
#line 1382 "TeeJee.Process.c"
}

gboolean
tee_jee_process_helper_cmd_exists (const gchar* cmd_tool)
{
	gboolean result = FALSE;
	gchar* path = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 270 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmd_tool != NULL, FALSE);
#line 271 "Utility/TeeJee.Process.vala"
	_tmp0_ = tee_jee_process_helper_get_cmd_path (cmd_tool);
#line 271 "Utility/TeeJee.Process.vala"
	path = _tmp0_;
#line 272 "Utility/TeeJee.Process.vala"
	_tmp2_ = path;
#line 272 "Utility/TeeJee.Process.vala"
	if (_tmp2_ == NULL) {
#line 272 "Utility/TeeJee.Process.vala"
		_tmp1_ = TRUE;
#line 1405 "TeeJee.Process.c"
	} else {
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 272 "Utility/TeeJee.Process.vala"
		_tmp3_ = path;
#line 272 "Utility/TeeJee.Process.vala"
		_tmp4_ = strlen (_tmp3_);
#line 272 "Utility/TeeJee.Process.vala"
		_tmp5_ = _tmp4_;
#line 272 "Utility/TeeJee.Process.vala"
		_tmp1_ = _tmp5_ == 0;
#line 1418 "TeeJee.Process.c"
	}
#line 272 "Utility/TeeJee.Process.vala"
	if (_tmp1_) {
#line 273 "Utility/TeeJee.Process.vala"
		result = FALSE;
#line 273 "Utility/TeeJee.Process.vala"
		_g_free0 (path);
#line 273 "Utility/TeeJee.Process.vala"
		return result;
#line 1428 "TeeJee.Process.c"
	} else {
#line 276 "Utility/TeeJee.Process.vala"
		result = TRUE;
#line 276 "Utility/TeeJee.Process.vala"
		_g_free0 (path);
#line 276 "Utility/TeeJee.Process.vala"
		return result;
#line 1436 "TeeJee.Process.c"
	}
#line 270 "Utility/TeeJee.Process.vala"
	_g_free0 (path);
#line 1440 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_get_pid_by_name (const gchar* name)
{
	gint result = 0;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
#line 281 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 286 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("pidof \"%s\"", name);
#line 286 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 286 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp1_, &_tmp2_, &_tmp3_);
#line 286 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 286 "Utility/TeeJee.Process.vala"
	std_out = _tmp2_;
#line 286 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 286 "Utility/TeeJee.Process.vala"
	std_err = _tmp3_;
#line 286 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 288 "Utility/TeeJee.Process.vala"
	_tmp4_ = std_out;
#line 288 "Utility/TeeJee.Process.vala"
	if (_tmp4_ != NULL) {
#line 1476 "TeeJee.Process.c"
		gchar** arr = NULL;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint arr_length1;
		gint _arr_size_;
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 289 "Utility/TeeJee.Process.vala"
		_tmp5_ = std_out;
#line 289 "Utility/TeeJee.Process.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 289 "Utility/TeeJee.Process.vala"
		arr = _tmp7_;
#line 289 "Utility/TeeJee.Process.vala"
		arr_length1 = _vala_array_length (_tmp6_);
#line 289 "Utility/TeeJee.Process.vala"
		_arr_size_ = arr_length1;
#line 290 "Utility/TeeJee.Process.vala"
		_tmp8_ = arr;
#line 290 "Utility/TeeJee.Process.vala"
		_tmp8__length1 = arr_length1;
#line 290 "Utility/TeeJee.Process.vala"
		if (_tmp8__length1 > 0) {
#line 1501 "TeeJee.Process.c"
			gchar** _tmp9_;
			gint _tmp9__length1;
			const gchar* _tmp10_;
#line 291 "Utility/TeeJee.Process.vala"
			_tmp9_ = arr;
#line 291 "Utility/TeeJee.Process.vala"
			_tmp9__length1 = arr_length1;
#line 291 "Utility/TeeJee.Process.vala"
			_tmp10_ = _tmp9_[0];
#line 291 "Utility/TeeJee.Process.vala"
			result = atoi (_tmp10_);
#line 291 "Utility/TeeJee.Process.vala"
			arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 291 "Utility/TeeJee.Process.vala"
			_g_free0 (std_err);
#line 291 "Utility/TeeJee.Process.vala"
			_g_free0 (std_out);
#line 291 "Utility/TeeJee.Process.vala"
			return result;
#line 1521 "TeeJee.Process.c"
		}
#line 288 "Utility/TeeJee.Process.vala"
		arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 1525 "TeeJee.Process.c"
	}
#line 295 "Utility/TeeJee.Process.vala"
	result = -1;
#line 295 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 295 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 295 "Utility/TeeJee.Process.vala"
	return result;
#line 1535 "TeeJee.Process.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 1554 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_get_pid_by_command (const gchar* cmdline)
{
	gint result = 0;
	GError* _inner_error0_ = NULL;
#line 298 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (cmdline != NULL, 0);
#line 1564 "TeeJee.Process.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFileEnumerator* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFileEnumerator* _tmp3_;
		GFileEnumerator* _tmp4_;
#line 307 "Utility/TeeJee.Process.vala"
		_tmp0_ = g_file_parse_name ("/proc");
#line 307 "Utility/TeeJee.Process.vala"
		file = _tmp0_;
#line 309 "Utility/TeeJee.Process.vala"
		_tmp2_ = file;
#line 309 "Utility/TeeJee.Process.vala"
		_tmp3_ = g_file_enumerate_children (_tmp2_, "standard::name", 0, NULL, &_inner_error0_);
#line 309 "Utility/TeeJee.Process.vala"
		_tmp1_ = _tmp3_;
#line 309 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 309 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (file);
#line 309 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (info);
#line 309 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (enumerator);
#line 1592 "TeeJee.Process.c"
			goto __catch88_g_error;
		}
#line 309 "Utility/TeeJee.Process.vala"
		_tmp4_ = _tmp1_;
#line 309 "Utility/TeeJee.Process.vala"
		_tmp1_ = NULL;
#line 309 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (enumerator);
#line 309 "Utility/TeeJee.Process.vala"
		enumerator = _tmp4_;
#line 310 "Utility/TeeJee.Process.vala"
		while (TRUE) {
#line 1605 "TeeJee.Process.c"
			GFileInfo* _tmp5_ = NULL;
			GFileEnumerator* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
#line 310 "Utility/TeeJee.Process.vala"
			_tmp6_ = enumerator;
#line 310 "Utility/TeeJee.Process.vala"
			_tmp7_ = g_file_enumerator_next_file (_tmp6_, NULL, &_inner_error0_);
#line 310 "Utility/TeeJee.Process.vala"
			_tmp5_ = _tmp7_;
#line 310 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 310 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp1_);
#line 310 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 310 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (info);
#line 310 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (enumerator);
#line 1627 "TeeJee.Process.c"
				goto __catch88_g_error;
			}
#line 310 "Utility/TeeJee.Process.vala"
			_tmp8_ = _tmp5_;
#line 310 "Utility/TeeJee.Process.vala"
			_tmp5_ = NULL;
#line 310 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (info);
#line 310 "Utility/TeeJee.Process.vala"
			info = _tmp8_;
#line 310 "Utility/TeeJee.Process.vala"
			_tmp9_ = info;
#line 310 "Utility/TeeJee.Process.vala"
			if (!(_tmp9_ != NULL)) {
#line 310 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp5_);
#line 310 "Utility/TeeJee.Process.vala"
				break;
#line 1646 "TeeJee.Process.c"
			}
			{
				gchar* io_stat_file_path = NULL;
				GFileInfo* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				GFile* io_stat_file = NULL;
				const gchar* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
#line 312 "Utility/TeeJee.Process.vala"
				_tmp10_ = info;
#line 312 "Utility/TeeJee.Process.vala"
				_tmp11_ = g_file_info_get_name (_tmp10_);
#line 312 "Utility/TeeJee.Process.vala"
				_tmp12_ = g_strdup_printf ("/proc/%s/cmdline", _tmp11_);
#line 312 "Utility/TeeJee.Process.vala"
				io_stat_file_path = _tmp12_;
#line 313 "Utility/TeeJee.Process.vala"
				_tmp13_ = io_stat_file_path;
#line 313 "Utility/TeeJee.Process.vala"
				_tmp14_ = g_file_new_for_path (_tmp13_);
#line 313 "Utility/TeeJee.Process.vala"
				io_stat_file = _tmp14_;
#line 314 "Utility/TeeJee.Process.vala"
				_tmp15_ = file;
#line 314 "Utility/TeeJee.Process.vala"
				if (g_file_query_exists (_tmp15_, NULL)) {
#line 1675 "TeeJee.Process.c"
					GFileInputStream* _tmp16_ = NULL;
					GFile* _tmp17_;
					GFileInputStream* _tmp18_;
					GDataInputStream* dis = NULL;
					GDataInputStream* _tmp19_;
					gchar* line = NULL;
					gchar* text = NULL;
					gchar* _tmp20_;
					gsize length = 0UL;
					gboolean _tmp32_ = FALSE;
					const gchar* _tmp33_;
#line 315 "Utility/TeeJee.Process.vala"
					_tmp17_ = io_stat_file;
#line 315 "Utility/TeeJee.Process.vala"
					_tmp18_ = g_file_read (_tmp17_, NULL, &_inner_error0_);
#line 315 "Utility/TeeJee.Process.vala"
					_tmp16_ = _tmp18_;
#line 315 "Utility/TeeJee.Process.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 315 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (io_stat_file);
#line 315 "Utility/TeeJee.Process.vala"
						_g_free0 (io_stat_file_path);
#line 1699 "TeeJee.Process.c"
						goto __catch89_g_error;
					}
#line 315 "Utility/TeeJee.Process.vala"
					_tmp19_ = g_data_input_stream_new ((GInputStream*) _tmp16_);
#line 315 "Utility/TeeJee.Process.vala"
					dis = _tmp19_;
#line 318 "Utility/TeeJee.Process.vala"
					_tmp20_ = g_strdup ("");
#line 318 "Utility/TeeJee.Process.vala"
					text = _tmp20_;
#line 320 "Utility/TeeJee.Process.vala"
					while (TRUE) {
#line 1712 "TeeJee.Process.c"
						gchar* _tmp21_ = NULL;
						GDataInputStream* _tmp22_;
						gsize _tmp23_ = 0UL;
						gchar* _tmp24_;
						gchar* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
#line 320 "Utility/TeeJee.Process.vala"
						_tmp22_ = dis;
#line 320 "Utility/TeeJee.Process.vala"
						_tmp24_ = g_data_input_stream_read_until (_tmp22_, "\0", &_tmp23_, NULL, &_inner_error0_);
#line 320 "Utility/TeeJee.Process.vala"
						length = _tmp23_;
#line 320 "Utility/TeeJee.Process.vala"
						_tmp21_ = _tmp24_;
#line 320 "Utility/TeeJee.Process.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 320 "Utility/TeeJee.Process.vala"
							_g_free0 (text);
#line 320 "Utility/TeeJee.Process.vala"
							_g_free0 (line);
#line 320 "Utility/TeeJee.Process.vala"
							_g_object_unref0 (dis);
#line 320 "Utility/TeeJee.Process.vala"
							_g_object_unref0 (_tmp16_);
#line 320 "Utility/TeeJee.Process.vala"
							_g_object_unref0 (io_stat_file);
#line 320 "Utility/TeeJee.Process.vala"
							_g_free0 (io_stat_file_path);
#line 1746 "TeeJee.Process.c"
							goto __catch89_g_error;
						}
#line 320 "Utility/TeeJee.Process.vala"
						_tmp25_ = _tmp21_;
#line 320 "Utility/TeeJee.Process.vala"
						_tmp21_ = NULL;
#line 320 "Utility/TeeJee.Process.vala"
						_g_free0 (line);
#line 320 "Utility/TeeJee.Process.vala"
						line = _tmp25_;
#line 320 "Utility/TeeJee.Process.vala"
						_tmp26_ = line;
#line 320 "Utility/TeeJee.Process.vala"
						if (!(_tmp26_ != NULL)) {
#line 320 "Utility/TeeJee.Process.vala"
							_g_free0 (_tmp21_);
#line 320 "Utility/TeeJee.Process.vala"
							break;
#line 1765 "TeeJee.Process.c"
						}
#line 321 "Utility/TeeJee.Process.vala"
						_tmp27_ = text;
#line 321 "Utility/TeeJee.Process.vala"
						_tmp28_ = line;
#line 321 "Utility/TeeJee.Process.vala"
						_tmp29_ = g_strconcat (" ", _tmp28_, NULL);
#line 321 "Utility/TeeJee.Process.vala"
						_tmp30_ = _tmp29_;
#line 321 "Utility/TeeJee.Process.vala"
						_tmp31_ = g_strconcat (_tmp27_, _tmp30_, NULL);
#line 321 "Utility/TeeJee.Process.vala"
						_g_free0 (text);
#line 321 "Utility/TeeJee.Process.vala"
						text = _tmp31_;
#line 321 "Utility/TeeJee.Process.vala"
						_g_free0 (_tmp30_);
#line 320 "Utility/TeeJee.Process.vala"
						_g_free0 (_tmp21_);
#line 1785 "TeeJee.Process.c"
					}
#line 324 "Utility/TeeJee.Process.vala"
					_tmp33_ = text;
#line 324 "Utility/TeeJee.Process.vala"
					if (_tmp33_ != NULL) {
#line 1791 "TeeJee.Process.c"
						const gchar* _tmp34_;
#line 324 "Utility/TeeJee.Process.vala"
						_tmp34_ = text;
#line 324 "Utility/TeeJee.Process.vala"
						_tmp32_ = string_contains (_tmp34_, cmdline);
#line 1797 "TeeJee.Process.c"
					} else {
#line 324 "Utility/TeeJee.Process.vala"
						_tmp32_ = FALSE;
#line 1801 "TeeJee.Process.c"
					}
#line 324 "Utility/TeeJee.Process.vala"
					if (_tmp32_) {
#line 1805 "TeeJee.Process.c"
						GFileInfo* _tmp35_;
						const gchar* _tmp36_;
#line 325 "Utility/TeeJee.Process.vala"
						_tmp35_ = info;
#line 325 "Utility/TeeJee.Process.vala"
						_tmp36_ = g_file_info_get_name (_tmp35_);
#line 325 "Utility/TeeJee.Process.vala"
						result = atoi (_tmp36_);
#line 325 "Utility/TeeJee.Process.vala"
						_g_free0 (text);
#line 325 "Utility/TeeJee.Process.vala"
						_g_free0 (line);
#line 325 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (dis);
#line 325 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp16_);
#line 325 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (io_stat_file);
#line 325 "Utility/TeeJee.Process.vala"
						_g_free0 (io_stat_file_path);
#line 325 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp5_);
#line 325 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (_tmp1_);
#line 325 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (file);
#line 325 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (info);
#line 325 "Utility/TeeJee.Process.vala"
						_g_object_unref0 (enumerator);
#line 325 "Utility/TeeJee.Process.vala"
						return result;
#line 1838 "TeeJee.Process.c"
					}
#line 314 "Utility/TeeJee.Process.vala"
					_g_free0 (text);
#line 314 "Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 314 "Utility/TeeJee.Process.vala"
					_g_object_unref0 (dis);
#line 314 "Utility/TeeJee.Process.vala"
					_g_object_unref0 (_tmp16_);
#line 1848 "TeeJee.Process.c"
				}
#line 311 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (io_stat_file);
#line 311 "Utility/TeeJee.Process.vala"
				_g_free0 (io_stat_file_path);
#line 1854 "TeeJee.Process.c"
			}
			goto __finally89;
			__catch89_g_error:
			{
				GError* e = NULL;
#line 311 "Utility/TeeJee.Process.vala"
				e = _inner_error0_;
#line 311 "Utility/TeeJee.Process.vala"
				_inner_error0_ = NULL;
#line 311 "Utility/TeeJee.Process.vala"
				_g_error_free0 (e);
#line 1866 "TeeJee.Process.c"
			}
			__finally89:
#line 311 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 311 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp5_);
#line 311 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (_tmp1_);
#line 311 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (file);
#line 311 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (info);
#line 311 "Utility/TeeJee.Process.vala"
				_g_object_unref0 (enumerator);
#line 1881 "TeeJee.Process.c"
				goto __catch88_g_error;
			}
#line 310 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (_tmp5_);
#line 1886 "TeeJee.Process.c"
		}
#line 304 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (_tmp1_);
#line 304 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 304 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (info);
#line 304 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (enumerator);
#line 1896 "TeeJee.Process.c"
	}
	goto __finally88;
	__catch88_g_error:
	{
		GError* e = NULL;
		GError* _tmp37_;
		const gchar* _tmp38_;
#line 304 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 304 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 336 "Utility/TeeJee.Process.vala"
		_tmp37_ = e;
#line 336 "Utility/TeeJee.Process.vala"
		_tmp38_ = _tmp37_->message;
#line 336 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp38_, FALSE, FALSE);
#line 304 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 1916 "TeeJee.Process.c"
	}
	__finally88:
#line 304 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1921 "TeeJee.Process.c"
		gint _tmp39_ = -1;
#line 304 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 304 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 304 "Utility/TeeJee.Process.vala"
		return _tmp39_;
#line 1929 "TeeJee.Process.c"
	}
#line 339 "Utility/TeeJee.Process.vala"
	result = -1;
#line 339 "Utility/TeeJee.Process.vala"
	return result;
#line 1935 "TeeJee.Process.c"
}

static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
#line 722 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 723 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, (guint) 0);
#line 723 "glib-2.0.vapi"
	return result;
#line 1948 "TeeJee.Process.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1970 "TeeJee.Process.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1974 "TeeJee.Process.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1980 "TeeJee.Process.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1984 "TeeJee.Process.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1988 "TeeJee.Process.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 1996 "TeeJee.Process.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2024 "TeeJee.Process.c"
				goto __catch91_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 2033 "TeeJee.Process.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2047 "TeeJee.Process.c"
				goto __catch91_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 2058 "TeeJee.Process.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 2072 "TeeJee.Process.c"
	}
	goto __finally91;
	__catch91_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 2086 "TeeJee.Process.c"
	}
	__finally91:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 2097 "TeeJee.Process.c"
	}
}

void
tee_jee_process_helper_get_proc_io_stats (gint pid,
                                          gint64* read_bytes,
                                          gint64* write_bytes)
{
	gint64 _vala_read_bytes = 0LL;
	gint64 _vala_write_bytes = 0LL;
	gchar* io_stat_file_path = NULL;
	gchar* _tmp0_;
	GFile* file = NULL;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 346 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("/proc/%d/io", pid);
#line 346 "Utility/TeeJee.Process.vala"
	io_stat_file_path = _tmp0_;
#line 347 "Utility/TeeJee.Process.vala"
	_tmp1_ = io_stat_file_path;
#line 347 "Utility/TeeJee.Process.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 347 "Utility/TeeJee.Process.vala"
	file = _tmp2_;
#line 349 "Utility/TeeJee.Process.vala"
	_vala_read_bytes = (gint64) 0;
#line 350 "Utility/TeeJee.Process.vala"
	_vala_write_bytes = (gint64) 0;
#line 2128 "TeeJee.Process.c"
	{
		GFile* _tmp3_;
#line 353 "Utility/TeeJee.Process.vala"
		_tmp3_ = file;
#line 353 "Utility/TeeJee.Process.vala"
		if (g_file_query_exists (_tmp3_, NULL)) {
#line 2135 "TeeJee.Process.c"
			GFileInputStream* _tmp4_ = NULL;
			GFile* _tmp5_;
			GFileInputStream* _tmp6_;
			GDataInputStream* dis = NULL;
			GDataInputStream* _tmp7_;
			gchar* line = NULL;
#line 354 "Utility/TeeJee.Process.vala"
			_tmp5_ = file;
#line 354 "Utility/TeeJee.Process.vala"
			_tmp6_ = g_file_read (_tmp5_, NULL, &_inner_error0_);
#line 354 "Utility/TeeJee.Process.vala"
			_tmp4_ = _tmp6_;
#line 354 "Utility/TeeJee.Process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2150 "TeeJee.Process.c"
				goto __catch90_g_error;
			}
#line 354 "Utility/TeeJee.Process.vala"
			_tmp7_ = g_data_input_stream_new ((GInputStream*) _tmp4_);
#line 354 "Utility/TeeJee.Process.vala"
			dis = _tmp7_;
#line 356 "Utility/TeeJee.Process.vala"
			while (TRUE) {
#line 2159 "TeeJee.Process.c"
				gchar* _tmp8_ = NULL;
				GDataInputStream* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
#line 356 "Utility/TeeJee.Process.vala"
				_tmp9_ = dis;
#line 356 "Utility/TeeJee.Process.vala"
				_tmp10_ = g_data_input_stream_read_line (_tmp9_, NULL, NULL, &_inner_error0_);
#line 356 "Utility/TeeJee.Process.vala"
				_tmp8_ = _tmp10_;
#line 356 "Utility/TeeJee.Process.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 356 "Utility/TeeJee.Process.vala"
					_g_object_unref0 (dis);
#line 356 "Utility/TeeJee.Process.vala"
					_g_object_unref0 (_tmp4_);
#line 2180 "TeeJee.Process.c"
					goto __catch90_g_error;
				}
#line 356 "Utility/TeeJee.Process.vala"
				_tmp11_ = _tmp8_;
#line 356 "Utility/TeeJee.Process.vala"
				_tmp8_ = NULL;
#line 356 "Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 356 "Utility/TeeJee.Process.vala"
				line = _tmp11_;
#line 356 "Utility/TeeJee.Process.vala"
				_tmp12_ = line;
#line 356 "Utility/TeeJee.Process.vala"
				if (!(_tmp12_ != NULL)) {
#line 356 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp8_);
#line 356 "Utility/TeeJee.Process.vala"
					break;
#line 2199 "TeeJee.Process.c"
				}
#line 357 "Utility/TeeJee.Process.vala"
				_tmp13_ = line;
#line 357 "Utility/TeeJee.Process.vala"
				if (g_str_has_prefix (_tmp13_, "rchar:")) {
#line 2205 "TeeJee.Process.c"
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
#line 358 "Utility/TeeJee.Process.vala"
					_tmp14_ = line;
#line 358 "Utility/TeeJee.Process.vala"
					_tmp15_ = string_replace (_tmp14_, "rchar:", "");
#line 358 "Utility/TeeJee.Process.vala"
					_tmp16_ = _tmp15_;
#line 358 "Utility/TeeJee.Process.vala"
					_tmp17_ = string_strip (_tmp16_);
#line 358 "Utility/TeeJee.Process.vala"
					_tmp18_ = _tmp17_;
#line 358 "Utility/TeeJee.Process.vala"
					_vala_read_bytes = int64_parse (_tmp18_);
#line 358 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp18_);
#line 358 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp16_);
#line 2227 "TeeJee.Process.c"
				} else {
					const gchar* _tmp19_;
#line 360 "Utility/TeeJee.Process.vala"
					_tmp19_ = line;
#line 360 "Utility/TeeJee.Process.vala"
					if (g_str_has_prefix (_tmp19_, "wchar:")) {
#line 2234 "TeeJee.Process.c"
						const gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
#line 361 "Utility/TeeJee.Process.vala"
						_tmp20_ = line;
#line 361 "Utility/TeeJee.Process.vala"
						_tmp21_ = string_replace (_tmp20_, "wchar:", "");
#line 361 "Utility/TeeJee.Process.vala"
						_tmp22_ = _tmp21_;
#line 361 "Utility/TeeJee.Process.vala"
						_tmp23_ = string_strip (_tmp22_);
#line 361 "Utility/TeeJee.Process.vala"
						_tmp24_ = _tmp23_;
#line 361 "Utility/TeeJee.Process.vala"
						_vala_write_bytes = int64_parse (_tmp24_);
#line 361 "Utility/TeeJee.Process.vala"
						_g_free0 (_tmp24_);
#line 361 "Utility/TeeJee.Process.vala"
						_g_free0 (_tmp22_);
#line 2256 "TeeJee.Process.c"
					}
				}
#line 356 "Utility/TeeJee.Process.vala"
				_g_free0 (_tmp8_);
#line 2261 "TeeJee.Process.c"
			}
#line 353 "Utility/TeeJee.Process.vala"
			_g_free0 (line);
#line 353 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (dis);
#line 353 "Utility/TeeJee.Process.vala"
			_g_object_unref0 (_tmp4_);
#line 2269 "TeeJee.Process.c"
		}
	}
	goto __finally90;
	__catch90_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 352 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 352 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 367 "Utility/TeeJee.Process.vala"
		_tmp25_ = e;
#line 367 "Utility/TeeJee.Process.vala"
		_tmp26_ = _tmp25_->message;
#line 367 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp26_, FALSE, FALSE);
#line 352 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 2290 "TeeJee.Process.c"
	}
	__finally90:
#line 352 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 352 "Utility/TeeJee.Process.vala"
		_g_object_unref0 (file);
#line 352 "Utility/TeeJee.Process.vala"
		_g_free0 (io_stat_file_path);
#line 352 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 352 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 352 "Utility/TeeJee.Process.vala"
		return;
#line 2305 "TeeJee.Process.c"
	}
#line 342 "Utility/TeeJee.Process.vala"
	_g_object_unref0 (file);
#line 342 "Utility/TeeJee.Process.vala"
	_g_free0 (io_stat_file_path);
#line 342 "Utility/TeeJee.Process.vala"
	if (read_bytes) {
#line 342 "Utility/TeeJee.Process.vala"
		*read_bytes = _vala_read_bytes;
#line 2315 "TeeJee.Process.c"
	}
#line 342 "Utility/TeeJee.Process.vala"
	if (write_bytes) {
#line 342 "Utility/TeeJee.Process.vala"
		*write_bytes = _vala_write_bytes;
#line 2321 "TeeJee.Process.c"
	}
}

gboolean
tee_jee_process_helper_process_is_running (glong pid)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
#line 376 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup ("");
#line 376 "Utility/TeeJee.Process.vala"
	cmd = _tmp0_;
#line 2339 "TeeJee.Process.c"
	{
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 382 "Utility/TeeJee.Process.vala"
		_tmp1_ = g_strdup_printf ("ps --pid %ld", pid);
#line 382 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 382 "Utility/TeeJee.Process.vala"
		cmd = _tmp1_;
#line 383 "Utility/TeeJee.Process.vala"
		_tmp2_ = cmd;
#line 383 "Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 383 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 383 "Utility/TeeJee.Process.vala"
		std_out = _tmp3_;
#line 383 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 383 "Utility/TeeJee.Process.vala"
		std_err = _tmp4_;
#line 383 "Utility/TeeJee.Process.vala"
		ret_val = _tmp5_;
#line 383 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2368 "TeeJee.Process.c"
			goto __catch92_g_error;
		}
	}
	goto __finally92;
	__catch92_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 381 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 381 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 386 "Utility/TeeJee.Process.vala"
		_tmp6_ = e;
#line 386 "Utility/TeeJee.Process.vala"
		_tmp7_ = _tmp6_->message;
#line 386 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 387 "Utility/TeeJee.Process.vala"
		result = FALSE;
#line 387 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 387 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 387 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 387 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 387 "Utility/TeeJee.Process.vala"
		return result;
#line 2400 "TeeJee.Process.c"
	}
	__finally92:
#line 381 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2405 "TeeJee.Process.c"
		gboolean _tmp8_ = FALSE;
#line 381 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 381 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 381 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 381 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 381 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 381 "Utility/TeeJee.Process.vala"
		return _tmp8_;
#line 2419 "TeeJee.Process.c"
	}
#line 390 "Utility/TeeJee.Process.vala"
	result = ret_val == 0;
#line 390 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 390 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 390 "Utility/TeeJee.Process.vala"
	_g_free0 (cmd);
#line 390 "Utility/TeeJee.Process.vala"
	return result;
#line 2431 "TeeJee.Process.c"
}

gboolean
tee_jee_process_helper_process_is_running_by_name (const gchar* proc_name)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
#line 394 "Utility/TeeJee.Process.vala"
	g_return_val_if_fail (proc_name != NULL, FALSE);
#line 398 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup ("");
#line 398 "Utility/TeeJee.Process.vala"
	cmd = _tmp0_;
#line 2450 "TeeJee.Process.c"
	{
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 404 "Utility/TeeJee.Process.vala"
		_tmp1_ = g_strdup_printf ("pgrep -f '%s'", proc_name);
#line 404 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 404 "Utility/TeeJee.Process.vala"
		cmd = _tmp1_;
#line 405 "Utility/TeeJee.Process.vala"
		_tmp2_ = cmd;
#line 405 "Utility/TeeJee.Process.vala"
		g_spawn_command_line_sync (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 405 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 405 "Utility/TeeJee.Process.vala"
		std_out = _tmp3_;
#line 405 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 405 "Utility/TeeJee.Process.vala"
		std_err = _tmp4_;
#line 405 "Utility/TeeJee.Process.vala"
		ret_val = _tmp5_;
#line 405 "Utility/TeeJee.Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2479 "TeeJee.Process.c"
			goto __catch93_g_error;
		}
	}
	goto __finally93;
	__catch93_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 403 "Utility/TeeJee.Process.vala"
		e = _inner_error0_;
#line 403 "Utility/TeeJee.Process.vala"
		_inner_error0_ = NULL;
#line 408 "Utility/TeeJee.Process.vala"
		_tmp6_ = e;
#line 408 "Utility/TeeJee.Process.vala"
		_tmp7_ = _tmp6_->message;
#line 408 "Utility/TeeJee.Process.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 409 "Utility/TeeJee.Process.vala"
		result = FALSE;
#line 409 "Utility/TeeJee.Process.vala"
		_g_error_free0 (e);
#line 409 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 409 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 409 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 409 "Utility/TeeJee.Process.vala"
		return result;
#line 2511 "TeeJee.Process.c"
	}
	__finally93:
#line 403 "Utility/TeeJee.Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2516 "TeeJee.Process.c"
		gboolean _tmp8_ = FALSE;
#line 403 "Utility/TeeJee.Process.vala"
		_g_free0 (std_err);
#line 403 "Utility/TeeJee.Process.vala"
		_g_free0 (std_out);
#line 403 "Utility/TeeJee.Process.vala"
		_g_free0 (cmd);
#line 403 "Utility/TeeJee.Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 403 "Utility/TeeJee.Process.vala"
		g_clear_error (&_inner_error0_);
#line 403 "Utility/TeeJee.Process.vala"
		return _tmp8_;
#line 2530 "TeeJee.Process.c"
	}
#line 412 "Utility/TeeJee.Process.vala"
	result = ret_val == 0;
#line 412 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 412 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 412 "Utility/TeeJee.Process.vala"
	_g_free0 (cmd);
#line 412 "Utility/TeeJee.Process.vala"
	return result;
#line 2542 "TeeJee.Process.c"
}

static void
_vala_array_add3 (gint* * array,
                  int* length,
                  int* size,
                  gint value)
{
#line 435 "Utility/TeeJee.Process.vala"
	if ((*length) == (*size)) {
#line 435 "Utility/TeeJee.Process.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 435 "Utility/TeeJee.Process.vala"
		*array = g_renew (gint, *array, *size);
#line 2557 "TeeJee.Process.c"
	}
#line 435 "Utility/TeeJee.Process.vala"
	(*array)[(*length)++] = value;
#line 2561 "TeeJee.Process.c"
}

gint*
tee_jee_process_helper_get_process_children (GPid parent_pid,
                                             gint* result_length1)
{
	gint* result = NULL;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gint pid = 0;
	gint* procList = NULL;
	gint* _tmp4_;
	gint procList_length1;
	gint _procList_size_;
	gchar** arr = NULL;
	gint arr_length1 = 0;
	gint _arr_size_ = 0;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint* _tmp18_;
	gint _tmp18__length1;
#line 421 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("ps --ppid %d", (gint) parent_pid);
#line 421 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 421 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp1_, &_tmp2_, &_tmp3_);
#line 421 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 421 "Utility/TeeJee.Process.vala"
	std_out = _tmp2_;
#line 421 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 421 "Utility/TeeJee.Process.vala"
	std_err = _tmp3_;
#line 421 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 424 "Utility/TeeJee.Process.vala"
	_tmp4_ = g_new0 (gint, 0);
#line 424 "Utility/TeeJee.Process.vala"
	procList = _tmp4_;
#line 424 "Utility/TeeJee.Process.vala"
	procList_length1 = 0;
#line 424 "Utility/TeeJee.Process.vala"
	_procList_size_ = procList_length1;
#line 427 "Utility/TeeJee.Process.vala"
	_tmp5_ = std_out;
#line 427 "Utility/TeeJee.Process.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 2616 "TeeJee.Process.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 427 "Utility/TeeJee.Process.vala"
		line_collection = _tmp7_;
#line 427 "Utility/TeeJee.Process.vala"
		line_collection_length1 = _vala_array_length (_tmp6_);
#line 427 "Utility/TeeJee.Process.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp6_); line_it = line_it + 1) {
#line 2628 "TeeJee.Process.c"
			gchar* _tmp8_;
			gchar* line = NULL;
#line 427 "Utility/TeeJee.Process.vala"
			_tmp8_ = g_strdup (line_collection[line_it]);
#line 427 "Utility/TeeJee.Process.vala"
			line = _tmp8_;
#line 2635 "TeeJee.Process.c"
			{
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar** _tmp12_;
				gchar** _tmp13_;
				gchar** _tmp14_;
				gint _tmp14__length1;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
#line 428 "Utility/TeeJee.Process.vala"
				_tmp9_ = line;
#line 428 "Utility/TeeJee.Process.vala"
				_tmp10_ = string_strip (_tmp9_);
#line 428 "Utility/TeeJee.Process.vala"
				_tmp11_ = _tmp10_;
#line 428 "Utility/TeeJee.Process.vala"
				_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, " ", 0);
#line 428 "Utility/TeeJee.Process.vala"
				arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 428 "Utility/TeeJee.Process.vala"
				arr = _tmp13_;
#line 428 "Utility/TeeJee.Process.vala"
				arr_length1 = _vala_array_length (_tmp12_);
#line 428 "Utility/TeeJee.Process.vala"
				_arr_size_ = arr_length1;
#line 428 "Utility/TeeJee.Process.vala"
				_g_free0 (_tmp11_);
#line 429 "Utility/TeeJee.Process.vala"
				_tmp14_ = arr;
#line 429 "Utility/TeeJee.Process.vala"
				_tmp14__length1 = arr_length1;
#line 429 "Utility/TeeJee.Process.vala"
				if (_tmp14__length1 < 1) {
#line 429 "Utility/TeeJee.Process.vala"
					_g_free0 (line);
#line 429 "Utility/TeeJee.Process.vala"
					continue;
#line 2675 "TeeJee.Process.c"
				}
#line 431 "Utility/TeeJee.Process.vala"
				pid = 0;
#line 432 "Utility/TeeJee.Process.vala"
				_tmp15_ = arr;
#line 432 "Utility/TeeJee.Process.vala"
				_tmp15__length1 = arr_length1;
#line 432 "Utility/TeeJee.Process.vala"
				_tmp16_ = _tmp15_[0];
#line 432 "Utility/TeeJee.Process.vala"
				pid = atoi (_tmp16_);
#line 434 "Utility/TeeJee.Process.vala"
				if (pid != 0) {
#line 2689 "TeeJee.Process.c"
					gint* _tmp17_;
					gint _tmp17__length1;
#line 435 "Utility/TeeJee.Process.vala"
					_tmp17_ = procList;
#line 435 "Utility/TeeJee.Process.vala"
					_tmp17__length1 = procList_length1;
#line 435 "Utility/TeeJee.Process.vala"
					_vala_array_add3 (&procList, &procList_length1, &_procList_size_, pid);
#line 2698 "TeeJee.Process.c"
				}
#line 427 "Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 2702 "TeeJee.Process.c"
			}
		}
#line 427 "Utility/TeeJee.Process.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2707 "TeeJee.Process.c"
	}
#line 438 "Utility/TeeJee.Process.vala"
	_tmp18_ = procList;
#line 438 "Utility/TeeJee.Process.vala"
	_tmp18__length1 = procList_length1;
#line 438 "Utility/TeeJee.Process.vala"
	if (result_length1) {
#line 438 "Utility/TeeJee.Process.vala"
		*result_length1 = _tmp18__length1;
#line 2717 "TeeJee.Process.c"
	}
#line 438 "Utility/TeeJee.Process.vala"
	result = _tmp18_;
#line 438 "Utility/TeeJee.Process.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 438 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 438 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 438 "Utility/TeeJee.Process.vala"
	return result;
#line 2729 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_quit (GPid process_pid,
                                     gboolean killChildren)
{
	gint* child_pids = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint child_pids_length1;
	gint _child_pids_size_;
#line 449 "Utility/TeeJee.Process.vala"
	_tmp1_ = tee_jee_process_helper_get_process_children (process_pid, &_tmp0_);
#line 449 "Utility/TeeJee.Process.vala"
	child_pids = _tmp1_;
#line 449 "Utility/TeeJee.Process.vala"
	child_pids_length1 = _tmp0_;
#line 449 "Utility/TeeJee.Process.vala"
	_child_pids_size_ = child_pids_length1;
#line 450 "Utility/TeeJee.Process.vala"
	kill ((pid_t) process_pid, SIGTERM);
#line 452 "Utility/TeeJee.Process.vala"
	if (killChildren) {
#line 2753 "TeeJee.Process.c"
		GPid childPid = 0;
		gint* _tmp2_;
		gint _tmp2__length1;
#line 454 "Utility/TeeJee.Process.vala"
		_tmp2_ = child_pids;
#line 454 "Utility/TeeJee.Process.vala"
		_tmp2__length1 = child_pids_length1;
#line 2761 "TeeJee.Process.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 454 "Utility/TeeJee.Process.vala"
			pid_collection = _tmp2_;
#line 454 "Utility/TeeJee.Process.vala"
			pid_collection_length1 = _tmp2__length1;
#line 454 "Utility/TeeJee.Process.vala"
			for (pid_it = 0; pid_it < _tmp2__length1; pid_it = pid_it + 1) {
#line 2773 "TeeJee.Process.c"
				glong pid = 0L;
#line 454 "Utility/TeeJee.Process.vala"
				pid = (glong) pid_collection[pid_it];
#line 2777 "TeeJee.Process.c"
				{
#line 455 "Utility/TeeJee.Process.vala"
					childPid = (GPid) pid;
#line 456 "Utility/TeeJee.Process.vala"
					kill ((pid_t) childPid, SIGTERM);
#line 2783 "TeeJee.Process.c"
				}
			}
		}
	}
#line 443 "Utility/TeeJee.Process.vala"
	child_pids = (g_free (child_pids), NULL);
#line 2790 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_kill (GPid process_pid,
                                     gboolean killChildren)
{
	gint* child_pids = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint child_pids_length1;
	gint _child_pids_size_;
#line 468 "Utility/TeeJee.Process.vala"
	_tmp1_ = tee_jee_process_helper_get_process_children (process_pid, &_tmp0_);
#line 468 "Utility/TeeJee.Process.vala"
	child_pids = _tmp1_;
#line 468 "Utility/TeeJee.Process.vala"
	child_pids_length1 = _tmp0_;
#line 468 "Utility/TeeJee.Process.vala"
	_child_pids_size_ = child_pids_length1;
#line 469 "Utility/TeeJee.Process.vala"
	kill ((pid_t) process_pid, SIGKILL);
#line 471 "Utility/TeeJee.Process.vala"
	if (killChildren) {
#line 2814 "TeeJee.Process.c"
		GPid childPid = 0;
		gint* _tmp2_;
		gint _tmp2__length1;
#line 473 "Utility/TeeJee.Process.vala"
		_tmp2_ = child_pids;
#line 473 "Utility/TeeJee.Process.vala"
		_tmp2__length1 = child_pids_length1;
#line 2822 "TeeJee.Process.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 473 "Utility/TeeJee.Process.vala"
			pid_collection = _tmp2_;
#line 473 "Utility/TeeJee.Process.vala"
			pid_collection_length1 = _tmp2__length1;
#line 473 "Utility/TeeJee.Process.vala"
			for (pid_it = 0; pid_it < _tmp2__length1; pid_it = pid_it + 1) {
#line 2834 "TeeJee.Process.c"
				glong pid = 0L;
#line 473 "Utility/TeeJee.Process.vala"
				pid = (glong) pid_collection[pid_it];
#line 2838 "TeeJee.Process.c"
				{
#line 474 "Utility/TeeJee.Process.vala"
					childPid = (GPid) pid;
#line 475 "Utility/TeeJee.Process.vala"
					kill ((pid_t) childPid, SIGKILL);
#line 2844 "TeeJee.Process.c"
				}
			}
		}
	}
#line 461 "Utility/TeeJee.Process.vala"
	child_pids = (g_free (child_pids), NULL);
#line 2851 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_process_pause (GPid procID)
{
	gint result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
#line 485 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("kill -STOP %d", (gint) procID);
#line 485 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 485 "Utility/TeeJee.Process.vala"
	_tmp2_ = tee_jee_process_helper_exec_sync (_tmp1_, NULL, NULL);
#line 485 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 485 "Utility/TeeJee.Process.vala"
	result = _tmp2_;
#line 485 "Utility/TeeJee.Process.vala"
	return result;
#line 2873 "TeeJee.Process.c"
}

gint
tee_jee_process_helper_process_resume (GPid procID)
{
	gint result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
#line 493 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("kill -CONT %d", (gint) procID);
#line 493 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 493 "Utility/TeeJee.Process.vala"
	_tmp2_ = tee_jee_process_helper_exec_sync (_tmp1_, NULL, NULL);
#line 493 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 493 "Utility/TeeJee.Process.vala"
	result = _tmp2_;
#line 493 "Utility/TeeJee.Process.vala"
	return result;
#line 2895 "TeeJee.Process.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2919 "TeeJee.Process.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 2927 "TeeJee.Process.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 2933 "TeeJee.Process.c"
	}
}

void
tee_jee_process_helper_process_quit_by_name (const gchar* cmd_name,
                                             const gchar* cmd_to_match,
                                             gboolean exact_match)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* pid = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
#line 497 "Utility/TeeJee.Process.vala"
	g_return_if_fail (cmd_name != NULL);
#line 497 "Utility/TeeJee.Process.vala"
	g_return_if_fail (cmd_to_match != NULL);
#line 502 "Utility/TeeJee.Process.vala"
	_tmp0_ = g_strdup_printf ("ps w -C '%s'", cmd_name);
#line 502 "Utility/TeeJee.Process.vala"
	_tmp1_ = _tmp0_;
#line 502 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_exec_sync (_tmp1_, &_tmp2_, &_tmp3_);
#line 502 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 502 "Utility/TeeJee.Process.vala"
	std_out = _tmp2_;
#line 502 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 502 "Utility/TeeJee.Process.vala"
	std_err = _tmp3_;
#line 502 "Utility/TeeJee.Process.vala"
	_g_free0 (_tmp1_);
#line 505 "Utility/TeeJee.Process.vala"
	_tmp4_ = g_strdup ("");
#line 505 "Utility/TeeJee.Process.vala"
	pid = _tmp4_;
#line 506 "Utility/TeeJee.Process.vala"
	_tmp5_ = std_out;
#line 506 "Utility/TeeJee.Process.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 2981 "TeeJee.Process.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 506 "Utility/TeeJee.Process.vala"
		line_collection = _tmp7_;
#line 506 "Utility/TeeJee.Process.vala"
		line_collection_length1 = _vala_array_length (_tmp6_);
#line 506 "Utility/TeeJee.Process.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp6_); line_it = line_it + 1) {
#line 2993 "TeeJee.Process.c"
			gchar* _tmp8_;
			gchar* line = NULL;
#line 506 "Utility/TeeJee.Process.vala"
			_tmp8_ = g_strdup (line_collection[line_it]);
#line 506 "Utility/TeeJee.Process.vala"
			line = _tmp8_;
#line 3000 "TeeJee.Process.c"
			{
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 507 "Utility/TeeJee.Process.vala"
				if (exact_match) {
#line 3006 "TeeJee.Process.c"
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
#line 507 "Utility/TeeJee.Process.vala"
					_tmp11_ = line;
#line 507 "Utility/TeeJee.Process.vala"
					_tmp12_ = g_strconcat (" ", cmd_to_match, NULL);
#line 507 "Utility/TeeJee.Process.vala"
					_tmp13_ = _tmp12_;
#line 507 "Utility/TeeJee.Process.vala"
					_tmp10_ = g_str_has_suffix (_tmp11_, _tmp13_);
#line 507 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp13_);
#line 3020 "TeeJee.Process.c"
				} else {
#line 507 "Utility/TeeJee.Process.vala"
					_tmp10_ = FALSE;
#line 3024 "TeeJee.Process.c"
				}
#line 507 "Utility/TeeJee.Process.vala"
				if (_tmp10_) {
#line 507 "Utility/TeeJee.Process.vala"
					_tmp9_ = TRUE;
#line 3030 "TeeJee.Process.c"
				} else {
					gboolean _tmp14_ = FALSE;
#line 508 "Utility/TeeJee.Process.vala"
					if (!exact_match) {
#line 3035 "TeeJee.Process.c"
						const gchar* _tmp15_;
#line 508 "Utility/TeeJee.Process.vala"
						_tmp15_ = line;
#line 508 "Utility/TeeJee.Process.vala"
						_tmp14_ = string_index_of (_tmp15_, cmd_to_match, 0) != -1;
#line 3041 "TeeJee.Process.c"
					} else {
#line 508 "Utility/TeeJee.Process.vala"
						_tmp14_ = FALSE;
#line 3045 "TeeJee.Process.c"
					}
#line 508 "Utility/TeeJee.Process.vala"
					_tmp9_ = _tmp14_;
#line 3049 "TeeJee.Process.c"
				}
#line 507 "Utility/TeeJee.Process.vala"
				if (_tmp9_) {
#line 3053 "TeeJee.Process.c"
					const gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar** _tmp19_;
					gchar** _tmp20_;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
#line 509 "Utility/TeeJee.Process.vala"
					_tmp16_ = line;
#line 509 "Utility/TeeJee.Process.vala"
					_tmp17_ = string_strip (_tmp16_);
#line 509 "Utility/TeeJee.Process.vala"
					_tmp18_ = _tmp17_;
#line 509 "Utility/TeeJee.Process.vala"
					_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, " ", 0);
#line 509 "Utility/TeeJee.Process.vala"
					_tmp21_ = _tmp20_;
#line 509 "Utility/TeeJee.Process.vala"
					_tmp21__length1 = _vala_array_length (_tmp19_);
#line 509 "Utility/TeeJee.Process.vala"
					_tmp22_ = _tmp21_[0];
#line 509 "Utility/TeeJee.Process.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 509 "Utility/TeeJee.Process.vala"
					_g_free0 (pid);
#line 509 "Utility/TeeJee.Process.vala"
					pid = _tmp23_;
#line 509 "Utility/TeeJee.Process.vala"
					_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 509 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp18_);
#line 510 "Utility/TeeJee.Process.vala"
					_tmp24_ = pid;
#line 510 "Utility/TeeJee.Process.vala"
					kill ((pid_t) ((GPid) atoi (_tmp24_)), 15);
#line 511 "Utility/TeeJee.Process.vala"
					_tmp25_ = g_strconcat (_ ("Stopped"), ": [PID=", NULL);
#line 511 "Utility/TeeJee.Process.vala"
					_tmp26_ = _tmp25_;
#line 511 "Utility/TeeJee.Process.vala"
					_tmp27_ = pid;
#line 511 "Utility/TeeJee.Process.vala"
					_tmp28_ = g_strconcat (_tmp26_, _tmp27_, NULL);
#line 511 "Utility/TeeJee.Process.vala"
					_tmp29_ = _tmp28_;
#line 511 "Utility/TeeJee.Process.vala"
					_tmp30_ = g_strconcat (_tmp29_, "] ", NULL);
#line 511 "Utility/TeeJee.Process.vala"
					_tmp31_ = _tmp30_;
#line 511 "Utility/TeeJee.Process.vala"
					tee_jee_logging_log_debug (_tmp31_);
#line 511 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp31_);
#line 511 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp29_);
#line 511 "Utility/TeeJee.Process.vala"
					_g_free0 (_tmp26_);
#line 3121 "TeeJee.Process.c"
				}
#line 506 "Utility/TeeJee.Process.vala"
				_g_free0 (line);
#line 3125 "TeeJee.Process.c"
			}
		}
#line 506 "Utility/TeeJee.Process.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3130 "TeeJee.Process.c"
	}
#line 497 "Utility/TeeJee.Process.vala"
	_g_free0 (pid);
#line 497 "Utility/TeeJee.Process.vala"
	_g_free0 (std_err);
#line 497 "Utility/TeeJee.Process.vala"
	_g_free0 (std_out);
#line 3138 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_set_priority (GPid procID,
                                             gint prio)
{
#line 522 "Utility/TeeJee.Process.vala"
	if (getpriority (PRIO_PROCESS, (gint) procID) != prio) {
#line 523 "Utility/TeeJee.Process.vala"
		setpriority (PRIO_PROCESS, (gint) procID, prio);
#line 3149 "TeeJee.Process.c"
	}
}

gint
tee_jee_process_helper_process_get_priority (GPid procID)
{
	gint result = 0;
#line 530 "Utility/TeeJee.Process.vala"
	result = getpriority (PRIO_PROCESS, (gint) procID);
#line 530 "Utility/TeeJee.Process.vala"
	return result;
#line 3161 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_set_priority_normal (GPid procID)
{
#line 537 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_process_set_priority (procID, 0);
#line 3169 "TeeJee.Process.c"
}

void
tee_jee_process_helper_process_set_priority_low (GPid procID)
{
#line 544 "Utility/TeeJee.Process.vala"
	tee_jee_process_helper_process_set_priority (procID, 5);
#line 3177 "TeeJee.Process.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

