/* Device.c generated by valac 0.43.91, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Device.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */
/* Functions and classes for handling disk partitions */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
typedef struct _DevicePrivate DevicePrivate;

#define TYPE_MOUNT_ENTRY (mount_entry_get_type ())
#define MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_ENTRY, MountEntry))
#define MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_ENTRY, MountEntryClass))
#define IS_MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_ENTRY))
#define IS_MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_ENTRY))
#define MOUNT_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_ENTRY, MountEntryClass))

typedef struct _MountEntry MountEntry;
typedef struct _MountEntryClass MountEntryClass;
enum  {
	DEVICE_0_PROPERTY,
	DEVICE_FREE_BYTES_PROPERTY,
	DEVICE_SIZE_PROPERTY,
	DEVICE_USED_PROPERTY,
	DEVICE_FREE_PROPERTY,
	DEVICE_IS_MOUNTED_PROPERTY,
	DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_FULL_NAME_WITH_PARENT_PROPERTY,
	DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY,
	DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY,
	DEVICE_NUM_PROPERTIES
};
static GParamSpec* device_properties[DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _MountEntryPrivate MountEntryPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_TIMEOUT_COUNTER (timeout_counter_get_type ())
#define TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounter))
#define TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))
#define IS_TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMEOUT_COUNTER))
#define IS_TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMEOUT_COUNTER))
#define TIMEOUT_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))

typedef struct _TimeoutCounter TimeoutCounter;
typedef struct _TimeoutCounterClass TimeoutCounterClass;

struct _Device {
	GObject parent_instance;
	DevicePrivate * priv;
	gchar* device;
	gchar* name;
	gchar* kname;
	gchar* pkname;
	gchar* pkname_toplevel;
	gchar* mapped_name;
	gchar* uuid;
	gchar* label;
	gchar* partuuid;
	gchar* partlabel;
	gint major;
	gint minor;
	gchar* device_mapper;
	gchar* device_by_uuid;
	gchar* device_by_label;
	gchar* device_by_partuuid;
	gchar* device_by_partlabel;
	gchar* type;
	gchar* fstype;
	gint order;
	gchar* vendor;
	gchar* model;
	gchar* serial;
	gchar* revision;
	gboolean removable;
	gboolean read_only;
	guint64 size_bytes;
	guint64 used_bytes;
	guint64 available_bytes;
	gchar* used_percent;
	gchar* dist_info;
	GeeArrayList* mount_points;
	GeeArrayList* symlinks;
	Device* parent;
	GeeArrayList* children;
};

struct _DeviceClass {
	GObjectClass parent_class;
};

struct _MountEntry {
	GObject parent_instance;
	MountEntryPrivate * priv;
	Device* device;
	gchar* mount_point;
	gchar* mount_options;
};

struct _MountEntryClass {
	GObjectClass parent_class;
};

static gpointer device_parent_class = NULL;
extern gdouble device_KB;
gdouble device_KB = (gdouble) 1000;
extern gdouble device_MB;
gdouble device_MB = 0.0;
extern gdouble device_GB;
gdouble device_GB = 0.0;
extern gdouble device_KiB;
gdouble device_KiB = (gdouble) 1024;
extern gdouble device_MiB;
gdouble device_MiB = 0.0;
extern gdouble device_GiB;
gdouble device_GiB = 0.0;
static gchar* device_lsblk_version;
static gchar* device_lsblk_version = NULL;
static gboolean device_lsblk_is_ancient;
static gboolean device_lsblk_is_ancient = FALSE;
static GeeArrayList* device_device_list;
static GeeArrayList* device_device_list = NULL;
extern gboolean tee_jee_logging_LOG_DEBUG;

GType device_get_type (void) G_GNUC_CONST;
GType mount_entry_get_type (void) G_GNUC_CONST;
Device* device_new (void);
Device* device_construct (GType object_type);
void device_test_lsblk_version (void);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gboolean device_is_mounted_at_path (Device* self,
                                    const gchar* subvolname,
                                    const gchar* mount_path);
gboolean device_has_linux_filesystem (Device* self);
gboolean device_is_encrypted_partition (Device* self);
gboolean device_is_on_encrypted_partition (Device* self);
gboolean device_is_lvm_partition (Device* self);
gboolean device_has_children (Device* self);
Device* device_first_linux_child (Device* self);
gboolean device_has_parent (Device* self);
GeeArrayList* device_get_filesystems (gboolean get_space,
                                      gboolean get_mounts);
GeeArrayList* device_get_block_devices_using_lsblk (const gchar* dev_name);
GeeArrayList* device_get_disk_space_using_df (const gchar* dev_name_or_mount_point);
Device* device_find_device_in_list (GeeArrayList* list,
                                    const gchar* _dev_alias);
GeeArrayList* device_get_mounted_filesystems_using_mtab (void);
void tee_jee_logging_log_debug (const gchar* message);
static void device_find_child_devices (GeeArrayList* list,
                                Device* parent);
static void device_find_toplevel_parent (GeeArrayList* list,
                                  Device* dev);
static void device_find_child_devices_using_dmsetup (GeeArrayList* list);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
MountEntry* mount_entry_new (Device* device,
                             const gchar* mount_point,
                             const gchar* mount_options);
MountEntry* mount_entry_construct (GType object_type,
                                   Device* device,
                                   const gchar* mount_point,
                                   const gchar* mount_options);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
GeeArrayList* device_get_block_devices_using_blkid (const gchar* dev_name);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* device_resolve_device_name (const gchar* dev_alias);
gchar* device_get_device_uuid (const gchar* device);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
Device* device_get_device_by_uuid (const gchar* uuid);
Device* device_get_device_by_name (const gchar* file_name);
Device* device_get_device_by_path (const gchar* path_to_check);
GeeArrayList* device_get_device_mount_points (const gchar* dev_name_or_uuid);
gboolean device_device_is_mounted (const gchar* dev_name_or_uuid);
gboolean device_mount_point_in_use (const gchar* mount_point);
gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
void device_copy_fields_from (Device* self,
                              Device* dev2);
Device* device_query_changes (Device* self);
void device_query_disk_space (Device* self);
gboolean device_automount_udisks (const gchar* dev_name_or_uuid,
                                  GtkWindow* parent_window);
void tee_jee_gtk_helper_gtk_messagebox (const gchar* title,
                                        const gchar* message,
                                        GtkWindow* parent_win,
                                        gboolean is_error);
gboolean device_automount_udisks_iso (const gchar* iso_file_path,
                                      gchar* * loop_device,
                                      GtkWindow* parent_window);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean device_unmount_udisks (const gchar* dev_name_or_uuid,
                                GtkWindow* parent_window);
Device* device_luks_unlock (Device* luks_device,
                            const gchar* mapped_name,
                            const gchar* passphrase,
                            GtkWindow* parent_window,
                            gchar* * message,
                            gchar* * details);
GType timeout_counter_get_type (void) G_GNUC_CONST;
TimeoutCounter* timeout_counter_new (void);
TimeoutCounter* timeout_counter_construct (GType object_type);
void timeout_counter_kill_process_on_timeout (TimeoutCounter* self,
                                              const gchar* process_to_kill,
                                              gint seconds_to_wait,
                                              gboolean exit_app);
void timeout_counter_stop (TimeoutCounter* self);
gchar* tee_jee_gtk_helper_gtk_inputbox (const gchar* title,
                                        const gchar* message,
                                        GtkWindow* parent_win,
                                        gboolean mask_password);
gboolean device_luks_lock (const gchar* kname,
                           GtkWindow* parent_window);
gboolean device_mount (const gchar* dev_name_or_uuid,
                       const gchar* mount_point,
                       const gchar* mount_options,
                       gboolean silent);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean device_unmount (const gchar* mount_point);
gchar* device_get_device_name_with_parent (Device* self);
gchar* device_automount (const gchar* dev_name_or_uuid,
                         const gchar* mount_options,
                         const gchar* mount_prefix);
gchar* device_description (Device* self);
gchar* device_description_formatted (Device* self);
gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
gchar* device_get_short_name_with_parent (Device* self);
gchar* device_description_simple (Device* self);
gchar* device_description_simple_formatted (Device* self);
gchar* device_description_full_free (Device* self);
guint64 device_get_free_bytes (Device* self);
gchar* device_description_free (Device* self);
gchar* device_description_full (Device* self);
gchar* device_get_used (Device* self);
gchar* device_get_size (Device* self);
gchar* device_description_usage (Device* self);
gchar* device_tooltip_text (Device* self);
static gchar* device_display_name (Device* self,
                            gboolean short_name,
                            gboolean show_label,
                            gboolean show_parent,
                            gboolean show_alias);
void device_test_all (void);
void device_print_device_list (GeeArrayList* list);
void device_print_device_mounts (GeeArrayList* list);
void device_print_device_disk_space (GeeArrayList* list);
gchar* device_get_free (Device* self);
gboolean device_get_is_mounted (Device* self);
gchar* device_get_full_name_with_alias (Device* self);
gchar* device_get_full_name_with_parent (Device* self);
gchar* device_get_short_name_with_alias (Device* self);
static void device_finalize (GObject * obj);
static void _vala_device_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

Device*
device_construct (GType object_type)
{
	Device * self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 94 "Utility/Device.vala"
	self = (Device*) g_object_new (object_type, NULL);
#line 95 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 95 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 95 "Utility/Device.vala"
	self->mount_points = _tmp0_;
#line 96 "Utility/Device.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 96 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 96 "Utility/Device.vala"
	self->symlinks = _tmp1_;
#line 97 "Utility/Device.vala"
	_tmp2_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 97 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 97 "Utility/Device.vala"
	self->children = _tmp2_;
#line 99 "Utility/Device.vala"
	device_test_lsblk_version ();
#line 94 "Utility/Device.vala"
	return self;
#line 357 "Device.c"
}

Device*
device_new (void)
{
#line 94 "Utility/Device.vala"
	return device_construct (TYPE_DEVICE);
#line 365 "Device.c"
}

void
device_test_lsblk_version (void)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
#line 104 "Utility/Device.vala"
	_tmp1_ = device_lsblk_version;
#line 104 "Utility/Device.vala"
	if (_tmp1_ != NULL) {
#line 383 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 104 "Utility/Device.vala"
		_tmp2_ = device_lsblk_version;
#line 104 "Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 104 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 104 "Utility/Device.vala"
		_tmp0_ = _tmp4_ > 0;
#line 395 "Device.c"
	} else {
#line 104 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 399 "Device.c"
	}
#line 104 "Utility/Device.vala"
	if (_tmp0_) {
#line 105 "Utility/Device.vala"
		return;
#line 405 "Device.c"
	}
#line 109 "Utility/Device.vala"
	_tmp7_ = tee_jee_process_helper_exec_sync ("lsblk --bytes --pairs --output HOTPLUG,PKNAME,VENDOR,SERIAL,REV", &_tmp5_, &_tmp6_);
#line 109 "Utility/Device.vala"
	_g_free0 (std_out);
#line 109 "Utility/Device.vala"
	std_out = _tmp5_;
#line 109 "Utility/Device.vala"
	_g_free0 (std_err);
#line 109 "Utility/Device.vala"
	std_err = _tmp6_;
#line 109 "Utility/Device.vala"
	status = _tmp7_;
#line 110 "Utility/Device.vala"
	if (status == 0) {
#line 421 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 111 "Utility/Device.vala"
		_tmp8_ = std_out;
#line 111 "Utility/Device.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 111 "Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 111 "Utility/Device.vala"
		device_lsblk_version = _tmp9_;
#line 112 "Utility/Device.vala"
		device_lsblk_is_ancient = FALSE;
#line 434 "Device.c"
	} else {
		gchar* _tmp10_;
#line 115 "Utility/Device.vala"
		_tmp10_ = g_strdup ("ancient");
#line 115 "Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 115 "Utility/Device.vala"
		device_lsblk_version = _tmp10_;
#line 116 "Utility/Device.vala"
		device_lsblk_is_ancient = TRUE;
#line 445 "Device.c"
	}
#line 102 "Utility/Device.vala"
	_g_free0 (std_err);
#line 102 "Utility/Device.vala"
	_g_free0 (std_out);
#line 451 "Device.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 160 "Utility/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 459 "Device.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 478 "Device.c"
}

gboolean
device_is_mounted_at_path (Device* self,
                           const gchar* subvolname,
                           const gchar* mount_path)
{
	gboolean result = FALSE;
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (subvolname != NULL, FALSE);
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (mount_path != NULL, FALSE);
#line 493 "Device.c"
	{
		GeeArrayList* _mnt_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _mnt_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _mnt_index = 0;
#line 160 "Utility/Device.vala"
		_tmp0_ = self->mount_points;
#line 160 "Utility/Device.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 160 "Utility/Device.vala"
		_mnt_list = _tmp1_;
#line 160 "Utility/Device.vala"
		_tmp2_ = _mnt_list;
#line 160 "Utility/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 160 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 160 "Utility/Device.vala"
		_mnt_size = _tmp4_;
#line 160 "Utility/Device.vala"
		_mnt_index = -1;
#line 160 "Utility/Device.vala"
		while (TRUE) {
#line 521 "Device.c"
			MountEntry* mnt = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			MountEntry* _tmp7_;
			const gchar* _tmp8_;
#line 160 "Utility/Device.vala"
			_mnt_index = _mnt_index + 1;
#line 160 "Utility/Device.vala"
			if (!(_mnt_index < _mnt_size)) {
#line 160 "Utility/Device.vala"
				break;
#line 533 "Device.c"
			}
#line 160 "Utility/Device.vala"
			_tmp5_ = _mnt_list;
#line 160 "Utility/Device.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _mnt_index);
#line 160 "Utility/Device.vala"
			mnt = (MountEntry*) _tmp6_;
#line 161 "Utility/Device.vala"
			_tmp7_ = mnt;
#line 161 "Utility/Device.vala"
			_tmp8_ = _tmp7_->mount_point;
#line 161 "Utility/Device.vala"
			if (g_strcmp0 (_tmp8_, mount_path) == 0) {
#line 547 "Device.c"
				gint _tmp9_;
				gint _tmp10_;
#line 162 "Utility/Device.vala"
				_tmp9_ = strlen (subvolname);
#line 162 "Utility/Device.vala"
				_tmp10_ = _tmp9_;
#line 162 "Utility/Device.vala"
				if (_tmp10_ == 0) {
#line 163 "Utility/Device.vala"
					result = TRUE;
#line 163 "Utility/Device.vala"
					_g_object_unref0 (mnt);
#line 163 "Utility/Device.vala"
					_g_object_unref0 (_mnt_list);
#line 163 "Utility/Device.vala"
					return result;
#line 564 "Device.c"
				} else {
					gboolean _tmp11_ = FALSE;
					MountEntry* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gboolean _tmp16_;
#line 165 "Utility/Device.vala"
					_tmp12_ = mnt;
#line 165 "Utility/Device.vala"
					_tmp13_ = _tmp12_->mount_options;
#line 165 "Utility/Device.vala"
					_tmp14_ = g_strdup_printf ("subvol=%s", subvolname);
#line 165 "Utility/Device.vala"
					_tmp15_ = _tmp14_;
#line 165 "Utility/Device.vala"
					_tmp16_ = string_contains (_tmp13_, _tmp15_);
#line 165 "Utility/Device.vala"
					_g_free0 (_tmp15_);
#line 165 "Utility/Device.vala"
					if (_tmp16_) {
#line 165 "Utility/Device.vala"
						_tmp11_ = TRUE;
#line 588 "Device.c"
					} else {
						MountEntry* _tmp17_;
						const gchar* _tmp18_;
						gchar* _tmp19_;
						gchar* _tmp20_;
#line 166 "Utility/Device.vala"
						_tmp17_ = mnt;
#line 166 "Utility/Device.vala"
						_tmp18_ = _tmp17_->mount_options;
#line 166 "Utility/Device.vala"
						_tmp19_ = g_strdup_printf ("subvol=/%s", subvolname);
#line 166 "Utility/Device.vala"
						_tmp20_ = _tmp19_;
#line 166 "Utility/Device.vala"
						_tmp11_ = string_contains (_tmp18_, _tmp20_);
#line 166 "Utility/Device.vala"
						_g_free0 (_tmp20_);
#line 606 "Device.c"
					}
#line 165 "Utility/Device.vala"
					if (_tmp11_) {
#line 168 "Utility/Device.vala"
						result = TRUE;
#line 168 "Utility/Device.vala"
						_g_object_unref0 (mnt);
#line 168 "Utility/Device.vala"
						_g_object_unref0 (_mnt_list);
#line 168 "Utility/Device.vala"
						return result;
#line 618 "Device.c"
					}
				}
			}
#line 160 "Utility/Device.vala"
			_g_object_unref0 (mnt);
#line 624 "Device.c"
		}
#line 160 "Utility/Device.vala"
		_g_object_unref0 (_mnt_list);
#line 628 "Device.c"
	}
#line 173 "Utility/Device.vala"
	result = FALSE;
#line 173 "Utility/Device.vala"
	return result;
#line 634 "Device.c"
}

gboolean
device_has_linux_filesystem (Device* self)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label6 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label7 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label8 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label9 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label10 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label11 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label12 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label13 = 0;
#line 176 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "Utility/Device.vala"
	_tmp0_ = self->fstype;
#line 177 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 177 "Utility/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 177 "Utility/Device.vala"
	if ((((((((((((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("ext2")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("ext3"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("ext4"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("reiserfs"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("reiser4"))))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("xfs"))))) || (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("jfs"))))) || (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("btrfs"))))) || (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("lvm"))))) || (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("lvm2"))))) || (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("lvm2_member"))))) || (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("luks"))))) || (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("crypt"))))) || (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("crypto_luks"))))) {
#line 177 "Utility/Device.vala"
		switch (0) {
#line 684 "Device.c"
			default:
			{
#line 192 "Utility/Device.vala"
				result = TRUE;
#line 192 "Utility/Device.vala"
				return result;
#line 691 "Device.c"
			}
		}
	} else {
#line 177 "Utility/Device.vala"
		switch (0) {
#line 697 "Device.c"
			default:
			{
#line 194 "Utility/Device.vala"
				result = FALSE;
#line 194 "Utility/Device.vala"
				return result;
#line 704 "Device.c"
			}
		}
	}
}

gboolean
device_is_encrypted_partition (Device* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 198 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 199 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 199 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 722 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 199 "Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 199 "Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 199 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 199 "Utility/Device.vala"
		_tmp0_ = string_contains (_tmp4_, "luks");
#line 199 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 736 "Device.c"
	} else {
#line 199 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 740 "Device.c"
	}
#line 199 "Utility/Device.vala"
	result = _tmp0_;
#line 199 "Utility/Device.vala"
	return result;
#line 746 "Device.c"
}

gboolean
device_is_on_encrypted_partition (Device* self)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
#line 202 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 203 "Utility/Device.vala"
	_tmp0_ = self->type;
#line 203 "Utility/Device.vala"
	result = g_strcmp0 (_tmp0_, "crypt") == 0;
#line 203 "Utility/Device.vala"
	return result;
#line 762 "Device.c"
}

gboolean
device_is_lvm_partition (Device* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 206 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 207 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 777 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 207 "Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 207 "Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 207 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 207 "Utility/Device.vala"
		_tmp0_ = string_contains (_tmp4_, "lvm2_member");
#line 207 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 791 "Device.c"
	} else {
#line 207 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 795 "Device.c"
	}
#line 207 "Utility/Device.vala"
	result = _tmp0_;
#line 207 "Utility/Device.vala"
	return result;
#line 801 "Device.c"
}

gboolean
device_has_children (Device* self)
{
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 210 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "Utility/Device.vala"
	_tmp0_ = self->children;
#line 211 "Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 211 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 211 "Utility/Device.vala"
	result = _tmp2_ > 0;
#line 211 "Utility/Device.vala"
	return result;
#line 823 "Device.c"
}

Device*
device_first_linux_child (Device* self)
{
	Device* result = NULL;
#line 214 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 832 "Device.c"
	{
		GeeArrayList* _child_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _child_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _child_index = 0;
#line 216 "Utility/Device.vala"
		_tmp0_ = self->children;
#line 216 "Utility/Device.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 216 "Utility/Device.vala"
		_child_list = _tmp1_;
#line 216 "Utility/Device.vala"
		_tmp2_ = _child_list;
#line 216 "Utility/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 216 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 216 "Utility/Device.vala"
		_child_size = _tmp4_;
#line 216 "Utility/Device.vala"
		_child_index = -1;
#line 216 "Utility/Device.vala"
		while (TRUE) {
#line 860 "Device.c"
			Device* child = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			Device* _tmp7_;
#line 216 "Utility/Device.vala"
			_child_index = _child_index + 1;
#line 216 "Utility/Device.vala"
			if (!(_child_index < _child_size)) {
#line 216 "Utility/Device.vala"
				break;
#line 871 "Device.c"
			}
#line 216 "Utility/Device.vala"
			_tmp5_ = _child_list;
#line 216 "Utility/Device.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _child_index);
#line 216 "Utility/Device.vala"
			child = (Device*) _tmp6_;
#line 217 "Utility/Device.vala"
			_tmp7_ = child;
#line 217 "Utility/Device.vala"
			if (device_has_linux_filesystem (_tmp7_)) {
#line 218 "Utility/Device.vala"
				result = child;
#line 218 "Utility/Device.vala"
				_g_object_unref0 (_child_list);
#line 218 "Utility/Device.vala"
				return result;
#line 889 "Device.c"
			}
#line 216 "Utility/Device.vala"
			_g_object_unref0 (child);
#line 893 "Device.c"
		}
#line 216 "Utility/Device.vala"
		_g_object_unref0 (_child_list);
#line 897 "Device.c"
	}
#line 222 "Utility/Device.vala"
	result = NULL;
#line 222 "Utility/Device.vala"
	return result;
#line 903 "Device.c"
}

gboolean
device_has_parent (Device* self)
{
	gboolean result = FALSE;
	Device* _tmp0_;
#line 225 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 226 "Utility/Device.vala"
	_tmp0_ = self->parent;
#line 226 "Utility/Device.vala"
	result = _tmp0_ != NULL;
#line 226 "Utility/Device.vala"
	return result;
#line 919 "Device.c"
}

GeeArrayList*
device_get_filesystems (gboolean get_space,
                        gboolean get_mounts)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
#line 236 "Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 236 "Utility/Device.vala"
	list = _tmp0_;
#line 238 "Utility/Device.vala"
	if (get_space) {
#line 940 "Device.c"
		GeeArrayList* list_df = NULL;
		GeeArrayList* _tmp1_;
#line 240 "Utility/Device.vala"
		_tmp1_ = device_get_disk_space_using_df ("");
#line 240 "Utility/Device.vala"
		list_df = _tmp1_;
#line 947 "Device.c"
		{
			GeeArrayList* _dev_df_list = NULL;
			GeeArrayList* _tmp2_;
			GeeArrayList* _tmp3_;
			gint _dev_df_size = 0;
			GeeArrayList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _dev_df_index = 0;
#line 241 "Utility/Device.vala"
			_tmp2_ = list_df;
#line 241 "Utility/Device.vala"
			_tmp3_ = _g_object_ref0 (_tmp2_);
#line 241 "Utility/Device.vala"
			_dev_df_list = _tmp3_;
#line 241 "Utility/Device.vala"
			_tmp4_ = _dev_df_list;
#line 241 "Utility/Device.vala"
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 241 "Utility/Device.vala"
			_tmp6_ = _tmp5_;
#line 241 "Utility/Device.vala"
			_dev_df_size = _tmp6_;
#line 241 "Utility/Device.vala"
			_dev_df_index = -1;
#line 241 "Utility/Device.vala"
			while (TRUE) {
#line 975 "Device.c"
				Device* dev_df = NULL;
				GeeArrayList* _tmp7_;
				gpointer _tmp8_;
				Device* dev = NULL;
				GeeArrayList* _tmp9_;
				Device* _tmp10_;
				const gchar* _tmp11_;
				Device* _tmp12_;
				Device* _tmp13_;
#line 241 "Utility/Device.vala"
				_dev_df_index = _dev_df_index + 1;
#line 241 "Utility/Device.vala"
				if (!(_dev_df_index < _dev_df_size)) {
#line 241 "Utility/Device.vala"
					break;
#line 991 "Device.c"
				}
#line 241 "Utility/Device.vala"
				_tmp7_ = _dev_df_list;
#line 241 "Utility/Device.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_df_index);
#line 241 "Utility/Device.vala"
				dev_df = (Device*) _tmp8_;
#line 242 "Utility/Device.vala"
				_tmp9_ = list;
#line 242 "Utility/Device.vala"
				_tmp10_ = dev_df;
#line 242 "Utility/Device.vala"
				_tmp11_ = _tmp10_->uuid;
#line 242 "Utility/Device.vala"
				_tmp12_ = device_find_device_in_list (_tmp9_, _tmp11_);
#line 242 "Utility/Device.vala"
				dev = _tmp12_;
#line 243 "Utility/Device.vala"
				_tmp13_ = dev;
#line 243 "Utility/Device.vala"
				if (_tmp13_ != NULL) {
#line 1013 "Device.c"
					Device* _tmp14_;
					Device* _tmp15_;
					Device* _tmp16_;
					Device* _tmp17_;
					Device* _tmp18_;
					Device* _tmp19_;
					Device* _tmp20_;
					Device* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
#line 244 "Utility/Device.vala"
					_tmp14_ = dev;
#line 244 "Utility/Device.vala"
					_tmp15_ = dev_df;
#line 244 "Utility/Device.vala"
					_tmp14_->size_bytes = _tmp15_->size_bytes;
#line 245 "Utility/Device.vala"
					_tmp16_ = dev;
#line 245 "Utility/Device.vala"
					_tmp17_ = dev_df;
#line 245 "Utility/Device.vala"
					_tmp16_->used_bytes = _tmp17_->used_bytes;
#line 246 "Utility/Device.vala"
					_tmp18_ = dev;
#line 246 "Utility/Device.vala"
					_tmp19_ = dev_df;
#line 246 "Utility/Device.vala"
					_tmp18_->available_bytes = _tmp19_->available_bytes;
#line 247 "Utility/Device.vala"
					_tmp20_ = dev;
#line 247 "Utility/Device.vala"
					_tmp21_ = dev_df;
#line 247 "Utility/Device.vala"
					_tmp22_ = _tmp21_->used_percent;
#line 247 "Utility/Device.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 247 "Utility/Device.vala"
					_g_free0 (_tmp20_->used_percent);
#line 247 "Utility/Device.vala"
					_tmp20_->used_percent = _tmp23_;
#line 1054 "Device.c"
				}
#line 241 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 241 "Utility/Device.vala"
				_g_object_unref0 (dev_df);
#line 1060 "Device.c"
			}
#line 241 "Utility/Device.vala"
			_g_object_unref0 (_dev_df_list);
#line 1064 "Device.c"
		}
#line 238 "Utility/Device.vala"
		_g_object_unref0 (list_df);
#line 1068 "Device.c"
	}
#line 252 "Utility/Device.vala"
	if (get_mounts) {
#line 1072 "Device.c"
		GeeArrayList* list_mtab = NULL;
		GeeArrayList* _tmp24_;
#line 254 "Utility/Device.vala"
		_tmp24_ = device_get_mounted_filesystems_using_mtab ();
#line 254 "Utility/Device.vala"
		list_mtab = _tmp24_;
#line 1079 "Device.c"
		{
			GeeArrayList* _dev_mtab_list = NULL;
			GeeArrayList* _tmp25_;
			GeeArrayList* _tmp26_;
			gint _dev_mtab_size = 0;
			GeeArrayList* _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
			gint _dev_mtab_index = 0;
#line 255 "Utility/Device.vala"
			_tmp25_ = list_mtab;
#line 255 "Utility/Device.vala"
			_tmp26_ = _g_object_ref0 (_tmp25_);
#line 255 "Utility/Device.vala"
			_dev_mtab_list = _tmp26_;
#line 255 "Utility/Device.vala"
			_tmp27_ = _dev_mtab_list;
#line 255 "Utility/Device.vala"
			_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
#line 255 "Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 255 "Utility/Device.vala"
			_dev_mtab_size = _tmp29_;
#line 255 "Utility/Device.vala"
			_dev_mtab_index = -1;
#line 255 "Utility/Device.vala"
			while (TRUE) {
#line 1107 "Device.c"
				Device* dev_mtab = NULL;
				GeeArrayList* _tmp30_;
				gpointer _tmp31_;
				Device* dev = NULL;
				GeeArrayList* _tmp32_;
				Device* _tmp33_;
				const gchar* _tmp34_;
				Device* _tmp35_;
				Device* _tmp36_;
#line 255 "Utility/Device.vala"
				_dev_mtab_index = _dev_mtab_index + 1;
#line 255 "Utility/Device.vala"
				if (!(_dev_mtab_index < _dev_mtab_size)) {
#line 255 "Utility/Device.vala"
					break;
#line 1123 "Device.c"
				}
#line 255 "Utility/Device.vala"
				_tmp30_ = _dev_mtab_list;
#line 255 "Utility/Device.vala"
				_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _dev_mtab_index);
#line 255 "Utility/Device.vala"
				dev_mtab = (Device*) _tmp31_;
#line 256 "Utility/Device.vala"
				_tmp32_ = list;
#line 256 "Utility/Device.vala"
				_tmp33_ = dev_mtab;
#line 256 "Utility/Device.vala"
				_tmp34_ = _tmp33_->uuid;
#line 256 "Utility/Device.vala"
				_tmp35_ = device_find_device_in_list (_tmp32_, _tmp34_);
#line 256 "Utility/Device.vala"
				dev = _tmp35_;
#line 257 "Utility/Device.vala"
				_tmp36_ = dev;
#line 257 "Utility/Device.vala"
				if (_tmp36_ != NULL) {
#line 1145 "Device.c"
					Device* _tmp37_;
					Device* _tmp38_;
					GeeArrayList* _tmp39_;
					GeeArrayList* _tmp40_;
#line 258 "Utility/Device.vala"
					_tmp37_ = dev;
#line 258 "Utility/Device.vala"
					_tmp38_ = dev_mtab;
#line 258 "Utility/Device.vala"
					_tmp39_ = _tmp38_->mount_points;
#line 258 "Utility/Device.vala"
					_tmp40_ = _g_object_ref0 (_tmp39_);
#line 258 "Utility/Device.vala"
					_g_object_unref0 (_tmp37_->mount_points);
#line 258 "Utility/Device.vala"
					_tmp37_->mount_points = _tmp40_;
#line 1162 "Device.c"
				}
#line 255 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 255 "Utility/Device.vala"
				_g_object_unref0 (dev_mtab);
#line 1168 "Device.c"
			}
#line 255 "Utility/Device.vala"
			_g_object_unref0 (_dev_mtab_list);
#line 1172 "Device.c"
		}
#line 252 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1176 "Device.c"
	}
#line 267 "Utility/Device.vala"
	_tmp41_ = list;
#line 267 "Utility/Device.vala"
	_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 267 "Utility/Device.vala"
	_tmp43_ = _tmp42_;
#line 267 "Utility/Device.vala"
	_tmp44_ = g_strdup_printf ("Device: get_filesystems(): %d", _tmp43_);
#line 267 "Utility/Device.vala"
	_tmp45_ = _tmp44_;
#line 267 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp45_);
#line 267 "Utility/Device.vala"
	_g_free0 (_tmp45_);
#line 269 "Utility/Device.vala"
	result = list;
#line 269 "Utility/Device.vala"
	return result;
#line 1196 "Device.c"
}

static void
device_find_child_devices (GeeArrayList* list,
                           Device* parent)
{
	gboolean _tmp0_ = FALSE;
#line 272 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 272 "Utility/Device.vala"
	g_return_if_fail (parent != NULL);
#line 273 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 1210 "Device.c"
		const gchar* _tmp1_;
#line 273 "Utility/Device.vala"
		_tmp1_ = parent->type;
#line 273 "Utility/Device.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, "disk") == 0;
#line 1216 "Device.c"
	} else {
#line 273 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 1220 "Device.c"
	}
#line 273 "Utility/Device.vala"
	if (_tmp0_) {
#line 1224 "Device.c"
		{
			GeeArrayList* _part_list = NULL;
			GeeArrayList* _tmp2_;
			gint _part_size = 0;
			GeeArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _part_index = 0;
#line 274 "Utility/Device.vala"
			_tmp2_ = _g_object_ref0 (list);
#line 274 "Utility/Device.vala"
			_part_list = _tmp2_;
#line 274 "Utility/Device.vala"
			_tmp3_ = _part_list;
#line 274 "Utility/Device.vala"
			_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 274 "Utility/Device.vala"
			_tmp5_ = _tmp4_;
#line 274 "Utility/Device.vala"
			_part_size = _tmp5_;
#line 274 "Utility/Device.vala"
			_part_index = -1;
#line 274 "Utility/Device.vala"
			while (TRUE) {
#line 1249 "Device.c"
				Device* part = NULL;
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
				gboolean _tmp8_ = FALSE;
				Device* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 274 "Utility/Device.vala"
				_part_index = _part_index + 1;
#line 274 "Utility/Device.vala"
				if (!(_part_index < _part_size)) {
#line 274 "Utility/Device.vala"
					break;
#line 1263 "Device.c"
				}
#line 274 "Utility/Device.vala"
				_tmp6_ = _part_list;
#line 274 "Utility/Device.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _part_index);
#line 274 "Utility/Device.vala"
				part = (Device*) _tmp7_;
#line 275 "Utility/Device.vala"
				_tmp9_ = part;
#line 275 "Utility/Device.vala"
				_tmp10_ = _tmp9_->kname;
#line 275 "Utility/Device.vala"
				_tmp11_ = parent->kname;
#line 275 "Utility/Device.vala"
				if (g_strcmp0 (_tmp10_, _tmp11_) != 0) {
#line 1279 "Device.c"
					Device* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 275 "Utility/Device.vala"
					_tmp12_ = part;
#line 275 "Utility/Device.vala"
					_tmp13_ = _tmp12_->kname;
#line 275 "Utility/Device.vala"
					_tmp14_ = parent->kname;
#line 275 "Utility/Device.vala"
					_tmp8_ = g_str_has_prefix (_tmp13_, _tmp14_);
#line 1291 "Device.c"
				} else {
#line 275 "Utility/Device.vala"
					_tmp8_ = FALSE;
#line 1295 "Device.c"
				}
#line 275 "Utility/Device.vala"
				if (_tmp8_) {
#line 1299 "Device.c"
					GeeArrayList* _tmp15_;
					Device* _tmp16_;
					Device* _tmp17_;
					Device* _tmp18_;
					Device* _tmp19_;
					const gchar* _tmp20_;
					gchar* _tmp21_;
					const gchar* _tmp22_;
					Device* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
#line 276 "Utility/Device.vala"
					_tmp15_ = parent->children;
#line 276 "Utility/Device.vala"
					_tmp16_ = part;
#line 276 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 277 "Utility/Device.vala"
					_tmp17_ = part;
#line 277 "Utility/Device.vala"
					_tmp18_ = _g_object_ref0 (parent);
#line 277 "Utility/Device.vala"
					_g_object_unref0 (_tmp17_->parent);
#line 277 "Utility/Device.vala"
					_tmp17_->parent = _tmp18_;
#line 278 "Utility/Device.vala"
					_tmp19_ = part;
#line 278 "Utility/Device.vala"
					_tmp20_ = parent->kname;
#line 278 "Utility/Device.vala"
					_tmp21_ = g_strdup (_tmp20_);
#line 278 "Utility/Device.vala"
					_g_free0 (_tmp19_->pkname);
#line 278 "Utility/Device.vala"
					_tmp19_->pkname = _tmp21_;
#line 279 "Utility/Device.vala"
					_tmp22_ = parent->kname;
#line 279 "Utility/Device.vala"
					_tmp23_ = part;
#line 279 "Utility/Device.vala"
					_tmp24_ = _tmp23_->kname;
#line 279 "Utility/Device.vala"
					_tmp25_ = g_strdup_printf ("%s -> %s", _tmp22_, _tmp24_);
#line 279 "Utility/Device.vala"
					_tmp26_ = _tmp25_;
#line 279 "Utility/Device.vala"
					tee_jee_logging_log_debug (_tmp26_);
#line 279 "Utility/Device.vala"
					_g_free0 (_tmp26_);
#line 1350 "Device.c"
				}
#line 274 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1354 "Device.c"
			}
#line 274 "Utility/Device.vala"
			_g_object_unref0 (_part_list);
#line 1358 "Device.c"
		}
	} else {
		{
			GeeArrayList* _part_list = NULL;
			GeeArrayList* _tmp27_;
			gint _part_size = 0;
			GeeArrayList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _part_index = 0;
#line 284 "Utility/Device.vala"
			_tmp27_ = _g_object_ref0 (list);
#line 284 "Utility/Device.vala"
			_part_list = _tmp27_;
#line 284 "Utility/Device.vala"
			_tmp28_ = _part_list;
#line 284 "Utility/Device.vala"
			_tmp29_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp28_);
#line 284 "Utility/Device.vala"
			_tmp30_ = _tmp29_;
#line 284 "Utility/Device.vala"
			_part_size = _tmp30_;
#line 284 "Utility/Device.vala"
			_part_index = -1;
#line 284 "Utility/Device.vala"
			while (TRUE) {
#line 1385 "Device.c"
				Device* part = NULL;
				GeeArrayList* _tmp31_;
				gpointer _tmp32_;
				Device* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
#line 284 "Utility/Device.vala"
				_part_index = _part_index + 1;
#line 284 "Utility/Device.vala"
				if (!(_part_index < _part_size)) {
#line 284 "Utility/Device.vala"
					break;
#line 1398 "Device.c"
				}
#line 284 "Utility/Device.vala"
				_tmp31_ = _part_list;
#line 284 "Utility/Device.vala"
				_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, _part_index);
#line 284 "Utility/Device.vala"
				part = (Device*) _tmp32_;
#line 285 "Utility/Device.vala"
				_tmp33_ = part;
#line 285 "Utility/Device.vala"
				_tmp34_ = _tmp33_->pkname;
#line 285 "Utility/Device.vala"
				_tmp35_ = parent->kname;
#line 285 "Utility/Device.vala"
				if (g_strcmp0 (_tmp34_, _tmp35_) == 0) {
#line 1414 "Device.c"
					GeeArrayList* _tmp36_;
					Device* _tmp37_;
					Device* _tmp38_;
					Device* _tmp39_;
#line 286 "Utility/Device.vala"
					_tmp36_ = parent->children;
#line 286 "Utility/Device.vala"
					_tmp37_ = part;
#line 286 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 287 "Utility/Device.vala"
					_tmp38_ = part;
#line 287 "Utility/Device.vala"
					_tmp39_ = _g_object_ref0 (parent);
#line 287 "Utility/Device.vala"
					_g_object_unref0 (_tmp38_->parent);
#line 287 "Utility/Device.vala"
					_tmp38_->parent = _tmp39_;
#line 1433 "Device.c"
				}
#line 284 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1437 "Device.c"
			}
#line 284 "Utility/Device.vala"
			_g_object_unref0 (_part_list);
#line 1441 "Device.c"
		}
	}
}

static void
device_find_toplevel_parent (GeeArrayList* list,
                             Device* dev)
{
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* top_kname = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
#line 293 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 293 "Utility/Device.vala"
	g_return_if_fail (dev != NULL);
#line 295 "Utility/Device.vala"
	_tmp0_ = dev->pkname;
#line 295 "Utility/Device.vala"
	_tmp1_ = strlen (_tmp0_);
#line 295 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 295 "Utility/Device.vala"
	if (_tmp2_ == 0) {
#line 295 "Utility/Device.vala"
		return;
#line 1472 "Device.c"
	}
#line 297 "Utility/Device.vala"
	_tmp3_ = dev->pkname;
#line 297 "Utility/Device.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 297 "Utility/Device.vala"
	top_kname = _tmp4_;
#line 1480 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp5_;
		gint _part_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _part_index = 0;
#line 299 "Utility/Device.vala"
		_tmp5_ = _g_object_ref0 (list);
#line 299 "Utility/Device.vala"
		_part_list = _tmp5_;
#line 299 "Utility/Device.vala"
		_tmp6_ = _part_list;
#line 299 "Utility/Device.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 299 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 299 "Utility/Device.vala"
		_part_size = _tmp8_;
#line 299 "Utility/Device.vala"
		_part_index = -1;
#line 299 "Utility/Device.vala"
		while (TRUE) {
#line 1505 "Device.c"
			Device* part = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			Device* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 299 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 299 "Utility/Device.vala"
			if (!(_part_index < _part_size)) {
#line 299 "Utility/Device.vala"
				break;
#line 1518 "Device.c"
			}
#line 299 "Utility/Device.vala"
			_tmp9_ = _part_list;
#line 299 "Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _part_index);
#line 299 "Utility/Device.vala"
			part = (Device*) _tmp10_;
#line 300 "Utility/Device.vala"
			_tmp11_ = part;
#line 300 "Utility/Device.vala"
			_tmp12_ = _tmp11_->kname;
#line 300 "Utility/Device.vala"
			_tmp13_ = top_kname;
#line 300 "Utility/Device.vala"
			if (g_strcmp0 (_tmp12_, _tmp13_) == 0) {
#line 1534 "Device.c"
				Device* _tmp14_;
				const gchar* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
#line 301 "Utility/Device.vala"
				_tmp14_ = part;
#line 301 "Utility/Device.vala"
				_tmp15_ = _tmp14_->pkname;
#line 301 "Utility/Device.vala"
				_tmp16_ = strlen (_tmp15_);
#line 301 "Utility/Device.vala"
				_tmp17_ = _tmp16_;
#line 301 "Utility/Device.vala"
				if (_tmp17_ > 0) {
#line 1549 "Device.c"
					Device* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 302 "Utility/Device.vala"
					_tmp18_ = part;
#line 302 "Utility/Device.vala"
					_tmp19_ = _tmp18_->pkname;
#line 302 "Utility/Device.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 302 "Utility/Device.vala"
					_g_free0 (top_kname);
#line 302 "Utility/Device.vala"
					top_kname = _tmp20_;
#line 1563 "Device.c"
				}
			}
#line 299 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 1568 "Device.c"
		}
#line 299 "Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 1572 "Device.c"
	}
#line 307 "Utility/Device.vala"
	_tmp21_ = top_kname;
#line 307 "Utility/Device.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 307 "Utility/Device.vala"
	_g_free0 (dev->pkname_toplevel);
#line 307 "Utility/Device.vala"
	dev->pkname_toplevel = _tmp22_;
#line 293 "Utility/Device.vala"
	_g_free0 (top_kname);
#line 1584 "Device.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 1608 "Device.c"
}

static void
device_find_child_devices_using_dmsetup (GeeArrayList* list)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	GError* _inner_error0_ = NULL;
#line 312 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 315 "Utility/Device.vala"
	tee_jee_process_helper_exec_sync ("dmsetup deps -o blkdevname", &_tmp0_, &_tmp1_);
#line 315 "Utility/Device.vala"
	_g_free0 (std_out);
#line 315 "Utility/Device.vala"
	std_out = _tmp0_;
#line 315 "Utility/Device.vala"
	_g_free0 (std_err);
#line 315 "Utility/Device.vala"
	std_err = _tmp1_;
#line 326 "Utility/Device.vala"
	_tmp2_ = std_out;
#line 326 "Utility/Device.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 1640 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 326 "Utility/Device.vala"
		line_collection = _tmp4_;
#line 326 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp3_);
#line 326 "Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp3_); line_it = line_it + 1) {
#line 1652 "Device.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 326 "Utility/Device.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 326 "Utility/Device.vala"
			line = _tmp5_;
#line 1659 "Device.c"
			{
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gboolean _tmp11_;
#line 327 "Utility/Device.vala"
				_tmp6_ = line;
#line 327 "Utility/Device.vala"
				_tmp7_ = string_strip (_tmp6_);
#line 327 "Utility/Device.vala"
				_tmp8_ = _tmp7_;
#line 327 "Utility/Device.vala"
				_tmp9_ = strlen (_tmp8_);
#line 327 "Utility/Device.vala"
				_tmp10_ = _tmp9_;
#line 327 "Utility/Device.vala"
				_tmp11_ = _tmp10_ == 0;
#line 327 "Utility/Device.vala"
				_g_free0 (_tmp8_);
#line 327 "Utility/Device.vala"
				if (_tmp11_) {
#line 327 "Utility/Device.vala"
					_g_free0 (line);
#line 327 "Utility/Device.vala"
					continue;
#line 1687 "Device.c"
				}
				{
					GRegex* _tmp12_ = NULL;
					GRegex* _tmp13_;
					GRegex* _tmp14_;
					GRegex* _tmp15_;
					const gchar* _tmp16_;
					GMatchInfo* _tmp17_ = NULL;
					gboolean _tmp18_;
#line 331 "Utility/Device.vala"
					_tmp13_ = g_regex_new ("([^:]*)\\:.*\\((.*)\\)", 0, 0, &_inner_error0_);
#line 331 "Utility/Device.vala"
					_tmp12_ = _tmp13_;
#line 331 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1703 "Device.c"
						goto __catch42_g_error;
					}
#line 331 "Utility/Device.vala"
					_tmp14_ = _tmp12_;
#line 331 "Utility/Device.vala"
					_tmp12_ = NULL;
#line 331 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 331 "Utility/Device.vala"
					rex = _tmp14_;
#line 333 "Utility/Device.vala"
					_tmp15_ = rex;
#line 333 "Utility/Device.vala"
					_tmp16_ = line;
#line 333 "Utility/Device.vala"
					_tmp18_ = g_regex_match (_tmp15_, _tmp16_, 0, &_tmp17_);
#line 333 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 333 "Utility/Device.vala"
					match = _tmp17_;
#line 333 "Utility/Device.vala"
					if (_tmp18_) {
#line 1726 "Device.c"
						gchar* child_name = NULL;
						GMatchInfo* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* parent_kname = NULL;
						GMatchInfo* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						Device* parent = NULL;
						Device* child = NULL;
						gboolean _tmp51_ = FALSE;
						Device* _tmp52_;
#line 335 "Utility/Device.vala"
						_tmp19_ = match;
#line 335 "Utility/Device.vala"
						_tmp20_ = g_match_info_fetch (_tmp19_, 1);
#line 335 "Utility/Device.vala"
						_tmp21_ = _tmp20_;
#line 335 "Utility/Device.vala"
						_tmp22_ = string_strip (_tmp21_);
#line 335 "Utility/Device.vala"
						_tmp23_ = _tmp22_;
#line 335 "Utility/Device.vala"
						_g_free0 (_tmp21_);
#line 335 "Utility/Device.vala"
						child_name = _tmp23_;
#line 336 "Utility/Device.vala"
						_tmp24_ = match;
#line 336 "Utility/Device.vala"
						_tmp25_ = g_match_info_fetch (_tmp24_, 2);
#line 336 "Utility/Device.vala"
						_tmp26_ = _tmp25_;
#line 336 "Utility/Device.vala"
						_tmp27_ = string_strip (_tmp26_);
#line 336 "Utility/Device.vala"
						_tmp28_ = _tmp27_;
#line 336 "Utility/Device.vala"
						_g_free0 (_tmp26_);
#line 336 "Utility/Device.vala"
						parent_kname = _tmp28_;
#line 338 "Utility/Device.vala"
						parent = NULL;
#line 1773 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							GeeArrayList* _tmp29_;
							gint _dev_size = 0;
							GeeArrayList* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _dev_index = 0;
#line 339 "Utility/Device.vala"
							_tmp29_ = _g_object_ref0 (list);
#line 339 "Utility/Device.vala"
							_dev_list = _tmp29_;
#line 339 "Utility/Device.vala"
							_tmp30_ = _dev_list;
#line 339 "Utility/Device.vala"
							_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 339 "Utility/Device.vala"
							_tmp32_ = _tmp31_;
#line 339 "Utility/Device.vala"
							_dev_size = _tmp32_;
#line 339 "Utility/Device.vala"
							_dev_index = -1;
#line 339 "Utility/Device.vala"
							while (TRUE) {
#line 1798 "Device.c"
								Device* dev = NULL;
								GeeArrayList* _tmp33_;
								gpointer _tmp34_;
								Device* _tmp35_;
								const gchar* _tmp36_;
								const gchar* _tmp37_;
#line 339 "Utility/Device.vala"
								_dev_index = _dev_index + 1;
#line 339 "Utility/Device.vala"
								if (!(_dev_index < _dev_size)) {
#line 339 "Utility/Device.vala"
									break;
#line 1811 "Device.c"
								}
#line 339 "Utility/Device.vala"
								_tmp33_ = _dev_list;
#line 339 "Utility/Device.vala"
								_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _dev_index);
#line 339 "Utility/Device.vala"
								dev = (Device*) _tmp34_;
#line 340 "Utility/Device.vala"
								_tmp35_ = dev;
#line 340 "Utility/Device.vala"
								_tmp36_ = _tmp35_->kname;
#line 340 "Utility/Device.vala"
								_tmp37_ = parent_kname;
#line 340 "Utility/Device.vala"
								if (g_strcmp0 (_tmp36_, _tmp37_) == 0) {
#line 1827 "Device.c"
									Device* _tmp38_;
									Device* _tmp39_;
#line 341 "Utility/Device.vala"
									_tmp38_ = dev;
#line 341 "Utility/Device.vala"
									_tmp39_ = _g_object_ref0 (_tmp38_);
#line 341 "Utility/Device.vala"
									_g_object_unref0 (parent);
#line 341 "Utility/Device.vala"
									parent = _tmp39_;
#line 342 "Utility/Device.vala"
									_g_object_unref0 (dev);
#line 342 "Utility/Device.vala"
									break;
#line 1842 "Device.c"
								}
#line 339 "Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1846 "Device.c"
							}
#line 339 "Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 1850 "Device.c"
						}
#line 346 "Utility/Device.vala"
						child = NULL;
#line 1854 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							GeeArrayList* _tmp40_;
							gint _dev_size = 0;
							GeeArrayList* _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
							gint _dev_index = 0;
#line 347 "Utility/Device.vala"
							_tmp40_ = _g_object_ref0 (list);
#line 347 "Utility/Device.vala"
							_dev_list = _tmp40_;
#line 347 "Utility/Device.vala"
							_tmp41_ = _dev_list;
#line 347 "Utility/Device.vala"
							_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 347 "Utility/Device.vala"
							_tmp43_ = _tmp42_;
#line 347 "Utility/Device.vala"
							_dev_size = _tmp43_;
#line 347 "Utility/Device.vala"
							_dev_index = -1;
#line 347 "Utility/Device.vala"
							while (TRUE) {
#line 1879 "Device.c"
								Device* dev = NULL;
								GeeArrayList* _tmp44_;
								gpointer _tmp45_;
								Device* _tmp46_;
								const gchar* _tmp47_;
								const gchar* _tmp48_;
#line 347 "Utility/Device.vala"
								_dev_index = _dev_index + 1;
#line 347 "Utility/Device.vala"
								if (!(_dev_index < _dev_size)) {
#line 347 "Utility/Device.vala"
									break;
#line 1892 "Device.c"
								}
#line 347 "Utility/Device.vala"
								_tmp44_ = _dev_list;
#line 347 "Utility/Device.vala"
								_tmp45_ = gee_abstract_list_get ((GeeAbstractList*) _tmp44_, _dev_index);
#line 347 "Utility/Device.vala"
								dev = (Device*) _tmp45_;
#line 348 "Utility/Device.vala"
								_tmp46_ = dev;
#line 348 "Utility/Device.vala"
								_tmp47_ = _tmp46_->mapped_name;
#line 348 "Utility/Device.vala"
								_tmp48_ = child_name;
#line 348 "Utility/Device.vala"
								if (g_strcmp0 (_tmp47_, _tmp48_) == 0) {
#line 1908 "Device.c"
									Device* _tmp49_;
									Device* _tmp50_;
#line 349 "Utility/Device.vala"
									_tmp49_ = dev;
#line 349 "Utility/Device.vala"
									_tmp50_ = _g_object_ref0 (_tmp49_);
#line 349 "Utility/Device.vala"
									_g_object_unref0 (child);
#line 349 "Utility/Device.vala"
									child = _tmp50_;
#line 350 "Utility/Device.vala"
									_g_object_unref0 (dev);
#line 350 "Utility/Device.vala"
									break;
#line 1923 "Device.c"
								}
#line 347 "Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1927 "Device.c"
							}
#line 347 "Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 1931 "Device.c"
						}
#line 354 "Utility/Device.vala"
						_tmp52_ = parent;
#line 354 "Utility/Device.vala"
						if (_tmp52_ != NULL) {
#line 1937 "Device.c"
							Device* _tmp53_;
#line 354 "Utility/Device.vala"
							_tmp53_ = child;
#line 354 "Utility/Device.vala"
							_tmp51_ = _tmp53_ != NULL;
#line 1943 "Device.c"
						} else {
#line 354 "Utility/Device.vala"
							_tmp51_ = FALSE;
#line 1947 "Device.c"
						}
#line 354 "Utility/Device.vala"
						if (_tmp51_) {
#line 1951 "Device.c"
							Device* _tmp54_;
							Device* _tmp55_;
							const gchar* _tmp56_;
							gchar* _tmp57_;
#line 355 "Utility/Device.vala"
							_tmp54_ = child;
#line 355 "Utility/Device.vala"
							_tmp55_ = parent;
#line 355 "Utility/Device.vala"
							_tmp56_ = _tmp55_->kname;
#line 355 "Utility/Device.vala"
							_tmp57_ = g_strdup (_tmp56_);
#line 355 "Utility/Device.vala"
							_g_free0 (_tmp54_->pkname);
#line 355 "Utility/Device.vala"
							_tmp54_->pkname = _tmp57_;
#line 1968 "Device.c"
						}
#line 333 "Utility/Device.vala"
						_g_object_unref0 (child);
#line 333 "Utility/Device.vala"
						_g_object_unref0 (parent);
#line 333 "Utility/Device.vala"
						_g_free0 (parent_kname);
#line 333 "Utility/Device.vala"
						_g_free0 (child_name);
#line 1978 "Device.c"
					} else {
						const gchar* _tmp58_;
						gchar* _tmp59_;
						gchar* _tmp60_;
#line 361 "Utility/Device.vala"
						_tmp58_ = line;
#line 361 "Utility/Device.vala"
						_tmp59_ = g_strdup_printf ("no-match: %s", _tmp58_);
#line 361 "Utility/Device.vala"
						_tmp60_ = _tmp59_;
#line 361 "Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp60_);
#line 361 "Utility/Device.vala"
						_g_free0 (_tmp60_);
#line 1993 "Device.c"
					}
#line 329 "Utility/Device.vala"
					_g_regex_unref0 (_tmp12_);
#line 1997 "Device.c"
				}
				goto __finally42;
				__catch42_g_error:
				{
					GError* e = NULL;
					GError* _tmp61_;
					const gchar* _tmp62_;
#line 329 "Utility/Device.vala"
					e = _inner_error0_;
#line 329 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 365 "Utility/Device.vala"
					_tmp61_ = e;
#line 365 "Utility/Device.vala"
					_tmp62_ = _tmp61_->message;
#line 365 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp62_, FALSE, FALSE);
#line 329 "Utility/Device.vala"
					_g_error_free0 (e);
#line 2017 "Device.c"
				}
				__finally42:
#line 329 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 329 "Utility/Device.vala"
					_g_free0 (line);
#line 329 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 329 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 329 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 329 "Utility/Device.vala"
					_g_free0 (std_err);
#line 329 "Utility/Device.vala"
					_g_free0 (std_out);
#line 329 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 329 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 329 "Utility/Device.vala"
					return;
#line 2040 "Device.c"
				}
#line 326 "Utility/Device.vala"
				_g_free0 (line);
#line 2044 "Device.c"
			}
		}
#line 326 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2049 "Device.c"
	}
#line 312 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 312 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 312 "Utility/Device.vala"
	_g_free0 (std_err);
#line 312 "Utility/Device.vala"
	_g_free0 (std_out);
#line 2059 "Device.c"
}

static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
#line 722 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 723 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, (guint) 0);
#line 723 "glib-2.0.vapi"
	return result;
#line 2072 "Device.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2094 "Device.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2098 "Device.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2104 "Device.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2108 "Device.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2112 "Device.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 2120 "Device.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2148 "Device.c"
				goto __catch45_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 2157 "Device.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2171 "Device.c"
				goto __catch45_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 2182 "Device.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 2196 "Device.c"
	}
	goto __finally45;
	__catch45_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 2210 "Device.c"
	}
	__finally45:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 2221 "Device.c"
	}
}

GeeArrayList*
device_get_block_devices_using_lsblk (const gchar* dev_name)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gint _tmp3_;
	gint _tmp4_;
	const gchar* _tmp9_;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gint _tmp12_;
	gint index = 0;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	GeeArrayList* _tmp263_;
	GeeArrayList* _tmp264_;
	GError* _inner_error0_ = NULL;
#line 371 "Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 378 "Utility/Device.vala"
	device_test_lsblk_version ();
#line 380 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 380 "Utility/Device.vala"
	list = _tmp0_;
#line 389 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 2260 "Device.c"
		gchar* _tmp1_;
#line 390 "Utility/Device.vala"
		_tmp1_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,RM,MAJ:MIN");
#line 390 "Utility/Device.vala"
		_g_free0 (cmd);
#line 390 "Utility/Device.vala"
		cmd = _tmp1_;
#line 2268 "Device.c"
	} else {
		gchar* _tmp2_;
#line 393 "Utility/Device.vala"
		_tmp2_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,HOTPLUG,MAJ:MIN,PARTLABEL,PARTUUID,PKNAME,VENDOR,S" \
"ERIAL,REV");
#line 393 "Utility/Device.vala"
		_g_free0 (cmd);
#line 393 "Utility/Device.vala"
		cmd = _tmp2_;
#line 2277 "Device.c"
	}
#line 396 "Utility/Device.vala"
	_tmp3_ = strlen (dev_name);
#line 396 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 396 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 2285 "Device.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 397 "Utility/Device.vala"
		_tmp5_ = cmd;
#line 397 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf (" %s", dev_name);
#line 397 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 397 "Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 397 "Utility/Device.vala"
		_g_free0 (cmd);
#line 397 "Utility/Device.vala"
		cmd = _tmp8_;
#line 397 "Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 2304 "Device.c"
	}
#line 400 "Utility/Device.vala"
	_tmp9_ = cmd;
#line 400 "Utility/Device.vala"
	_tmp12_ = tee_jee_process_helper_exec_sync (_tmp9_, &_tmp10_, &_tmp11_);
#line 400 "Utility/Device.vala"
	_g_free0 (std_out);
#line 400 "Utility/Device.vala"
	std_out = _tmp10_;
#line 400 "Utility/Device.vala"
	_g_free0 (std_err);
#line 400 "Utility/Device.vala"
	std_err = _tmp11_;
#line 400 "Utility/Device.vala"
	ret_val = _tmp12_;
#line 421 "Utility/Device.vala"
	index = -1;
#line 423 "Utility/Device.vala"
	_tmp13_ = std_out;
#line 423 "Utility/Device.vala"
	_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "\n", 0);
#line 2326 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 423 "Utility/Device.vala"
		line_collection = _tmp15_;
#line 423 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp14_);
#line 423 "Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp14_); line_it = line_it + 1) {
#line 2338 "Device.c"
			gchar* _tmp16_;
			gchar* line = NULL;
#line 423 "Utility/Device.vala"
			_tmp16_ = g_strdup (line_collection[line_it]);
#line 423 "Utility/Device.vala"
			line = _tmp16_;
#line 2345 "Device.c"
			{
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gboolean _tmp22_;
#line 424 "Utility/Device.vala"
				_tmp17_ = line;
#line 424 "Utility/Device.vala"
				_tmp18_ = string_strip (_tmp17_);
#line 424 "Utility/Device.vala"
				_tmp19_ = _tmp18_;
#line 424 "Utility/Device.vala"
				_tmp20_ = strlen (_tmp19_);
#line 424 "Utility/Device.vala"
				_tmp21_ = _tmp20_;
#line 424 "Utility/Device.vala"
				_tmp22_ = _tmp21_ == 0;
#line 424 "Utility/Device.vala"
				_g_free0 (_tmp19_);
#line 424 "Utility/Device.vala"
				if (_tmp22_) {
#line 424 "Utility/Device.vala"
					_g_free0 (line);
#line 424 "Utility/Device.vala"
					continue;
#line 2373 "Device.c"
				}
				{
					GRegex* _tmp29_;
					const gchar* _tmp30_;
					GMatchInfo* _tmp31_ = NULL;
					gboolean _tmp32_;
#line 427 "Utility/Device.vala"
					if (device_lsblk_is_ancient) {
#line 2382 "Device.c"
						GRegex* _tmp23_ = NULL;
						GRegex* _tmp24_;
						GRegex* _tmp25_;
#line 428 "Utility/Device.vala"
						_tmp24_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" RM=\"([0-9]+)\" MAJ:MIN=\"([0-9:]+)\"", 0, 0, &_inner_error0_);
#line 428 "Utility/Device.vala"
						_tmp23_ = _tmp24_;
#line 428 "Utility/Device.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2392 "Device.c"
							goto __catch43_g_error;
						}
#line 428 "Utility/Device.vala"
						_tmp25_ = _tmp23_;
#line 428 "Utility/Device.vala"
						_tmp23_ = NULL;
#line 428 "Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 428 "Utility/Device.vala"
						rex = _tmp25_;
#line 427 "Utility/Device.vala"
						_g_regex_unref0 (_tmp23_);
#line 2405 "Device.c"
					} else {
						GRegex* _tmp26_ = NULL;
						GRegex* _tmp27_;
						GRegex* _tmp28_;
#line 431 "Utility/Device.vala"
						_tmp27_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" HOTPLUG=\"([0-9]+)\" MAJ:MIN=\"([0-9:]+)\" PARTLABEL=\"(.*)" \
"\" PARTUUID=\"(.*)\" PKNAME=\"(.*)\" VENDOR=\"(.*)\" SERIAL=\"(.*)\" R" \
"EV=\"(.*)\"", 0, 0, &_inner_error0_);
#line 431 "Utility/Device.vala"
						_tmp26_ = _tmp27_;
#line 431 "Utility/Device.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2416 "Device.c"
							goto __catch43_g_error;
						}
#line 431 "Utility/Device.vala"
						_tmp28_ = _tmp26_;
#line 431 "Utility/Device.vala"
						_tmp26_ = NULL;
#line 431 "Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 431 "Utility/Device.vala"
						rex = _tmp28_;
#line 427 "Utility/Device.vala"
						_g_regex_unref0 (_tmp26_);
#line 2429 "Device.c"
					}
#line 434 "Utility/Device.vala"
					_tmp29_ = rex;
#line 434 "Utility/Device.vala"
					_tmp30_ = line;
#line 434 "Utility/Device.vala"
					_tmp32_ = g_regex_match (_tmp29_, _tmp30_, 0, &_tmp31_);
#line 434 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 434 "Utility/Device.vala"
					match = _tmp31_;
#line 434 "Utility/Device.vala"
					if (_tmp32_) {
#line 2443 "Device.c"
						Device* pi = NULL;
						Device* _tmp33_;
						gint pos = 0;
						Device* _tmp34_;
						GMatchInfo* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
						gchar* _tmp38_;
						Device* _tmp39_;
						GMatchInfo* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
						Device* _tmp44_;
						GMatchInfo* _tmp45_;
						gchar* _tmp46_;
						Device* _tmp47_;
						GMatchInfo* _tmp48_;
						gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						Device* _tmp52_;
						GMatchInfo* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						gchar* _tmp56_;
						gchar* _tmp57_;
						gchar* _tmp58_;
						Device* _tmp59_;
						GMatchInfo* _tmp60_;
						gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						gchar* _tmp64_;
						gchar* _tmp65_;
						const gchar* _tmp66_ = NULL;
						Device* _tmp67_;
						const gchar* _tmp68_;
						Device* _tmp71_;
						gchar* _tmp72_;
						const gchar* _tmp73_ = NULL;
						Device* _tmp74_;
						const gchar* _tmp75_;
						Device* _tmp78_;
						gchar* _tmp79_;
						Device* _tmp80_;
						GMatchInfo* _tmp81_;
						gchar* _tmp82_;
						gchar* _tmp83_;
						gchar* _tmp84_;
						gchar* _tmp85_;
						gchar* mp = NULL;
						GMatchInfo* _tmp86_;
						gchar* _tmp87_;
						gchar* _tmp88_;
						gchar* _tmp89_;
						gchar* _tmp90_;
						const gchar* _tmp91_;
						gint _tmp92_;
						gint _tmp93_;
						Device* _tmp100_;
						GMatchInfo* _tmp101_;
						gchar* _tmp102_;
						gchar* _tmp103_;
						gchar* _tmp104_;
						Device* _tmp105_;
						GMatchInfo* _tmp106_;
						gchar* _tmp107_;
						gchar* _tmp108_;
						gchar* _tmp109_;
						gchar* _tmp110_;
						Device* _tmp111_;
						GMatchInfo* _tmp112_;
						gchar* _tmp113_;
						gchar* _tmp114_;
						gchar* _tmp115_;
						gchar* _tmp116_;
						gchar* txt = NULL;
						GMatchInfo* _tmp117_;
						gchar* _tmp118_;
						gchar* _tmp119_;
						gchar* _tmp120_;
						gchar* _tmp121_;
						const gchar* _tmp122_;
						Device* _tmp163_;
						Device* _tmp164_;
						Device* _tmp165_;
						const gchar* _tmp166_;
						gchar* _tmp167_;
						Device* _tmp168_;
						const gchar* _tmp169_;
						gint _tmp170_;
						gint _tmp171_;
						Device* _tmp176_;
						const gchar* _tmp177_;
						gint _tmp178_;
						gint _tmp179_;
						Device* _tmp184_;
						const gchar* _tmp185_;
						gint _tmp186_;
						gint _tmp187_;
						Device* _tmp192_;
						const gchar* _tmp193_;
						gint _tmp194_;
						gint _tmp195_;
						GeeArrayList* _tmp200_;
						Device* _tmp201_;
#line 436 "Utility/Device.vala"
						_tmp33_ = device_new ();
#line 436 "Utility/Device.vala"
						pi = _tmp33_;
#line 438 "Utility/Device.vala"
						pos = 0;
#line 440 "Utility/Device.vala"
						_tmp34_ = pi;
#line 440 "Utility/Device.vala"
						_tmp35_ = match;
#line 440 "Utility/Device.vala"
						pos = pos + 1;
#line 440 "Utility/Device.vala"
						_tmp36_ = g_match_info_fetch (_tmp35_, pos);
#line 440 "Utility/Device.vala"
						_tmp37_ = _tmp36_;
#line 440 "Utility/Device.vala"
						_tmp38_ = string_strip (_tmp37_);
#line 440 "Utility/Device.vala"
						_g_free0 (_tmp34_->name);
#line 440 "Utility/Device.vala"
						_tmp34_->name = _tmp38_;
#line 440 "Utility/Device.vala"
						_g_free0 (_tmp37_);
#line 441 "Utility/Device.vala"
						_tmp39_ = pi;
#line 441 "Utility/Device.vala"
						_tmp40_ = match;
#line 441 "Utility/Device.vala"
						pos = pos + 1;
#line 441 "Utility/Device.vala"
						_tmp41_ = g_match_info_fetch (_tmp40_, pos);
#line 441 "Utility/Device.vala"
						_tmp42_ = _tmp41_;
#line 441 "Utility/Device.vala"
						_tmp43_ = string_strip (_tmp42_);
#line 441 "Utility/Device.vala"
						_g_free0 (_tmp39_->kname);
#line 441 "Utility/Device.vala"
						_tmp39_->kname = _tmp43_;
#line 441 "Utility/Device.vala"
						_g_free0 (_tmp42_);
#line 443 "Utility/Device.vala"
						_tmp44_ = pi;
#line 443 "Utility/Device.vala"
						_tmp45_ = match;
#line 443 "Utility/Device.vala"
						pos = pos + 1;
#line 443 "Utility/Device.vala"
						_tmp46_ = g_match_info_fetch (_tmp45_, pos);
#line 443 "Utility/Device.vala"
						_g_free0 (_tmp44_->label);
#line 443 "Utility/Device.vala"
						_tmp44_->label = _tmp46_;
#line 444 "Utility/Device.vala"
						_tmp47_ = pi;
#line 444 "Utility/Device.vala"
						_tmp48_ = match;
#line 444 "Utility/Device.vala"
						pos = pos + 1;
#line 444 "Utility/Device.vala"
						_tmp49_ = g_match_info_fetch (_tmp48_, pos);
#line 444 "Utility/Device.vala"
						_tmp50_ = _tmp49_;
#line 444 "Utility/Device.vala"
						_tmp51_ = string_strip (_tmp50_);
#line 444 "Utility/Device.vala"
						_g_free0 (_tmp47_->uuid);
#line 444 "Utility/Device.vala"
						_tmp47_->uuid = _tmp51_;
#line 444 "Utility/Device.vala"
						_g_free0 (_tmp50_);
#line 446 "Utility/Device.vala"
						_tmp52_ = pi;
#line 446 "Utility/Device.vala"
						_tmp53_ = match;
#line 446 "Utility/Device.vala"
						pos = pos + 1;
#line 446 "Utility/Device.vala"
						_tmp54_ = g_match_info_fetch (_tmp53_, pos);
#line 446 "Utility/Device.vala"
						_tmp55_ = _tmp54_;
#line 446 "Utility/Device.vala"
						_tmp56_ = string_strip (_tmp55_);
#line 446 "Utility/Device.vala"
						_tmp57_ = _tmp56_;
#line 446 "Utility/Device.vala"
						_tmp58_ = g_utf8_strdown (_tmp57_, (gssize) -1);
#line 446 "Utility/Device.vala"
						_g_free0 (_tmp52_->type);
#line 446 "Utility/Device.vala"
						_tmp52_->type = _tmp58_;
#line 446 "Utility/Device.vala"
						_g_free0 (_tmp57_);
#line 446 "Utility/Device.vala"
						_g_free0 (_tmp55_);
#line 448 "Utility/Device.vala"
						_tmp59_ = pi;
#line 448 "Utility/Device.vala"
						_tmp60_ = match;
#line 448 "Utility/Device.vala"
						pos = pos + 1;
#line 448 "Utility/Device.vala"
						_tmp61_ = g_match_info_fetch (_tmp60_, pos);
#line 448 "Utility/Device.vala"
						_tmp62_ = _tmp61_;
#line 448 "Utility/Device.vala"
						_tmp63_ = string_strip (_tmp62_);
#line 448 "Utility/Device.vala"
						_tmp64_ = _tmp63_;
#line 448 "Utility/Device.vala"
						_tmp65_ = g_utf8_strdown (_tmp64_, (gssize) -1);
#line 448 "Utility/Device.vala"
						_g_free0 (_tmp59_->fstype);
#line 448 "Utility/Device.vala"
						_tmp59_->fstype = _tmp65_;
#line 448 "Utility/Device.vala"
						_g_free0 (_tmp64_);
#line 448 "Utility/Device.vala"
						_g_free0 (_tmp62_);
#line 449 "Utility/Device.vala"
						_tmp67_ = pi;
#line 449 "Utility/Device.vala"
						_tmp68_ = _tmp67_->fstype;
#line 449 "Utility/Device.vala"
						if (g_strcmp0 (_tmp68_, "crypto_luks") == 0) {
#line 449 "Utility/Device.vala"
							_tmp66_ = "luks";
#line 2679 "Device.c"
						} else {
							Device* _tmp69_;
							const gchar* _tmp70_;
#line 449 "Utility/Device.vala"
							_tmp69_ = pi;
#line 449 "Utility/Device.vala"
							_tmp70_ = _tmp69_->fstype;
#line 449 "Utility/Device.vala"
							_tmp66_ = _tmp70_;
#line 2689 "Device.c"
						}
#line 449 "Utility/Device.vala"
						_tmp71_ = pi;
#line 449 "Utility/Device.vala"
						_tmp72_ = g_strdup (_tmp66_);
#line 449 "Utility/Device.vala"
						_g_free0 (_tmp71_->fstype);
#line 449 "Utility/Device.vala"
						_tmp71_->fstype = _tmp72_;
#line 450 "Utility/Device.vala"
						_tmp74_ = pi;
#line 450 "Utility/Device.vala"
						_tmp75_ = _tmp74_->fstype;
#line 450 "Utility/Device.vala"
						if (g_strcmp0 (_tmp75_, "lvm2_member") == 0) {
#line 450 "Utility/Device.vala"
							_tmp73_ = "lvm2";
#line 2707 "Device.c"
						} else {
							Device* _tmp76_;
							const gchar* _tmp77_;
#line 450 "Utility/Device.vala"
							_tmp76_ = pi;
#line 450 "Utility/Device.vala"
							_tmp77_ = _tmp76_->fstype;
#line 450 "Utility/Device.vala"
							_tmp73_ = _tmp77_;
#line 2717 "Device.c"
						}
#line 450 "Utility/Device.vala"
						_tmp78_ = pi;
#line 450 "Utility/Device.vala"
						_tmp79_ = g_strdup (_tmp73_);
#line 450 "Utility/Device.vala"
						_g_free0 (_tmp78_->fstype);
#line 450 "Utility/Device.vala"
						_tmp78_->fstype = _tmp79_;
#line 452 "Utility/Device.vala"
						_tmp80_ = pi;
#line 452 "Utility/Device.vala"
						_tmp81_ = match;
#line 452 "Utility/Device.vala"
						pos = pos + 1;
#line 452 "Utility/Device.vala"
						_tmp82_ = g_match_info_fetch (_tmp81_, pos);
#line 452 "Utility/Device.vala"
						_tmp83_ = _tmp82_;
#line 452 "Utility/Device.vala"
						_tmp84_ = string_strip (_tmp83_);
#line 452 "Utility/Device.vala"
						_tmp85_ = _tmp84_;
#line 452 "Utility/Device.vala"
						_tmp80_->size_bytes = (guint64) int64_parse (_tmp85_);
#line 452 "Utility/Device.vala"
						_g_free0 (_tmp85_);
#line 452 "Utility/Device.vala"
						_g_free0 (_tmp83_);
#line 454 "Utility/Device.vala"
						_tmp86_ = match;
#line 454 "Utility/Device.vala"
						pos = pos + 1;
#line 454 "Utility/Device.vala"
						_tmp87_ = g_match_info_fetch (_tmp86_, pos);
#line 454 "Utility/Device.vala"
						_tmp88_ = _tmp87_;
#line 454 "Utility/Device.vala"
						_tmp89_ = string_strip (_tmp88_);
#line 454 "Utility/Device.vala"
						_tmp90_ = _tmp89_;
#line 454 "Utility/Device.vala"
						_g_free0 (_tmp88_);
#line 454 "Utility/Device.vala"
						mp = _tmp90_;
#line 455 "Utility/Device.vala"
						_tmp91_ = mp;
#line 455 "Utility/Device.vala"
						_tmp92_ = strlen (_tmp91_);
#line 455 "Utility/Device.vala"
						_tmp93_ = _tmp92_;
#line 455 "Utility/Device.vala"
						if (_tmp93_ > 0) {
#line 2771 "Device.c"
							Device* _tmp94_;
							GeeArrayList* _tmp95_;
							Device* _tmp96_;
							const gchar* _tmp97_;
							MountEntry* _tmp98_;
							MountEntry* _tmp99_;
#line 456 "Utility/Device.vala"
							_tmp94_ = pi;
#line 456 "Utility/Device.vala"
							_tmp95_ = _tmp94_->mount_points;
#line 456 "Utility/Device.vala"
							_tmp96_ = pi;
#line 456 "Utility/Device.vala"
							_tmp97_ = mp;
#line 456 "Utility/Device.vala"
							_tmp98_ = mount_entry_new (_tmp96_, _tmp97_, "");
#line 456 "Utility/Device.vala"
							_tmp99_ = _tmp98_;
#line 456 "Utility/Device.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp95_, _tmp99_);
#line 456 "Utility/Device.vala"
							_g_object_unref0 (_tmp99_);
#line 2794 "Device.c"
						}
#line 459 "Utility/Device.vala"
						_tmp100_ = pi;
#line 459 "Utility/Device.vala"
						_tmp101_ = match;
#line 459 "Utility/Device.vala"
						pos = pos + 1;
#line 459 "Utility/Device.vala"
						_tmp102_ = g_match_info_fetch (_tmp101_, pos);
#line 459 "Utility/Device.vala"
						_tmp103_ = _tmp102_;
#line 459 "Utility/Device.vala"
						_tmp104_ = string_strip (_tmp103_);
#line 459 "Utility/Device.vala"
						_g_free0 (_tmp100_->model);
#line 459 "Utility/Device.vala"
						_tmp100_->model = _tmp104_;
#line 459 "Utility/Device.vala"
						_g_free0 (_tmp103_);
#line 461 "Utility/Device.vala"
						_tmp105_ = pi;
#line 461 "Utility/Device.vala"
						_tmp106_ = match;
#line 461 "Utility/Device.vala"
						pos = pos + 1;
#line 461 "Utility/Device.vala"
						_tmp107_ = g_match_info_fetch (_tmp106_, pos);
#line 461 "Utility/Device.vala"
						_tmp108_ = _tmp107_;
#line 461 "Utility/Device.vala"
						_tmp109_ = string_strip (_tmp108_);
#line 461 "Utility/Device.vala"
						_tmp110_ = _tmp109_;
#line 461 "Utility/Device.vala"
						_tmp105_->read_only = g_strcmp0 (_tmp110_, "1") == 0;
#line 461 "Utility/Device.vala"
						_g_free0 (_tmp110_);
#line 461 "Utility/Device.vala"
						_g_free0 (_tmp108_);
#line 463 "Utility/Device.vala"
						_tmp111_ = pi;
#line 463 "Utility/Device.vala"
						_tmp112_ = match;
#line 463 "Utility/Device.vala"
						pos = pos + 1;
#line 463 "Utility/Device.vala"
						_tmp113_ = g_match_info_fetch (_tmp112_, pos);
#line 463 "Utility/Device.vala"
						_tmp114_ = _tmp113_;
#line 463 "Utility/Device.vala"
						_tmp115_ = string_strip (_tmp114_);
#line 463 "Utility/Device.vala"
						_tmp116_ = _tmp115_;
#line 463 "Utility/Device.vala"
						_tmp111_->removable = g_strcmp0 (_tmp116_, "1") == 0;
#line 463 "Utility/Device.vala"
						_g_free0 (_tmp116_);
#line 463 "Utility/Device.vala"
						_g_free0 (_tmp114_);
#line 465 "Utility/Device.vala"
						_tmp117_ = match;
#line 465 "Utility/Device.vala"
						pos = pos + 1;
#line 465 "Utility/Device.vala"
						_tmp118_ = g_match_info_fetch (_tmp117_, pos);
#line 465 "Utility/Device.vala"
						_tmp119_ = _tmp118_;
#line 465 "Utility/Device.vala"
						_tmp120_ = string_strip (_tmp119_);
#line 465 "Utility/Device.vala"
						_tmp121_ = _tmp120_;
#line 465 "Utility/Device.vala"
						_g_free0 (_tmp119_);
#line 465 "Utility/Device.vala"
						txt = _tmp121_;
#line 466 "Utility/Device.vala"
						_tmp122_ = txt;
#line 466 "Utility/Device.vala"
						if (string_contains (_tmp122_, ":")) {
#line 2874 "Device.c"
							Device* _tmp123_;
							const gchar* _tmp124_;
							gchar** _tmp125_;
							gchar** _tmp126_;
							gchar** _tmp127_;
							gint _tmp127__length1;
							const gchar* _tmp128_;
							Device* _tmp129_;
							const gchar* _tmp130_;
							gchar** _tmp131_;
							gchar** _tmp132_;
							gchar** _tmp133_;
							gint _tmp133__length1;
							const gchar* _tmp134_;
#line 467 "Utility/Device.vala"
							_tmp123_ = pi;
#line 467 "Utility/Device.vala"
							_tmp124_ = txt;
#line 467 "Utility/Device.vala"
							_tmp126_ = _tmp125_ = g_strsplit (_tmp124_, ":", 0);
#line 467 "Utility/Device.vala"
							_tmp127_ = _tmp126_;
#line 467 "Utility/Device.vala"
							_tmp127__length1 = _vala_array_length (_tmp125_);
#line 467 "Utility/Device.vala"
							_tmp128_ = _tmp127_[0];
#line 467 "Utility/Device.vala"
							_tmp123_->major = atoi (_tmp128_);
#line 467 "Utility/Device.vala"
							_tmp127_ = (_vala_array_free (_tmp127_, _tmp127__length1, (GDestroyNotify) g_free), NULL);
#line 468 "Utility/Device.vala"
							_tmp129_ = pi;
#line 468 "Utility/Device.vala"
							_tmp130_ = txt;
#line 468 "Utility/Device.vala"
							_tmp132_ = _tmp131_ = g_strsplit (_tmp130_, ":", 0);
#line 468 "Utility/Device.vala"
							_tmp133_ = _tmp132_;
#line 468 "Utility/Device.vala"
							_tmp133__length1 = _vala_array_length (_tmp131_);
#line 468 "Utility/Device.vala"
							_tmp134_ = _tmp133_[1];
#line 468 "Utility/Device.vala"
							_tmp129_->minor = atoi (_tmp134_);
#line 468 "Utility/Device.vala"
							_tmp133_ = (_vala_array_free (_tmp133_, _tmp133__length1, (GDestroyNotify) g_free), NULL);
#line 2921 "Device.c"
						}
#line 471 "Utility/Device.vala"
						if (!device_lsblk_is_ancient) {
#line 2925 "Device.c"
							Device* _tmp135_;
							GMatchInfo* _tmp136_;
							gchar* _tmp137_;
							Device* _tmp138_;
							GMatchInfo* _tmp139_;
							gchar* _tmp140_;
							gchar* _tmp141_;
							gchar* _tmp142_;
							Device* _tmp143_;
							GMatchInfo* _tmp144_;
							gchar* _tmp145_;
							gchar* _tmp146_;
							gchar* _tmp147_;
							Device* _tmp148_;
							GMatchInfo* _tmp149_;
							gchar* _tmp150_;
							gchar* _tmp151_;
							gchar* _tmp152_;
							Device* _tmp153_;
							GMatchInfo* _tmp154_;
							gchar* _tmp155_;
							gchar* _tmp156_;
							gchar* _tmp157_;
							Device* _tmp158_;
							GMatchInfo* _tmp159_;
							gchar* _tmp160_;
							gchar* _tmp161_;
							gchar* _tmp162_;
#line 473 "Utility/Device.vala"
							_tmp135_ = pi;
#line 473 "Utility/Device.vala"
							_tmp136_ = match;
#line 473 "Utility/Device.vala"
							pos = pos + 1;
#line 473 "Utility/Device.vala"
							_tmp137_ = g_match_info_fetch (_tmp136_, pos);
#line 473 "Utility/Device.vala"
							_g_free0 (_tmp135_->partlabel);
#line 473 "Utility/Device.vala"
							_tmp135_->partlabel = _tmp137_;
#line 474 "Utility/Device.vala"
							_tmp138_ = pi;
#line 474 "Utility/Device.vala"
							_tmp139_ = match;
#line 474 "Utility/Device.vala"
							pos = pos + 1;
#line 474 "Utility/Device.vala"
							_tmp140_ = g_match_info_fetch (_tmp139_, pos);
#line 474 "Utility/Device.vala"
							_tmp141_ = _tmp140_;
#line 474 "Utility/Device.vala"
							_tmp142_ = string_strip (_tmp141_);
#line 474 "Utility/Device.vala"
							_g_free0 (_tmp138_->partuuid);
#line 474 "Utility/Device.vala"
							_tmp138_->partuuid = _tmp142_;
#line 474 "Utility/Device.vala"
							_g_free0 (_tmp141_);
#line 476 "Utility/Device.vala"
							_tmp143_ = pi;
#line 476 "Utility/Device.vala"
							_tmp144_ = match;
#line 476 "Utility/Device.vala"
							pos = pos + 1;
#line 476 "Utility/Device.vala"
							_tmp145_ = g_match_info_fetch (_tmp144_, pos);
#line 476 "Utility/Device.vala"
							_tmp146_ = _tmp145_;
#line 476 "Utility/Device.vala"
							_tmp147_ = string_strip (_tmp146_);
#line 476 "Utility/Device.vala"
							_g_free0 (_tmp143_->pkname);
#line 476 "Utility/Device.vala"
							_tmp143_->pkname = _tmp147_;
#line 476 "Utility/Device.vala"
							_g_free0 (_tmp146_);
#line 477 "Utility/Device.vala"
							_tmp148_ = pi;
#line 477 "Utility/Device.vala"
							_tmp149_ = match;
#line 477 "Utility/Device.vala"
							pos = pos + 1;
#line 477 "Utility/Device.vala"
							_tmp150_ = g_match_info_fetch (_tmp149_, pos);
#line 477 "Utility/Device.vala"
							_tmp151_ = _tmp150_;
#line 477 "Utility/Device.vala"
							_tmp152_ = string_strip (_tmp151_);
#line 477 "Utility/Device.vala"
							_g_free0 (_tmp148_->vendor);
#line 477 "Utility/Device.vala"
							_tmp148_->vendor = _tmp152_;
#line 477 "Utility/Device.vala"
							_g_free0 (_tmp151_);
#line 478 "Utility/Device.vala"
							_tmp153_ = pi;
#line 478 "Utility/Device.vala"
							_tmp154_ = match;
#line 478 "Utility/Device.vala"
							pos = pos + 1;
#line 478 "Utility/Device.vala"
							_tmp155_ = g_match_info_fetch (_tmp154_, pos);
#line 478 "Utility/Device.vala"
							_tmp156_ = _tmp155_;
#line 478 "Utility/Device.vala"
							_tmp157_ = string_strip (_tmp156_);
#line 478 "Utility/Device.vala"
							_g_free0 (_tmp153_->serial);
#line 478 "Utility/Device.vala"
							_tmp153_->serial = _tmp157_;
#line 478 "Utility/Device.vala"
							_g_free0 (_tmp156_);
#line 479 "Utility/Device.vala"
							_tmp158_ = pi;
#line 479 "Utility/Device.vala"
							_tmp159_ = match;
#line 479 "Utility/Device.vala"
							pos = pos + 1;
#line 479 "Utility/Device.vala"
							_tmp160_ = g_match_info_fetch (_tmp159_, pos);
#line 479 "Utility/Device.vala"
							_tmp161_ = _tmp160_;
#line 479 "Utility/Device.vala"
							_tmp162_ = string_strip (_tmp161_);
#line 479 "Utility/Device.vala"
							_g_free0 (_tmp158_->revision);
#line 479 "Utility/Device.vala"
							_tmp158_->revision = _tmp162_;
#line 479 "Utility/Device.vala"
							_g_free0 (_tmp161_);
#line 3056 "Device.c"
						}
#line 482 "Utility/Device.vala"
						_tmp163_ = pi;
#line 482 "Utility/Device.vala"
						index = index + 1;
#line 482 "Utility/Device.vala"
						_tmp163_->order = index;
#line 483 "Utility/Device.vala"
						_tmp164_ = pi;
#line 483 "Utility/Device.vala"
						_tmp165_ = pi;
#line 483 "Utility/Device.vala"
						_tmp166_ = _tmp165_->kname;
#line 483 "Utility/Device.vala"
						_tmp167_ = g_strdup_printf ("/dev/%s", _tmp166_);
#line 483 "Utility/Device.vala"
						_g_free0 (_tmp164_->device);
#line 483 "Utility/Device.vala"
						_tmp164_->device = _tmp167_;
#line 485 "Utility/Device.vala"
						_tmp168_ = pi;
#line 485 "Utility/Device.vala"
						_tmp169_ = _tmp168_->uuid;
#line 485 "Utility/Device.vala"
						_tmp170_ = strlen (_tmp169_);
#line 485 "Utility/Device.vala"
						_tmp171_ = _tmp170_;
#line 485 "Utility/Device.vala"
						if (_tmp171_ > 0) {
#line 3086 "Device.c"
							Device* _tmp172_;
							Device* _tmp173_;
							const gchar* _tmp174_;
							gchar* _tmp175_;
#line 486 "Utility/Device.vala"
							_tmp172_ = pi;
#line 486 "Utility/Device.vala"
							_tmp173_ = pi;
#line 486 "Utility/Device.vala"
							_tmp174_ = _tmp173_->uuid;
#line 486 "Utility/Device.vala"
							_tmp175_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp174_);
#line 486 "Utility/Device.vala"
							_g_free0 (_tmp172_->device_by_uuid);
#line 486 "Utility/Device.vala"
							_tmp172_->device_by_uuid = _tmp175_;
#line 3103 "Device.c"
						}
#line 489 "Utility/Device.vala"
						_tmp176_ = pi;
#line 489 "Utility/Device.vala"
						_tmp177_ = _tmp176_->label;
#line 489 "Utility/Device.vala"
						_tmp178_ = strlen (_tmp177_);
#line 489 "Utility/Device.vala"
						_tmp179_ = _tmp178_;
#line 489 "Utility/Device.vala"
						if (_tmp179_ > 0) {
#line 3115 "Device.c"
							Device* _tmp180_;
							Device* _tmp181_;
							const gchar* _tmp182_;
							gchar* _tmp183_;
#line 490 "Utility/Device.vala"
							_tmp180_ = pi;
#line 490 "Utility/Device.vala"
							_tmp181_ = pi;
#line 490 "Utility/Device.vala"
							_tmp182_ = _tmp181_->label;
#line 490 "Utility/Device.vala"
							_tmp183_ = g_strdup_printf ("/dev/disk/by-label/%s", _tmp182_);
#line 490 "Utility/Device.vala"
							_g_free0 (_tmp180_->device_by_label);
#line 490 "Utility/Device.vala"
							_tmp180_->device_by_label = _tmp183_;
#line 3132 "Device.c"
						}
#line 493 "Utility/Device.vala"
						_tmp184_ = pi;
#line 493 "Utility/Device.vala"
						_tmp185_ = _tmp184_->partuuid;
#line 493 "Utility/Device.vala"
						_tmp186_ = strlen (_tmp185_);
#line 493 "Utility/Device.vala"
						_tmp187_ = _tmp186_;
#line 493 "Utility/Device.vala"
						if (_tmp187_ > 0) {
#line 3144 "Device.c"
							Device* _tmp188_;
							Device* _tmp189_;
							const gchar* _tmp190_;
							gchar* _tmp191_;
#line 494 "Utility/Device.vala"
							_tmp188_ = pi;
#line 494 "Utility/Device.vala"
							_tmp189_ = pi;
#line 494 "Utility/Device.vala"
							_tmp190_ = _tmp189_->partuuid;
#line 494 "Utility/Device.vala"
							_tmp191_ = g_strdup_printf ("/dev/disk/by-partuuid/%s", _tmp190_);
#line 494 "Utility/Device.vala"
							_g_free0 (_tmp188_->device_by_partuuid);
#line 494 "Utility/Device.vala"
							_tmp188_->device_by_partuuid = _tmp191_;
#line 3161 "Device.c"
						}
#line 497 "Utility/Device.vala"
						_tmp192_ = pi;
#line 497 "Utility/Device.vala"
						_tmp193_ = _tmp192_->partlabel;
#line 497 "Utility/Device.vala"
						_tmp194_ = strlen (_tmp193_);
#line 497 "Utility/Device.vala"
						_tmp195_ = _tmp194_;
#line 497 "Utility/Device.vala"
						if (_tmp195_ > 0) {
#line 3173 "Device.c"
							Device* _tmp196_;
							Device* _tmp197_;
							const gchar* _tmp198_;
							gchar* _tmp199_;
#line 498 "Utility/Device.vala"
							_tmp196_ = pi;
#line 498 "Utility/Device.vala"
							_tmp197_ = pi;
#line 498 "Utility/Device.vala"
							_tmp198_ = _tmp197_->partlabel;
#line 498 "Utility/Device.vala"
							_tmp199_ = g_strdup_printf ("/dev/disk/by-partlabel/%s", _tmp198_);
#line 498 "Utility/Device.vala"
							_g_free0 (_tmp196_->device_by_partlabel);
#line 498 "Utility/Device.vala"
							_tmp196_->device_by_partlabel = _tmp199_;
#line 3190 "Device.c"
						}
#line 506 "Utility/Device.vala"
						_tmp200_ = list;
#line 506 "Utility/Device.vala"
						_tmp201_ = pi;
#line 506 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp200_, _tmp201_);
#line 434 "Utility/Device.vala"
						_g_free0 (txt);
#line 434 "Utility/Device.vala"
						_g_free0 (mp);
#line 434 "Utility/Device.vala"
						_g_object_unref0 (pi);
#line 3204 "Device.c"
					} else {
						const gchar* _tmp202_;
						gchar* _tmp203_;
						gchar* _tmp204_;
#line 510 "Utility/Device.vala"
						_tmp202_ = line;
#line 510 "Utility/Device.vala"
						_tmp203_ = g_strdup_printf ("no-match: %s", _tmp202_);
#line 510 "Utility/Device.vala"
						_tmp204_ = _tmp203_;
#line 510 "Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp204_);
#line 510 "Utility/Device.vala"
						_g_free0 (_tmp204_);
#line 3219 "Device.c"
					}
				}
				goto __finally43;
				__catch43_g_error:
				{
					GError* e = NULL;
					GError* _tmp205_;
					const gchar* _tmp206_;
#line 426 "Utility/Device.vala"
					e = _inner_error0_;
#line 426 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 514 "Utility/Device.vala"
					_tmp205_ = e;
#line 514 "Utility/Device.vala"
					_tmp206_ = _tmp205_->message;
#line 514 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp206_, FALSE, FALSE);
#line 426 "Utility/Device.vala"
					_g_error_free0 (e);
#line 3240 "Device.c"
				}
				__finally43:
#line 426 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 426 "Utility/Device.vala"
					_g_free0 (line);
#line 426 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 426 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 426 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 426 "Utility/Device.vala"
					_g_free0 (cmd);
#line 426 "Utility/Device.vala"
					_g_free0 (std_err);
#line 426 "Utility/Device.vala"
					_g_free0 (std_out);
#line 426 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 426 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 426 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 426 "Utility/Device.vala"
					return NULL;
#line 3267 "Device.c"
				}
#line 423 "Utility/Device.vala"
				_g_free0 (line);
#line 3271 "Device.c"
			}
		}
#line 423 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3276 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp207_;
		GeeArrayList* _tmp208_;
		gint _dev_size = 0;
		GeeArrayList* _tmp209_;
		gint _tmp210_;
		gint _tmp211_;
		gint _dev_index = 0;
#line 525 "Utility/Device.vala"
		_tmp207_ = list;
#line 525 "Utility/Device.vala"
		_tmp208_ = _g_object_ref0 (_tmp207_);
#line 525 "Utility/Device.vala"
		_dev_list = _tmp208_;
#line 525 "Utility/Device.vala"
		_tmp209_ = _dev_list;
#line 525 "Utility/Device.vala"
		_tmp210_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp209_);
#line 525 "Utility/Device.vala"
		_tmp211_ = _tmp210_;
#line 525 "Utility/Device.vala"
		_dev_size = _tmp211_;
#line 525 "Utility/Device.vala"
		_dev_index = -1;
#line 525 "Utility/Device.vala"
		while (TRUE) {
#line 3305 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp212_;
			gpointer _tmp213_;
			gchar* dev_by_uuid = NULL;
			Device* _tmp214_;
			const gchar* _tmp215_;
			gchar* _tmp216_;
			const gchar* _tmp217_;
#line 525 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 525 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 525 "Utility/Device.vala"
				break;
#line 3320 "Device.c"
			}
#line 525 "Utility/Device.vala"
			_tmp212_ = _dev_list;
#line 525 "Utility/Device.vala"
			_tmp213_ = gee_abstract_list_get ((GeeAbstractList*) _tmp212_, _dev_index);
#line 525 "Utility/Device.vala"
			dev = (Device*) _tmp213_;
#line 526 "Utility/Device.vala"
			_tmp214_ = dev;
#line 526 "Utility/Device.vala"
			_tmp215_ = _tmp214_->uuid;
#line 526 "Utility/Device.vala"
			_tmp216_ = tee_jee_file_system_path_combine ("/dev/disk/by-uuid/", _tmp215_);
#line 526 "Utility/Device.vala"
			dev_by_uuid = _tmp216_;
#line 527 "Utility/Device.vala"
			_tmp217_ = dev_by_uuid;
#line 527 "Utility/Device.vala"
			if (tee_jee_file_system_file_exists (_tmp217_)) {
#line 3340 "Device.c"
				Device* _tmp218_;
				GeeArrayList* _tmp219_;
				const gchar* _tmp220_;
#line 528 "Utility/Device.vala"
				_tmp218_ = dev;
#line 528 "Utility/Device.vala"
				_tmp219_ = _tmp218_->symlinks;
#line 528 "Utility/Device.vala"
				_tmp220_ = dev_by_uuid;
#line 528 "Utility/Device.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp219_, _tmp220_);
#line 3352 "Device.c"
			}
#line 525 "Utility/Device.vala"
			_g_free0 (dev_by_uuid);
#line 525 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 3358 "Device.c"
		}
#line 525 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 3362 "Device.c"
	}
	{
		GFile* f_dev_mapper = NULL;
		GFile* _tmp221_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp222_;
		gchar* _tmp223_;
		gchar* _tmp224_;
		GFileEnumerator* _tmp225_;
		GFileEnumerator* _tmp226_;
		GFileInfo* info = NULL;
#line 536 "Utility/Device.vala"
		_tmp221_ = g_file_new_for_path ("/dev/mapper");
#line 536 "Utility/Device.vala"
		f_dev_mapper = _tmp221_;
#line 538 "Utility/Device.vala"
		_tmp222_ = f_dev_mapper;
#line 538 "Utility/Device.vala"
		_tmp223_ = g_strdup_printf ("%s,%s", G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 538 "Utility/Device.vala"
		_tmp224_ = _tmp223_;
#line 538 "Utility/Device.vala"
		_tmp225_ = g_file_enumerate_children (_tmp222_, _tmp224_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 538 "Utility/Device.vala"
		_tmp226_ = _tmp225_;
#line 538 "Utility/Device.vala"
		_g_free0 (_tmp224_);
#line 538 "Utility/Device.vala"
		enumerator = _tmp226_;
#line 538 "Utility/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 538 "Utility/Device.vala"
			_g_object_unref0 (f_dev_mapper);
#line 3396 "Device.c"
			goto __catch44_g_error;
		}
#line 544 "Utility/Device.vala"
		while (TRUE) {
#line 3401 "Device.c"
			GFileInfo* _tmp227_ = NULL;
			GFileEnumerator* _tmp228_;
			GFileInfo* _tmp229_;
			GFileInfo* _tmp230_;
			GFileInfo* _tmp231_;
			GFileInfo* _tmp232_;
			const gchar* _tmp233_;
			GFile* f_mapped = NULL;
			GFile* _tmp234_;
			GFileInfo* _tmp235_;
			const gchar* _tmp236_;
			GFile* _tmp237_;
			gchar* mapped_file = NULL;
			GFile* _tmp238_;
			gchar* _tmp239_;
			gchar* mapped_device = NULL;
			GFileInfo* _tmp240_;
			const gchar* _tmp241_;
			gchar* _tmp242_;
			const gchar* _tmp243_;
			gchar* _tmp244_;
#line 544 "Utility/Device.vala"
			_tmp228_ = enumerator;
#line 544 "Utility/Device.vala"
			_tmp229_ = g_file_enumerator_next_file (_tmp228_, NULL, &_inner_error0_);
#line 544 "Utility/Device.vala"
			_tmp227_ = _tmp229_;
#line 544 "Utility/Device.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 544 "Utility/Device.vala"
				_g_object_unref0 (info);
#line 544 "Utility/Device.vala"
				_g_object_unref0 (enumerator);
#line 544 "Utility/Device.vala"
				_g_object_unref0 (f_dev_mapper);
#line 3437 "Device.c"
				goto __catch44_g_error;
			}
#line 544 "Utility/Device.vala"
			_tmp230_ = _tmp227_;
#line 544 "Utility/Device.vala"
			_tmp227_ = NULL;
#line 544 "Utility/Device.vala"
			_g_object_unref0 (info);
#line 544 "Utility/Device.vala"
			info = _tmp230_;
#line 544 "Utility/Device.vala"
			_tmp231_ = info;
#line 544 "Utility/Device.vala"
			if (!(_tmp231_ != NULL)) {
#line 544 "Utility/Device.vala"
				_g_object_unref0 (_tmp227_);
#line 544 "Utility/Device.vala"
				break;
#line 3456 "Device.c"
			}
#line 546 "Utility/Device.vala"
			_tmp232_ = info;
#line 546 "Utility/Device.vala"
			_tmp233_ = g_file_info_get_name (_tmp232_);
#line 546 "Utility/Device.vala"
			if (g_strcmp0 (_tmp233_, "control") == 0) {
#line 546 "Utility/Device.vala"
				_g_object_unref0 (_tmp227_);
#line 546 "Utility/Device.vala"
				continue;
#line 3468 "Device.c"
			}
#line 548 "Utility/Device.vala"
			_tmp234_ = f_dev_mapper;
#line 548 "Utility/Device.vala"
			_tmp235_ = info;
#line 548 "Utility/Device.vala"
			_tmp236_ = g_file_info_get_name (_tmp235_);
#line 548 "Utility/Device.vala"
			_tmp237_ = g_file_resolve_relative_path (_tmp234_, _tmp236_);
#line 548 "Utility/Device.vala"
			f_mapped = _tmp237_;
#line 550 "Utility/Device.vala"
			_tmp238_ = f_mapped;
#line 550 "Utility/Device.vala"
			_tmp239_ = g_file_get_path (_tmp238_);
#line 550 "Utility/Device.vala"
			mapped_file = _tmp239_;
#line 551 "Utility/Device.vala"
			_tmp240_ = info;
#line 551 "Utility/Device.vala"
			_tmp241_ = g_file_info_get_symlink_target (_tmp240_);
#line 551 "Utility/Device.vala"
			_tmp242_ = g_strdup (_tmp241_);
#line 551 "Utility/Device.vala"
			mapped_device = _tmp242_;
#line 552 "Utility/Device.vala"
			_tmp243_ = mapped_device;
#line 552 "Utility/Device.vala"
			_tmp244_ = string_replace (_tmp243_, "..", "/dev");
#line 552 "Utility/Device.vala"
			_g_free0 (mapped_device);
#line 552 "Utility/Device.vala"
			mapped_device = _tmp244_;
#line 3502 "Device.c"
			{
				GeeArrayList* _dev_list = NULL;
				GeeArrayList* _tmp245_;
				GeeArrayList* _tmp246_;
				gint _dev_size = 0;
				GeeArrayList* _tmp247_;
				gint _tmp248_;
				gint _tmp249_;
				gint _dev_index = 0;
#line 558 "Utility/Device.vala"
				_tmp245_ = list;
#line 558 "Utility/Device.vala"
				_tmp246_ = _g_object_ref0 (_tmp245_);
#line 558 "Utility/Device.vala"
				_dev_list = _tmp246_;
#line 558 "Utility/Device.vala"
				_tmp247_ = _dev_list;
#line 558 "Utility/Device.vala"
				_tmp248_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp247_);
#line 558 "Utility/Device.vala"
				_tmp249_ = _tmp248_;
#line 558 "Utility/Device.vala"
				_dev_size = _tmp249_;
#line 558 "Utility/Device.vala"
				_dev_index = -1;
#line 558 "Utility/Device.vala"
				while (TRUE) {
#line 3530 "Device.c"
					Device* dev = NULL;
					GeeArrayList* _tmp250_;
					gpointer _tmp251_;
					Device* _tmp252_;
					const gchar* _tmp253_;
					const gchar* _tmp254_;
#line 558 "Utility/Device.vala"
					_dev_index = _dev_index + 1;
#line 558 "Utility/Device.vala"
					if (!(_dev_index < _dev_size)) {
#line 558 "Utility/Device.vala"
						break;
#line 3543 "Device.c"
					}
#line 558 "Utility/Device.vala"
					_tmp250_ = _dev_list;
#line 558 "Utility/Device.vala"
					_tmp251_ = gee_abstract_list_get ((GeeAbstractList*) _tmp250_, _dev_index);
#line 558 "Utility/Device.vala"
					dev = (Device*) _tmp251_;
#line 559 "Utility/Device.vala"
					_tmp252_ = dev;
#line 559 "Utility/Device.vala"
					_tmp253_ = _tmp252_->device;
#line 559 "Utility/Device.vala"
					_tmp254_ = mapped_device;
#line 559 "Utility/Device.vala"
					if (g_strcmp0 (_tmp253_, _tmp254_) == 0) {
#line 3559 "Device.c"
						Device* _tmp255_;
						const gchar* _tmp256_;
						gchar* _tmp257_;
						Device* _tmp258_;
						GeeArrayList* _tmp259_;
						const gchar* _tmp260_;
#line 560 "Utility/Device.vala"
						_tmp255_ = dev;
#line 560 "Utility/Device.vala"
						_tmp256_ = mapped_file;
#line 560 "Utility/Device.vala"
						_tmp257_ = string_replace (_tmp256_, "/dev/mapper/", "");
#line 560 "Utility/Device.vala"
						_g_free0 (_tmp255_->mapped_name);
#line 560 "Utility/Device.vala"
						_tmp255_->mapped_name = _tmp257_;
#line 561 "Utility/Device.vala"
						_tmp258_ = dev;
#line 561 "Utility/Device.vala"
						_tmp259_ = _tmp258_->symlinks;
#line 561 "Utility/Device.vala"
						_tmp260_ = mapped_file;
#line 561 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp259_, _tmp260_);
#line 563 "Utility/Device.vala"
						_g_object_unref0 (dev);
#line 563 "Utility/Device.vala"
						break;
#line 3588 "Device.c"
					}
#line 558 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 3592 "Device.c"
				}
#line 558 "Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 3596 "Device.c"
			}
#line 544 "Utility/Device.vala"
			_g_free0 (mapped_device);
#line 544 "Utility/Device.vala"
			_g_free0 (mapped_file);
#line 544 "Utility/Device.vala"
			_g_object_unref0 (f_mapped);
#line 544 "Utility/Device.vala"
			_g_object_unref0 (_tmp227_);
#line 3606 "Device.c"
		}
#line 534 "Utility/Device.vala"
		_g_object_unref0 (info);
#line 534 "Utility/Device.vala"
		_g_object_unref0 (enumerator);
#line 534 "Utility/Device.vala"
		_g_object_unref0 (f_dev_mapper);
#line 3614 "Device.c"
	}
	goto __finally44;
	__catch44_g_error:
	{
		GError* e = NULL;
		GError* _tmp261_;
		const gchar* _tmp262_;
#line 534 "Utility/Device.vala"
		e = _inner_error0_;
#line 534 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 569 "Utility/Device.vala"
		_tmp261_ = e;
#line 569 "Utility/Device.vala"
		_tmp262_ = _tmp261_->message;
#line 569 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp262_, FALSE, FALSE);
#line 534 "Utility/Device.vala"
		_g_error_free0 (e);
#line 3634 "Device.c"
	}
	__finally44:
#line 534 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 534 "Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 534 "Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 534 "Utility/Device.vala"
		_g_free0 (cmd);
#line 534 "Utility/Device.vala"
		_g_free0 (std_err);
#line 534 "Utility/Device.vala"
		_g_free0 (std_out);
#line 534 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 534 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 534 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 534 "Utility/Device.vala"
		return NULL;
#line 3657 "Device.c"
	}
#line 572 "Utility/Device.vala"
	_tmp263_ = list;
#line 572 "Utility/Device.vala"
	_tmp264_ = _g_object_ref0 (_tmp263_);
#line 572 "Utility/Device.vala"
	_g_object_unref0 (device_device_list);
#line 572 "Utility/Device.vala"
	device_device_list = _tmp264_;
#line 3667 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp265_;
		GeeArrayList* _tmp266_;
		gint _part_size = 0;
		GeeArrayList* _tmp267_;
		gint _tmp268_;
		gint _tmp269_;
		gint _part_index = 0;
#line 574 "Utility/Device.vala"
		_tmp265_ = list;
#line 574 "Utility/Device.vala"
		_tmp266_ = _g_object_ref0 (_tmp265_);
#line 574 "Utility/Device.vala"
		_part_list = _tmp266_;
#line 574 "Utility/Device.vala"
		_tmp267_ = _part_list;
#line 574 "Utility/Device.vala"
		_tmp268_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp267_);
#line 574 "Utility/Device.vala"
		_tmp269_ = _tmp268_;
#line 574 "Utility/Device.vala"
		_part_size = _tmp269_;
#line 574 "Utility/Device.vala"
		_part_index = -1;
#line 574 "Utility/Device.vala"
		while (TRUE) {
#line 3695 "Device.c"
			Device* part = NULL;
			GeeArrayList* _tmp270_;
			gpointer _tmp271_;
			GeeArrayList* _tmp272_;
			Device* _tmp273_;
			GeeArrayList* _tmp274_;
			Device* _tmp275_;
#line 574 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 574 "Utility/Device.vala"
			if (!(_part_index < _part_size)) {
#line 574 "Utility/Device.vala"
				break;
#line 3709 "Device.c"
			}
#line 574 "Utility/Device.vala"
			_tmp270_ = _part_list;
#line 574 "Utility/Device.vala"
			_tmp271_ = gee_abstract_list_get ((GeeAbstractList*) _tmp270_, _part_index);
#line 574 "Utility/Device.vala"
			part = (Device*) _tmp271_;
#line 575 "Utility/Device.vala"
			_tmp272_ = list;
#line 575 "Utility/Device.vala"
			_tmp273_ = part;
#line 575 "Utility/Device.vala"
			device_find_child_devices (_tmp272_, _tmp273_);
#line 576 "Utility/Device.vala"
			_tmp274_ = list;
#line 576 "Utility/Device.vala"
			_tmp275_ = part;
#line 576 "Utility/Device.vala"
			device_find_toplevel_parent (_tmp274_, _tmp275_);
#line 574 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 3731 "Device.c"
		}
#line 574 "Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 3735 "Device.c"
	}
#line 581 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 3739 "Device.c"
		GeeArrayList* _tmp276_;
#line 582 "Utility/Device.vala"
		_tmp276_ = list;
#line 582 "Utility/Device.vala"
		device_find_child_devices_using_dmsetup (_tmp276_);
#line 3745 "Device.c"
	}
#line 589 "Utility/Device.vala"
	result = list;
#line 589 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 589 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 589 "Utility/Device.vala"
	_g_free0 (cmd);
#line 589 "Utility/Device.vala"
	_g_free0 (std_err);
#line 589 "Utility/Device.vala"
	_g_free0 (std_out);
#line 589 "Utility/Device.vala"
	return result;
#line 3761 "Device.c"
}

GeeArrayList*
device_get_block_devices_using_blkid (const gchar* dev_name)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp6_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_;
	const gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	GeeArrayList* _tmp104_;
	gint _tmp105_;
	gint _tmp106_;
	gchar* _tmp107_;
	gchar* _tmp108_;
	GError* _inner_error0_ = NULL;
#line 593 "Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 598 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 598 "Utility/Device.vala"
	list = _tmp0_;
#line 607 "Utility/Device.vala"
	_tmp2_ = strlen (dev_name);
#line 607 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 607 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 3805 "Device.c"
		gchar* _tmp4_;
#line 607 "Utility/Device.vala"
		_tmp4_ = g_strconcat (" ", dev_name, NULL);
#line 607 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 607 "Utility/Device.vala"
		_tmp1_ = _tmp4_;
#line 3813 "Device.c"
	} else {
		gchar* _tmp5_;
#line 607 "Utility/Device.vala"
		_tmp5_ = g_strdup ("");
#line 607 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 607 "Utility/Device.vala"
		_tmp1_ = _tmp5_;
#line 3822 "Device.c"
	}
#line 607 "Utility/Device.vala"
	_tmp6_ = g_strconcat ("/sbin/blkid", _tmp1_, NULL);
#line 607 "Utility/Device.vala"
	_g_free0 (cmd);
#line 607 "Utility/Device.vala"
	cmd = _tmp6_;
#line 609 "Utility/Device.vala"
	if (tee_jee_logging_LOG_DEBUG) {
#line 3832 "Device.c"
		const gchar* _tmp7_;
#line 610 "Utility/Device.vala"
		_tmp7_ = cmd;
#line 610 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp7_);
#line 3838 "Device.c"
	}
#line 613 "Utility/Device.vala"
	_tmp8_ = cmd;
#line 613 "Utility/Device.vala"
	_tmp11_ = tee_jee_process_helper_exec_script_sync (_tmp8_, &_tmp9_, &_tmp10_, FALSE, FALSE, TRUE, FALSE);
#line 613 "Utility/Device.vala"
	_g_free0 (std_out);
#line 613 "Utility/Device.vala"
	std_out = _tmp9_;
#line 613 "Utility/Device.vala"
	_g_free0 (std_err);
#line 613 "Utility/Device.vala"
	std_err = _tmp10_;
#line 613 "Utility/Device.vala"
	ret_val = _tmp11_;
#line 614 "Utility/Device.vala"
	if (ret_val != 0) {
#line 3856 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gint _tmp14_;
		gint _tmp15_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
#line 615 "Utility/Device.vala"
		_tmp12_ = g_strconcat ("blkid: ", _ ("Failed to get partition list"), NULL);
#line 615 "Utility/Device.vala"
		msg = _tmp12_;
#line 616 "Utility/Device.vala"
		_tmp14_ = strlen (dev_name);
#line 616 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 616 "Utility/Device.vala"
		if (_tmp15_ > 0) {
#line 3875 "Device.c"
			gchar* _tmp16_;
#line 616 "Utility/Device.vala"
			_tmp16_ = g_strconcat (": ", dev_name, NULL);
#line 616 "Utility/Device.vala"
			_g_free0 (_tmp13_);
#line 616 "Utility/Device.vala"
			_tmp13_ = _tmp16_;
#line 3883 "Device.c"
		} else {
			gchar* _tmp17_;
#line 616 "Utility/Device.vala"
			_tmp17_ = g_strdup ("");
#line 616 "Utility/Device.vala"
			_g_free0 (_tmp13_);
#line 616 "Utility/Device.vala"
			_tmp13_ = _tmp17_;
#line 3892 "Device.c"
		}
#line 616 "Utility/Device.vala"
		_tmp18_ = msg;
#line 616 "Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp18_, _tmp13_, NULL);
#line 616 "Utility/Device.vala"
		_g_free0 (msg);
#line 616 "Utility/Device.vala"
		msg = _tmp19_;
#line 617 "Utility/Device.vala"
		_tmp20_ = msg;
#line 617 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp20_, FALSE, FALSE);
#line 618 "Utility/Device.vala"
		result = list;
#line 618 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 618 "Utility/Device.vala"
		_g_free0 (msg);
#line 618 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 618 "Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 618 "Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 618 "Utility/Device.vala"
		_g_free0 (cmd);
#line 618 "Utility/Device.vala"
		_g_free0 (std_err);
#line 618 "Utility/Device.vala"
		_g_free0 (std_out);
#line 618 "Utility/Device.vala"
		return result;
#line 3926 "Device.c"
	}
#line 631 "Utility/Device.vala"
	_tmp21_ = std_out;
#line 631 "Utility/Device.vala"
	_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, "\n", 0);
#line 3932 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 631 "Utility/Device.vala"
		line_collection = _tmp23_;
#line 631 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp22_);
#line 631 "Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp22_); line_it = line_it + 1) {
#line 3944 "Device.c"
			gchar* _tmp24_;
			gchar* line = NULL;
#line 631 "Utility/Device.vala"
			_tmp24_ = g_strdup (line_collection[line_it]);
#line 631 "Utility/Device.vala"
			line = _tmp24_;
#line 3951 "Device.c"
			{
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gboolean _tmp30_;
				Device* pi = NULL;
				Device* _tmp31_;
				Device* _tmp32_;
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gchar** _tmp35_;
				gchar** _tmp36_;
				gint _tmp36__length1;
				const gchar* _tmp37_;
				gchar* _tmp38_;
				Device* _tmp39_;
				const gchar* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				Device* _tmp43_;
				const gchar* _tmp44_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_ = FALSE;
				Device* _tmp48_;
				const gchar* _tmp49_;
				Device* _tmp98_;
				const gchar* _tmp99_;
				gint _tmp100_;
				gint _tmp101_;
#line 632 "Utility/Device.vala"
				_tmp25_ = line;
#line 632 "Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 632 "Utility/Device.vala"
				_tmp27_ = _tmp26_;
#line 632 "Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 632 "Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 632 "Utility/Device.vala"
				_tmp30_ = _tmp29_ == 0;
#line 632 "Utility/Device.vala"
				_g_free0 (_tmp27_);
#line 632 "Utility/Device.vala"
				if (_tmp30_) {
#line 632 "Utility/Device.vala"
					_g_free0 (line);
#line 632 "Utility/Device.vala"
					continue;
#line 4004 "Device.c"
				}
#line 634 "Utility/Device.vala"
				_tmp31_ = device_new ();
#line 634 "Utility/Device.vala"
				pi = _tmp31_;
#line 636 "Utility/Device.vala"
				_tmp32_ = pi;
#line 636 "Utility/Device.vala"
				_tmp33_ = line;
#line 636 "Utility/Device.vala"
				_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, ":", 0);
#line 636 "Utility/Device.vala"
				_tmp36_ = _tmp35_;
#line 636 "Utility/Device.vala"
				_tmp36__length1 = _vala_array_length (_tmp34_);
#line 636 "Utility/Device.vala"
				_tmp37_ = _tmp36_[0];
#line 636 "Utility/Device.vala"
				_tmp38_ = string_strip (_tmp37_);
#line 636 "Utility/Device.vala"
				_g_free0 (_tmp32_->device);
#line 636 "Utility/Device.vala"
				_tmp32_->device = _tmp38_;
#line 636 "Utility/Device.vala"
				_tmp36_ = (_vala_array_free (_tmp36_, _tmp36__length1, (GDestroyNotify) g_free), NULL);
#line 638 "Utility/Device.vala"
				_tmp39_ = pi;
#line 638 "Utility/Device.vala"
				_tmp40_ = _tmp39_->device;
#line 638 "Utility/Device.vala"
				_tmp41_ = strlen (_tmp40_);
#line 638 "Utility/Device.vala"
				_tmp42_ = _tmp41_;
#line 638 "Utility/Device.vala"
				if (_tmp42_ == 0) {
#line 638 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 638 "Utility/Device.vala"
					_g_free0 (line);
#line 638 "Utility/Device.vala"
					continue;
#line 4046 "Device.c"
				}
#line 642 "Utility/Device.vala"
				_tmp43_ = pi;
#line 642 "Utility/Device.vala"
				_tmp44_ = _tmp43_->device;
#line 642 "Utility/Device.vala"
				if (!g_str_has_prefix (_tmp44_, "/dev/")) {
#line 643 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 643 "Utility/Device.vala"
					_g_free0 (line);
#line 643 "Utility/Device.vala"
					continue;
#line 4060 "Device.c"
				}
#line 646 "Utility/Device.vala"
				_tmp48_ = pi;
#line 646 "Utility/Device.vala"
				_tmp49_ = _tmp48_->device;
#line 646 "Utility/Device.vala"
				if (g_str_has_prefix (_tmp49_, "/dev/sd")) {
#line 646 "Utility/Device.vala"
					_tmp47_ = TRUE;
#line 4070 "Device.c"
				} else {
					Device* _tmp50_;
					const gchar* _tmp51_;
#line 646 "Utility/Device.vala"
					_tmp50_ = pi;
#line 646 "Utility/Device.vala"
					_tmp51_ = _tmp50_->device;
#line 646 "Utility/Device.vala"
					_tmp47_ = g_str_has_prefix (_tmp51_, "/dev/hd");
#line 4080 "Device.c"
				}
#line 646 "Utility/Device.vala"
				if (_tmp47_) {
#line 646 "Utility/Device.vala"
					_tmp46_ = TRUE;
#line 4086 "Device.c"
				} else {
					Device* _tmp52_;
					const gchar* _tmp53_;
#line 646 "Utility/Device.vala"
					_tmp52_ = pi;
#line 646 "Utility/Device.vala"
					_tmp53_ = _tmp52_->device;
#line 646 "Utility/Device.vala"
					_tmp46_ = g_str_has_prefix (_tmp53_, "/dev/mapper/");
#line 4096 "Device.c"
				}
#line 646 "Utility/Device.vala"
				if (_tmp46_) {
#line 646 "Utility/Device.vala"
					_tmp45_ = TRUE;
#line 4102 "Device.c"
				} else {
					Device* _tmp54_;
					const gchar* _tmp55_;
#line 646 "Utility/Device.vala"
					_tmp54_ = pi;
#line 646 "Utility/Device.vala"
					_tmp55_ = _tmp54_->device;
#line 646 "Utility/Device.vala"
					_tmp45_ = g_str_has_prefix (_tmp55_, "/dev/dm");
#line 4112 "Device.c"
				}
#line 646 "Utility/Device.vala"
				if (_tmp45_) {
#line 4116 "Device.c"
				} else {
					Device* _tmp56_;
					const gchar* _tmp57_;
#line 649 "Utility/Device.vala"
					_tmp56_ = pi;
#line 649 "Utility/Device.vala"
					_tmp57_ = _tmp56_->device;
#line 649 "Utility/Device.vala"
					if (g_str_has_prefix (_tmp57_, "/dev/disk/by-uuid/")) {
#line 4126 "Device.c"
						Device* _tmp58_;
						Device* _tmp59_;
						const gchar* _tmp60_;
						gchar* _tmp61_;
#line 651 "Utility/Device.vala"
						_tmp58_ = pi;
#line 651 "Utility/Device.vala"
						_tmp59_ = pi;
#line 651 "Utility/Device.vala"
						_tmp60_ = _tmp59_->device;
#line 651 "Utility/Device.vala"
						_tmp61_ = string_replace (_tmp60_, "/dev/disk/by-uuid/", "");
#line 651 "Utility/Device.vala"
						_g_free0 (_tmp58_->uuid);
#line 651 "Utility/Device.vala"
						_tmp58_->uuid = _tmp61_;
#line 4143 "Device.c"
					} else {
#line 654 "Utility/Device.vala"
						_g_object_unref0 (pi);
#line 654 "Utility/Device.vala"
						_g_free0 (line);
#line 654 "Utility/Device.vala"
						continue;
#line 4151 "Device.c"
					}
				}
				{
					GRegex* _tmp62_ = NULL;
					GRegex* _tmp63_;
					GRegex* _tmp64_;
					GRegex* _tmp65_;
					const gchar* _tmp66_;
					GMatchInfo* _tmp67_ = NULL;
					gboolean _tmp68_;
					GRegex* _tmp72_ = NULL;
					GRegex* _tmp73_;
					GRegex* _tmp74_;
					GRegex* _tmp75_;
					const gchar* _tmp76_;
					GMatchInfo* _tmp77_ = NULL;
					gboolean _tmp78_;
					GRegex* _tmp84_ = NULL;
					GRegex* _tmp85_;
					GRegex* _tmp86_;
					GRegex* _tmp87_;
					const gchar* _tmp88_;
					GMatchInfo* _tmp89_ = NULL;
					gboolean _tmp90_;
#line 660 "Utility/Device.vala"
					_tmp63_ = g_regex_new ("LABEL=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 660 "Utility/Device.vala"
					_tmp62_ = _tmp63_;
#line 660 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4182 "Device.c"
						goto __catch46_g_error;
					}
#line 660 "Utility/Device.vala"
					_tmp64_ = _tmp62_;
#line 660 "Utility/Device.vala"
					_tmp62_ = NULL;
#line 660 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 660 "Utility/Device.vala"
					rex = _tmp64_;
#line 661 "Utility/Device.vala"
					_tmp65_ = rex;
#line 661 "Utility/Device.vala"
					_tmp66_ = line;
#line 661 "Utility/Device.vala"
					_tmp68_ = g_regex_match (_tmp65_, _tmp66_, 0, &_tmp67_);
#line 661 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 661 "Utility/Device.vala"
					match = _tmp67_;
#line 661 "Utility/Device.vala"
					if (_tmp68_) {
#line 4205 "Device.c"
						Device* _tmp69_;
						GMatchInfo* _tmp70_;
						gchar* _tmp71_;
#line 662 "Utility/Device.vala"
						_tmp69_ = pi;
#line 662 "Utility/Device.vala"
						_tmp70_ = match;
#line 662 "Utility/Device.vala"
						_tmp71_ = g_match_info_fetch (_tmp70_, 1);
#line 662 "Utility/Device.vala"
						_g_free0 (_tmp69_->label);
#line 662 "Utility/Device.vala"
						_tmp69_->label = _tmp71_;
#line 4219 "Device.c"
					}
#line 665 "Utility/Device.vala"
					_tmp73_ = g_regex_new ("UUID=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 665 "Utility/Device.vala"
					_tmp72_ = _tmp73_;
#line 665 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 665 "Utility/Device.vala"
						_g_regex_unref0 (_tmp62_);
#line 4229 "Device.c"
						goto __catch46_g_error;
					}
#line 665 "Utility/Device.vala"
					_tmp74_ = _tmp72_;
#line 665 "Utility/Device.vala"
					_tmp72_ = NULL;
#line 665 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 665 "Utility/Device.vala"
					rex = _tmp74_;
#line 666 "Utility/Device.vala"
					_tmp75_ = rex;
#line 666 "Utility/Device.vala"
					_tmp76_ = line;
#line 666 "Utility/Device.vala"
					_tmp78_ = g_regex_match (_tmp75_, _tmp76_, 0, &_tmp77_);
#line 666 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 666 "Utility/Device.vala"
					match = _tmp77_;
#line 666 "Utility/Device.vala"
					if (_tmp78_) {
#line 4252 "Device.c"
						Device* _tmp79_;
						GMatchInfo* _tmp80_;
						gchar* _tmp81_;
						gchar* _tmp82_;
						gchar* _tmp83_;
#line 667 "Utility/Device.vala"
						_tmp79_ = pi;
#line 667 "Utility/Device.vala"
						_tmp80_ = match;
#line 667 "Utility/Device.vala"
						_tmp81_ = g_match_info_fetch (_tmp80_, 1);
#line 667 "Utility/Device.vala"
						_tmp82_ = _tmp81_;
#line 667 "Utility/Device.vala"
						_tmp83_ = string_strip (_tmp82_);
#line 667 "Utility/Device.vala"
						_g_free0 (_tmp79_->uuid);
#line 667 "Utility/Device.vala"
						_tmp79_->uuid = _tmp83_;
#line 667 "Utility/Device.vala"
						_g_free0 (_tmp82_);
#line 4274 "Device.c"
					}
#line 670 "Utility/Device.vala"
					_tmp85_ = g_regex_new ("TYPE=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 670 "Utility/Device.vala"
					_tmp84_ = _tmp85_;
#line 670 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 670 "Utility/Device.vala"
						_g_regex_unref0 (_tmp72_);
#line 670 "Utility/Device.vala"
						_g_regex_unref0 (_tmp62_);
#line 4286 "Device.c"
						goto __catch46_g_error;
					}
#line 670 "Utility/Device.vala"
					_tmp86_ = _tmp84_;
#line 670 "Utility/Device.vala"
					_tmp84_ = NULL;
#line 670 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 670 "Utility/Device.vala"
					rex = _tmp86_;
#line 671 "Utility/Device.vala"
					_tmp87_ = rex;
#line 671 "Utility/Device.vala"
					_tmp88_ = line;
#line 671 "Utility/Device.vala"
					_tmp90_ = g_regex_match (_tmp87_, _tmp88_, 0, &_tmp89_);
#line 671 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 671 "Utility/Device.vala"
					match = _tmp89_;
#line 671 "Utility/Device.vala"
					if (_tmp90_) {
#line 4309 "Device.c"
						Device* _tmp91_;
						GMatchInfo* _tmp92_;
						gchar* _tmp93_;
						gchar* _tmp94_;
						gchar* _tmp95_;
#line 672 "Utility/Device.vala"
						_tmp91_ = pi;
#line 672 "Utility/Device.vala"
						_tmp92_ = match;
#line 672 "Utility/Device.vala"
						_tmp93_ = g_match_info_fetch (_tmp92_, 1);
#line 672 "Utility/Device.vala"
						_tmp94_ = _tmp93_;
#line 672 "Utility/Device.vala"
						_tmp95_ = string_strip (_tmp94_);
#line 672 "Utility/Device.vala"
						_g_free0 (_tmp91_->fstype);
#line 672 "Utility/Device.vala"
						_tmp91_->fstype = _tmp95_;
#line 672 "Utility/Device.vala"
						_g_free0 (_tmp94_);
#line 4331 "Device.c"
					}
#line 659 "Utility/Device.vala"
					_g_regex_unref0 (_tmp84_);
#line 659 "Utility/Device.vala"
					_g_regex_unref0 (_tmp72_);
#line 659 "Utility/Device.vala"
					_g_regex_unref0 (_tmp62_);
#line 4339 "Device.c"
				}
				goto __finally46;
				__catch46_g_error:
				{
					GError* e = NULL;
					GError* _tmp96_;
					const gchar* _tmp97_;
#line 659 "Utility/Device.vala"
					e = _inner_error0_;
#line 659 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 676 "Utility/Device.vala"
					_tmp96_ = e;
#line 676 "Utility/Device.vala"
					_tmp97_ = _tmp96_->message;
#line 676 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp97_, FALSE, FALSE);
#line 659 "Utility/Device.vala"
					_g_error_free0 (e);
#line 4359 "Device.c"
				}
				__finally46:
#line 659 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 659 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 659 "Utility/Device.vala"
					_g_free0 (line);
#line 659 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 659 "Utility/Device.vala"
					_g_free0 (_tmp1_);
#line 659 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 659 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 659 "Utility/Device.vala"
					_g_free0 (cmd);
#line 659 "Utility/Device.vala"
					_g_free0 (std_err);
#line 659 "Utility/Device.vala"
					_g_free0 (std_out);
#line 659 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 659 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 659 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 659 "Utility/Device.vala"
					return NULL;
#line 4390 "Device.c"
				}
#line 681 "Utility/Device.vala"
				_tmp98_ = pi;
#line 681 "Utility/Device.vala"
				_tmp99_ = _tmp98_->uuid;
#line 681 "Utility/Device.vala"
				_tmp100_ = strlen (_tmp99_);
#line 681 "Utility/Device.vala"
				_tmp101_ = _tmp100_;
#line 681 "Utility/Device.vala"
				if (_tmp101_ > 0) {
#line 4402 "Device.c"
					GeeArrayList* _tmp102_;
					Device* _tmp103_;
#line 682 "Utility/Device.vala"
					_tmp102_ = list;
#line 682 "Utility/Device.vala"
					_tmp103_ = pi;
#line 682 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp102_, _tmp103_);
#line 4411 "Device.c"
				}
#line 631 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 631 "Utility/Device.vala"
				_g_free0 (line);
#line 4417 "Device.c"
			}
		}
#line 631 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 4422 "Device.c"
	}
#line 686 "Utility/Device.vala"
	_tmp104_ = list;
#line 686 "Utility/Device.vala"
	_tmp105_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp104_);
#line 686 "Utility/Device.vala"
	_tmp106_ = _tmp105_;
#line 686 "Utility/Device.vala"
	_tmp107_ = g_strdup_printf ("Device: get_block_devices_using_blkid(): %d", _tmp106_);
#line 686 "Utility/Device.vala"
	_tmp108_ = _tmp107_;
#line 686 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp108_);
#line 686 "Utility/Device.vala"
	_g_free0 (_tmp108_);
#line 688 "Utility/Device.vala"
	result = list;
#line 688 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 688 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 688 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 688 "Utility/Device.vala"
	_g_free0 (cmd);
#line 688 "Utility/Device.vala"
	_g_free0 (std_err);
#line 688 "Utility/Device.vala"
	_g_free0 (std_out);
#line 688 "Utility/Device.vala"
	return result;
#line 4454 "Device.c"
}

static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
#line 782 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 783 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, (guint) 0);
#line 783 "glib-2.0.vapi"
	return result;
#line 4467 "Device.c"
}

GeeArrayList*
device_get_disk_space_using_df (const gchar* dev_name_or_mount_point)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gint _tmp14_;
	gchar** lines = NULL;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint lines_length1;
	gint _lines_size_;
	gint line_num = 0;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GeeArrayList* _tmp73_;
	gint _tmp74_;
	gint _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
#line 691 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_mount_point != NULL, NULL);
#line 698 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 698 "Utility/Device.vala"
	list = _tmp0_;
#line 705 "Utility/Device.vala"
	_tmp1_ = g_strdup ("df -T -B1");
#line 705 "Utility/Device.vala"
	_g_free0 (cmd);
#line 705 "Utility/Device.vala"
	cmd = _tmp1_;
#line 707 "Utility/Device.vala"
	_tmp2_ = strlen (dev_name_or_mount_point);
#line 707 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 707 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 4519 "Device.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 708 "Utility/Device.vala"
		_tmp4_ = cmd;
#line 708 "Utility/Device.vala"
		_tmp5_ = tee_jee_file_system_escape_single_quote (dev_name_or_mount_point);
#line 708 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 708 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" '%s'", _tmp6_);
#line 708 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 708 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp4_, _tmp8_, NULL);
#line 708 "Utility/Device.vala"
		_g_free0 (cmd);
#line 708 "Utility/Device.vala"
		cmd = _tmp9_;
#line 708 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 708 "Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 4546 "Device.c"
	}
#line 711 "Utility/Device.vala"
	if (tee_jee_logging_LOG_DEBUG) {
#line 4550 "Device.c"
		const gchar* _tmp10_;
#line 712 "Utility/Device.vala"
		_tmp10_ = cmd;
#line 712 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp10_);
#line 4556 "Device.c"
	}
#line 715 "Utility/Device.vala"
	_tmp11_ = cmd;
#line 715 "Utility/Device.vala"
	_tmp14_ = tee_jee_process_helper_exec_sync (_tmp11_, &_tmp12_, &_tmp13_);
#line 715 "Utility/Device.vala"
	_g_free0 (std_out);
#line 715 "Utility/Device.vala"
	std_out = _tmp12_;
#line 715 "Utility/Device.vala"
	_g_free0 (std_err);
#line 715 "Utility/Device.vala"
	std_err = _tmp13_;
#line 715 "Utility/Device.vala"
	ret_val = _tmp14_;
#line 730 "Utility/Device.vala"
	_tmp15_ = std_out;
#line 730 "Utility/Device.vala"
	_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, "\n", 0);
#line 730 "Utility/Device.vala"
	lines = _tmp17_;
#line 730 "Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp16_);
#line 730 "Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 732 "Utility/Device.vala"
	line_num = 0;
#line 733 "Utility/Device.vala"
	_tmp18_ = lines;
#line 733 "Utility/Device.vala"
	_tmp18__length1 = lines_length1;
#line 4588 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 733 "Utility/Device.vala"
		line_collection = _tmp18_;
#line 733 "Utility/Device.vala"
		line_collection_length1 = _tmp18__length1;
#line 733 "Utility/Device.vala"
		for (line_it = 0; line_it < _tmp18__length1; line_it = line_it + 1) {
#line 4600 "Device.c"
			gchar* _tmp19_;
			gchar* line = NULL;
#line 733 "Utility/Device.vala"
			_tmp19_ = g_strdup (line_collection[line_it]);
#line 733 "Utility/Device.vala"
			line = _tmp19_;
#line 4607 "Device.c"
			{
				const gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gboolean _tmp25_;
				Device* pi = NULL;
				Device* _tmp26_;
				gint k = 0;
				const gchar* _tmp27_;
				gchar** _tmp28_;
				gchar** _tmp29_;
				Device* _tmp59_;
				Device* _tmp60_;
				const gchar* _tmp61_;
				gchar* _tmp62_;
				Device* _tmp63_;
				Device* _tmp64_;
				const gchar* _tmp65_;
				gchar* _tmp66_;
				Device* _tmp67_;
				const gchar* _tmp68_;
				gint _tmp69_;
				gint _tmp70_;
#line 735 "Utility/Device.vala"
				line_num = line_num + 1;
#line 735 "Utility/Device.vala"
				if (line_num == 1) {
#line 735 "Utility/Device.vala"
					_g_free0 (line);
#line 735 "Utility/Device.vala"
					continue;
#line 4641 "Device.c"
				}
#line 736 "Utility/Device.vala"
				_tmp20_ = line;
#line 736 "Utility/Device.vala"
				_tmp21_ = string_strip (_tmp20_);
#line 736 "Utility/Device.vala"
				_tmp22_ = _tmp21_;
#line 736 "Utility/Device.vala"
				_tmp23_ = strlen (_tmp22_);
#line 736 "Utility/Device.vala"
				_tmp24_ = _tmp23_;
#line 736 "Utility/Device.vala"
				_tmp25_ = _tmp24_ == 0;
#line 736 "Utility/Device.vala"
				_g_free0 (_tmp22_);
#line 736 "Utility/Device.vala"
				if (_tmp25_) {
#line 736 "Utility/Device.vala"
					_g_free0 (line);
#line 736 "Utility/Device.vala"
					continue;
#line 4663 "Device.c"
				}
#line 738 "Utility/Device.vala"
				_tmp26_ = device_new ();
#line 738 "Utility/Device.vala"
				pi = _tmp26_;
#line 742 "Utility/Device.vala"
				k = 1;
#line 743 "Utility/Device.vala"
				_tmp27_ = line;
#line 743 "Utility/Device.vala"
				_tmp29_ = _tmp28_ = g_strsplit (_tmp27_, " ", 0);
#line 4675 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 743 "Utility/Device.vala"
					val_collection = _tmp29_;
#line 743 "Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp28_);
#line 743 "Utility/Device.vala"
					for (val_it = 0; val_it < _vala_array_length (_tmp28_); val_it = val_it + 1) {
#line 4687 "Device.c"
						gchar* _tmp30_;
						gchar* val = NULL;
#line 743 "Utility/Device.vala"
						_tmp30_ = g_strdup (val_collection[val_it]);
#line 743 "Utility/Device.vala"
						val = _tmp30_;
#line 4694 "Device.c"
						{
							const gchar* _tmp31_;
							gchar* _tmp32_;
							gchar* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							gboolean _tmp36_;
							gint _tmp37_;
#line 745 "Utility/Device.vala"
							_tmp31_ = val;
#line 745 "Utility/Device.vala"
							_tmp32_ = string_strip (_tmp31_);
#line 745 "Utility/Device.vala"
							_tmp33_ = _tmp32_;
#line 745 "Utility/Device.vala"
							_tmp34_ = strlen (_tmp33_);
#line 745 "Utility/Device.vala"
							_tmp35_ = _tmp34_;
#line 745 "Utility/Device.vala"
							_tmp36_ = _tmp35_ == 0;
#line 745 "Utility/Device.vala"
							_g_free0 (_tmp33_);
#line 745 "Utility/Device.vala"
							if (_tmp36_) {
#line 745 "Utility/Device.vala"
								_g_free0 (val);
#line 745 "Utility/Device.vala"
								continue;
#line 4723 "Device.c"
							}
#line 747 "Utility/Device.vala"
							_tmp37_ = k;
#line 747 "Utility/Device.vala"
							k = _tmp37_ + 1;
#line 747 "Utility/Device.vala"
							switch (_tmp37_) {
#line 747 "Utility/Device.vala"
								case 1:
#line 4733 "Device.c"
								{
									Device* _tmp38_;
									const gchar* _tmp39_;
									gchar* _tmp40_;
#line 749 "Utility/Device.vala"
									_tmp38_ = pi;
#line 749 "Utility/Device.vala"
									_tmp39_ = val;
#line 749 "Utility/Device.vala"
									_tmp40_ = string_strip (_tmp39_);
#line 749 "Utility/Device.vala"
									_g_free0 (_tmp38_->device);
#line 749 "Utility/Device.vala"
									_tmp38_->device = _tmp40_;
#line 750 "Utility/Device.vala"
									break;
#line 4750 "Device.c"
								}
#line 747 "Utility/Device.vala"
								case 2:
#line 4754 "Device.c"
								{
									Device* _tmp41_;
									const gchar* _tmp42_;
									gchar* _tmp43_;
#line 752 "Utility/Device.vala"
									_tmp41_ = pi;
#line 752 "Utility/Device.vala"
									_tmp42_ = val;
#line 752 "Utility/Device.vala"
									_tmp43_ = string_strip (_tmp42_);
#line 752 "Utility/Device.vala"
									_g_free0 (_tmp41_->fstype);
#line 752 "Utility/Device.vala"
									_tmp41_->fstype = _tmp43_;
#line 753 "Utility/Device.vala"
									break;
#line 4771 "Device.c"
								}
#line 747 "Utility/Device.vala"
								case 3:
#line 4775 "Device.c"
								{
									Device* _tmp44_;
									const gchar* _tmp45_;
									gchar* _tmp46_;
									gchar* _tmp47_;
#line 755 "Utility/Device.vala"
									_tmp44_ = pi;
#line 755 "Utility/Device.vala"
									_tmp45_ = val;
#line 755 "Utility/Device.vala"
									_tmp46_ = string_strip (_tmp45_);
#line 755 "Utility/Device.vala"
									_tmp47_ = _tmp46_;
#line 755 "Utility/Device.vala"
									_tmp44_->size_bytes = uint64_parse (_tmp47_);
#line 755 "Utility/Device.vala"
									_g_free0 (_tmp47_);
#line 756 "Utility/Device.vala"
									break;
#line 4795 "Device.c"
								}
#line 747 "Utility/Device.vala"
								case 4:
#line 4799 "Device.c"
								{
									Device* _tmp48_;
									const gchar* _tmp49_;
									gchar* _tmp50_;
									gchar* _tmp51_;
#line 758 "Utility/Device.vala"
									_tmp48_ = pi;
#line 758 "Utility/Device.vala"
									_tmp49_ = val;
#line 758 "Utility/Device.vala"
									_tmp50_ = string_strip (_tmp49_);
#line 758 "Utility/Device.vala"
									_tmp51_ = _tmp50_;
#line 758 "Utility/Device.vala"
									_tmp48_->used_bytes = uint64_parse (_tmp51_);
#line 758 "Utility/Device.vala"
									_g_free0 (_tmp51_);
#line 759 "Utility/Device.vala"
									break;
#line 4819 "Device.c"
								}
#line 747 "Utility/Device.vala"
								case 5:
#line 4823 "Device.c"
								{
									Device* _tmp52_;
									const gchar* _tmp53_;
									gchar* _tmp54_;
									gchar* _tmp55_;
#line 761 "Utility/Device.vala"
									_tmp52_ = pi;
#line 761 "Utility/Device.vala"
									_tmp53_ = val;
#line 761 "Utility/Device.vala"
									_tmp54_ = string_strip (_tmp53_);
#line 761 "Utility/Device.vala"
									_tmp55_ = _tmp54_;
#line 761 "Utility/Device.vala"
									_tmp52_->available_bytes = uint64_parse (_tmp55_);
#line 761 "Utility/Device.vala"
									_g_free0 (_tmp55_);
#line 762 "Utility/Device.vala"
									break;
#line 4843 "Device.c"
								}
#line 747 "Utility/Device.vala"
								case 6:
#line 4847 "Device.c"
								{
									Device* _tmp56_;
									const gchar* _tmp57_;
									gchar* _tmp58_;
#line 764 "Utility/Device.vala"
									_tmp56_ = pi;
#line 764 "Utility/Device.vala"
									_tmp57_ = val;
#line 764 "Utility/Device.vala"
									_tmp58_ = string_strip (_tmp57_);
#line 764 "Utility/Device.vala"
									_g_free0 (_tmp56_->used_percent);
#line 764 "Utility/Device.vala"
									_tmp56_->used_percent = _tmp58_;
#line 765 "Utility/Device.vala"
									break;
#line 4864 "Device.c"
								}
#line 747 "Utility/Device.vala"
								case 7:
#line 4868 "Device.c"
								{
#line 771 "Utility/Device.vala"
									break;
#line 4872 "Device.c"
								}
								default:
#line 747 "Utility/Device.vala"
								break;
#line 4877 "Device.c"
							}
#line 743 "Utility/Device.vala"
							_g_free0 (val);
#line 4881 "Device.c"
						}
					}
#line 743 "Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 4886 "Device.c"
				}
#line 784 "Utility/Device.vala"
				_tmp59_ = pi;
#line 784 "Utility/Device.vala"
				_tmp60_ = pi;
#line 784 "Utility/Device.vala"
				_tmp61_ = _tmp60_->device;
#line 784 "Utility/Device.vala"
				_tmp62_ = device_resolve_device_name (_tmp61_);
#line 784 "Utility/Device.vala"
				_g_free0 (_tmp59_->device);
#line 784 "Utility/Device.vala"
				_tmp59_->device = _tmp62_;
#line 788 "Utility/Device.vala"
				_tmp63_ = pi;
#line 788 "Utility/Device.vala"
				_tmp64_ = pi;
#line 788 "Utility/Device.vala"
				_tmp65_ = _tmp64_->device;
#line 788 "Utility/Device.vala"
				_tmp66_ = device_get_device_uuid (_tmp65_);
#line 788 "Utility/Device.vala"
				_g_free0 (_tmp63_->uuid);
#line 788 "Utility/Device.vala"
				_tmp63_->uuid = _tmp66_;
#line 792 "Utility/Device.vala"
				_tmp67_ = pi;
#line 792 "Utility/Device.vala"
				_tmp68_ = _tmp67_->uuid;
#line 792 "Utility/Device.vala"
				_tmp69_ = strlen (_tmp68_);
#line 792 "Utility/Device.vala"
				_tmp70_ = _tmp69_;
#line 792 "Utility/Device.vala"
				if (_tmp70_ > 0) {
#line 4922 "Device.c"
					GeeArrayList* _tmp71_;
					Device* _tmp72_;
#line 793 "Utility/Device.vala"
					_tmp71_ = list;
#line 793 "Utility/Device.vala"
					_tmp72_ = pi;
#line 793 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp71_, _tmp72_);
#line 4931 "Device.c"
				}
#line 733 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 733 "Utility/Device.vala"
				_g_free0 (line);
#line 4937 "Device.c"
			}
		}
	}
#line 797 "Utility/Device.vala"
	_tmp73_ = list;
#line 797 "Utility/Device.vala"
	_tmp74_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp73_);
#line 797 "Utility/Device.vala"
	_tmp75_ = _tmp74_;
#line 797 "Utility/Device.vala"
	_tmp76_ = g_strdup_printf ("Device: get_disk_space_using_df(): %d", _tmp75_);
#line 797 "Utility/Device.vala"
	_tmp77_ = _tmp76_;
#line 797 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp77_);
#line 797 "Utility/Device.vala"
	_g_free0 (_tmp77_);
#line 799 "Utility/Device.vala"
	result = list;
#line 799 "Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 799 "Utility/Device.vala"
	_g_free0 (cmd);
#line 799 "Utility/Device.vala"
	_g_free0 (std_err);
#line 799 "Utility/Device.vala"
	_g_free0 (std_out);
#line 799 "Utility/Device.vala"
	return result;
#line 4967 "Device.c"
}

GeeArrayList*
device_get_mounted_filesystems_using_mtab (void)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* mtab_path = NULL;
	gchar* _tmp1_;
	gchar* mtab_lines = NULL;
	gchar* _tmp2_;
	GFile* f = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar** lines = NULL;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint lines_length1;
	gint _lines_size_;
	GeeArrayList* mount_list = NULL;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp97_;
	gint _tmp98_;
	gint _tmp99_;
	gchar* _tmp100_;
	gchar* _tmp101_;
#line 807 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 807 "Utility/Device.vala"
	list = _tmp0_;
#line 809 "Utility/Device.vala"
	_tmp1_ = g_strdup ("/etc/mtab");
#line 809 "Utility/Device.vala"
	mtab_path = _tmp1_;
#line 810 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 810 "Utility/Device.vala"
	mtab_lines = _tmp2_;
#line 816 "Utility/Device.vala"
	_tmp3_ = g_strdup ("/proc/mounts");
#line 816 "Utility/Device.vala"
	_g_free0 (mtab_path);
#line 816 "Utility/Device.vala"
	mtab_path = _tmp3_;
#line 817 "Utility/Device.vala"
	_tmp4_ = mtab_path;
#line 817 "Utility/Device.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 817 "Utility/Device.vala"
	_g_object_unref0 (f);
#line 817 "Utility/Device.vala"
	f = _tmp5_;
#line 818 "Utility/Device.vala"
	_tmp6_ = f;
#line 818 "Utility/Device.vala"
	if (!g_file_query_exists (_tmp6_, NULL)) {
#line 5030 "Device.c"
		gchar* _tmp7_;
		const gchar* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
#line 819 "Utility/Device.vala"
		_tmp7_ = g_strdup ("/proc/self/mounts");
#line 819 "Utility/Device.vala"
		_g_free0 (mtab_path);
#line 819 "Utility/Device.vala"
		mtab_path = _tmp7_;
#line 820 "Utility/Device.vala"
		_tmp8_ = mtab_path;
#line 820 "Utility/Device.vala"
		_tmp9_ = g_file_new_for_path (_tmp8_);
#line 820 "Utility/Device.vala"
		_g_object_unref0 (f);
#line 820 "Utility/Device.vala"
		f = _tmp9_;
#line 821 "Utility/Device.vala"
		_tmp10_ = f;
#line 821 "Utility/Device.vala"
		if (!g_file_query_exists (_tmp10_, NULL)) {
#line 5053 "Device.c"
			gchar* _tmp11_;
			const gchar* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
#line 822 "Utility/Device.vala"
			_tmp11_ = g_strdup ("/etc/mtab");
#line 822 "Utility/Device.vala"
			_g_free0 (mtab_path);
#line 822 "Utility/Device.vala"
			mtab_path = _tmp11_;
#line 823 "Utility/Device.vala"
			_tmp12_ = mtab_path;
#line 823 "Utility/Device.vala"
			_tmp13_ = g_file_new_for_path (_tmp12_);
#line 823 "Utility/Device.vala"
			_g_object_unref0 (f);
#line 823 "Utility/Device.vala"
			f = _tmp13_;
#line 824 "Utility/Device.vala"
			_tmp14_ = f;
#line 824 "Utility/Device.vala"
			if (!g_file_query_exists (_tmp14_, NULL)) {
#line 825 "Utility/Device.vala"
				result = list;
#line 825 "Utility/Device.vala"
				_g_object_unref0 (f);
#line 825 "Utility/Device.vala"
				_g_free0 (mtab_lines);
#line 825 "Utility/Device.vala"
				_g_free0 (mtab_path);
#line 825 "Utility/Device.vala"
				return result;
#line 5086 "Device.c"
			}
		}
	}
#line 838 "Utility/Device.vala"
	_tmp15_ = mtab_path;
#line 838 "Utility/Device.vala"
	_tmp16_ = tee_jee_file_system_file_read (_tmp15_);
#line 838 "Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 838 "Utility/Device.vala"
	mtab_lines = _tmp16_;
#line 867 "Utility/Device.vala"
	_tmp17_ = mtab_lines;
#line 867 "Utility/Device.vala"
	_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "\n", 0);
#line 867 "Utility/Device.vala"
	lines = _tmp19_;
#line 867 "Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp18_);
#line 867 "Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 868 "Utility/Device.vala"
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 868 "Utility/Device.vala"
	mount_list = _tmp20_;
#line 5112 "Device.c"
	{
		gint i = 0;
		gchar** _tmp21_;
		gint _tmp21__length1;
#line 870 "Utility/Device.vala"
		_tmp21_ = lines;
#line 870 "Utility/Device.vala"
		_tmp21__length1 = lines_length1;
#line 870 "Utility/Device.vala"
		i = _tmp21__length1 - 1;
#line 5123 "Device.c"
		{
			gboolean _tmp22_ = FALSE;
#line 870 "Utility/Device.vala"
			_tmp22_ = TRUE;
#line 870 "Utility/Device.vala"
			while (TRUE) {
#line 5130 "Device.c"
				gchar* line = NULL;
				gchar** _tmp24_;
				gint _tmp24__length1;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				Device* pi = NULL;
				Device* _tmp30_;
				MountEntry* mp = NULL;
				Device* _tmp31_;
				MountEntry* _tmp32_;
				gint k = 0;
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gchar** _tmp35_;
				Device* _tmp67_;
				Device* _tmp68_;
				const gchar* _tmp69_;
				gchar* _tmp70_;
				Device* _tmp71_;
				Device* _tmp72_;
				const gchar* _tmp73_;
				gchar* _tmp74_;
				Device* _tmp75_;
				const gchar* _tmp76_;
				gint _tmp77_;
				gint _tmp78_;
#line 870 "Utility/Device.vala"
				if (!_tmp22_) {
#line 5162 "Device.c"
					gint _tmp23_;
#line 870 "Utility/Device.vala"
					_tmp23_ = i;
#line 870 "Utility/Device.vala"
					i = _tmp23_ - 1;
#line 5168 "Device.c"
				}
#line 870 "Utility/Device.vala"
				_tmp22_ = FALSE;
#line 870 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 870 "Utility/Device.vala"
					break;
#line 5176 "Device.c"
				}
#line 872 "Utility/Device.vala"
				_tmp24_ = lines;
#line 872 "Utility/Device.vala"
				_tmp24__length1 = lines_length1;
#line 872 "Utility/Device.vala"
				_tmp25_ = _tmp24_[i];
#line 872 "Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 872 "Utility/Device.vala"
				line = _tmp26_;
#line 873 "Utility/Device.vala"
				_tmp27_ = line;
#line 873 "Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 873 "Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 873 "Utility/Device.vala"
				if (_tmp29_ == 0) {
#line 873 "Utility/Device.vala"
					_g_free0 (line);
#line 873 "Utility/Device.vala"
					continue;
#line 5200 "Device.c"
				}
#line 875 "Utility/Device.vala"
				_tmp30_ = device_new ();
#line 875 "Utility/Device.vala"
				pi = _tmp30_;
#line 877 "Utility/Device.vala"
				_tmp31_ = pi;
#line 877 "Utility/Device.vala"
				_tmp32_ = mount_entry_new (_tmp31_, "", "");
#line 877 "Utility/Device.vala"
				mp = _tmp32_;
#line 881 "Utility/Device.vala"
				k = 1;
#line 882 "Utility/Device.vala"
				_tmp33_ = line;
#line 882 "Utility/Device.vala"
				_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, " ", 0);
#line 5218 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 882 "Utility/Device.vala"
					val_collection = _tmp35_;
#line 882 "Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp34_);
#line 882 "Utility/Device.vala"
					for (val_it = 0; val_it < _vala_array_length (_tmp34_); val_it = val_it + 1) {
#line 5230 "Device.c"
						gchar* _tmp36_;
						gchar* val = NULL;
#line 882 "Utility/Device.vala"
						_tmp36_ = g_strdup (val_collection[val_it]);
#line 882 "Utility/Device.vala"
						val = _tmp36_;
#line 5237 "Device.c"
						{
							const gchar* _tmp37_;
							gchar* _tmp38_;
							gchar* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							gboolean _tmp42_;
							gint _tmp43_;
#line 883 "Utility/Device.vala"
							_tmp37_ = val;
#line 883 "Utility/Device.vala"
							_tmp38_ = string_strip (_tmp37_);
#line 883 "Utility/Device.vala"
							_tmp39_ = _tmp38_;
#line 883 "Utility/Device.vala"
							_tmp40_ = strlen (_tmp39_);
#line 883 "Utility/Device.vala"
							_tmp41_ = _tmp40_;
#line 883 "Utility/Device.vala"
							_tmp42_ = _tmp41_ == 0;
#line 883 "Utility/Device.vala"
							_g_free0 (_tmp39_);
#line 883 "Utility/Device.vala"
							if (_tmp42_) {
#line 883 "Utility/Device.vala"
								_g_free0 (val);
#line 883 "Utility/Device.vala"
								continue;
#line 5266 "Device.c"
							}
#line 884 "Utility/Device.vala"
							_tmp43_ = k;
#line 884 "Utility/Device.vala"
							k = _tmp43_ + 1;
#line 884 "Utility/Device.vala"
							switch (_tmp43_) {
#line 884 "Utility/Device.vala"
								case 1:
#line 5276 "Device.c"
								{
									Device* _tmp44_;
									const gchar* _tmp45_;
									gchar* _tmp46_;
#line 886 "Utility/Device.vala"
									_tmp44_ = pi;
#line 886 "Utility/Device.vala"
									_tmp45_ = val;
#line 886 "Utility/Device.vala"
									_tmp46_ = string_strip (_tmp45_);
#line 886 "Utility/Device.vala"
									_g_free0 (_tmp44_->device);
#line 886 "Utility/Device.vala"
									_tmp44_->device = _tmp46_;
#line 887 "Utility/Device.vala"
									break;
#line 5293 "Device.c"
								}
#line 884 "Utility/Device.vala"
								case 2:
#line 5297 "Device.c"
								{
									MountEntry* _tmp47_;
									const gchar* _tmp48_;
									gchar* _tmp49_;
									gchar* _tmp50_;
									gchar* _tmp51_;
									GeeArrayList* _tmp52_;
									MountEntry* _tmp53_;
									const gchar* _tmp54_;
#line 889 "Utility/Device.vala"
									_tmp47_ = mp;
#line 889 "Utility/Device.vala"
									_tmp48_ = val;
#line 889 "Utility/Device.vala"
									_tmp49_ = string_strip (_tmp48_);
#line 889 "Utility/Device.vala"
									_tmp50_ = _tmp49_;
#line 889 "Utility/Device.vala"
									_tmp51_ = string_replace (_tmp50_, "\\040", " ");
#line 889 "Utility/Device.vala"
									_g_free0 (_tmp47_->mount_point);
#line 889 "Utility/Device.vala"
									_tmp47_->mount_point = _tmp51_;
#line 889 "Utility/Device.vala"
									_g_free0 (_tmp50_);
#line 890 "Utility/Device.vala"
									_tmp52_ = mount_list;
#line 890 "Utility/Device.vala"
									_tmp53_ = mp;
#line 890 "Utility/Device.vala"
									_tmp54_ = _tmp53_->mount_point;
#line 890 "Utility/Device.vala"
									if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp52_, _tmp54_)) {
#line 5331 "Device.c"
										GeeArrayList* _tmp55_;
										MountEntry* _tmp56_;
										const gchar* _tmp57_;
										Device* _tmp58_;
										GeeArrayList* _tmp59_;
										MountEntry* _tmp60_;
#line 891 "Utility/Device.vala"
										_tmp55_ = mount_list;
#line 891 "Utility/Device.vala"
										_tmp56_ = mp;
#line 891 "Utility/Device.vala"
										_tmp57_ = _tmp56_->mount_point;
#line 891 "Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp55_, _tmp57_);
#line 892 "Utility/Device.vala"
										_tmp58_ = pi;
#line 892 "Utility/Device.vala"
										_tmp59_ = _tmp58_->mount_points;
#line 892 "Utility/Device.vala"
										_tmp60_ = mp;
#line 892 "Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp59_, _tmp60_);
#line 5354 "Device.c"
									}
#line 894 "Utility/Device.vala"
									break;
#line 5358 "Device.c"
								}
#line 884 "Utility/Device.vala"
								case 3:
#line 5362 "Device.c"
								{
									Device* _tmp61_;
									const gchar* _tmp62_;
									gchar* _tmp63_;
#line 896 "Utility/Device.vala"
									_tmp61_ = pi;
#line 896 "Utility/Device.vala"
									_tmp62_ = val;
#line 896 "Utility/Device.vala"
									_tmp63_ = string_strip (_tmp62_);
#line 896 "Utility/Device.vala"
									_g_free0 (_tmp61_->fstype);
#line 896 "Utility/Device.vala"
									_tmp61_->fstype = _tmp63_;
#line 897 "Utility/Device.vala"
									break;
#line 5379 "Device.c"
								}
#line 884 "Utility/Device.vala"
								case 4:
#line 5383 "Device.c"
								{
									MountEntry* _tmp64_;
									const gchar* _tmp65_;
									gchar* _tmp66_;
#line 899 "Utility/Device.vala"
									_tmp64_ = mp;
#line 899 "Utility/Device.vala"
									_tmp65_ = val;
#line 899 "Utility/Device.vala"
									_tmp66_ = string_strip (_tmp65_);
#line 899 "Utility/Device.vala"
									_g_free0 (_tmp64_->mount_options);
#line 899 "Utility/Device.vala"
									_tmp64_->mount_options = _tmp66_;
#line 900 "Utility/Device.vala"
									break;
#line 5400 "Device.c"
								}
								default:
								{
#line 903 "Utility/Device.vala"
									break;
#line 5406 "Device.c"
								}
							}
#line 882 "Utility/Device.vala"
							_g_free0 (val);
#line 5411 "Device.c"
						}
					}
#line 882 "Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5416 "Device.c"
				}
#line 909 "Utility/Device.vala"
				_tmp67_ = pi;
#line 909 "Utility/Device.vala"
				_tmp68_ = pi;
#line 909 "Utility/Device.vala"
				_tmp69_ = _tmp68_->device;
#line 909 "Utility/Device.vala"
				_tmp70_ = device_resolve_device_name (_tmp69_);
#line 909 "Utility/Device.vala"
				_g_free0 (_tmp67_->device);
#line 909 "Utility/Device.vala"
				_tmp67_->device = _tmp70_;
#line 913 "Utility/Device.vala"
				_tmp71_ = pi;
#line 913 "Utility/Device.vala"
				_tmp72_ = pi;
#line 913 "Utility/Device.vala"
				_tmp73_ = _tmp72_->device;
#line 913 "Utility/Device.vala"
				_tmp74_ = device_get_device_uuid (_tmp73_);
#line 913 "Utility/Device.vala"
				_g_free0 (_tmp71_->uuid);
#line 913 "Utility/Device.vala"
				_tmp71_->uuid = _tmp74_;
#line 917 "Utility/Device.vala"
				_tmp75_ = pi;
#line 917 "Utility/Device.vala"
				_tmp76_ = _tmp75_->uuid;
#line 917 "Utility/Device.vala"
				_tmp77_ = strlen (_tmp76_);
#line 917 "Utility/Device.vala"
				_tmp78_ = _tmp77_;
#line 917 "Utility/Device.vala"
				if (_tmp78_ > 0) {
#line 5452 "Device.c"
					Device* dev = NULL;
					GeeArrayList* _tmp79_;
					Device* _tmp80_;
					const gchar* _tmp81_;
					Device* _tmp82_;
					Device* _tmp83_;
#line 918 "Utility/Device.vala"
					_tmp79_ = list;
#line 918 "Utility/Device.vala"
					_tmp80_ = pi;
#line 918 "Utility/Device.vala"
					_tmp81_ = _tmp80_->uuid;
#line 918 "Utility/Device.vala"
					_tmp82_ = device_find_device_in_list (_tmp79_, _tmp81_);
#line 918 "Utility/Device.vala"
					dev = _tmp82_;
#line 919 "Utility/Device.vala"
					_tmp83_ = dev;
#line 919 "Utility/Device.vala"
					if (_tmp83_ == NULL) {
#line 5473 "Device.c"
						GeeArrayList* _tmp84_;
						Device* _tmp85_;
#line 920 "Utility/Device.vala"
						_tmp84_ = list;
#line 920 "Utility/Device.vala"
						_tmp85_ = pi;
#line 920 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp84_, _tmp85_);
#line 5482 "Device.c"
					} else {
						{
							GeeArrayList* _item_list = NULL;
							Device* _tmp86_;
							GeeArrayList* _tmp87_;
							GeeArrayList* _tmp88_;
							gint _item_size = 0;
							GeeArrayList* _tmp89_;
							gint _tmp90_;
							gint _tmp91_;
							gint _item_index = 0;
#line 924 "Utility/Device.vala"
							_tmp86_ = pi;
#line 924 "Utility/Device.vala"
							_tmp87_ = _tmp86_->mount_points;
#line 924 "Utility/Device.vala"
							_tmp88_ = _g_object_ref0 (_tmp87_);
#line 924 "Utility/Device.vala"
							_item_list = _tmp88_;
#line 924 "Utility/Device.vala"
							_tmp89_ = _item_list;
#line 924 "Utility/Device.vala"
							_tmp90_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp89_);
#line 924 "Utility/Device.vala"
							_tmp91_ = _tmp90_;
#line 924 "Utility/Device.vala"
							_item_size = _tmp91_;
#line 924 "Utility/Device.vala"
							_item_index = -1;
#line 924 "Utility/Device.vala"
							while (TRUE) {
#line 5514 "Device.c"
								MountEntry* item = NULL;
								GeeArrayList* _tmp92_;
								gpointer _tmp93_;
								Device* _tmp94_;
								GeeArrayList* _tmp95_;
								MountEntry* _tmp96_;
#line 924 "Utility/Device.vala"
								_item_index = _item_index + 1;
#line 924 "Utility/Device.vala"
								if (!(_item_index < _item_size)) {
#line 924 "Utility/Device.vala"
									break;
#line 5527 "Device.c"
								}
#line 924 "Utility/Device.vala"
								_tmp92_ = _item_list;
#line 924 "Utility/Device.vala"
								_tmp93_ = gee_abstract_list_get ((GeeAbstractList*) _tmp92_, _item_index);
#line 924 "Utility/Device.vala"
								item = (MountEntry*) _tmp93_;
#line 925 "Utility/Device.vala"
								_tmp94_ = dev;
#line 925 "Utility/Device.vala"
								_tmp95_ = _tmp94_->mount_points;
#line 925 "Utility/Device.vala"
								_tmp96_ = item;
#line 925 "Utility/Device.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp95_, _tmp96_);
#line 924 "Utility/Device.vala"
								_g_object_unref0 (item);
#line 5545 "Device.c"
							}
#line 924 "Utility/Device.vala"
							_g_object_unref0 (_item_list);
#line 5549 "Device.c"
						}
					}
#line 917 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 5554 "Device.c"
				}
#line 870 "Utility/Device.vala"
				_g_object_unref0 (mp);
#line 870 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 870 "Utility/Device.vala"
				_g_free0 (line);
#line 5562 "Device.c"
			}
		}
	}
#line 931 "Utility/Device.vala"
	_tmp97_ = list;
#line 931 "Utility/Device.vala"
	_tmp98_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp97_);
#line 931 "Utility/Device.vala"
	_tmp99_ = _tmp98_;
#line 931 "Utility/Device.vala"
	_tmp100_ = g_strdup_printf ("Device: get_mounted_filesystems_using_mtab(): %d", _tmp99_);
#line 931 "Utility/Device.vala"
	_tmp101_ = _tmp100_;
#line 931 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp101_);
#line 931 "Utility/Device.vala"
	_g_free0 (_tmp101_);
#line 933 "Utility/Device.vala"
	result = list;
#line 933 "Utility/Device.vala"
	_g_object_unref0 (mount_list);
#line 933 "Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 933 "Utility/Device.vala"
	_g_object_unref0 (f);
#line 933 "Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 933 "Utility/Device.vala"
	_g_free0 (mtab_path);
#line 933 "Utility/Device.vala"
	return result;
#line 5594 "Device.c"
}

Device*
device_get_device_by_uuid (const gchar* uuid)
{
	Device* result = NULL;
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
#line 938 "Utility/Device.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 940 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 940 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, uuid);
#line 940 "Utility/Device.vala"
	result = _tmp1_;
#line 940 "Utility/Device.vala"
	return result;
#line 5613 "Device.c"
}

Device*
device_get_device_by_name (const gchar* file_name)
{
	Device* result = NULL;
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
#line 943 "Utility/Device.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 945 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 945 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, file_name);
#line 945 "Utility/Device.vala"
	result = _tmp1_;
#line 945 "Utility/Device.vala"
	return result;
#line 5632 "Device.c"
}

Device*
device_get_device_by_path (const gchar* path_to_check)
{
	Device* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 948 "Utility/Device.vala"
	g_return_val_if_fail (path_to_check != NULL, NULL);
#line 950 "Utility/Device.vala"
	_tmp0_ = device_get_disk_space_using_df (path_to_check);
#line 950 "Utility/Device.vala"
	list = _tmp0_;
#line 952 "Utility/Device.vala"
	_tmp1_ = list;
#line 952 "Utility/Device.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 952 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 952 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 5658 "Device.c"
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
#line 953 "Utility/Device.vala"
		_tmp4_ = list;
#line 953 "Utility/Device.vala"
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, 0);
#line 953 "Utility/Device.vala"
		result = (Device*) _tmp5_;
#line 953 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 953 "Utility/Device.vala"
		return result;
#line 5671 "Device.c"
	}
#line 956 "Utility/Device.vala"
	result = NULL;
#line 956 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 956 "Utility/Device.vala"
	return result;
#line 5679 "Device.c"
}

gchar*
device_get_device_uuid (const gchar* device)
{
	gchar* result = NULL;
	GeeArrayList* _tmp0_;
	gchar* _tmp14_;
#line 959 "Utility/Device.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 961 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 961 "Utility/Device.vala"
	if (_tmp0_ == NULL) {
#line 5694 "Device.c"
		GeeArrayList* _tmp1_;
#line 962 "Utility/Device.vala"
		_tmp1_ = device_get_block_devices_using_lsblk ("");
#line 962 "Utility/Device.vala"
		_g_object_unref0 (device_device_list);
#line 962 "Utility/Device.vala"
		device_device_list = _tmp1_;
#line 5702 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 964 "Utility/Device.vala"
		_tmp2_ = device_device_list;
#line 964 "Utility/Device.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 964 "Utility/Device.vala"
		_dev_list = _tmp3_;
#line 964 "Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 964 "Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 964 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 964 "Utility/Device.vala"
		_dev_size = _tmp6_;
#line 964 "Utility/Device.vala"
		_dev_index = -1;
#line 964 "Utility/Device.vala"
		while (TRUE) {
#line 5731 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			Device* _tmp9_;
			const gchar* _tmp10_;
#line 964 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 964 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 964 "Utility/Device.vala"
				break;
#line 5743 "Device.c"
			}
#line 964 "Utility/Device.vala"
			_tmp7_ = _dev_list;
#line 964 "Utility/Device.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_index);
#line 964 "Utility/Device.vala"
			dev = (Device*) _tmp8_;
#line 965 "Utility/Device.vala"
			_tmp9_ = dev;
#line 965 "Utility/Device.vala"
			_tmp10_ = _tmp9_->device;
#line 965 "Utility/Device.vala"
			if (g_strcmp0 (_tmp10_, device) == 0) {
#line 5757 "Device.c"
				Device* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 966 "Utility/Device.vala"
				_tmp11_ = dev;
#line 966 "Utility/Device.vala"
				_tmp12_ = _tmp11_->uuid;
#line 966 "Utility/Device.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 966 "Utility/Device.vala"
				result = _tmp13_;
#line 966 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 966 "Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 966 "Utility/Device.vala"
				return result;
#line 5775 "Device.c"
			}
#line 964 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 5779 "Device.c"
		}
#line 964 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 5783 "Device.c"
	}
#line 970 "Utility/Device.vala"
	_tmp14_ = g_strdup ("");
#line 970 "Utility/Device.vala"
	result = _tmp14_;
#line 970 "Utility/Device.vala"
	return result;
#line 5791 "Device.c"
}

GeeArrayList*
device_get_device_mount_points (const gchar* dev_name_or_uuid)
{
	GeeArrayList* result = NULL;
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	GeeArrayList* list_mtab = NULL;
	GeeArrayList* _tmp9_;
	Device* dev = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	Device* _tmp12_;
	Device* _tmp13_;
#line 973 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 974 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 974 "Utility/Device.vala"
	device = _tmp0_;
#line 975 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 975 "Utility/Device.vala"
	uuid = _tmp1_;
#line 977 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 5821 "Device.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 978 "Utility/Device.vala"
		_tmp2_ = g_strdup (dev_name_or_uuid);
#line 978 "Utility/Device.vala"
		_g_free0 (device);
#line 978 "Utility/Device.vala"
		device = _tmp2_;
#line 979 "Utility/Device.vala"
		_tmp3_ = device_get_device_uuid (dev_name_or_uuid);
#line 979 "Utility/Device.vala"
		_g_free0 (uuid);
#line 979 "Utility/Device.vala"
		uuid = _tmp3_;
#line 5836 "Device.c"
	} else {
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 982 "Utility/Device.vala"
		_tmp4_ = g_strdup (dev_name_or_uuid);
#line 982 "Utility/Device.vala"
		_g_free0 (uuid);
#line 982 "Utility/Device.vala"
		uuid = _tmp4_;
#line 983 "Utility/Device.vala"
		_tmp5_ = uuid;
#line 983 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp5_);
#line 983 "Utility/Device.vala"
		_g_free0 (device);
#line 983 "Utility/Device.vala"
		device = _tmp6_;
#line 984 "Utility/Device.vala"
		_tmp7_ = device;
#line 984 "Utility/Device.vala"
		_tmp8_ = device_resolve_device_name (_tmp7_);
#line 984 "Utility/Device.vala"
		_g_free0 (device);
#line 984 "Utility/Device.vala"
		device = _tmp8_;
#line 5865 "Device.c"
	}
#line 987 "Utility/Device.vala"
	_tmp9_ = device_get_mounted_filesystems_using_mtab ();
#line 987 "Utility/Device.vala"
	list_mtab = _tmp9_;
#line 989 "Utility/Device.vala"
	_tmp10_ = list_mtab;
#line 989 "Utility/Device.vala"
	_tmp11_ = uuid;
#line 989 "Utility/Device.vala"
	_tmp12_ = device_find_device_in_list (_tmp10_, _tmp11_);
#line 989 "Utility/Device.vala"
	dev = _tmp12_;
#line 991 "Utility/Device.vala"
	_tmp13_ = dev;
#line 991 "Utility/Device.vala"
	if (_tmp13_ != NULL) {
#line 5883 "Device.c"
		Device* _tmp14_;
		GeeArrayList* _tmp15_;
		GeeArrayList* _tmp16_;
#line 992 "Utility/Device.vala"
		_tmp14_ = dev;
#line 992 "Utility/Device.vala"
		_tmp15_ = _tmp14_->mount_points;
#line 992 "Utility/Device.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 992 "Utility/Device.vala"
		result = _tmp16_;
#line 992 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 992 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 992 "Utility/Device.vala"
		_g_free0 (uuid);
#line 992 "Utility/Device.vala"
		_g_free0 (device);
#line 992 "Utility/Device.vala"
		return result;
#line 5905 "Device.c"
	} else {
		GeeArrayList* _tmp17_;
#line 995 "Utility/Device.vala"
		_tmp17_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 995 "Utility/Device.vala"
		result = _tmp17_;
#line 995 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 995 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 995 "Utility/Device.vala"
		_g_free0 (uuid);
#line 995 "Utility/Device.vala"
		_g_free0 (device);
#line 995 "Utility/Device.vala"
		return result;
#line 5922 "Device.c"
	}
#line 973 "Utility/Device.vala"
	_g_object_unref0 (dev);
#line 973 "Utility/Device.vala"
	_g_object_unref0 (list_mtab);
#line 973 "Utility/Device.vala"
	_g_free0 (uuid);
#line 973 "Utility/Device.vala"
	_g_free0 (device);
#line 5932 "Device.c"
}

gboolean
device_device_is_mounted (const gchar* dev_name_or_uuid)
{
	gboolean result = FALSE;
	GeeArrayList* mps = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 999 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1001 "Utility/Device.vala"
	_tmp0_ = device_get_device_mount_points (dev_name_or_uuid);
#line 1001 "Utility/Device.vala"
	mps = _tmp0_;
#line 1002 "Utility/Device.vala"
	_tmp1_ = mps;
#line 1002 "Utility/Device.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1002 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1002 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 1003 "Utility/Device.vala"
		result = TRUE;
#line 1003 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1003 "Utility/Device.vala"
		return result;
#line 5964 "Device.c"
	}
#line 1006 "Utility/Device.vala"
	result = FALSE;
#line 1006 "Utility/Device.vala"
	_g_object_unref0 (mps);
#line 1006 "Utility/Device.vala"
	return result;
#line 5972 "Device.c"
}

gboolean
device_mount_point_in_use (const gchar* mount_point)
{
	gboolean result = FALSE;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
#line 1009 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1010 "Utility/Device.vala"
	_tmp0_ = device_get_mounted_filesystems_using_mtab ();
#line 1010 "Utility/Device.vala"
	list = _tmp0_;
#line 5987 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
#line 1011 "Utility/Device.vala"
		_tmp1_ = list;
#line 1011 "Utility/Device.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1011 "Utility/Device.vala"
		_dev_list = _tmp2_;
#line 1011 "Utility/Device.vala"
		_tmp3_ = _dev_list;
#line 1011 "Utility/Device.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1011 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1011 "Utility/Device.vala"
		_dev_size = _tmp5_;
#line 1011 "Utility/Device.vala"
		_dev_index = -1;
#line 1011 "Utility/Device.vala"
		while (TRUE) {
#line 6015 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
#line 1011 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1011 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 1011 "Utility/Device.vala"
				break;
#line 6025 "Device.c"
			}
#line 1011 "Utility/Device.vala"
			_tmp6_ = _dev_list;
#line 1011 "Utility/Device.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
#line 1011 "Utility/Device.vala"
			dev = (Device*) _tmp7_;
#line 6033 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp8_;
				GeeArrayList* _tmp9_;
				GeeArrayList* _tmp10_;
				gint _mp_size = 0;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _mp_index = 0;
#line 1012 "Utility/Device.vala"
				_tmp8_ = dev;
#line 1012 "Utility/Device.vala"
				_tmp9_ = _tmp8_->mount_points;
#line 1012 "Utility/Device.vala"
				_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1012 "Utility/Device.vala"
				_mp_list = _tmp10_;
#line 1012 "Utility/Device.vala"
				_tmp11_ = _mp_list;
#line 1012 "Utility/Device.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 1012 "Utility/Device.vala"
				_tmp13_ = _tmp12_;
#line 1012 "Utility/Device.vala"
				_mp_size = _tmp13_;
#line 1012 "Utility/Device.vala"
				_mp_index = -1;
#line 1012 "Utility/Device.vala"
				while (TRUE) {
#line 6064 "Device.c"
					MountEntry* mp = NULL;
					GeeArrayList* _tmp14_;
					gpointer _tmp15_;
					MountEntry* _tmp16_;
					const gchar* _tmp17_;
#line 1012 "Utility/Device.vala"
					_mp_index = _mp_index + 1;
#line 1012 "Utility/Device.vala"
					if (!(_mp_index < _mp_size)) {
#line 1012 "Utility/Device.vala"
						break;
#line 6076 "Device.c"
					}
#line 1012 "Utility/Device.vala"
					_tmp14_ = _mp_list;
#line 1012 "Utility/Device.vala"
					_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _mp_index);
#line 1012 "Utility/Device.vala"
					mp = (MountEntry*) _tmp15_;
#line 1013 "Utility/Device.vala"
					_tmp16_ = mp;
#line 1013 "Utility/Device.vala"
					_tmp17_ = _tmp16_->mount_point;
#line 1013 "Utility/Device.vala"
					if (g_str_has_prefix (_tmp17_, mount_point)) {
#line 1015 "Utility/Device.vala"
						result = TRUE;
#line 1015 "Utility/Device.vala"
						_g_object_unref0 (mp);
#line 1015 "Utility/Device.vala"
						_g_object_unref0 (_mp_list);
#line 1015 "Utility/Device.vala"
						_g_object_unref0 (dev);
#line 1015 "Utility/Device.vala"
						_g_object_unref0 (_dev_list);
#line 1015 "Utility/Device.vala"
						_g_object_unref0 (list);
#line 1015 "Utility/Device.vala"
						return result;
#line 6104 "Device.c"
					}
#line 1012 "Utility/Device.vala"
					_g_object_unref0 (mp);
#line 6108 "Device.c"
				}
#line 1012 "Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 6112 "Device.c"
			}
#line 1011 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 6116 "Device.c"
		}
#line 1011 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 6120 "Device.c"
	}
#line 1019 "Utility/Device.vala"
	result = FALSE;
#line 1019 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1019 "Utility/Device.vala"
	return result;
#line 6128 "Device.c"
}

gchar*
device_resolve_device_name (const gchar* dev_alias)
{
	gchar* result = NULL;
	Device* dev = NULL;
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
	Device* _tmp2_;
#line 1022 "Utility/Device.vala"
	g_return_val_if_fail (dev_alias != NULL, NULL);
#line 1024 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1024 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, dev_alias);
#line 1024 "Utility/Device.vala"
	dev = _tmp1_;
#line 1026 "Utility/Device.vala"
	_tmp2_ = dev;
#line 1026 "Utility/Device.vala"
	if (_tmp2_ != NULL) {
#line 6151 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 1027 "Utility/Device.vala"
		_tmp3_ = dev;
#line 1027 "Utility/Device.vala"
		_tmp4_ = _tmp3_->device;
#line 1027 "Utility/Device.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 1027 "Utility/Device.vala"
		result = _tmp5_;
#line 1027 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1027 "Utility/Device.vala"
		return result;
#line 6167 "Device.c"
	} else {
		gchar* _tmp6_;
#line 1030 "Utility/Device.vala"
		_tmp6_ = g_strdup (dev_alias);
#line 1030 "Utility/Device.vala"
		result = _tmp6_;
#line 1030 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1030 "Utility/Device.vala"
		return result;
#line 6178 "Device.c"
	}
#line 1022 "Utility/Device.vala"
	_g_object_unref0 (dev);
#line 6182 "Device.c"
}

Device*
device_find_device_in_list (GeeArrayList* list,
                            const gchar* _dev_alias)
{
	Device* result = NULL;
	gchar* dev_alias = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 1034 "Utility/Device.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 1034 "Utility/Device.vala"
	g_return_val_if_fail (_dev_alias != NULL, NULL);
#line 1036 "Utility/Device.vala"
	_tmp0_ = g_strdup (_dev_alias);
#line 1036 "Utility/Device.vala"
	dev_alias = _tmp0_;
#line 1038 "Utility/Device.vala"
	_tmp1_ = dev_alias;
#line 1038 "Utility/Device.vala"
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) -1);
#line 1038 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1038 "Utility/Device.vala"
	_tmp4_ = g_str_has_prefix (_tmp3_, "uuid=");
#line 1038 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1038 "Utility/Device.vala"
	if (_tmp4_) {
#line 6216 "Device.c"
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 1040 "Utility/Device.vala"
		_tmp5_ = dev_alias;
#line 1040 "Utility/Device.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "=", 2);
#line 1040 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1040 "Utility/Device.vala"
		_tmp8__length1 = _vala_array_length (_tmp6_);
#line 1040 "Utility/Device.vala"
		_tmp9_ = _tmp8_[1];
#line 1040 "Utility/Device.vala"
		_tmp10_ = string_strip (_tmp9_);
#line 1040 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1040 "Utility/Device.vala"
		_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 1040 "Utility/Device.vala"
		_g_free0 (dev_alias);
#line 1040 "Utility/Device.vala"
		dev_alias = _tmp12_;
#line 1040 "Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1040 "Utility/Device.vala"
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 6250 "Device.c"
	} else {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 1042 "Utility/Device.vala"
		_tmp14_ = dev_alias;
#line 1042 "Utility/Device.vala"
		if (tee_jee_file_system_file_exists (_tmp14_)) {
#line 6258 "Device.c"
			const gchar* _tmp15_;
#line 1042 "Utility/Device.vala"
			_tmp15_ = dev_alias;
#line 1042 "Utility/Device.vala"
			_tmp13_ = tee_jee_file_system_file_is_symlink (_tmp15_);
#line 6264 "Device.c"
		} else {
#line 1042 "Utility/Device.vala"
			_tmp13_ = FALSE;
#line 6268 "Device.c"
		}
#line 1042 "Utility/Device.vala"
		if (_tmp13_) {
#line 6272 "Device.c"
			gchar* link_path = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 1044 "Utility/Device.vala"
			_tmp16_ = dev_alias;
#line 1044 "Utility/Device.vala"
			_tmp17_ = tee_jee_file_system_file_get_symlink_target (_tmp16_);
#line 1044 "Utility/Device.vala"
			link_path = _tmp17_;
#line 1046 "Utility/Device.vala"
			_tmp18_ = link_path;
#line 1046 "Utility/Device.vala"
			_tmp19_ = string_replace (_tmp18_, "../../../", "/dev/");
#line 1046 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1046 "Utility/Device.vala"
			_tmp21_ = string_replace (_tmp20_, "../../", "/dev/");
#line 1046 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1046 "Utility/Device.vala"
			_tmp23_ = string_replace (_tmp22_, "../", "/dev/");
#line 1046 "Utility/Device.vala"
			_g_free0 (dev_alias);
#line 1046 "Utility/Device.vala"
			dev_alias = _tmp23_;
#line 1046 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 1046 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1042 "Utility/Device.vala"
			_g_free0 (link_path);
#line 6310 "Device.c"
		}
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp24_;
		gint _dev_size = 0;
		GeeArrayList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _dev_index = 0;
#line 1049 "Utility/Device.vala"
		_tmp24_ = _g_object_ref0 (list);
#line 1049 "Utility/Device.vala"
		_dev_list = _tmp24_;
#line 1049 "Utility/Device.vala"
		_tmp25_ = _dev_list;
#line 1049 "Utility/Device.vala"
		_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 1049 "Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1049 "Utility/Device.vala"
		_dev_size = _tmp27_;
#line 1049 "Utility/Device.vala"
		_dev_index = -1;
#line 1049 "Utility/Device.vala"
		while (TRUE) {
#line 6337 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp28_;
			gpointer _tmp29_;
			Device* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
#line 1049 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1049 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 1049 "Utility/Device.vala"
				break;
#line 6350 "Device.c"
			}
#line 1049 "Utility/Device.vala"
			_tmp28_ = _dev_list;
#line 1049 "Utility/Device.vala"
			_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, _dev_index);
#line 1049 "Utility/Device.vala"
			dev = (Device*) _tmp29_;
#line 1051 "Utility/Device.vala"
			_tmp30_ = dev;
#line 1051 "Utility/Device.vala"
			_tmp31_ = _tmp30_->device;
#line 1051 "Utility/Device.vala"
			_tmp32_ = dev_alias;
#line 1051 "Utility/Device.vala"
			if (g_strcmp0 (_tmp31_, _tmp32_) == 0) {
#line 1052 "Utility/Device.vala"
				result = dev;
#line 1052 "Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 1052 "Utility/Device.vala"
				_g_free0 (dev_alias);
#line 1052 "Utility/Device.vala"
				return result;
#line 6374 "Device.c"
			} else {
				Device* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
#line 1054 "Utility/Device.vala"
				_tmp33_ = dev;
#line 1054 "Utility/Device.vala"
				_tmp34_ = _tmp33_->uuid;
#line 1054 "Utility/Device.vala"
				_tmp35_ = dev_alias;
#line 1054 "Utility/Device.vala"
				if (g_strcmp0 (_tmp34_, _tmp35_) == 0) {
#line 1055 "Utility/Device.vala"
					result = dev;
#line 1055 "Utility/Device.vala"
					_g_object_unref0 (_dev_list);
#line 1055 "Utility/Device.vala"
					_g_free0 (dev_alias);
#line 1055 "Utility/Device.vala"
					return result;
#line 6395 "Device.c"
				} else {
					Device* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
#line 1057 "Utility/Device.vala"
					_tmp36_ = dev;
#line 1057 "Utility/Device.vala"
					_tmp37_ = _tmp36_->label;
#line 1057 "Utility/Device.vala"
					_tmp38_ = dev_alias;
#line 1057 "Utility/Device.vala"
					if (g_strcmp0 (_tmp37_, _tmp38_) == 0) {
#line 1058 "Utility/Device.vala"
						result = dev;
#line 1058 "Utility/Device.vala"
						_g_object_unref0 (_dev_list);
#line 1058 "Utility/Device.vala"
						_g_free0 (dev_alias);
#line 1058 "Utility/Device.vala"
						return result;
#line 6416 "Device.c"
					} else {
						Device* _tmp39_;
						const gchar* _tmp40_;
						const gchar* _tmp41_;
#line 1060 "Utility/Device.vala"
						_tmp39_ = dev;
#line 1060 "Utility/Device.vala"
						_tmp40_ = _tmp39_->partuuid;
#line 1060 "Utility/Device.vala"
						_tmp41_ = dev_alias;
#line 1060 "Utility/Device.vala"
						if (g_strcmp0 (_tmp40_, _tmp41_) == 0) {
#line 1061 "Utility/Device.vala"
							result = dev;
#line 1061 "Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 1061 "Utility/Device.vala"
							_g_free0 (dev_alias);
#line 1061 "Utility/Device.vala"
							return result;
#line 6437 "Device.c"
						} else {
							Device* _tmp42_;
							const gchar* _tmp43_;
							const gchar* _tmp44_;
#line 1063 "Utility/Device.vala"
							_tmp42_ = dev;
#line 1063 "Utility/Device.vala"
							_tmp43_ = _tmp42_->partlabel;
#line 1063 "Utility/Device.vala"
							_tmp44_ = dev_alias;
#line 1063 "Utility/Device.vala"
							if (g_strcmp0 (_tmp43_, _tmp44_) == 0) {
#line 1064 "Utility/Device.vala"
								result = dev;
#line 1064 "Utility/Device.vala"
								_g_object_unref0 (_dev_list);
#line 1064 "Utility/Device.vala"
								_g_free0 (dev_alias);
#line 1064 "Utility/Device.vala"
								return result;
#line 6458 "Device.c"
							} else {
								Device* _tmp45_;
								const gchar* _tmp46_;
								const gchar* _tmp47_;
#line 1066 "Utility/Device.vala"
								_tmp45_ = dev;
#line 1066 "Utility/Device.vala"
								_tmp46_ = _tmp45_->device_by_uuid;
#line 1066 "Utility/Device.vala"
								_tmp47_ = dev_alias;
#line 1066 "Utility/Device.vala"
								if (g_strcmp0 (_tmp46_, _tmp47_) == 0) {
#line 1067 "Utility/Device.vala"
									result = dev;
#line 1067 "Utility/Device.vala"
									_g_object_unref0 (_dev_list);
#line 1067 "Utility/Device.vala"
									_g_free0 (dev_alias);
#line 1067 "Utility/Device.vala"
									return result;
#line 6479 "Device.c"
								} else {
									Device* _tmp48_;
									const gchar* _tmp49_;
									const gchar* _tmp50_;
#line 1069 "Utility/Device.vala"
									_tmp48_ = dev;
#line 1069 "Utility/Device.vala"
									_tmp49_ = _tmp48_->device_by_label;
#line 1069 "Utility/Device.vala"
									_tmp50_ = dev_alias;
#line 1069 "Utility/Device.vala"
									if (g_strcmp0 (_tmp49_, _tmp50_) == 0) {
#line 1070 "Utility/Device.vala"
										result = dev;
#line 1070 "Utility/Device.vala"
										_g_object_unref0 (_dev_list);
#line 1070 "Utility/Device.vala"
										_g_free0 (dev_alias);
#line 1070 "Utility/Device.vala"
										return result;
#line 6500 "Device.c"
									} else {
										Device* _tmp51_;
										const gchar* _tmp52_;
										const gchar* _tmp53_;
#line 1072 "Utility/Device.vala"
										_tmp51_ = dev;
#line 1072 "Utility/Device.vala"
										_tmp52_ = _tmp51_->device_by_partuuid;
#line 1072 "Utility/Device.vala"
										_tmp53_ = dev_alias;
#line 1072 "Utility/Device.vala"
										if (g_strcmp0 (_tmp52_, _tmp53_) == 0) {
#line 1073 "Utility/Device.vala"
											result = dev;
#line 1073 "Utility/Device.vala"
											_g_object_unref0 (_dev_list);
#line 1073 "Utility/Device.vala"
											_g_free0 (dev_alias);
#line 1073 "Utility/Device.vala"
											return result;
#line 6521 "Device.c"
										} else {
											Device* _tmp54_;
											const gchar* _tmp55_;
											const gchar* _tmp56_;
#line 1075 "Utility/Device.vala"
											_tmp54_ = dev;
#line 1075 "Utility/Device.vala"
											_tmp55_ = _tmp54_->device_by_partlabel;
#line 1075 "Utility/Device.vala"
											_tmp56_ = dev_alias;
#line 1075 "Utility/Device.vala"
											if (g_strcmp0 (_tmp55_, _tmp56_) == 0) {
#line 1076 "Utility/Device.vala"
												result = dev;
#line 1076 "Utility/Device.vala"
												_g_object_unref0 (_dev_list);
#line 1076 "Utility/Device.vala"
												_g_free0 (dev_alias);
#line 1076 "Utility/Device.vala"
												return result;
#line 6542 "Device.c"
											} else {
												Device* _tmp57_;
												const gchar* _tmp58_;
												const gchar* _tmp59_;
#line 1078 "Utility/Device.vala"
												_tmp57_ = dev;
#line 1078 "Utility/Device.vala"
												_tmp58_ = _tmp57_->device_mapper;
#line 1078 "Utility/Device.vala"
												_tmp59_ = dev_alias;
#line 1078 "Utility/Device.vala"
												if (g_strcmp0 (_tmp58_, _tmp59_) == 0) {
#line 1079 "Utility/Device.vala"
													result = dev;
#line 1079 "Utility/Device.vala"
													_g_object_unref0 (_dev_list);
#line 1079 "Utility/Device.vala"
													_g_free0 (dev_alias);
#line 1079 "Utility/Device.vala"
													return result;
#line 6563 "Device.c"
												} else {
													Device* _tmp60_;
													const gchar* _tmp61_;
													const gchar* _tmp62_;
#line 1081 "Utility/Device.vala"
													_tmp60_ = dev;
#line 1081 "Utility/Device.vala"
													_tmp61_ = _tmp60_->mapped_name;
#line 1081 "Utility/Device.vala"
													_tmp62_ = dev_alias;
#line 1081 "Utility/Device.vala"
													if (g_strcmp0 (_tmp61_, _tmp62_) == 0) {
#line 1082 "Utility/Device.vala"
														result = dev;
#line 1082 "Utility/Device.vala"
														_g_object_unref0 (_dev_list);
#line 1082 "Utility/Device.vala"
														_g_free0 (dev_alias);
#line 1082 "Utility/Device.vala"
														return result;
#line 6584 "Device.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 1049 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 6598 "Device.c"
		}
#line 1049 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 6602 "Device.c"
	}
#line 1086 "Utility/Device.vala"
	result = NULL;
#line 1086 "Utility/Device.vala"
	_g_free0 (dev_alias);
#line 1086 "Utility/Device.vala"
	return result;
#line 6610 "Device.c"
}

void
device_copy_fields_from (Device* self,
                         Device* dev2)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GeeArrayList* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	Device* _tmp22_;
	Device* _tmp23_;
	GeeArrayList* _tmp24_;
	GeeArrayList* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
#line 1089 "Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1089 "Utility/Device.vala"
	g_return_if_fail (dev2 != NULL);
#line 1091 "Utility/Device.vala"
	_tmp0_ = dev2->device;
#line 1091 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1091 "Utility/Device.vala"
	_g_free0 (self->device);
#line 1091 "Utility/Device.vala"
	self->device = _tmp1_;
#line 1092 "Utility/Device.vala"
	_tmp2_ = dev2->name;
#line 1092 "Utility/Device.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1092 "Utility/Device.vala"
	_g_free0 (self->name);
#line 1092 "Utility/Device.vala"
	self->name = _tmp3_;
#line 1093 "Utility/Device.vala"
	_tmp4_ = dev2->kname;
#line 1093 "Utility/Device.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 1093 "Utility/Device.vala"
	_g_free0 (self->kname);
#line 1093 "Utility/Device.vala"
	self->kname = _tmp5_;
#line 1094 "Utility/Device.vala"
	_tmp6_ = dev2->pkname;
#line 1094 "Utility/Device.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 1094 "Utility/Device.vala"
	_g_free0 (self->pkname);
#line 1094 "Utility/Device.vala"
	self->pkname = _tmp7_;
#line 1095 "Utility/Device.vala"
	_tmp8_ = dev2->label;
#line 1095 "Utility/Device.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 1095 "Utility/Device.vala"
	_g_free0 (self->label);
#line 1095 "Utility/Device.vala"
	self->label = _tmp9_;
#line 1096 "Utility/Device.vala"
	_tmp10_ = dev2->uuid;
#line 1096 "Utility/Device.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 1096 "Utility/Device.vala"
	_g_free0 (self->uuid);
#line 1096 "Utility/Device.vala"
	self->uuid = _tmp11_;
#line 1097 "Utility/Device.vala"
	_tmp12_ = dev2->mapped_name;
#line 1097 "Utility/Device.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 1097 "Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 1097 "Utility/Device.vala"
	self->mapped_name = _tmp13_;
#line 1099 "Utility/Device.vala"
	_tmp14_ = dev2->type;
#line 1099 "Utility/Device.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 1099 "Utility/Device.vala"
	_g_free0 (self->type);
#line 1099 "Utility/Device.vala"
	self->type = _tmp15_;
#line 1100 "Utility/Device.vala"
	_tmp16_ = dev2->fstype;
#line 1100 "Utility/Device.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 1100 "Utility/Device.vala"
	_g_free0 (self->fstype);
#line 1100 "Utility/Device.vala"
	self->fstype = _tmp17_;
#line 1102 "Utility/Device.vala"
	self->size_bytes = dev2->size_bytes;
#line 1103 "Utility/Device.vala"
	self->used_bytes = dev2->used_bytes;
#line 1104 "Utility/Device.vala"
	self->available_bytes = dev2->available_bytes;
#line 1106 "Utility/Device.vala"
	_tmp18_ = dev2->mount_points;
#line 1106 "Utility/Device.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1106 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 1106 "Utility/Device.vala"
	self->mount_points = _tmp19_;
#line 1107 "Utility/Device.vala"
	_tmp20_ = dev2->symlinks;
#line 1107 "Utility/Device.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1107 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 1107 "Utility/Device.vala"
	self->symlinks = _tmp21_;
#line 1108 "Utility/Device.vala"
	_tmp22_ = dev2->parent;
#line 1108 "Utility/Device.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 1108 "Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 1108 "Utility/Device.vala"
	self->parent = _tmp23_;
#line 1109 "Utility/Device.vala"
	_tmp24_ = dev2->children;
#line 1109 "Utility/Device.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 1109 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 1109 "Utility/Device.vala"
	self->children = _tmp25_;
#line 1111 "Utility/Device.vala"
	_tmp26_ = dev2->vendor;
#line 1111 "Utility/Device.vala"
	_tmp27_ = g_strdup (_tmp26_);
#line 1111 "Utility/Device.vala"
	_g_free0 (self->vendor);
#line 1111 "Utility/Device.vala"
	self->vendor = _tmp27_;
#line 1112 "Utility/Device.vala"
	_tmp28_ = dev2->model;
#line 1112 "Utility/Device.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 1112 "Utility/Device.vala"
	_g_free0 (self->model);
#line 1112 "Utility/Device.vala"
	self->model = _tmp29_;
#line 1113 "Utility/Device.vala"
	_tmp30_ = dev2->serial;
#line 1113 "Utility/Device.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 1113 "Utility/Device.vala"
	_g_free0 (self->serial);
#line 1113 "Utility/Device.vala"
	self->serial = _tmp31_;
#line 1114 "Utility/Device.vala"
	_tmp32_ = dev2->revision;
#line 1114 "Utility/Device.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 1114 "Utility/Device.vala"
	_g_free0 (self->revision);
#line 1114 "Utility/Device.vala"
	self->revision = _tmp33_;
#line 1116 "Utility/Device.vala"
	self->removable = dev2->removable;
#line 1117 "Utility/Device.vala"
	self->read_only = dev2->read_only;
#line 6801 "Device.c"
}

Device*
device_query_changes (Device* self)
{
	Device* result = NULL;
	Device* dev_new = NULL;
#line 1120 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1122 "Utility/Device.vala"
	dev_new = NULL;
#line 6813 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 1124 "Utility/Device.vala"
		_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 1124 "Utility/Device.vala"
		_dev_list = _tmp0_;
#line 1124 "Utility/Device.vala"
		_tmp1_ = _dev_list;
#line 1124 "Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1124 "Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1124 "Utility/Device.vala"
		_dev_size = _tmp3_;
#line 1124 "Utility/Device.vala"
		_dev_index = -1;
#line 1124 "Utility/Device.vala"
		while (TRUE) {
#line 6838 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp4_;
			gpointer _tmp5_;
			const gchar* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 1124 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1124 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 1124 "Utility/Device.vala"
				break;
#line 6851 "Device.c"
			}
#line 1124 "Utility/Device.vala"
			_tmp4_ = _dev_list;
#line 1124 "Utility/Device.vala"
			_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, _dev_index);
#line 1124 "Utility/Device.vala"
			dev = (Device*) _tmp5_;
#line 1125 "Utility/Device.vala"
			_tmp6_ = self->uuid;
#line 1125 "Utility/Device.vala"
			_tmp7_ = strlen (_tmp6_);
#line 1125 "Utility/Device.vala"
			_tmp8_ = _tmp7_;
#line 1125 "Utility/Device.vala"
			if (_tmp8_ > 0) {
#line 6867 "Device.c"
				Device* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 1126 "Utility/Device.vala"
				_tmp9_ = dev;
#line 1126 "Utility/Device.vala"
				_tmp10_ = _tmp9_->uuid;
#line 1126 "Utility/Device.vala"
				_tmp11_ = self->uuid;
#line 1126 "Utility/Device.vala"
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 6879 "Device.c"
					Device* _tmp12_;
					Device* _tmp13_;
#line 1127 "Utility/Device.vala"
					_tmp12_ = dev;
#line 1127 "Utility/Device.vala"
					_tmp13_ = _g_object_ref0 (_tmp12_);
#line 1127 "Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1127 "Utility/Device.vala"
					dev_new = _tmp13_;
#line 1128 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1128 "Utility/Device.vala"
					break;
#line 6894 "Device.c"
				}
			} else {
				Device* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
#line 1132 "Utility/Device.vala"
				_tmp14_ = dev;
#line 1132 "Utility/Device.vala"
				_tmp15_ = _tmp14_->device;
#line 1132 "Utility/Device.vala"
				_tmp16_ = self->device;
#line 1132 "Utility/Device.vala"
				if (g_strcmp0 (_tmp15_, _tmp16_) == 0) {
#line 6908 "Device.c"
					Device* _tmp17_;
					Device* _tmp18_;
#line 1133 "Utility/Device.vala"
					_tmp17_ = dev;
#line 1133 "Utility/Device.vala"
					_tmp18_ = _g_object_ref0 (_tmp17_);
#line 1133 "Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1133 "Utility/Device.vala"
					dev_new = _tmp18_;
#line 1134 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1134 "Utility/Device.vala"
					break;
#line 6923 "Device.c"
				}
			}
#line 1124 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 6928 "Device.c"
		}
#line 1124 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 6932 "Device.c"
	}
#line 1139 "Utility/Device.vala"
	result = dev_new;
#line 1139 "Utility/Device.vala"
	return result;
#line 6938 "Device.c"
}

void
device_query_disk_space (Device* self)
{
	GeeArrayList* list_df = NULL;
	const gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	Device* dev_df = NULL;
	GeeArrayList* _tmp2_;
	const gchar* _tmp3_;
	Device* _tmp4_;
	Device* _tmp5_;
#line 1142 "Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1146 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1146 "Utility/Device.vala"
	_tmp1_ = device_get_disk_space_using_df (_tmp0_);
#line 1146 "Utility/Device.vala"
	list_df = _tmp1_;
#line 1148 "Utility/Device.vala"
	_tmp2_ = list_df;
#line 1148 "Utility/Device.vala"
	_tmp3_ = self->uuid;
#line 1148 "Utility/Device.vala"
	_tmp4_ = device_find_device_in_list (_tmp2_, _tmp3_);
#line 1148 "Utility/Device.vala"
	dev_df = _tmp4_;
#line 1150 "Utility/Device.vala"
	_tmp5_ = dev_df;
#line 1150 "Utility/Device.vala"
	if (_tmp5_ != NULL) {
#line 6972 "Device.c"
		Device* _tmp6_;
		Device* _tmp7_;
		Device* _tmp8_;
		Device* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 1152 "Utility/Device.vala"
		_tmp6_ = dev_df;
#line 1152 "Utility/Device.vala"
		self->size_bytes = _tmp6_->size_bytes;
#line 1153 "Utility/Device.vala"
		_tmp7_ = dev_df;
#line 1153 "Utility/Device.vala"
		self->used_bytes = _tmp7_->used_bytes;
#line 1154 "Utility/Device.vala"
		_tmp8_ = dev_df;
#line 1154 "Utility/Device.vala"
		self->available_bytes = _tmp8_->available_bytes;
#line 1155 "Utility/Device.vala"
		_tmp9_ = dev_df;
#line 1155 "Utility/Device.vala"
		_tmp10_ = _tmp9_->used_percent;
#line 1155 "Utility/Device.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 1155 "Utility/Device.vala"
		_g_free0 (self->used_percent);
#line 1155 "Utility/Device.vala"
		self->used_percent = _tmp11_;
#line 7001 "Device.c"
	}
#line 1142 "Utility/Device.vala"
	_g_object_unref0 (dev_df);
#line 1142 "Utility/Device.vala"
	_g_object_unref0 (list_df);
#line 7007 "Device.c"
}

gboolean
device_automount_udisks (const gchar* dev_name_or_uuid,
                         GtkWindow* parent_window)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
#line 1161 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1163 "Utility/Device.vala"
	_tmp0_ = strlen (dev_name_or_uuid);
#line 1163 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1163 "Utility/Device.vala"
	if (_tmp1_ == 0) {
#line 1164 "Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1165 "Utility/Device.vala"
		result = FALSE;
#line 1165 "Utility/Device.vala"
		return result;
#line 7036 "Device.c"
	}
#line 1168 "Utility/Device.vala"
	_tmp2_ = g_strdup_printf ("udisksctl mount -b '%s'", dev_name_or_uuid);
#line 1168 "Utility/Device.vala"
	cmd = _tmp2_;
#line 1169 "Utility/Device.vala"
	_tmp3_ = cmd;
#line 1169 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1170 "Utility/Device.vala"
	_tmp4_ = cmd;
#line 1170 "Utility/Device.vala"
	status = system (_tmp4_);
#line 1172 "Utility/Device.vala"
	if (status != 0) {
#line 1173 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 7054 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 1174 "Utility/Device.vala"
			_tmp5_ = g_strdup_printf ("Failed to mount: %s", dev_name_or_uuid);
#line 1174 "Utility/Device.vala"
			msg = _tmp5_;
#line 1175 "Utility/Device.vala"
			_tmp6_ = msg;
#line 1175 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp6_, parent_window, TRUE);
#line 1173 "Utility/Device.vala"
			_g_free0 (msg);
#line 7068 "Device.c"
		}
	}
#line 1179 "Utility/Device.vala"
	result = status == 0;
#line 1179 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1179 "Utility/Device.vala"
	return result;
#line 7077 "Device.c"
}

gboolean
device_automount_udisks_iso (const gchar* iso_file_path,
                             gchar* * loop_device,
                             GtkWindow* parent_window)
{
	gchar* _vala_loop_device = NULL;
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint exit_code = 0;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_;
#line 1182 "Utility/Device.vala"
	g_return_val_if_fail (iso_file_path != NULL, FALSE);
#line 1184 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1184 "Utility/Device.vala"
	_g_free0 (_vala_loop_device);
#line 1184 "Utility/Device.vala"
	_vala_loop_device = _tmp0_;
#line 1186 "Utility/Device.vala"
	if (!tee_jee_file_system_file_exists (iso_file_path)) {
#line 7111 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 1187 "Utility/Device.vala"
		_tmp1_ = g_strdup_printf ("%s: %s", _ ("Could not find file"), iso_file_path);
#line 1187 "Utility/Device.vala"
		msg = _tmp1_;
#line 1188 "Utility/Device.vala"
		_tmp2_ = msg;
#line 1188 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp2_, FALSE, FALSE);
#line 1189 "Utility/Device.vala"
		result = FALSE;
#line 1189 "Utility/Device.vala"
		_g_free0 (msg);
#line 1189 "Utility/Device.vala"
		if (loop_device) {
#line 1189 "Utility/Device.vala"
			*loop_device = _vala_loop_device;
#line 7131 "Device.c"
		} else {
#line 1189 "Utility/Device.vala"
			_g_free0 (_vala_loop_device);
#line 7135 "Device.c"
		}
#line 1189 "Utility/Device.vala"
		return result;
#line 7139 "Device.c"
	}
#line 1192 "Utility/Device.vala"
	_tmp3_ = tee_jee_file_system_escape_single_quote (iso_file_path);
#line 1192 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1192 "Utility/Device.vala"
	_tmp5_ = g_strdup_printf ("udisksctl loop-setup -r -f '%s'", _tmp4_);
#line 1192 "Utility/Device.vala"
	_tmp6_ = _tmp5_;
#line 1192 "Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1192 "Utility/Device.vala"
	cmd = _tmp6_;
#line 1195 "Utility/Device.vala"
	_tmp7_ = cmd;
#line 1195 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp7_);
#line 1197 "Utility/Device.vala"
	_tmp8_ = cmd;
#line 1197 "Utility/Device.vala"
	_tmp11_ = tee_jee_process_helper_exec_sync (_tmp8_, &_tmp9_, &_tmp10_);
#line 1197 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1197 "Utility/Device.vala"
	std_out = _tmp9_;
#line 1197 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1197 "Utility/Device.vala"
	std_err = _tmp10_;
#line 1197 "Utility/Device.vala"
	exit_code = _tmp11_;
#line 1199 "Utility/Device.vala"
	if (exit_code == 0) {
#line 7173 "Device.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar** _tmp17_;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp27_;
#line 1200 "Utility/Device.vala"
		_tmp12_ = std_out;
#line 1200 "Utility/Device.vala"
		_tmp13_ = g_strdup_printf ("%s", _tmp12_);
#line 1200 "Utility/Device.vala"
		_tmp14_ = _tmp13_;
#line 1200 "Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp14_, FALSE);
#line 1200 "Utility/Device.vala"
		_g_free0 (_tmp14_);
#line 1203 "Utility/Device.vala"
		_tmp15_ = std_out;
#line 1203 "Utility/Device.vala"
		if (!string_contains (_tmp15_, " as ")) {
#line 1204 "Utility/Device.vala"
			tee_jee_logging_log_error ("Could not determine loop device", FALSE, FALSE);
#line 1205 "Utility/Device.vala"
			result = FALSE;
#line 1205 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1205 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1205 "Utility/Device.vala"
			_g_free0 (cmd);
#line 1205 "Utility/Device.vala"
			if (loop_device) {
#line 1205 "Utility/Device.vala"
				*loop_device = _vala_loop_device;
#line 7220 "Device.c"
			} else {
#line 1205 "Utility/Device.vala"
				_g_free0 (_vala_loop_device);
#line 7224 "Device.c"
			}
#line 1205 "Utility/Device.vala"
			return result;
#line 7228 "Device.c"
		}
#line 1208 "Utility/Device.vala"
		_tmp16_ = std_out;
#line 1208 "Utility/Device.vala"
		_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, " as ", 0);
#line 1208 "Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1208 "Utility/Device.vala"
		_tmp19__length1 = _vala_array_length (_tmp17_);
#line 1208 "Utility/Device.vala"
		_tmp20_ = _tmp19_[1];
#line 1208 "Utility/Device.vala"
		_tmp21_ = string_replace (_tmp20_, ".", "");
#line 1208 "Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1208 "Utility/Device.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 1208 "Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 1208 "Utility/Device.vala"
		_vala_loop_device = _tmp23_;
#line 1208 "Utility/Device.vala"
		_g_free0 (_tmp22_);
#line 1208 "Utility/Device.vala"
		_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 1209 "Utility/Device.vala"
		_tmp24_ = _vala_loop_device;
#line 1209 "Utility/Device.vala"
		_tmp25_ = g_strdup_printf ("loop_device: %s", _tmp24_);
#line 1209 "Utility/Device.vala"
		_tmp26_ = _tmp25_;
#line 1209 "Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp26_, FALSE);
#line 1209 "Utility/Device.vala"
		_g_free0 (_tmp26_);
#line 1211 "Utility/Device.vala"
		_tmp27_ = device_get_block_devices_using_lsblk ("");
#line 1211 "Utility/Device.vala"
		list = _tmp27_;
#line 7268 "Device.c"
		{
			GeeArrayList* _dev_list = NULL;
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			gint _dev_size = 0;
			GeeArrayList* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gint _dev_index = 0;
#line 1212 "Utility/Device.vala"
			_tmp28_ = list;
#line 1212 "Utility/Device.vala"
			_tmp29_ = _g_object_ref0 (_tmp28_);
#line 1212 "Utility/Device.vala"
			_dev_list = _tmp29_;
#line 1212 "Utility/Device.vala"
			_tmp30_ = _dev_list;
#line 1212 "Utility/Device.vala"
			_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 1212 "Utility/Device.vala"
			_tmp32_ = _tmp31_;
#line 1212 "Utility/Device.vala"
			_dev_size = _tmp32_;
#line 1212 "Utility/Device.vala"
			_dev_index = -1;
#line 1212 "Utility/Device.vala"
			while (TRUE) {
#line 7296 "Device.c"
				Device* dev = NULL;
				GeeArrayList* _tmp33_;
				gpointer _tmp34_;
				gboolean _tmp35_ = FALSE;
				Device* _tmp36_;
				const gchar* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gboolean _tmp41_;
#line 1212 "Utility/Device.vala"
				_dev_index = _dev_index + 1;
#line 1212 "Utility/Device.vala"
				if (!(_dev_index < _dev_size)) {
#line 1212 "Utility/Device.vala"
					break;
#line 7313 "Device.c"
				}
#line 1212 "Utility/Device.vala"
				_tmp33_ = _dev_list;
#line 1212 "Utility/Device.vala"
				_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _dev_index);
#line 1212 "Utility/Device.vala"
				dev = (Device*) _tmp34_;
#line 1213 "Utility/Device.vala"
				_tmp36_ = dev;
#line 1213 "Utility/Device.vala"
				_tmp37_ = _tmp36_->pkname;
#line 1213 "Utility/Device.vala"
				_tmp38_ = _vala_loop_device;
#line 1213 "Utility/Device.vala"
				_tmp39_ = string_replace (_tmp38_, "/dev/", "");
#line 1213 "Utility/Device.vala"
				_tmp40_ = _tmp39_;
#line 1213 "Utility/Device.vala"
				_tmp41_ = g_strcmp0 (_tmp37_, _tmp40_) == 0;
#line 1213 "Utility/Device.vala"
				_g_free0 (_tmp40_);
#line 1213 "Utility/Device.vala"
				if (_tmp41_) {
#line 7337 "Device.c"
					Device* _tmp42_;
					const gchar* _tmp43_;
#line 1213 "Utility/Device.vala"
					_tmp42_ = dev;
#line 1213 "Utility/Device.vala"
					_tmp43_ = _tmp42_->fstype;
#line 1213 "Utility/Device.vala"
					_tmp35_ = g_strcmp0 (_tmp43_, "iso9660") == 0;
#line 7346 "Device.c"
				} else {
#line 1213 "Utility/Device.vala"
					_tmp35_ = FALSE;
#line 7350 "Device.c"
				}
#line 1213 "Utility/Device.vala"
				if (_tmp35_) {
#line 7354 "Device.c"
					Device* _tmp44_;
					const gchar* _tmp45_;
					gchar* _tmp46_;
					Device* _tmp47_;
					const gchar* _tmp48_;
#line 1214 "Utility/Device.vala"
					_tmp44_ = dev;
#line 1214 "Utility/Device.vala"
					_tmp45_ = _tmp44_->device;
#line 1214 "Utility/Device.vala"
					_tmp46_ = g_strdup (_tmp45_);
#line 1214 "Utility/Device.vala"
					_g_free0 (_vala_loop_device);
#line 1214 "Utility/Device.vala"
					_vala_loop_device = _tmp46_;
#line 1215 "Utility/Device.vala"
					_tmp47_ = dev;
#line 1215 "Utility/Device.vala"
					_tmp48_ = _tmp47_->device;
#line 1215 "Utility/Device.vala"
					result = device_automount_udisks (_tmp48_, parent_window);
#line 1215 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1215 "Utility/Device.vala"
					_g_object_unref0 (_dev_list);
#line 1215 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 1215 "Utility/Device.vala"
					_g_free0 (std_err);
#line 1215 "Utility/Device.vala"
					_g_free0 (std_out);
#line 1215 "Utility/Device.vala"
					_g_free0 (cmd);
#line 1215 "Utility/Device.vala"
					if (loop_device) {
#line 1215 "Utility/Device.vala"
						*loop_device = _vala_loop_device;
#line 7392 "Device.c"
					} else {
#line 1215 "Utility/Device.vala"
						_g_free0 (_vala_loop_device);
#line 7396 "Device.c"
					}
#line 1215 "Utility/Device.vala"
					return result;
#line 7400 "Device.c"
				}
#line 1212 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 7404 "Device.c"
			}
#line 1212 "Utility/Device.vala"
			_g_object_unref0 (_dev_list);
#line 7408 "Device.c"
		}
#line 1199 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 7412 "Device.c"
	}
#line 1220 "Utility/Device.vala"
	result = FALSE;
#line 1220 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1220 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1220 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1220 "Utility/Device.vala"
	if (loop_device) {
#line 1220 "Utility/Device.vala"
		*loop_device = _vala_loop_device;
#line 7426 "Device.c"
	} else {
#line 1220 "Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 7430 "Device.c"
	}
#line 1220 "Utility/Device.vala"
	return result;
#line 7434 "Device.c"
}

gboolean
device_unmount_udisks (const gchar* dev_name_or_uuid,
                       GtkWindow* parent_window)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
#line 1223 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1225 "Utility/Device.vala"
	_tmp0_ = strlen (dev_name_or_uuid);
#line 1225 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1225 "Utility/Device.vala"
	if (_tmp1_ == 0) {
#line 1226 "Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1227 "Utility/Device.vala"
		result = FALSE;
#line 1227 "Utility/Device.vala"
		return result;
#line 7463 "Device.c"
	}
#line 1230 "Utility/Device.vala"
	_tmp2_ = g_strdup_printf ("udisksctl unmount -b '%s'", dev_name_or_uuid);
#line 1230 "Utility/Device.vala"
	cmd = _tmp2_;
#line 1231 "Utility/Device.vala"
	_tmp3_ = cmd;
#line 1231 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1232 "Utility/Device.vala"
	_tmp4_ = cmd;
#line 1232 "Utility/Device.vala"
	status = system (_tmp4_);
#line 1234 "Utility/Device.vala"
	if (status != 0) {
#line 1235 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 7481 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 1236 "Utility/Device.vala"
			_tmp5_ = g_strdup_printf ("Failed to unmount: %s", dev_name_or_uuid);
#line 1236 "Utility/Device.vala"
			msg = _tmp5_;
#line 1237 "Utility/Device.vala"
			_tmp6_ = msg;
#line 1237 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp6_, parent_window, TRUE);
#line 1235 "Utility/Device.vala"
			_g_free0 (msg);
#line 7495 "Device.c"
		}
	}
#line 1241 "Utility/Device.vala"
	result = status == 0;
#line 1241 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1241 "Utility/Device.vala"
	return result;
#line 7504 "Device.c"
}

Device*
device_luks_unlock (Device* luks_device,
                    const gchar* mapped_name,
                    const gchar* passphrase,
                    GtkWindow* parent_window,
                    gchar* * message,
                    gchar* * details)
{
	gchar* _vala_message = NULL;
	gchar* _vala_details = NULL;
	Device* result = NULL;
	Device* unlocked_device = NULL;
	gchar* std_out = NULL;
	gchar* _tmp0_;
	gchar* std_err = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp7_;
	gchar* luks_pass = NULL;
	gchar* _tmp24_;
	gchar* luks_name = NULL;
	gchar* _tmp25_;
	gboolean _tmp26_ = FALSE;
	const gchar* _tmp27_;
	GeeArrayList* _tmp95_;
	gboolean is_error = FALSE;
	Device* _tmp108_;
#line 1244 "Utility/Device.vala"
	g_return_val_if_fail (luks_device != NULL, NULL);
#line 1244 "Utility/Device.vala"
	g_return_val_if_fail (mapped_name != NULL, NULL);
#line 1244 "Utility/Device.vala"
	g_return_val_if_fail (passphrase != NULL, NULL);
#line 1254 "Utility/Device.vala"
	unlocked_device = NULL;
#line 1255 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1255 "Utility/Device.vala"
	std_out = _tmp0_;
#line 1255 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1255 "Utility/Device.vala"
	std_err = _tmp1_;
#line 1258 "Utility/Device.vala"
	_tmp3_ = luks_device->fstype;
#line 1258 "Utility/Device.vala"
	if (!string_contains (_tmp3_, "luks")) {
#line 7556 "Device.c"
		const gchar* _tmp4_;
#line 1258 "Utility/Device.vala"
		_tmp4_ = luks_device->fstype;
#line 1258 "Utility/Device.vala"
		_tmp2_ = !string_contains (_tmp4_, "crypt");
#line 7562 "Device.c"
	} else {
#line 1258 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 7566 "Device.c"
	}
#line 1258 "Utility/Device.vala"
	if (_tmp2_) {
#line 7570 "Device.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1259 "Utility/Device.vala"
		_tmp5_ = g_strdup (_ ("This device is not encrypted"));
#line 1259 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1259 "Utility/Device.vala"
		_vala_message = _tmp5_;
#line 1260 "Utility/Device.vala"
		_tmp6_ = g_strdup (_ ("Failed to unlock device"));
#line 1260 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1260 "Utility/Device.vala"
		_vala_details = _tmp6_;
#line 1261 "Utility/Device.vala"
		result = NULL;
#line 1261 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1261 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1261 "Utility/Device.vala"
		_g_object_unref0 (unlocked_device);
#line 1261 "Utility/Device.vala"
		if (message) {
#line 1261 "Utility/Device.vala"
			*message = _vala_message;
#line 7597 "Device.c"
		} else {
#line 1261 "Utility/Device.vala"
			_g_free0 (_vala_message);
#line 7601 "Device.c"
		}
#line 1261 "Utility/Device.vala"
		if (details) {
#line 1261 "Utility/Device.vala"
			*details = _vala_details;
#line 7607 "Device.c"
		} else {
#line 1261 "Utility/Device.vala"
			_g_free0 (_vala_details);
#line 7611 "Device.c"
		}
#line 1261 "Utility/Device.vala"
		return result;
#line 7615 "Device.c"
	}
#line 1265 "Utility/Device.vala"
	_tmp7_ = device_get_block_devices_using_lsblk ("");
#line 1265 "Utility/Device.vala"
	list = _tmp7_;
#line 7621 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp8_;
		GeeArrayList* _tmp9_;
		gint _part_size = 0;
		GeeArrayList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _part_index = 0;
#line 1266 "Utility/Device.vala"
		_tmp8_ = list;
#line 1266 "Utility/Device.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1266 "Utility/Device.vala"
		_part_list = _tmp9_;
#line 1266 "Utility/Device.vala"
		_tmp10_ = _part_list;
#line 1266 "Utility/Device.vala"
		_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 1266 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1266 "Utility/Device.vala"
		_part_size = _tmp12_;
#line 1266 "Utility/Device.vala"
		_part_index = -1;
#line 1266 "Utility/Device.vala"
		while (TRUE) {
#line 7649 "Device.c"
			Device* part = NULL;
			GeeArrayList* _tmp13_;
			gpointer _tmp14_;
			Device* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 1266 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 1266 "Utility/Device.vala"
			if (!(_part_index < _part_size)) {
#line 1266 "Utility/Device.vala"
				break;
#line 7662 "Device.c"
			}
#line 1266 "Utility/Device.vala"
			_tmp13_ = _part_list;
#line 1266 "Utility/Device.vala"
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _part_index);
#line 1266 "Utility/Device.vala"
			part = (Device*) _tmp14_;
#line 1267 "Utility/Device.vala"
			_tmp15_ = part;
#line 1267 "Utility/Device.vala"
			_tmp16_ = _tmp15_->pkname;
#line 1267 "Utility/Device.vala"
			_tmp17_ = luks_device->kname;
#line 1267 "Utility/Device.vala"
			if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 7678 "Device.c"
				Device* _tmp18_;
				Device* _tmp19_;
				gchar* _tmp20_;
				Device* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
#line 1268 "Utility/Device.vala"
				_tmp18_ = part;
#line 1268 "Utility/Device.vala"
				_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1268 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1268 "Utility/Device.vala"
				unlocked_device = _tmp19_;
#line 1269 "Utility/Device.vala"
				_tmp20_ = g_strdup (_ ("Device is unlocked"));
#line 1269 "Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1269 "Utility/Device.vala"
				_vala_message = _tmp20_;
#line 1270 "Utility/Device.vala"
				_tmp21_ = part;
#line 1270 "Utility/Device.vala"
				_tmp22_ = _tmp21_->mapped_name;
#line 1270 "Utility/Device.vala"
				_tmp23_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp22_);
#line 1270 "Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1270 "Utility/Device.vala"
				_vala_details = _tmp23_;
#line 1271 "Utility/Device.vala"
				result = part;
#line 1271 "Utility/Device.vala"
				_g_object_unref0 (_part_list);
#line 1271 "Utility/Device.vala"
				_g_object_unref0 (list);
#line 1271 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1271 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1271 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1271 "Utility/Device.vala"
				if (message) {
#line 1271 "Utility/Device.vala"
					*message = _vala_message;
#line 7725 "Device.c"
				} else {
#line 1271 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 7729 "Device.c"
				}
#line 1271 "Utility/Device.vala"
				if (details) {
#line 1271 "Utility/Device.vala"
					*details = _vala_details;
#line 7735 "Device.c"
				} else {
#line 1271 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 7739 "Device.c"
				}
#line 1271 "Utility/Device.vala"
				return result;
#line 7743 "Device.c"
			}
#line 1266 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 7747 "Device.c"
		}
#line 1266 "Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 7751 "Device.c"
	}
#line 1275 "Utility/Device.vala"
	_tmp24_ = g_strdup (passphrase);
#line 1275 "Utility/Device.vala"
	luks_pass = _tmp24_;
#line 1276 "Utility/Device.vala"
	_tmp25_ = g_strdup (mapped_name);
#line 1276 "Utility/Device.vala"
	luks_name = _tmp25_;
#line 1278 "Utility/Device.vala"
	_tmp27_ = luks_name;
#line 1278 "Utility/Device.vala"
	if (_tmp27_ == NULL) {
#line 1278 "Utility/Device.vala"
		_tmp26_ = TRUE;
#line 7767 "Device.c"
	} else {
		const gchar* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 1278 "Utility/Device.vala"
		_tmp28_ = luks_name;
#line 1278 "Utility/Device.vala"
		_tmp29_ = strlen (_tmp28_);
#line 1278 "Utility/Device.vala"
		_tmp30_ = _tmp29_;
#line 1278 "Utility/Device.vala"
		_tmp26_ = _tmp30_ == 0;
#line 7780 "Device.c"
	}
#line 1278 "Utility/Device.vala"
	if (_tmp26_) {
#line 7784 "Device.c"
		const gchar* _tmp31_;
		gchar* _tmp32_;
#line 1279 "Utility/Device.vala"
		_tmp31_ = luks_device->kname;
#line 1279 "Utility/Device.vala"
		_tmp32_ = g_strdup_printf ("%s_crypt", _tmp31_);
#line 1279 "Utility/Device.vala"
		_g_free0 (luks_name);
#line 1279 "Utility/Device.vala"
		luks_name = _tmp32_;
#line 7795 "Device.c"
	}
#line 1282 "Utility/Device.vala"
	if (parent_window == NULL) {
#line 7799 "Device.c"
		gboolean _tmp33_ = FALSE;
		const gchar* _tmp34_;
#line 1286 "Utility/Device.vala"
		_tmp34_ = luks_pass;
#line 1286 "Utility/Device.vala"
		if (_tmp34_ == NULL) {
#line 1286 "Utility/Device.vala"
			_tmp33_ = TRUE;
#line 7808 "Device.c"
		} else {
			const gchar* _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
#line 1286 "Utility/Device.vala"
			_tmp35_ = luks_pass;
#line 1286 "Utility/Device.vala"
			_tmp36_ = strlen (_tmp35_);
#line 1286 "Utility/Device.vala"
			_tmp37_ = _tmp36_;
#line 1286 "Utility/Device.vala"
			_tmp33_ = _tmp37_ == 0;
#line 7821 "Device.c"
		}
#line 1286 "Utility/Device.vala"
		if (_tmp33_) {
#line 7825 "Device.c"
			TimeoutCounter* counter = NULL;
			TimeoutCounter* _tmp38_;
			TimeoutCounter* _tmp39_;
			gchar* cmd = NULL;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			const gchar* _tmp43_;
			const gchar* _tmp44_;
			TimeoutCounter* _tmp45_;
#line 1290 "Utility/Device.vala"
			_tmp38_ = timeout_counter_new ();
#line 1290 "Utility/Device.vala"
			counter = _tmp38_;
#line 1291 "Utility/Device.vala"
			_tmp39_ = counter;
#line 1291 "Utility/Device.vala"
			timeout_counter_kill_process_on_timeout (_tmp39_, "cryptsetup", 20, TRUE);
#line 1292 "Utility/Device.vala"
			_tmp40_ = luks_device->device;
#line 1292 "Utility/Device.vala"
			_tmp41_ = luks_name;
#line 1292 "Utility/Device.vala"
			_tmp42_ = g_strdup_printf ("cryptsetup luksOpen '%s' '%s'", _tmp40_, _tmp41_);
#line 1292 "Utility/Device.vala"
			cmd = _tmp42_;
#line 1294 "Utility/Device.vala"
			_tmp43_ = cmd;
#line 1294 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp43_);
#line 1295 "Utility/Device.vala"
			_tmp44_ = cmd;
#line 1295 "Utility/Device.vala"
			system (_tmp44_);
#line 1296 "Utility/Device.vala"
			_tmp45_ = counter;
#line 1296 "Utility/Device.vala"
			timeout_counter_stop (_tmp45_);
#line 1297 "Utility/Device.vala"
			tee_jee_logging_log_msg ("", FALSE);
#line 1286 "Utility/Device.vala"
			_g_free0 (cmd);
#line 1286 "Utility/Device.vala"
			_g_object_unref0 (counter);
#line 7870 "Device.c"
		} else {
			gchar* cmd = NULL;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			const gchar* _tmp48_;
			gchar* _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gint status = 0;
			const gchar* _tmp54_;
			gchar* _tmp55_ = NULL;
			gchar* _tmp56_ = NULL;
			gint _tmp57_;
#line 1304 "Utility/Device.vala"
			_tmp46_ = luks_pass;
#line 1304 "Utility/Device.vala"
			_tmp47_ = luks_device->device;
#line 1304 "Utility/Device.vala"
			_tmp48_ = luks_name;
#line 1304 "Utility/Device.vala"
			_tmp49_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp46_, _tmp47_, _tmp48_);
#line 1304 "Utility/Device.vala"
			cmd = _tmp49_;
#line 1307 "Utility/Device.vala"
			_tmp50_ = cmd;
#line 1307 "Utility/Device.vala"
			_tmp51_ = luks_pass;
#line 1307 "Utility/Device.vala"
			_tmp52_ = string_replace (_tmp50_, _tmp51_, "**PASSWORD**");
#line 1307 "Utility/Device.vala"
			_tmp53_ = _tmp52_;
#line 1307 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp53_);
#line 1307 "Utility/Device.vala"
			_g_free0 (_tmp53_);
#line 1309 "Utility/Device.vala"
			_tmp54_ = cmd;
#line 1309 "Utility/Device.vala"
			_tmp57_ = tee_jee_process_helper_exec_script_sync (_tmp54_, &_tmp55_, &_tmp56_, FALSE, TRUE, TRUE, FALSE);
#line 1309 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1309 "Utility/Device.vala"
			std_out = _tmp55_;
#line 1309 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1309 "Utility/Device.vala"
			std_err = _tmp56_;
#line 1309 "Utility/Device.vala"
			status = _tmp57_;
#line 1311 "Utility/Device.vala"
			switch (status) {
#line 1311 "Utility/Device.vala"
				case 512:
#line 7926 "Device.c"
				{
					gchar* _tmp58_;
					gchar* _tmp59_;
					const gchar* _tmp60_;
					const gchar* _tmp61_;
#line 1313 "Utility/Device.vala"
					_tmp58_ = g_strdup (_ ("Wrong password"));
#line 1313 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1313 "Utility/Device.vala"
					_vala_message = _tmp58_;
#line 1314 "Utility/Device.vala"
					_tmp59_ = g_strdup (_ ("Failed to unlock device"));
#line 1314 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1314 "Utility/Device.vala"
					_vala_details = _tmp59_;
#line 1315 "Utility/Device.vala"
					_tmp60_ = _vala_message;
#line 1315 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp60_, FALSE, FALSE);
#line 1316 "Utility/Device.vala"
					_tmp61_ = _vala_details;
#line 1316 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp61_, FALSE, FALSE);
#line 1317 "Utility/Device.vala"
					break;
#line 7954 "Device.c"
				}
				default:
#line 1311 "Utility/Device.vala"
				break;
#line 7959 "Device.c"
			}
#line 1286 "Utility/Device.vala"
			_g_free0 (cmd);
#line 7963 "Device.c"
		}
	} else {
		gboolean _tmp62_ = FALSE;
		const gchar* _tmp63_;
		gboolean _tmp74_ = FALSE;
		const gchar* _tmp75_;
#line 1326 "Utility/Device.vala"
		_tmp63_ = luks_pass;
#line 1326 "Utility/Device.vala"
		if (_tmp63_ == NULL) {
#line 1326 "Utility/Device.vala"
			_tmp62_ = TRUE;
#line 7976 "Device.c"
		} else {
			const gchar* _tmp64_;
			gint _tmp65_;
			gint _tmp66_;
#line 1326 "Utility/Device.vala"
			_tmp64_ = luks_pass;
#line 1326 "Utility/Device.vala"
			_tmp65_ = strlen (_tmp64_);
#line 1326 "Utility/Device.vala"
			_tmp66_ = _tmp65_;
#line 1326 "Utility/Device.vala"
			_tmp62_ = _tmp66_ == 0;
#line 7989 "Device.c"
		}
#line 1326 "Utility/Device.vala"
		if (_tmp62_) {
#line 7993 "Device.c"
			const gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
			const gchar* _tmp71_;
#line 1330 "Utility/Device.vala"
			tee_jee_logging_log_debug ("Prompting user for passphrase..");
#line 1332 "Utility/Device.vala"
			_tmp67_ = luks_device->name;
#line 1332 "Utility/Device.vala"
			_tmp68_ = g_strdup_printf (_ ("Enter passphrase to unlock '%s'"), _tmp67_);
#line 1332 "Utility/Device.vala"
			_tmp69_ = _tmp68_;
#line 1332 "Utility/Device.vala"
			_tmp70_ = tee_jee_gtk_helper_gtk_inputbox (_ ("Encrypted Device"), _tmp69_, parent_window, TRUE);
#line 1332 "Utility/Device.vala"
			_g_free0 (luks_pass);
#line 1332 "Utility/Device.vala"
			luks_pass = _tmp70_;
#line 1332 "Utility/Device.vala"
			_g_free0 (_tmp69_);
#line 1337 "Utility/Device.vala"
			_tmp71_ = luks_pass;
#line 1337 "Utility/Device.vala"
			if (_tmp71_ == NULL) {
#line 8019 "Device.c"
				gchar* _tmp72_;
				gchar* _tmp73_;
#line 1339 "Utility/Device.vala"
				_tmp72_ = g_strdup (_ ("Failed to unlock device"));
#line 1339 "Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1339 "Utility/Device.vala"
				_vala_message = _tmp72_;
#line 1340 "Utility/Device.vala"
				_tmp73_ = g_strdup (_ ("User cancelled the password prompt"));
#line 1340 "Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1340 "Utility/Device.vala"
				_vala_details = _tmp73_;
#line 1341 "Utility/Device.vala"
				tee_jee_logging_log_debug ("User cancelled the password prompt");
#line 1342 "Utility/Device.vala"
				result = NULL;
#line 1342 "Utility/Device.vala"
				_g_free0 (luks_name);
#line 1342 "Utility/Device.vala"
				_g_free0 (luks_pass);
#line 1342 "Utility/Device.vala"
				_g_object_unref0 (list);
#line 1342 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1342 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1342 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1342 "Utility/Device.vala"
				if (message) {
#line 1342 "Utility/Device.vala"
					*message = _vala_message;
#line 8054 "Device.c"
				} else {
#line 1342 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 8058 "Device.c"
				}
#line 1342 "Utility/Device.vala"
				if (details) {
#line 1342 "Utility/Device.vala"
					*details = _vala_details;
#line 8064 "Device.c"
				} else {
#line 1342 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 8068 "Device.c"
				}
#line 1342 "Utility/Device.vala"
				return result;
#line 8072 "Device.c"
			}
		}
#line 1346 "Utility/Device.vala"
		_tmp75_ = luks_pass;
#line 1346 "Utility/Device.vala"
		if (_tmp75_ != NULL) {
#line 8079 "Device.c"
			const gchar* _tmp76_;
			gint _tmp77_;
			gint _tmp78_;
#line 1346 "Utility/Device.vala"
			_tmp76_ = luks_pass;
#line 1346 "Utility/Device.vala"
			_tmp77_ = strlen (_tmp76_);
#line 1346 "Utility/Device.vala"
			_tmp78_ = _tmp77_;
#line 1346 "Utility/Device.vala"
			_tmp74_ = _tmp78_ > 0;
#line 8091 "Device.c"
		} else {
#line 1346 "Utility/Device.vala"
			_tmp74_ = FALSE;
#line 8095 "Device.c"
		}
#line 1346 "Utility/Device.vala"
		if (_tmp74_) {
#line 8099 "Device.c"
			gchar* cmd = NULL;
			const gchar* _tmp79_;
			const gchar* _tmp80_;
			const gchar* _tmp81_;
			gchar* _tmp82_;
			const gchar* _tmp83_;
			const gchar* _tmp84_;
			gchar* _tmp85_;
			gchar* _tmp86_;
			gint status = 0;
			const gchar* _tmp87_;
			gchar* _tmp88_ = NULL;
			gchar* _tmp89_ = NULL;
			gint _tmp90_;
#line 1350 "Utility/Device.vala"
			_tmp79_ = luks_pass;
#line 1350 "Utility/Device.vala"
			_tmp80_ = luks_device->device;
#line 1350 "Utility/Device.vala"
			_tmp81_ = luks_name;
#line 1350 "Utility/Device.vala"
			_tmp82_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp79_, _tmp80_, _tmp81_);
#line 1350 "Utility/Device.vala"
			cmd = _tmp82_;
#line 1353 "Utility/Device.vala"
			_tmp83_ = cmd;
#line 1353 "Utility/Device.vala"
			_tmp84_ = luks_pass;
#line 1353 "Utility/Device.vala"
			_tmp85_ = string_replace (_tmp83_, _tmp84_, "**PASSWORD**");
#line 1353 "Utility/Device.vala"
			_tmp86_ = _tmp85_;
#line 1353 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp86_);
#line 1353 "Utility/Device.vala"
			_g_free0 (_tmp86_);
#line 1355 "Utility/Device.vala"
			_tmp87_ = cmd;
#line 1355 "Utility/Device.vala"
			_tmp90_ = tee_jee_process_helper_exec_script_sync (_tmp87_, &_tmp88_, &_tmp89_, FALSE, TRUE, TRUE, FALSE);
#line 1355 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1355 "Utility/Device.vala"
			std_out = _tmp88_;
#line 1355 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1355 "Utility/Device.vala"
			std_err = _tmp89_;
#line 1355 "Utility/Device.vala"
			status = _tmp90_;
#line 1357 "Utility/Device.vala"
			switch (status) {
#line 1357 "Utility/Device.vala"
				case 512:
#line 8154 "Device.c"
				{
					gchar* _tmp91_;
					gchar* _tmp92_;
					const gchar* _tmp93_;
					const gchar* _tmp94_;
#line 1359 "Utility/Device.vala"
					_tmp91_ = g_strdup (_ ("Wrong password"));
#line 1359 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1359 "Utility/Device.vala"
					_vala_message = _tmp91_;
#line 1360 "Utility/Device.vala"
					_tmp92_ = g_strdup (_ ("Failed to unlock device"));
#line 1360 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1360 "Utility/Device.vala"
					_vala_details = _tmp92_;
#line 1361 "Utility/Device.vala"
					_tmp93_ = _vala_message;
#line 1361 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp93_, FALSE, FALSE);
#line 1362 "Utility/Device.vala"
					_tmp94_ = _vala_details;
#line 1362 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp94_, FALSE, FALSE);
#line 1363 "Utility/Device.vala"
					break;
#line 8182 "Device.c"
				}
				default:
#line 1357 "Utility/Device.vala"
				break;
#line 8187 "Device.c"
			}
#line 1346 "Utility/Device.vala"
			_g_free0 (cmd);
#line 8191 "Device.c"
		}
	}
#line 1370 "Utility/Device.vala"
	_tmp95_ = device_get_block_devices_using_lsblk ("");
#line 1370 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1370 "Utility/Device.vala"
	list = _tmp95_;
#line 8200 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp96_;
		GeeArrayList* _tmp97_;
		gint _part_size = 0;
		GeeArrayList* _tmp98_;
		gint _tmp99_;
		gint _tmp100_;
		gint _part_index = 0;
#line 1371 "Utility/Device.vala"
		_tmp96_ = list;
#line 1371 "Utility/Device.vala"
		_tmp97_ = _g_object_ref0 (_tmp96_);
#line 1371 "Utility/Device.vala"
		_part_list = _tmp97_;
#line 1371 "Utility/Device.vala"
		_tmp98_ = _part_list;
#line 1371 "Utility/Device.vala"
		_tmp99_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp98_);
#line 1371 "Utility/Device.vala"
		_tmp100_ = _tmp99_;
#line 1371 "Utility/Device.vala"
		_part_size = _tmp100_;
#line 1371 "Utility/Device.vala"
		_part_index = -1;
#line 1371 "Utility/Device.vala"
		while (TRUE) {
#line 8228 "Device.c"
			Device* part = NULL;
			GeeArrayList* _tmp101_;
			gpointer _tmp102_;
			Device* _tmp103_;
			const gchar* _tmp104_;
			const gchar* _tmp105_;
#line 1371 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 1371 "Utility/Device.vala"
			if (!(_part_index < _part_size)) {
#line 1371 "Utility/Device.vala"
				break;
#line 8241 "Device.c"
			}
#line 1371 "Utility/Device.vala"
			_tmp101_ = _part_list;
#line 1371 "Utility/Device.vala"
			_tmp102_ = gee_abstract_list_get ((GeeAbstractList*) _tmp101_, _part_index);
#line 1371 "Utility/Device.vala"
			part = (Device*) _tmp102_;
#line 1372 "Utility/Device.vala"
			_tmp103_ = part;
#line 1372 "Utility/Device.vala"
			_tmp104_ = _tmp103_->pkname;
#line 1372 "Utility/Device.vala"
			_tmp105_ = luks_device->kname;
#line 1372 "Utility/Device.vala"
			if (g_strcmp0 (_tmp104_, _tmp105_) == 0) {
#line 8257 "Device.c"
				Device* _tmp106_;
				Device* _tmp107_;
#line 1373 "Utility/Device.vala"
				_tmp106_ = part;
#line 1373 "Utility/Device.vala"
				_tmp107_ = _g_object_ref0 (_tmp106_);
#line 1373 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1373 "Utility/Device.vala"
				unlocked_device = _tmp107_;
#line 1374 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1374 "Utility/Device.vala"
				break;
#line 8272 "Device.c"
			}
#line 1371 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 8276 "Device.c"
		}
#line 1371 "Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 8280 "Device.c"
	}
#line 1378 "Utility/Device.vala"
	is_error = FALSE;
#line 1379 "Utility/Device.vala"
	_tmp108_ = unlocked_device;
#line 1379 "Utility/Device.vala"
	if (_tmp108_ == NULL) {
#line 8288 "Device.c"
		const gchar* _tmp109_;
		gchar* _tmp110_;
		gchar* _tmp111_;
		gchar* _tmp112_;
		const gchar* _tmp113_;
		gchar* _tmp114_;
#line 1380 "Utility/Device.vala"
		_tmp109_ = luks_device->device;
#line 1380 "Utility/Device.vala"
		_tmp110_ = g_strdup_printf (" '%s'", _tmp109_);
#line 1380 "Utility/Device.vala"
		_tmp111_ = _tmp110_;
#line 1380 "Utility/Device.vala"
		_tmp112_ = g_strconcat (_ ("Failed to unlock device"), _tmp111_, NULL);
#line 1380 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1380 "Utility/Device.vala"
		_vala_message = _tmp112_;
#line 1380 "Utility/Device.vala"
		_g_free0 (_tmp111_);
#line 1381 "Utility/Device.vala"
		_tmp113_ = std_err;
#line 1381 "Utility/Device.vala"
		_tmp114_ = g_strdup (_tmp113_);
#line 1381 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1381 "Utility/Device.vala"
		_vala_details = _tmp114_;
#line 1382 "Utility/Device.vala"
		is_error = TRUE;
#line 8319 "Device.c"
	} else {
		gchar* _tmp115_;
		Device* _tmp116_;
		const gchar* _tmp117_;
		gchar* _tmp118_;
#line 1385 "Utility/Device.vala"
		_tmp115_ = g_strdup (_ ("Unlocked successfully"));
#line 1385 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1385 "Utility/Device.vala"
		_vala_message = _tmp115_;
#line 1386 "Utility/Device.vala"
		_tmp116_ = unlocked_device;
#line 1386 "Utility/Device.vala"
		_tmp117_ = _tmp116_->mapped_name;
#line 1386 "Utility/Device.vala"
		_tmp118_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp117_);
#line 1386 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1386 "Utility/Device.vala"
		_vala_details = _tmp118_;
#line 8341 "Device.c"
	}
#line 1389 "Utility/Device.vala"
	if (parent_window != NULL) {
#line 8345 "Device.c"
		const gchar* _tmp119_;
		const gchar* _tmp120_;
#line 1390 "Utility/Device.vala"
		_tmp119_ = _vala_message;
#line 1390 "Utility/Device.vala"
		_tmp120_ = _vala_details;
#line 1390 "Utility/Device.vala"
		tee_jee_gtk_helper_gtk_messagebox (_tmp119_, _tmp120_, parent_window, is_error);
#line 8354 "Device.c"
	}
#line 1393 "Utility/Device.vala"
	result = unlocked_device;
#line 1393 "Utility/Device.vala"
	_g_free0 (luks_name);
#line 1393 "Utility/Device.vala"
	_g_free0 (luks_pass);
#line 1393 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1393 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1393 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1393 "Utility/Device.vala"
	if (message) {
#line 1393 "Utility/Device.vala"
		*message = _vala_message;
#line 8372 "Device.c"
	} else {
#line 1393 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 8376 "Device.c"
	}
#line 1393 "Utility/Device.vala"
	if (details) {
#line 1393 "Utility/Device.vala"
		*details = _vala_details;
#line 8382 "Device.c"
	} else {
#line 1393 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 8386 "Device.c"
	}
#line 1393 "Utility/Device.vala"
	return result;
#line 8390 "Device.c"
}

gboolean
device_luks_lock (const gchar* kname,
                  GtkWindow* parent_window)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 1396 "Utility/Device.vala"
	g_return_val_if_fail (kname != NULL, FALSE);
#line 1397 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("cryptsetup luksClose %s", kname);
#line 1397 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1399 "Utility/Device.vala"
	_tmp1_ = cmd;
#line 1399 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 1402 "Utility/Device.vala"
	_tmp2_ = cmd;
#line 1402 "Utility/Device.vala"
	_tmp5_ = tee_jee_process_helper_exec_script_sync (_tmp2_, &_tmp3_, &_tmp4_, FALSE, TRUE, TRUE, FALSE);
#line 1402 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1402 "Utility/Device.vala"
	std_out = _tmp3_;
#line 1402 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1402 "Utility/Device.vala"
	std_err = _tmp4_;
#line 1402 "Utility/Device.vala"
	status = _tmp5_;
#line 1403 "Utility/Device.vala"
	_tmp6_ = std_out;
#line 1403 "Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp6_, FALSE);
#line 1404 "Utility/Device.vala"
	_tmp7_ = std_err;
#line 1404 "Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp7_, FALSE);
#line 1406 "Utility/Device.vala"
	if (status != 0) {
#line 1407 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 8446 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp8_;
			const gchar* _tmp9_;
#line 1408 "Utility/Device.vala"
			_tmp8_ = g_strdup_printf ("Failed to lock device: %s", kname);
#line 1408 "Utility/Device.vala"
			msg = _tmp8_;
#line 1409 "Utility/Device.vala"
			_tmp9_ = msg;
#line 1409 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp9_, parent_window, TRUE);
#line 1407 "Utility/Device.vala"
			_g_free0 (msg);
#line 8460 "Device.c"
		}
	}
#line 1413 "Utility/Device.vala"
	result = status == 0;
#line 1413 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1413 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1413 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1413 "Utility/Device.vala"
	return result;
#line 8473 "Device.c"
}

gboolean
device_mount (const gchar* dev_name_or_uuid,
              const gchar* mount_point,
              const gchar* mount_options,
              gboolean silent)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* device = NULL;
	gchar* _tmp1_;
	gchar* uuid = NULL;
	gchar* _tmp2_;
	GeeArrayList* mps = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gint _tmp48_;
	gint _tmp49_;
	const gchar* _tmp54_;
	gchar* _tmp55_ = NULL;
	gchar* _tmp56_ = NULL;
	gint _tmp57_;
#line 1427 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1427 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1427 "Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, FALSE);
#line 1435 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1435 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1440 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1440 "Utility/Device.vala"
	device = _tmp1_;
#line 1441 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 1441 "Utility/Device.vala"
	uuid = _tmp2_;
#line 1445 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 8523 "Device.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 1446 "Utility/Device.vala"
		_tmp3_ = g_strdup (dev_name_or_uuid);
#line 1446 "Utility/Device.vala"
		_g_free0 (device);
#line 1446 "Utility/Device.vala"
		device = _tmp3_;
#line 1447 "Utility/Device.vala"
		_tmp4_ = device_get_device_uuid (dev_name_or_uuid);
#line 1447 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1447 "Utility/Device.vala"
		uuid = _tmp4_;
#line 8538 "Device.c"
	} else {
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 1450 "Utility/Device.vala"
		_tmp5_ = g_strdup (dev_name_or_uuid);
#line 1450 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1450 "Utility/Device.vala"
		uuid = _tmp5_;
#line 1451 "Utility/Device.vala"
		_tmp6_ = uuid;
#line 1451 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp6_);
#line 1451 "Utility/Device.vala"
		_g_free0 (device);
#line 1451 "Utility/Device.vala"
		device = _tmp7_;
#line 1452 "Utility/Device.vala"
		_tmp8_ = device;
#line 1452 "Utility/Device.vala"
		_tmp9_ = device_resolve_device_name (_tmp8_);
#line 1452 "Utility/Device.vala"
		_g_free0 (device);
#line 1452 "Utility/Device.vala"
		device = _tmp9_;
#line 8567 "Device.c"
	}
#line 1457 "Utility/Device.vala"
	_tmp10_ = device_get_device_mount_points (dev_name_or_uuid);
#line 1457 "Utility/Device.vala"
	mps = _tmp10_;
#line 1459 "Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 1460 "Utility/Device.vala"
	_tmp11_ = device;
#line 1460 "Utility/Device.vala"
	_tmp12_ = g_strdup_printf ("arg=%s, device=%s", dev_name_or_uuid, _tmp11_);
#line 1460 "Utility/Device.vala"
	_tmp13_ = _tmp12_;
#line 1460 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp13_);
#line 1460 "Utility/Device.vala"
	_g_free0 (_tmp13_);
#line 8585 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp14_;
		GeeArrayList* _tmp15_;
		gint _mp_size = 0;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _mp_index = 0;
#line 1461 "Utility/Device.vala"
		_tmp14_ = mps;
#line 1461 "Utility/Device.vala"
		_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1461 "Utility/Device.vala"
		_mp_list = _tmp15_;
#line 1461 "Utility/Device.vala"
		_tmp16_ = _mp_list;
#line 1461 "Utility/Device.vala"
		_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 1461 "Utility/Device.vala"
		_tmp18_ = _tmp17_;
#line 1461 "Utility/Device.vala"
		_mp_size = _tmp18_;
#line 1461 "Utility/Device.vala"
		_mp_index = -1;
#line 1461 "Utility/Device.vala"
		while (TRUE) {
#line 8613 "Device.c"
			MountEntry* mp = NULL;
			GeeArrayList* _tmp19_;
			gpointer _tmp20_;
			MountEntry* _tmp21_;
			const gchar* _tmp22_;
#line 1461 "Utility/Device.vala"
			_mp_index = _mp_index + 1;
#line 1461 "Utility/Device.vala"
			if (!(_mp_index < _mp_size)) {
#line 1461 "Utility/Device.vala"
				break;
#line 8625 "Device.c"
			}
#line 1461 "Utility/Device.vala"
			_tmp19_ = _mp_list;
#line 1461 "Utility/Device.vala"
			_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _mp_index);
#line 1461 "Utility/Device.vala"
			mp = (MountEntry*) _tmp20_;
#line 1462 "Utility/Device.vala"
			_tmp21_ = mp;
#line 1462 "Utility/Device.vala"
			_tmp22_ = _tmp21_->mount_point;
#line 1462 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp22_);
#line 1461 "Utility/Device.vala"
			_g_object_unref0 (mp);
#line 8641 "Device.c"
		}
#line 1461 "Utility/Device.vala"
		_g_object_unref0 (_mp_list);
#line 8645 "Device.c"
	}
#line 1464 "Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 8649 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp23_;
		GeeArrayList* _tmp24_;
		gint _mp_size = 0;
		GeeArrayList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _mp_index = 0;
#line 1466 "Utility/Device.vala"
		_tmp23_ = mps;
#line 1466 "Utility/Device.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 1466 "Utility/Device.vala"
		_mp_list = _tmp24_;
#line 1466 "Utility/Device.vala"
		_tmp25_ = _mp_list;
#line 1466 "Utility/Device.vala"
		_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 1466 "Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1466 "Utility/Device.vala"
		_mp_size = _tmp27_;
#line 1466 "Utility/Device.vala"
		_mp_index = -1;
#line 1466 "Utility/Device.vala"
		while (TRUE) {
#line 8677 "Device.c"
			MountEntry* mp = NULL;
			GeeArrayList* _tmp28_;
			gpointer _tmp29_;
			gboolean _tmp30_ = FALSE;
			MountEntry* _tmp31_;
			const gchar* _tmp32_;
#line 1466 "Utility/Device.vala"
			_mp_index = _mp_index + 1;
#line 1466 "Utility/Device.vala"
			if (!(_mp_index < _mp_size)) {
#line 1466 "Utility/Device.vala"
				break;
#line 8690 "Device.c"
			}
#line 1466 "Utility/Device.vala"
			_tmp28_ = _mp_list;
#line 1466 "Utility/Device.vala"
			_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, _mp_index);
#line 1466 "Utility/Device.vala"
			mp = (MountEntry*) _tmp29_;
#line 1467 "Utility/Device.vala"
			_tmp31_ = mp;
#line 1467 "Utility/Device.vala"
			_tmp32_ = _tmp31_->mount_point;
#line 1467 "Utility/Device.vala"
			if (g_strcmp0 (_tmp32_, mount_point) == 0) {
#line 8704 "Device.c"
				MountEntry* _tmp33_;
				const gchar* _tmp34_;
#line 1467 "Utility/Device.vala"
				_tmp33_ = mp;
#line 1467 "Utility/Device.vala"
				_tmp34_ = _tmp33_->mount_options;
#line 1467 "Utility/Device.vala"
				_tmp30_ = string_contains (_tmp34_, mount_options);
#line 8713 "Device.c"
			} else {
#line 1467 "Utility/Device.vala"
				_tmp30_ = FALSE;
#line 8717 "Device.c"
			}
#line 1467 "Utility/Device.vala"
			if (_tmp30_) {
#line 1468 "Utility/Device.vala"
				if (!silent) {
#line 8723 "Device.c"
					gchar* msg = NULL;
					const gchar* _tmp35_;
					gchar* _tmp36_;
					MountEntry* _tmp37_;
					const gchar* _tmp38_;
					gint _tmp39_;
					gint _tmp40_;
					const gchar* _tmp47_;
#line 1469 "Utility/Device.vala"
					_tmp35_ = device;
#line 1469 "Utility/Device.vala"
					_tmp36_ = g_strdup_printf ("%s is mounted at: %s", _tmp35_, mount_point);
#line 1469 "Utility/Device.vala"
					msg = _tmp36_;
#line 1470 "Utility/Device.vala"
					_tmp37_ = mp;
#line 1470 "Utility/Device.vala"
					_tmp38_ = _tmp37_->mount_options;
#line 1470 "Utility/Device.vala"
					_tmp39_ = strlen (_tmp38_);
#line 1470 "Utility/Device.vala"
					_tmp40_ = _tmp39_;
#line 1470 "Utility/Device.vala"
					if (_tmp40_ > 0) {
#line 8748 "Device.c"
						const gchar* _tmp41_;
						MountEntry* _tmp42_;
						const gchar* _tmp43_;
						gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
#line 1471 "Utility/Device.vala"
						_tmp41_ = msg;
#line 1471 "Utility/Device.vala"
						_tmp42_ = mp;
#line 1471 "Utility/Device.vala"
						_tmp43_ = _tmp42_->mount_options;
#line 1471 "Utility/Device.vala"
						_tmp44_ = g_strdup_printf (", options: %s", _tmp43_);
#line 1471 "Utility/Device.vala"
						_tmp45_ = _tmp44_;
#line 1471 "Utility/Device.vala"
						_tmp46_ = g_strconcat (_tmp41_, _tmp45_, NULL);
#line 1471 "Utility/Device.vala"
						_g_free0 (msg);
#line 1471 "Utility/Device.vala"
						msg = _tmp46_;
#line 1471 "Utility/Device.vala"
						_g_free0 (_tmp45_);
#line 8773 "Device.c"
					}
#line 1473 "Utility/Device.vala"
					_tmp47_ = msg;
#line 1473 "Utility/Device.vala"
					tee_jee_logging_log_msg (_tmp47_, FALSE);
#line 1468 "Utility/Device.vala"
					_g_free0 (msg);
#line 8781 "Device.c"
				}
#line 1475 "Utility/Device.vala"
				result = TRUE;
#line 1475 "Utility/Device.vala"
				_g_object_unref0 (mp);
#line 1475 "Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 1475 "Utility/Device.vala"
				_g_object_unref0 (mps);
#line 1475 "Utility/Device.vala"
				_g_free0 (uuid);
#line 1475 "Utility/Device.vala"
				_g_free0 (device);
#line 1475 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1475 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1475 "Utility/Device.vala"
				_g_free0 (cmd);
#line 1475 "Utility/Device.vala"
				return result;
#line 8803 "Device.c"
			}
#line 1466 "Utility/Device.vala"
			_g_object_unref0 (mp);
#line 8807 "Device.c"
		}
#line 1466 "Utility/Device.vala"
		_g_object_unref0 (_mp_list);
#line 8811 "Device.c"
	}
#line 1479 "Utility/Device.vala"
	tee_jee_file_system_dir_create (mount_point, FALSE);
#line 1483 "Utility/Device.vala"
	device_unmount (mount_point);
#line 1487 "Utility/Device.vala"
	_tmp48_ = strlen (mount_options);
#line 1487 "Utility/Device.vala"
	_tmp49_ = _tmp48_;
#line 1487 "Utility/Device.vala"
	if (_tmp49_ > 0) {
#line 8823 "Device.c"
		const gchar* _tmp50_;
		gchar* _tmp51_;
#line 1488 "Utility/Device.vala"
		_tmp50_ = device;
#line 1488 "Utility/Device.vala"
		_tmp51_ = g_strdup_printf ("mount -o %s \"%s\" \"%s\"", mount_options, _tmp50_, mount_point);
#line 1488 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1488 "Utility/Device.vala"
		cmd = _tmp51_;
#line 8834 "Device.c"
	} else {
		const gchar* _tmp52_;
		gchar* _tmp53_;
#line 1491 "Utility/Device.vala"
		_tmp52_ = device;
#line 1491 "Utility/Device.vala"
		_tmp53_ = g_strdup_printf ("mount \"%s\" \"%s\"", _tmp52_, mount_point);
#line 1491 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1491 "Utility/Device.vala"
		cmd = _tmp53_;
#line 8846 "Device.c"
	}
#line 1494 "Utility/Device.vala"
	_tmp54_ = cmd;
#line 1494 "Utility/Device.vala"
	_tmp57_ = tee_jee_process_helper_exec_sync (_tmp54_, &_tmp55_, &_tmp56_);
#line 1494 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1494 "Utility/Device.vala"
	std_out = _tmp55_;
#line 1494 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1494 "Utility/Device.vala"
	std_err = _tmp56_;
#line 1494 "Utility/Device.vala"
	ret_val = _tmp57_;
#line 1496 "Utility/Device.vala"
	if (ret_val != 0) {
#line 8864 "Device.c"
		const gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		const gchar* _tmp61_;
#line 1497 "Utility/Device.vala"
		_tmp58_ = device;
#line 1497 "Utility/Device.vala"
		_tmp59_ = g_strdup_printf ("Failed to mount device '%s' at mount point '%s'", _tmp58_, mount_point);
#line 1497 "Utility/Device.vala"
		_tmp60_ = _tmp59_;
#line 1497 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp60_, FALSE, FALSE);
#line 1497 "Utility/Device.vala"
		_g_free0 (_tmp60_);
#line 1498 "Utility/Device.vala"
		_tmp61_ = std_err;
#line 1498 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp61_, FALSE, FALSE);
#line 1499 "Utility/Device.vala"
		result = FALSE;
#line 1499 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1499 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1499 "Utility/Device.vala"
		_g_free0 (device);
#line 1499 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1499 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1499 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1499 "Utility/Device.vala"
		return result;
#line 8899 "Device.c"
	} else {
#line 1502 "Utility/Device.vala"
		if (!silent) {
#line 8903 "Device.c"
			Device* dev = NULL;
			const gchar* _tmp62_;
			Device* _tmp63_;
			gchar* _tmp64_ = NULL;
			Device* _tmp65_;
			gchar* _tmp71_ = NULL;
			gint _tmp72_;
			gint _tmp73_;
			gchar* _tmp76_;
			gchar* _tmp77_;
#line 1503 "Utility/Device.vala"
			_tmp62_ = device;
#line 1503 "Utility/Device.vala"
			_tmp63_ = device_get_device_by_name (_tmp62_);
#line 1503 "Utility/Device.vala"
			dev = _tmp63_;
#line 1505 "Utility/Device.vala"
			_tmp65_ = dev;
#line 1505 "Utility/Device.vala"
			if (_tmp65_ == NULL) {
#line 8924 "Device.c"
				const gchar* _tmp66_;
				gchar* _tmp67_;
#line 1505 "Utility/Device.vala"
				_tmp66_ = device;
#line 1505 "Utility/Device.vala"
				_tmp67_ = g_strdup (_tmp66_);
#line 1505 "Utility/Device.vala"
				_g_free0 (_tmp64_);
#line 1505 "Utility/Device.vala"
				_tmp64_ = _tmp67_;
#line 8935 "Device.c"
			} else {
				Device* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
#line 1505 "Utility/Device.vala"
				_tmp68_ = dev;
#line 1505 "Utility/Device.vala"
				_tmp69_ = device_get_device_name_with_parent (_tmp68_);
#line 1505 "Utility/Device.vala"
				_tmp70_ = _tmp69_;
#line 1505 "Utility/Device.vala"
				_g_free0 (_tmp64_);
#line 1505 "Utility/Device.vala"
				_tmp64_ = _tmp70_;
#line 8950 "Device.c"
			}
#line 1506 "Utility/Device.vala"
			_tmp72_ = strlen (mount_options);
#line 1506 "Utility/Device.vala"
			_tmp73_ = _tmp72_;
#line 1506 "Utility/Device.vala"
			if (_tmp73_ > 0) {
#line 8958 "Device.c"
				gchar* _tmp74_;
#line 1506 "Utility/Device.vala"
				_tmp74_ = g_strdup_printf (" (%s)", mount_options);
#line 1506 "Utility/Device.vala"
				_g_free0 (_tmp71_);
#line 1506 "Utility/Device.vala"
				_tmp71_ = _tmp74_;
#line 8966 "Device.c"
			} else {
				gchar* _tmp75_;
#line 1506 "Utility/Device.vala"
				_tmp75_ = g_strdup ("");
#line 1506 "Utility/Device.vala"
				_g_free0 (_tmp71_);
#line 1506 "Utility/Device.vala"
				_tmp71_ = _tmp75_;
#line 8975 "Device.c"
			}
#line 1504 "Utility/Device.vala"
			_tmp76_ = g_strdup_printf ("Mounted '%s'%s at '%s'", _tmp64_, _tmp71_, mount_point);
#line 1504 "Utility/Device.vala"
			_tmp77_ = _tmp76_;
#line 1504 "Utility/Device.vala"
			tee_jee_logging_log_msg (_tmp77_, FALSE);
#line 1504 "Utility/Device.vala"
			_g_free0 (_tmp77_);
#line 1502 "Utility/Device.vala"
			_g_free0 (_tmp71_);
#line 1502 "Utility/Device.vala"
			_g_free0 (_tmp64_);
#line 1502 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 8991 "Device.c"
		}
#line 1509 "Utility/Device.vala"
		result = TRUE;
#line 1509 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1509 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1509 "Utility/Device.vala"
		_g_free0 (device);
#line 1509 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1509 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1509 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1509 "Utility/Device.vala"
		return result;
#line 9009 "Device.c"
	}
#line 1427 "Utility/Device.vala"
	_g_object_unref0 (mps);
#line 1427 "Utility/Device.vala"
	_g_free0 (uuid);
#line 1427 "Utility/Device.vala"
	_g_free0 (device);
#line 1427 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1427 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1427 "Utility/Device.vala"
	_g_free0 (cmd);
#line 9023 "Device.c"
}

gchar*
device_automount (const gchar* dev_name_or_uuid,
                  const gchar* mount_options,
                  const gchar* mount_prefix)
{
	gchar* result = NULL;
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp9_;
	Device* dev = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	Device* _tmp12_;
	Device* _tmp13_;
	gchar* mount_point = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 1524 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 1524 "Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, NULL);
#line 1524 "Utility/Device.vala"
	g_return_val_if_fail (mount_prefix != NULL, NULL);
#line 1531 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1531 "Utility/Device.vala"
	device = _tmp0_;
#line 1532 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1532 "Utility/Device.vala"
	uuid = _tmp1_;
#line 1536 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 9065 "Device.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1537 "Utility/Device.vala"
		_tmp2_ = g_strdup (dev_name_or_uuid);
#line 1537 "Utility/Device.vala"
		_g_free0 (device);
#line 1537 "Utility/Device.vala"
		device = _tmp2_;
#line 1538 "Utility/Device.vala"
		_tmp3_ = device_get_device_uuid (dev_name_or_uuid);
#line 1538 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1538 "Utility/Device.vala"
		uuid = _tmp3_;
#line 9080 "Device.c"
	} else {
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1541 "Utility/Device.vala"
		_tmp4_ = g_strdup (dev_name_or_uuid);
#line 1541 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1541 "Utility/Device.vala"
		uuid = _tmp4_;
#line 1542 "Utility/Device.vala"
		_tmp5_ = uuid;
#line 1542 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp5_);
#line 1542 "Utility/Device.vala"
		_g_free0 (device);
#line 1542 "Utility/Device.vala"
		device = _tmp6_;
#line 1543 "Utility/Device.vala"
		_tmp7_ = device;
#line 1543 "Utility/Device.vala"
		_tmp8_ = device_resolve_device_name (_tmp7_);
#line 1543 "Utility/Device.vala"
		_g_free0 (device);
#line 1543 "Utility/Device.vala"
		device = _tmp8_;
#line 9109 "Device.c"
	}
#line 1548 "Utility/Device.vala"
	_tmp9_ = device_get_block_devices_using_lsblk ("");
#line 1548 "Utility/Device.vala"
	list = _tmp9_;
#line 1549 "Utility/Device.vala"
	_tmp10_ = list;
#line 1549 "Utility/Device.vala"
	_tmp11_ = uuid;
#line 1549 "Utility/Device.vala"
	_tmp12_ = device_find_device_in_list (_tmp10_, _tmp11_);
#line 1549 "Utility/Device.vala"
	dev = _tmp12_;
#line 1550 "Utility/Device.vala"
	_tmp13_ = dev;
#line 1550 "Utility/Device.vala"
	if (_tmp13_ != NULL) {
#line 9127 "Device.c"
		Device* _tmp14_;
		GeeArrayList* _tmp15_;
		gpointer _tmp16_;
		MountEntry* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 1551 "Utility/Device.vala"
		_tmp14_ = dev;
#line 1551 "Utility/Device.vala"
		_tmp15_ = _tmp14_->mount_points;
#line 1551 "Utility/Device.vala"
		_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, 0);
#line 1551 "Utility/Device.vala"
		_tmp17_ = (MountEntry*) _tmp16_;
#line 1551 "Utility/Device.vala"
		_tmp18_ = _tmp17_->mount_point;
#line 1551 "Utility/Device.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 1551 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1551 "Utility/Device.vala"
		_g_object_unref0 (_tmp17_);
#line 1551 "Utility/Device.vala"
		result = _tmp20_;
#line 1551 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1551 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1551 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1551 "Utility/Device.vala"
		_g_free0 (device);
#line 1551 "Utility/Device.vala"
		return result;
#line 9163 "Device.c"
	}
#line 1556 "Utility/Device.vala"
	_tmp21_ = uuid;
#line 1556 "Utility/Device.vala"
	_tmp22_ = g_strdup_printf ("%s/%s", mount_prefix, _tmp21_);
#line 1556 "Utility/Device.vala"
	mount_point = _tmp22_;
#line 9171 "Device.c"
	{
		GFile* file = NULL;
		const gchar* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
#line 1559 "Utility/Device.vala"
		_tmp23_ = mount_point;
#line 1559 "Utility/Device.vala"
		_tmp24_ = g_file_new_for_path (_tmp23_);
#line 1559 "Utility/Device.vala"
		file = _tmp24_;
#line 1560 "Utility/Device.vala"
		_tmp25_ = file;
#line 1560 "Utility/Device.vala"
		if (!g_file_query_exists (_tmp25_, NULL)) {
#line 9187 "Device.c"
			GFile* _tmp26_;
#line 1561 "Utility/Device.vala"
			_tmp26_ = file;
#line 1561 "Utility/Device.vala"
			g_file_make_directory_with_parents (_tmp26_, NULL, &_inner_error0_);
#line 1561 "Utility/Device.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1561 "Utility/Device.vala"
				_g_object_unref0 (file);
#line 9197 "Device.c"
				goto __catch47_g_error;
			}
		}
#line 1558 "Utility/Device.vala"
		_g_object_unref0 (file);
#line 9203 "Device.c"
	}
	goto __finally47;
	__catch47_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1558 "Utility/Device.vala"
		e = _inner_error0_;
#line 1558 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 1565 "Utility/Device.vala"
		_tmp27_ = e;
#line 1565 "Utility/Device.vala"
		_tmp28_ = _tmp27_->message;
#line 1565 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp28_, FALSE, FALSE);
#line 1566 "Utility/Device.vala"
		_tmp29_ = g_strdup ("");
#line 1566 "Utility/Device.vala"
		result = _tmp29_;
#line 1566 "Utility/Device.vala"
		_g_error_free0 (e);
#line 1566 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1566 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1566 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1566 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1566 "Utility/Device.vala"
		_g_free0 (device);
#line 1566 "Utility/Device.vala"
		return result;
#line 9240 "Device.c"
	}
	__finally47:
#line 1558 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1558 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1558 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1558 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1558 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1558 "Utility/Device.vala"
		_g_free0 (device);
#line 1558 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1558 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1558 "Utility/Device.vala"
		return NULL;
#line 9261 "Device.c"
	}
#line 1571 "Utility/Device.vala"
	_tmp30_ = uuid;
#line 1571 "Utility/Device.vala"
	_tmp31_ = mount_point;
#line 1571 "Utility/Device.vala"
	if (device_mount (_tmp30_, _tmp31_, mount_options, FALSE)) {
#line 1572 "Utility/Device.vala"
		result = mount_point;
#line 1572 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1572 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1572 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1572 "Utility/Device.vala"
		_g_free0 (device);
#line 1572 "Utility/Device.vala"
		return result;
#line 9281 "Device.c"
	} else {
		gchar* _tmp32_;
#line 1575 "Utility/Device.vala"
		_tmp32_ = g_strdup ("");
#line 1575 "Utility/Device.vala"
		result = _tmp32_;
#line 1575 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1575 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1575 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1575 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1575 "Utility/Device.vala"
		_g_free0 (device);
#line 1575 "Utility/Device.vala"
		return result;
#line 9300 "Device.c"
	}
#line 1524 "Utility/Device.vala"
	_g_free0 (mount_point);
#line 1524 "Utility/Device.vala"
	_g_object_unref0 (dev);
#line 1524 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1524 "Utility/Device.vala"
	_g_free0 (uuid);
#line 1524 "Utility/Device.vala"
	_g_free0 (device);
#line 9312 "Device.c"
}

gboolean
device_unmount (const gchar* mount_point)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
#line 1579 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1584 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1584 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1590 "Utility/Device.vala"
	if (!device_mount_point_in_use (mount_point)) {
#line 1591 "Utility/Device.vala"
		result = TRUE;
#line 1591 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1591 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1591 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1591 "Utility/Device.vala"
		return result;
#line 9343 "Device.c"
	}
	{
		gchar* cmd_unmount = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gint _tmp14_;
#line 1598 "Utility/Device.vala"
		_tmp1_ = g_strdup_printf ("cat /proc/mounts | awk '{print $2}' | grep '%s' | sort -r | xargs umou" \
"nt", mount_point);
#line 1598 "Utility/Device.vala"
		cmd_unmount = _tmp1_;
#line 1600 "Utility/Device.vala"
		_tmp2_ = g_strdup_printf (": '%s'", mount_point);
#line 1600 "Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1600 "Utility/Device.vala"
		_tmp4_ = g_strconcat (_ ("Unmounting from"), _tmp3_, NULL);
#line 1600 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1600 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp5_);
#line 1600 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1600 "Utility/Device.vala"
		_g_free0 (_tmp3_);
#line 1603 "Utility/Device.vala"
		_tmp6_ = g_strdup ("sync");
#line 1603 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1603 "Utility/Device.vala"
		cmd = _tmp6_;
#line 1604 "Utility/Device.vala"
		_tmp7_ = cmd;
#line 1604 "Utility/Device.vala"
		g_spawn_command_line_sync (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_inner_error0_);
#line 1604 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1604 "Utility/Device.vala"
		std_out = _tmp8_;
#line 1604 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1604 "Utility/Device.vala"
		std_err = _tmp9_;
#line 1604 "Utility/Device.vala"
		ret_val = _tmp10_;
#line 1604 "Utility/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1604 "Utility/Device.vala"
			_g_free0 (cmd_unmount);
#line 9403 "Device.c"
			goto __catch48_g_error;
		}
#line 1608 "Utility/Device.vala"
		_tmp11_ = cmd_unmount;
#line 1608 "Utility/Device.vala"
		_tmp14_ = tee_jee_process_helper_exec_script_sync (_tmp11_, &_tmp12_, &_tmp13_, FALSE, FALSE, TRUE, FALSE);
#line 1608 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1608 "Utility/Device.vala"
		std_out = _tmp12_;
#line 1608 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1608 "Utility/Device.vala"
		std_err = _tmp13_;
#line 1608 "Utility/Device.vala"
		ret_val = _tmp14_;
#line 1610 "Utility/Device.vala"
		if (ret_val != 0) {
#line 9422 "Device.c"
			const gchar* _tmp15_;
#line 1611 "Utility/Device.vala"
			tee_jee_logging_log_error (_ ("Failed to unmount"), FALSE, FALSE);
#line 1612 "Utility/Device.vala"
			_tmp15_ = std_err;
#line 1612 "Utility/Device.vala"
			tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 9430 "Device.c"
		}
#line 1596 "Utility/Device.vala"
		_g_free0 (cmd_unmount);
#line 9434 "Device.c"
	}
	goto __finally48;
	__catch48_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 1596 "Utility/Device.vala"
		e = _inner_error0_;
#line 1596 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 1616 "Utility/Device.vala"
		_tmp16_ = e;
#line 1616 "Utility/Device.vala"
		_tmp17_ = _tmp16_->message;
#line 1616 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 1617 "Utility/Device.vala"
		result = FALSE;
#line 1617 "Utility/Device.vala"
		_g_error_free0 (e);
#line 1617 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1617 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1617 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1617 "Utility/Device.vala"
		return result;
#line 9464 "Device.c"
	}
	__finally48:
#line 1596 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9469 "Device.c"
		gboolean _tmp18_ = FALSE;
#line 1596 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1596 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1596 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1596 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1596 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1596 "Utility/Device.vala"
		return _tmp18_;
#line 9483 "Device.c"
	}
#line 1621 "Utility/Device.vala"
	if (!device_mount_point_in_use (mount_point)) {
#line 1622 "Utility/Device.vala"
		result = TRUE;
#line 1622 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1622 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1622 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1622 "Utility/Device.vala"
		return result;
#line 9497 "Device.c"
	} else {
#line 1625 "Utility/Device.vala"
		result = FALSE;
#line 1625 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1625 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1625 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1625 "Utility/Device.vala"
		return result;
#line 9509 "Device.c"
	}
#line 1579 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1579 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1579 "Utility/Device.vala"
	_g_free0 (cmd);
#line 9517 "Device.c"
}

gchar*
device_description (Device* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 1681 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1682 "Utility/Device.vala"
	_tmp0_ = device_description_formatted (self);
#line 1682 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1682 "Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1682 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1682 "Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1682 "Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1682 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1682 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1682 "Utility/Device.vala"
	result = _tmp5_;
#line 1682 "Utility/Device.vala"
	return result;
#line 9552 "Device.c"
}

gchar*
device_description_formatted (Device* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
#line 1685 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1686 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1686 "Utility/Device.vala"
	s = _tmp0_;
#line 1688 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1688 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 9574 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
#line 1689 "Utility/Device.vala"
		_tmp2_ = s;
#line 1689 "Utility/Device.vala"
		_tmp3_ = self->kname;
#line 1689 "Utility/Device.vala"
		_tmp4_ = g_strconcat ("<b>", _tmp3_, NULL);
#line 1689 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1689 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp5_, "</b> ~", NULL);
#line 1689 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1689 "Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp2_, _tmp7_, NULL);
#line 1689 "Utility/Device.vala"
		_g_free0 (s);
#line 1689 "Utility/Device.vala"
		s = _tmp8_;
#line 1689 "Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 1689 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1690 "Utility/Device.vala"
		_tmp9_ = self->vendor;
#line 1690 "Utility/Device.vala"
		_tmp10_ = strlen (_tmp9_);
#line 1690 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1690 "Utility/Device.vala"
		if (_tmp11_ > 0) {
#line 9618 "Device.c"
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 1691 "Utility/Device.vala"
			_tmp12_ = s;
#line 1691 "Utility/Device.vala"
			_tmp13_ = self->vendor;
#line 1691 "Utility/Device.vala"
			_tmp14_ = g_strconcat (" ", _tmp13_, NULL);
#line 1691 "Utility/Device.vala"
			_tmp15_ = _tmp14_;
#line 1691 "Utility/Device.vala"
			_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1691 "Utility/Device.vala"
			_g_free0 (s);
#line 1691 "Utility/Device.vala"
			s = _tmp16_;
#line 1691 "Utility/Device.vala"
			_g_free0 (_tmp15_);
#line 9640 "Device.c"
		}
#line 1693 "Utility/Device.vala"
		_tmp17_ = self->model;
#line 1693 "Utility/Device.vala"
		_tmp18_ = strlen (_tmp17_);
#line 1693 "Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1693 "Utility/Device.vala"
		if (_tmp19_ > 0) {
#line 9650 "Device.c"
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 1694 "Utility/Device.vala"
			_tmp20_ = s;
#line 1694 "Utility/Device.vala"
			_tmp21_ = self->model;
#line 1694 "Utility/Device.vala"
			_tmp22_ = g_strconcat (" ", _tmp21_, NULL);
#line 1694 "Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 1694 "Utility/Device.vala"
			_tmp24_ = g_strconcat (_tmp20_, _tmp23_, NULL);
#line 1694 "Utility/Device.vala"
			_g_free0 (s);
#line 1694 "Utility/Device.vala"
			s = _tmp24_;
#line 1694 "Utility/Device.vala"
			_g_free0 (_tmp23_);
#line 9672 "Device.c"
		}
#line 1696 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 9676 "Device.c"
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 1697 "Utility/Device.vala"
			_tmp25_ = s;
#line 1697 "Utility/Device.vala"
			_tmp26_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1697 "Utility/Device.vala"
			_tmp27_ = _tmp26_;
#line 1697 "Utility/Device.vala"
			_tmp28_ = g_strdup_printf (" (%s)", _tmp27_);
#line 1697 "Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 1697 "Utility/Device.vala"
			_tmp30_ = g_strconcat (_tmp25_, _tmp29_, NULL);
#line 1697 "Utility/Device.vala"
			_g_free0 (s);
#line 1697 "Utility/Device.vala"
			s = _tmp30_;
#line 1697 "Utility/Device.vala"
			_g_free0 (_tmp29_);
#line 1697 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 9703 "Device.c"
		}
	} else {
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_ = NULL;
		const gchar* _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_ = NULL;
		const gchar* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
#line 1701 "Utility/Device.vala"
		_tmp31_ = s;
#line 1701 "Utility/Device.vala"
		_tmp32_ = device_get_short_name_with_parent (self);
#line 1701 "Utility/Device.vala"
		_tmp33_ = _tmp32_;
#line 1701 "Utility/Device.vala"
		_tmp34_ = _tmp33_;
#line 1701 "Utility/Device.vala"
		_tmp35_ = g_strconcat ("<b>", _tmp34_, NULL);
#line 1701 "Utility/Device.vala"
		_tmp36_ = _tmp35_;
#line 1701 "Utility/Device.vala"
		_tmp37_ = g_strconcat (_tmp36_, "</b>", NULL);
#line 1701 "Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1701 "Utility/Device.vala"
		_tmp39_ = g_strconcat (_tmp31_, _tmp38_, NULL);
#line 1701 "Utility/Device.vala"
		_g_free0 (s);
#line 1701 "Utility/Device.vala"
		s = _tmp39_;
#line 1701 "Utility/Device.vala"
		_g_free0 (_tmp38_);
#line 1701 "Utility/Device.vala"
		_g_free0 (_tmp36_);
#line 1701 "Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 1702 "Utility/Device.vala"
		_tmp41_ = self->label;
#line 1702 "Utility/Device.vala"
		_tmp42_ = strlen (_tmp41_);
#line 1702 "Utility/Device.vala"
		_tmp43_ = _tmp42_;
#line 1702 "Utility/Device.vala"
		if (_tmp43_ > 0) {
#line 9763 "Device.c"
			const gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
#line 1702 "Utility/Device.vala"
			_tmp44_ = self->label;
#line 1702 "Utility/Device.vala"
			_tmp45_ = g_strconcat (" (", _tmp44_, NULL);
#line 1702 "Utility/Device.vala"
			_tmp46_ = _tmp45_;
#line 1702 "Utility/Device.vala"
			_tmp47_ = g_strconcat (_tmp46_, ")", NULL);
#line 1702 "Utility/Device.vala"
			_g_free0 (_tmp40_);
#line 1702 "Utility/Device.vala"
			_tmp40_ = _tmp47_;
#line 1702 "Utility/Device.vala"
			_g_free0 (_tmp46_);
#line 9782 "Device.c"
		} else {
			gchar* _tmp48_;
#line 1702 "Utility/Device.vala"
			_tmp48_ = g_strdup ("");
#line 1702 "Utility/Device.vala"
			_g_free0 (_tmp40_);
#line 1702 "Utility/Device.vala"
			_tmp40_ = _tmp48_;
#line 9791 "Device.c"
		}
#line 1702 "Utility/Device.vala"
		_tmp49_ = s;
#line 1702 "Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp49_, _tmp40_, NULL);
#line 1702 "Utility/Device.vala"
		_g_free0 (s);
#line 1702 "Utility/Device.vala"
		s = _tmp50_;
#line 1703 "Utility/Device.vala"
		_tmp52_ = self->fstype;
#line 1703 "Utility/Device.vala"
		_tmp53_ = strlen (_tmp52_);
#line 1703 "Utility/Device.vala"
		_tmp54_ = _tmp53_;
#line 1703 "Utility/Device.vala"
		if (_tmp54_ > 0) {
#line 9809 "Device.c"
			const gchar* _tmp55_;
			gchar* _tmp56_;
#line 1703 "Utility/Device.vala"
			_tmp55_ = self->fstype;
#line 1703 "Utility/Device.vala"
			_tmp56_ = g_strconcat (" ~ ", _tmp55_, NULL);
#line 1703 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 1703 "Utility/Device.vala"
			_tmp51_ = _tmp56_;
#line 9820 "Device.c"
		} else {
			gchar* _tmp57_;
#line 1703 "Utility/Device.vala"
			_tmp57_ = g_strdup ("");
#line 1703 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 1703 "Utility/Device.vala"
			_tmp51_ = _tmp57_;
#line 9829 "Device.c"
		}
#line 1703 "Utility/Device.vala"
		_tmp58_ = s;
#line 1703 "Utility/Device.vala"
		_tmp59_ = g_strconcat (_tmp58_, _tmp51_, NULL);
#line 1703 "Utility/Device.vala"
		_g_free0 (s);
#line 1703 "Utility/Device.vala"
		s = _tmp59_;
#line 1704 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 9841 "Device.c"
			const gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
#line 1705 "Utility/Device.vala"
			_tmp60_ = s;
#line 1705 "Utility/Device.vala"
			_tmp61_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1705 "Utility/Device.vala"
			_tmp62_ = _tmp61_;
#line 1705 "Utility/Device.vala"
			_tmp63_ = g_strdup_printf (" (%s)", _tmp62_);
#line 1705 "Utility/Device.vala"
			_tmp64_ = _tmp63_;
#line 1705 "Utility/Device.vala"
			_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 1705 "Utility/Device.vala"
			_g_free0 (s);
#line 1705 "Utility/Device.vala"
			s = _tmp65_;
#line 1705 "Utility/Device.vala"
			_g_free0 (_tmp64_);
#line 1705 "Utility/Device.vala"
			_g_free0 (_tmp62_);
#line 9868 "Device.c"
		}
#line 1688 "Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1688 "Utility/Device.vala"
		_g_free0 (_tmp40_);
#line 9874 "Device.c"
	}
#line 1709 "Utility/Device.vala"
	_tmp66_ = s;
#line 1709 "Utility/Device.vala"
	_tmp67_ = string_strip (_tmp66_);
#line 1709 "Utility/Device.vala"
	result = _tmp67_;
#line 1709 "Utility/Device.vala"
	_g_free0 (s);
#line 1709 "Utility/Device.vala"
	return result;
#line 9886 "Device.c"
}

gchar*
device_description_simple (Device* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 1712 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1713 "Utility/Device.vala"
	_tmp0_ = device_description_simple_formatted (self);
#line 1713 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1713 "Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1713 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1713 "Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1713 "Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1713 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1713 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1713 "Utility/Device.vala"
	result = _tmp5_;
#line 1713 "Utility/Device.vala"
	return result;
#line 9921 "Device.c"
}

gchar*
device_description_simple_formatted (Device* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp71_;
	gchar* _tmp72_;
#line 1716 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1718 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1718 "Utility/Device.vala"
	s = _tmp0_;
#line 1720 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1720 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 9943 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1721 "Utility/Device.vala"
		_tmp2_ = self->vendor;
#line 1721 "Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 1721 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 1721 "Utility/Device.vala"
		if (_tmp4_ > 0) {
#line 9958 "Device.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 1722 "Utility/Device.vala"
			_tmp5_ = s;
#line 1722 "Utility/Device.vala"
			_tmp6_ = self->vendor;
#line 1722 "Utility/Device.vala"
			_tmp7_ = g_strconcat (" ", _tmp6_, NULL);
#line 1722 "Utility/Device.vala"
			_tmp8_ = _tmp7_;
#line 1722 "Utility/Device.vala"
			_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1722 "Utility/Device.vala"
			_g_free0 (s);
#line 1722 "Utility/Device.vala"
			s = _tmp9_;
#line 1722 "Utility/Device.vala"
			_g_free0 (_tmp8_);
#line 9980 "Device.c"
		}
#line 1724 "Utility/Device.vala"
		_tmp10_ = self->model;
#line 1724 "Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1724 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1724 "Utility/Device.vala"
		if (_tmp12_ > 0) {
#line 9990 "Device.c"
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 1725 "Utility/Device.vala"
			_tmp13_ = s;
#line 1725 "Utility/Device.vala"
			_tmp14_ = self->model;
#line 1725 "Utility/Device.vala"
			_tmp15_ = g_strconcat (" ", _tmp14_, NULL);
#line 1725 "Utility/Device.vala"
			_tmp16_ = _tmp15_;
#line 1725 "Utility/Device.vala"
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
#line 1725 "Utility/Device.vala"
			_g_free0 (s);
#line 1725 "Utility/Device.vala"
			s = _tmp17_;
#line 1725 "Utility/Device.vala"
			_g_free0 (_tmp16_);
#line 10012 "Device.c"
		}
#line 1727 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 10016 "Device.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gboolean _tmp23_;
#line 1728 "Utility/Device.vala"
			_tmp18_ = s;
#line 1728 "Utility/Device.vala"
			_tmp19_ = string_strip (_tmp18_);
#line 1728 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1728 "Utility/Device.vala"
			_tmp21_ = strlen (_tmp20_);
#line 1728 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1728 "Utility/Device.vala"
			_tmp23_ = _tmp22_ == 0;
#line 1728 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1728 "Utility/Device.vala"
			if (_tmp23_) {
#line 10039 "Device.c"
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 1729 "Utility/Device.vala"
				_tmp24_ = s;
#line 1729 "Utility/Device.vala"
				_tmp25_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1729 "Utility/Device.vala"
				_tmp26_ = _tmp25_;
#line 1729 "Utility/Device.vala"
				_tmp27_ = g_strdup_printf ("%s Device", _tmp26_);
#line 1729 "Utility/Device.vala"
				_tmp28_ = _tmp27_;
#line 1729 "Utility/Device.vala"
				_tmp29_ = g_strconcat (_tmp24_, _tmp28_, NULL);
#line 1729 "Utility/Device.vala"
				_g_free0 (s);
#line 1729 "Utility/Device.vala"
				s = _tmp29_;
#line 1729 "Utility/Device.vala"
				_g_free0 (_tmp28_);
#line 1729 "Utility/Device.vala"
				_g_free0 (_tmp26_);
#line 10066 "Device.c"
			} else {
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 1732 "Utility/Device.vala"
				_tmp30_ = s;
#line 1732 "Utility/Device.vala"
				_tmp31_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1732 "Utility/Device.vala"
				_tmp32_ = _tmp31_;
#line 1732 "Utility/Device.vala"
				_tmp33_ = g_strdup_printf (" (%s)", _tmp32_);
#line 1732 "Utility/Device.vala"
				_tmp34_ = _tmp33_;
#line 1732 "Utility/Device.vala"
				_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
#line 1732 "Utility/Device.vala"
				_g_free0 (s);
#line 1732 "Utility/Device.vala"
				s = _tmp35_;
#line 1732 "Utility/Device.vala"
				_g_free0 (_tmp34_);
#line 1732 "Utility/Device.vala"
				_g_free0 (_tmp32_);
#line 10094 "Device.c"
			}
		}
	} else {
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_ = NULL;
		const gchar* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_ = NULL;
		const gchar* _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		const gchar* _tmp63_;
		gchar* _tmp64_;
#line 1737 "Utility/Device.vala"
		_tmp36_ = s;
#line 1737 "Utility/Device.vala"
		_tmp37_ = device_get_short_name_with_parent (self);
#line 1737 "Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1737 "Utility/Device.vala"
		_tmp39_ = _tmp38_;
#line 1737 "Utility/Device.vala"
		_tmp40_ = g_strconcat ("<b>", _tmp39_, NULL);
#line 1737 "Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1737 "Utility/Device.vala"
		_tmp42_ = g_strconcat (_tmp41_, "</b>", NULL);
#line 1737 "Utility/Device.vala"
		_tmp43_ = _tmp42_;
#line 1737 "Utility/Device.vala"
		_tmp44_ = g_strconcat (_tmp36_, _tmp43_, NULL);
#line 1737 "Utility/Device.vala"
		_g_free0 (s);
#line 1737 "Utility/Device.vala"
		s = _tmp44_;
#line 1737 "Utility/Device.vala"
		_g_free0 (_tmp43_);
#line 1737 "Utility/Device.vala"
		_g_free0 (_tmp41_);
#line 1737 "Utility/Device.vala"
		_g_free0 (_tmp39_);
#line 1738 "Utility/Device.vala"
		_tmp46_ = self->label;
#line 1738 "Utility/Device.vala"
		_tmp47_ = strlen (_tmp46_);
#line 1738 "Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1738 "Utility/Device.vala"
		if (_tmp48_ > 0) {
#line 10155 "Device.c"
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
#line 1738 "Utility/Device.vala"
			_tmp49_ = self->label;
#line 1738 "Utility/Device.vala"
			_tmp50_ = g_strconcat (" (", _tmp49_, NULL);
#line 1738 "Utility/Device.vala"
			_tmp51_ = _tmp50_;
#line 1738 "Utility/Device.vala"
			_tmp52_ = g_strconcat (_tmp51_, ")", NULL);
#line 1738 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 1738 "Utility/Device.vala"
			_tmp45_ = _tmp52_;
#line 1738 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 10174 "Device.c"
		} else {
			gchar* _tmp53_;
#line 1738 "Utility/Device.vala"
			_tmp53_ = g_strdup ("");
#line 1738 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 1738 "Utility/Device.vala"
			_tmp45_ = _tmp53_;
#line 10183 "Device.c"
		}
#line 1738 "Utility/Device.vala"
		_tmp54_ = s;
#line 1738 "Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp54_, _tmp45_, NULL);
#line 1738 "Utility/Device.vala"
		_g_free0 (s);
#line 1738 "Utility/Device.vala"
		s = _tmp55_;
#line 1739 "Utility/Device.vala"
		_tmp57_ = self->fstype;
#line 1739 "Utility/Device.vala"
		_tmp58_ = strlen (_tmp57_);
#line 1739 "Utility/Device.vala"
		_tmp59_ = _tmp58_;
#line 1739 "Utility/Device.vala"
		if (_tmp59_ > 0) {
#line 10201 "Device.c"
			const gchar* _tmp60_;
			gchar* _tmp61_;
#line 1739 "Utility/Device.vala"
			_tmp60_ = self->fstype;
#line 1739 "Utility/Device.vala"
			_tmp61_ = g_strconcat (" ~ ", _tmp60_, NULL);
#line 1739 "Utility/Device.vala"
			_g_free0 (_tmp56_);
#line 1739 "Utility/Device.vala"
			_tmp56_ = _tmp61_;
#line 10212 "Device.c"
		} else {
			gchar* _tmp62_;
#line 1739 "Utility/Device.vala"
			_tmp62_ = g_strdup ("");
#line 1739 "Utility/Device.vala"
			_g_free0 (_tmp56_);
#line 1739 "Utility/Device.vala"
			_tmp56_ = _tmp62_;
#line 10221 "Device.c"
		}
#line 1739 "Utility/Device.vala"
		_tmp63_ = s;
#line 1739 "Utility/Device.vala"
		_tmp64_ = g_strconcat (_tmp63_, _tmp56_, NULL);
#line 1739 "Utility/Device.vala"
		_g_free0 (s);
#line 1739 "Utility/Device.vala"
		s = _tmp64_;
#line 1740 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 10233 "Device.c"
			const gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
#line 1741 "Utility/Device.vala"
			_tmp65_ = s;
#line 1741 "Utility/Device.vala"
			_tmp66_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1741 "Utility/Device.vala"
			_tmp67_ = _tmp66_;
#line 1741 "Utility/Device.vala"
			_tmp68_ = g_strdup_printf (" (%s)", _tmp67_);
#line 1741 "Utility/Device.vala"
			_tmp69_ = _tmp68_;
#line 1741 "Utility/Device.vala"
			_tmp70_ = g_strconcat (_tmp65_, _tmp69_, NULL);
#line 1741 "Utility/Device.vala"
			_g_free0 (s);
#line 1741 "Utility/Device.vala"
			s = _tmp70_;
#line 1741 "Utility/Device.vala"
			_g_free0 (_tmp69_);
#line 1741 "Utility/Device.vala"
			_g_free0 (_tmp67_);
#line 10260 "Device.c"
		}
#line 1720 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1720 "Utility/Device.vala"
		_g_free0 (_tmp45_);
#line 10266 "Device.c"
	}
#line 1745 "Utility/Device.vala"
	_tmp71_ = s;
#line 1745 "Utility/Device.vala"
	_tmp72_ = string_strip (_tmp71_);
#line 1745 "Utility/Device.vala"
	result = _tmp72_;
#line 1745 "Utility/Device.vala"
	_g_free0 (s);
#line 1745 "Utility/Device.vala"
	return result;
#line 10278 "Device.c"
}

gchar*
device_description_full_free (Device* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1748 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1749 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1749 "Utility/Device.vala"
	s = _tmp0_;
#line 1751 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1751 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 10298 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1752 "Utility/Device.vala"
		_tmp2_ = s;
#line 1752 "Utility/Device.vala"
		_tmp3_ = self->model;
#line 1752 "Utility/Device.vala"
		_tmp4_ = self->vendor;
#line 1752 "Utility/Device.vala"
		_tmp5_ = g_strdup_printf ("%s %s", _tmp3_, _tmp4_);
#line 1752 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 1752 "Utility/Device.vala"
		_tmp7_ = string_strip (_tmp6_);
#line 1752 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1752 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp2_, _tmp8_, NULL);
#line 1752 "Utility/Device.vala"
		_g_free0 (s);
#line 1752 "Utility/Device.vala"
		s = _tmp9_;
#line 1752 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1752 "Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 1753 "Utility/Device.vala"
		_tmp10_ = s;
#line 1753 "Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1753 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1753 "Utility/Device.vala"
		if (_tmp12_ == 0) {
#line 10342 "Device.c"
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 1754 "Utility/Device.vala"
			_tmp13_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1754 "Utility/Device.vala"
			_tmp14_ = _tmp13_;
#line 1754 "Utility/Device.vala"
			_tmp15_ = g_strdup_printf ("%s Disk", _tmp14_);
#line 1754 "Utility/Device.vala"
			_g_free0 (s);
#line 1754 "Utility/Device.vala"
			s = _tmp15_;
#line 1754 "Utility/Device.vala"
			_g_free0 (_tmp14_);
#line 10358 "Device.c"
		} else {
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 1757 "Utility/Device.vala"
			_tmp16_ = s;
#line 1757 "Utility/Device.vala"
			_tmp17_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1757 "Utility/Device.vala"
			_tmp18_ = _tmp17_;
#line 1757 "Utility/Device.vala"
			_tmp19_ = g_strdup_printf (" (%s Disk)", _tmp18_);
#line 1757 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1757 "Utility/Device.vala"
			_tmp21_ = g_strconcat (_tmp16_, _tmp20_, NULL);
#line 1757 "Utility/Device.vala"
			_g_free0 (s);
#line 1757 "Utility/Device.vala"
			s = _tmp21_;
#line 1757 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1757 "Utility/Device.vala"
			_g_free0 (_tmp18_);
#line 10386 "Device.c"
		}
	} else {
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		guint64 _tmp41_;
		guint64 _tmp42_;
#line 1761 "Utility/Device.vala"
		_tmp22_ = s;
#line 1761 "Utility/Device.vala"
		_tmp23_ = self->kname;
#line 1761 "Utility/Device.vala"
		_tmp24_ = g_strconcat (_tmp22_, _tmp23_, NULL);
#line 1761 "Utility/Device.vala"
		_g_free0 (s);
#line 1761 "Utility/Device.vala"
		s = _tmp24_;
#line 1762 "Utility/Device.vala"
		_tmp25_ = self->label;
#line 1762 "Utility/Device.vala"
		_tmp26_ = strlen (_tmp25_);
#line 1762 "Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1762 "Utility/Device.vala"
		if (_tmp27_ > 0) {
#line 10418 "Device.c"
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 1763 "Utility/Device.vala"
			_tmp28_ = s;
#line 1763 "Utility/Device.vala"
			_tmp29_ = self->label;
#line 1763 "Utility/Device.vala"
			_tmp30_ = g_strdup_printf (" (%s)", _tmp29_);
#line 1763 "Utility/Device.vala"
			_tmp31_ = _tmp30_;
#line 1763 "Utility/Device.vala"
			_tmp32_ = g_strconcat (_tmp28_, _tmp31_, NULL);
#line 1763 "Utility/Device.vala"
			_g_free0 (s);
#line 1763 "Utility/Device.vala"
			s = _tmp32_;
#line 1763 "Utility/Device.vala"
			_g_free0 (_tmp31_);
#line 10440 "Device.c"
		}
#line 1765 "Utility/Device.vala"
		_tmp33_ = self->fstype;
#line 1765 "Utility/Device.vala"
		_tmp34_ = strlen (_tmp33_);
#line 1765 "Utility/Device.vala"
		_tmp35_ = _tmp34_;
#line 1765 "Utility/Device.vala"
		if (_tmp35_ > 0) {
#line 10450 "Device.c"
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 1766 "Utility/Device.vala"
			_tmp36_ = s;
#line 1766 "Utility/Device.vala"
			_tmp37_ = self->fstype;
#line 1766 "Utility/Device.vala"
			_tmp38_ = g_strdup_printf (" ~ %s", _tmp37_);
#line 1766 "Utility/Device.vala"
			_tmp39_ = _tmp38_;
#line 1766 "Utility/Device.vala"
			_tmp40_ = g_strconcat (_tmp36_, _tmp39_, NULL);
#line 1766 "Utility/Device.vala"
			_g_free0 (s);
#line 1766 "Utility/Device.vala"
			s = _tmp40_;
#line 1766 "Utility/Device.vala"
			_g_free0 (_tmp39_);
#line 10472 "Device.c"
		}
#line 1768 "Utility/Device.vala"
		_tmp41_ = device_get_free_bytes (self);
#line 1768 "Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1768 "Utility/Device.vala"
		if (_tmp42_ > ((guint64) 0)) {
#line 10480 "Device.c"
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
#line 1769 "Utility/Device.vala"
			_tmp43_ = s;
#line 1769 "Utility/Device.vala"
			_tmp44_ = device_description_free (self);
#line 1769 "Utility/Device.vala"
			_tmp45_ = _tmp44_;
#line 1769 "Utility/Device.vala"
			_tmp46_ = g_strdup_printf (" ~ %s", _tmp45_);
#line 1769 "Utility/Device.vala"
			_tmp47_ = _tmp46_;
#line 1769 "Utility/Device.vala"
			_tmp48_ = g_strconcat (_tmp43_, _tmp47_, NULL);
#line 1769 "Utility/Device.vala"
			_g_free0 (s);
#line 1769 "Utility/Device.vala"
			s = _tmp48_;
#line 1769 "Utility/Device.vala"
			_g_free0 (_tmp47_);
#line 1769 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 10507 "Device.c"
		}
	}
#line 1773 "Utility/Device.vala"
	result = s;
#line 1773 "Utility/Device.vala"
	return result;
#line 10514 "Device.c"
}

gchar*
device_description_full (Device* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp39_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
#line 1776 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1777 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1777 "Utility/Device.vala"
	s = _tmp0_;
#line 1778 "Utility/Device.vala"
	_tmp1_ = s;
#line 1778 "Utility/Device.vala"
	_tmp2_ = self->device;
#line 1778 "Utility/Device.vala"
	_tmp3_ = g_strconcat (_tmp1_, _tmp2_, NULL);
#line 1778 "Utility/Device.vala"
	_g_free0 (s);
#line 1778 "Utility/Device.vala"
	s = _tmp3_;
#line 1779 "Utility/Device.vala"
	_tmp5_ = self->label;
#line 1779 "Utility/Device.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1779 "Utility/Device.vala"
	_tmp7_ = _tmp6_;
#line 1779 "Utility/Device.vala"
	if (_tmp7_ > 0) {
#line 10577 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1779 "Utility/Device.vala"
		_tmp8_ = self->label;
#line 1779 "Utility/Device.vala"
		_tmp9_ = g_strconcat (" (", _tmp8_, NULL);
#line 1779 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1779 "Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp10_, ")", NULL);
#line 1779 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1779 "Utility/Device.vala"
		_tmp4_ = _tmp11_;
#line 1779 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 10596 "Device.c"
	} else {
		gchar* _tmp12_;
#line 1779 "Utility/Device.vala"
		_tmp12_ = g_strdup ("");
#line 1779 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1779 "Utility/Device.vala"
		_tmp4_ = _tmp12_;
#line 10605 "Device.c"
	}
#line 1779 "Utility/Device.vala"
	_tmp13_ = s;
#line 1779 "Utility/Device.vala"
	_tmp14_ = g_strconcat (_tmp13_, _tmp4_, NULL);
#line 1779 "Utility/Device.vala"
	_g_free0 (s);
#line 1779 "Utility/Device.vala"
	s = _tmp14_;
#line 1780 "Utility/Device.vala"
	_tmp16_ = self->uuid;
#line 1780 "Utility/Device.vala"
	_tmp17_ = strlen (_tmp16_);
#line 1780 "Utility/Device.vala"
	_tmp18_ = _tmp17_;
#line 1780 "Utility/Device.vala"
	if (_tmp18_ > 0) {
#line 10623 "Device.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 1780 "Utility/Device.vala"
		_tmp19_ = self->uuid;
#line 1780 "Utility/Device.vala"
		_tmp20_ = g_strconcat (" ~ ", _tmp19_, NULL);
#line 1780 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1780 "Utility/Device.vala"
		_tmp15_ = _tmp20_;
#line 10634 "Device.c"
	} else {
		gchar* _tmp21_;
#line 1780 "Utility/Device.vala"
		_tmp21_ = g_strdup ("");
#line 1780 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1780 "Utility/Device.vala"
		_tmp15_ = _tmp21_;
#line 10643 "Device.c"
	}
#line 1780 "Utility/Device.vala"
	_tmp22_ = s;
#line 1780 "Utility/Device.vala"
	_tmp23_ = g_strconcat (_tmp22_, _tmp15_, NULL);
#line 1780 "Utility/Device.vala"
	_g_free0 (s);
#line 1780 "Utility/Device.vala"
	s = _tmp23_;
#line 1781 "Utility/Device.vala"
	_tmp25_ = self->fstype;
#line 1781 "Utility/Device.vala"
	_tmp26_ = strlen (_tmp25_);
#line 1781 "Utility/Device.vala"
	_tmp27_ = _tmp26_;
#line 1781 "Utility/Device.vala"
	if (_tmp27_ > 0) {
#line 10661 "Device.c"
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1781 "Utility/Device.vala"
		_tmp28_ = self->fstype;
#line 1781 "Utility/Device.vala"
		_tmp29_ = g_strconcat (" ~ ", _tmp28_, NULL);
#line 1781 "Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1781 "Utility/Device.vala"
		_tmp24_ = _tmp29_;
#line 10672 "Device.c"
	} else {
		gchar* _tmp30_;
#line 1781 "Utility/Device.vala"
		_tmp30_ = g_strdup ("");
#line 1781 "Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1781 "Utility/Device.vala"
		_tmp24_ = _tmp30_;
#line 10681 "Device.c"
	}
#line 1781 "Utility/Device.vala"
	_tmp31_ = s;
#line 1781 "Utility/Device.vala"
	_tmp32_ = g_strconcat (_tmp31_, _tmp24_, NULL);
#line 1781 "Utility/Device.vala"
	_g_free0 (s);
#line 1781 "Utility/Device.vala"
	s = _tmp32_;
#line 1782 "Utility/Device.vala"
	_tmp34_ = device_get_used (self);
#line 1782 "Utility/Device.vala"
	_tmp35_ = _tmp34_;
#line 1782 "Utility/Device.vala"
	_tmp36_ = _tmp35_;
#line 1782 "Utility/Device.vala"
	_tmp37_ = strlen (_tmp36_);
#line 1782 "Utility/Device.vala"
	_tmp38_ = _tmp37_;
#line 1782 "Utility/Device.vala"
	_tmp39_ = _tmp38_ > 0;
#line 1782 "Utility/Device.vala"
	_g_free0 (_tmp36_);
#line 1782 "Utility/Device.vala"
	if (_tmp39_) {
#line 10707 "Device.c"
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 1782 "Utility/Device.vala"
		_tmp40_ = device_get_used (self);
#line 1782 "Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1782 "Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1782 "Utility/Device.vala"
		_tmp43_ = g_strconcat (" ~ ", _tmp42_, NULL);
#line 1782 "Utility/Device.vala"
		_tmp44_ = _tmp43_;
#line 1782 "Utility/Device.vala"
		_tmp45_ = g_strconcat (_tmp44_, " / ", NULL);
#line 1782 "Utility/Device.vala"
		_tmp46_ = _tmp45_;
#line 1782 "Utility/Device.vala"
		_tmp47_ = device_get_size (self);
#line 1782 "Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1782 "Utility/Device.vala"
		_tmp49_ = _tmp48_;
#line 1782 "Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 1782 "Utility/Device.vala"
		_tmp51_ = _tmp50_;
#line 1782 "Utility/Device.vala"
		_tmp52_ = g_strconcat (_tmp51_, " GB used (", NULL);
#line 1782 "Utility/Device.vala"
		_tmp53_ = _tmp52_;
#line 1782 "Utility/Device.vala"
		_tmp54_ = self->used_percent;
#line 1782 "Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp53_, _tmp54_, NULL);
#line 1782 "Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1782 "Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp56_, ")", NULL);
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1782 "Utility/Device.vala"
		_tmp33_ = _tmp57_;
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp53_);
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp49_);
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp46_);
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp44_);
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp42_);
#line 10780 "Device.c"
	} else {
		gchar* _tmp58_;
#line 1782 "Utility/Device.vala"
		_tmp58_ = g_strdup ("");
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1782 "Utility/Device.vala"
		_tmp33_ = _tmp58_;
#line 10789 "Device.c"
	}
#line 1782 "Utility/Device.vala"
	_tmp59_ = s;
#line 1782 "Utility/Device.vala"
	_tmp60_ = g_strconcat (_tmp59_, _tmp33_, NULL);
#line 1782 "Utility/Device.vala"
	_g_free0 (s);
#line 1782 "Utility/Device.vala"
	s = _tmp60_;
#line 1784 "Utility/Device.vala"
	result = s;
#line 1784 "Utility/Device.vala"
	_g_free0 (_tmp33_);
#line 1784 "Utility/Device.vala"
	_g_free0 (_tmp24_);
#line 1784 "Utility/Device.vala"
	_g_free0 (_tmp15_);
#line 1784 "Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1784 "Utility/Device.vala"
	return result;
#line 10811 "Device.c"
}

gchar*
device_description_usage (Device* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
#line 1787 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1788 "Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1788 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1788 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1788 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1788 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1788 "Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1788 "Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1788 "Utility/Device.vala"
	if (_tmp5_) {
#line 10842 "Device.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 1789 "Utility/Device.vala"
		_tmp6_ = device_get_used (self);
#line 1789 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1789 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1789 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp8_, " / ", NULL);
#line 1789 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1789 "Utility/Device.vala"
		_tmp11_ = device_get_size (self);
#line 1789 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1789 "Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1789 "Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 1789 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1789 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " used (", NULL);
#line 1789 "Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1789 "Utility/Device.vala"
		_tmp18_ = self->used_percent;
#line 1789 "Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp17_, _tmp18_, NULL);
#line 1789 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1789 "Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp20_, ")", NULL);
#line 1789 "Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1789 "Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1789 "Utility/Device.vala"
		_g_free0 (_tmp17_);
#line 1789 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1789 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1789 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1789 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1789 "Utility/Device.vala"
		result = _tmp22_;
#line 1789 "Utility/Device.vala"
		return result;
#line 10910 "Device.c"
	} else {
		gchar* _tmp23_;
#line 1792 "Utility/Device.vala"
		_tmp23_ = g_strdup ("");
#line 1792 "Utility/Device.vala"
		result = _tmp23_;
#line 1792 "Utility/Device.vala"
		return result;
#line 10919 "Device.c"
	}
}

gchar*
device_description_free (Device* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
#line 1796 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1797 "Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1797 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1797 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1797 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1797 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1797 "Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1797 "Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1797 "Utility/Device.vala"
	if (_tmp5_) {
#line 10951 "Device.c"
		guint64 _tmp6_;
		guint64 _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 1798 "Utility/Device.vala"
		_tmp6_ = device_get_free_bytes (self);
#line 1798 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1798 "Utility/Device.vala"
		_tmp8_ = tee_jee_file_system_format_file_size (_tmp7_, FALSE, "g", FALSE, 1);
#line 1798 "Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1798 "Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp9_, " / ", NULL);
#line 1798 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1798 "Utility/Device.vala"
		_tmp12_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "g", TRUE, 1);
#line 1798 "Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1798 "Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
#line 1798 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1798 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " free", NULL);
#line 1798 "Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1798 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1798 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1798 "Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1798 "Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 1798 "Utility/Device.vala"
		result = _tmp17_;
#line 1798 "Utility/Device.vala"
		return result;
#line 11000 "Device.c"
	} else {
		gchar* _tmp18_;
#line 1802 "Utility/Device.vala"
		_tmp18_ = g_strdup ("");
#line 1802 "Utility/Device.vala"
		result = _tmp18_;
#line 1802 "Utility/Device.vala"
		return result;
#line 11009 "Device.c"
	}
}

gchar*
device_tooltip_text (Device* self)
{
	gchar* result = NULL;
	gchar* tt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp92_;
	gchar* _tmp93_;
#line 1806 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1807 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1807 "Utility/Device.vala"
	tt = _tmp0_;
#line 1809 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1809 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11032 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_ = NULL;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 1810 "Utility/Device.vala"
		_tmp2_ = tt;
#line 1810 "Utility/Device.vala"
		_tmp3_ = self->device;
#line 1810 "Utility/Device.vala"
		_tmp4_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp3_);
#line 1810 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1810 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 1810 "Utility/Device.vala"
		_g_free0 (tt);
#line 1810 "Utility/Device.vala"
		tt = _tmp6_;
#line 1810 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1811 "Utility/Device.vala"
		_tmp7_ = tt;
#line 1811 "Utility/Device.vala"
		_tmp8_ = self->vendor;
#line 1811 "Utility/Device.vala"
		_tmp9_ = g_strdup_printf ("%-15s: %s\n", _ ("Vendor"), _tmp8_);
#line 1811 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1811 "Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
#line 1811 "Utility/Device.vala"
		_g_free0 (tt);
#line 1811 "Utility/Device.vala"
		tt = _tmp11_;
#line 1811 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1812 "Utility/Device.vala"
		_tmp12_ = tt;
#line 1812 "Utility/Device.vala"
		_tmp13_ = self->model;
#line 1812 "Utility/Device.vala"
		_tmp14_ = g_strdup_printf ("%-15s: %s\n", _ ("Model"), _tmp13_);
#line 1812 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1812 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1812 "Utility/Device.vala"
		_g_free0 (tt);
#line 1812 "Utility/Device.vala"
		tt = _tmp16_;
#line 1812 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1813 "Utility/Device.vala"
		_tmp17_ = tt;
#line 1813 "Utility/Device.vala"
		_tmp18_ = self->serial;
#line 1813 "Utility/Device.vala"
		_tmp19_ = g_strdup_printf ("%-15s: %s\n", _ ("Serial"), _tmp18_);
#line 1813 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1813 "Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp17_, _tmp20_, NULL);
#line 1813 "Utility/Device.vala"
		_g_free0 (tt);
#line 1813 "Utility/Device.vala"
		tt = _tmp21_;
#line 1813 "Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1814 "Utility/Device.vala"
		_tmp22_ = tt;
#line 1814 "Utility/Device.vala"
		_tmp23_ = self->revision;
#line 1814 "Utility/Device.vala"
		_tmp24_ = g_strdup_printf ("%-15s: %s\n", _ ("Revision"), _tmp23_);
#line 1814 "Utility/Device.vala"
		_tmp25_ = _tmp24_;
#line 1814 "Utility/Device.vala"
		_tmp26_ = g_strconcat (_tmp22_, _tmp25_, NULL);
#line 1814 "Utility/Device.vala"
		_g_free0 (tt);
#line 1814 "Utility/Device.vala"
		tt = _tmp26_;
#line 1814 "Utility/Device.vala"
		_g_free0 (_tmp25_);
#line 1817 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11145 "Device.c"
			gchar* _tmp28_;
#line 1817 "Utility/Device.vala"
			_tmp28_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1817 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1817 "Utility/Device.vala"
			_tmp27_ = _tmp28_;
#line 11153 "Device.c"
		} else {
			gchar* _tmp29_;
#line 1817 "Utility/Device.vala"
			_tmp29_ = g_strdup ("N/A");
#line 1817 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1817 "Utility/Device.vala"
			_tmp27_ = _tmp29_;
#line 11162 "Device.c"
		}
#line 1816 "Utility/Device.vala"
		_tmp30_ = tt;
#line 1816 "Utility/Device.vala"
		_tmp31_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp27_);
#line 1816 "Utility/Device.vala"
		_tmp32_ = _tmp31_;
#line 1816 "Utility/Device.vala"
		_tmp33_ = g_strconcat (_tmp30_, _tmp32_, NULL);
#line 1816 "Utility/Device.vala"
		_g_free0 (tt);
#line 1816 "Utility/Device.vala"
		tt = _tmp33_;
#line 1816 "Utility/Device.vala"
		_g_free0 (_tmp32_);
#line 1809 "Utility/Device.vala"
		_g_free0 (_tmp27_);
#line 11180 "Device.c"
	} else {
		gchar* _tmp34_ = NULL;
		const gchar* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		const gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		const gchar* _tmp63_;
		const gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_ = NULL;
		const gchar* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		gchar* _tmp79_;
		gchar* _tmp80_ = NULL;
		const gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		gchar* _tmp86_;
		const gchar* _tmp87_;
		const gchar* _tmp88_;
		gchar* _tmp89_;
		gchar* _tmp90_;
		gchar* _tmp91_;
#line 1821 "Utility/Device.vala"
		_tmp35_ = self->mapped_name;
#line 1821 "Utility/Device.vala"
		_tmp36_ = strlen (_tmp35_);
#line 1821 "Utility/Device.vala"
		_tmp37_ = _tmp36_;
#line 1821 "Utility/Device.vala"
		if (_tmp37_ > 0) {
#line 11233 "Device.c"
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
#line 1821 "Utility/Device.vala"
			_tmp38_ = self->device;
#line 1821 "Utility/Device.vala"
			_tmp39_ = self->mapped_name;
#line 1821 "Utility/Device.vala"
			_tmp40_ = g_strdup_printf ("%s → %s", _tmp38_, _tmp39_);
#line 1821 "Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 1821 "Utility/Device.vala"
			_tmp34_ = _tmp40_;
#line 11247 "Device.c"
		} else {
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 1821 "Utility/Device.vala"
			_tmp41_ = self->device;
#line 1821 "Utility/Device.vala"
			_tmp42_ = g_strdup (_tmp41_);
#line 1821 "Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 1821 "Utility/Device.vala"
			_tmp34_ = _tmp42_;
#line 11259 "Device.c"
		}
#line 1820 "Utility/Device.vala"
		_tmp43_ = tt;
#line 1820 "Utility/Device.vala"
		_tmp44_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp34_);
#line 1820 "Utility/Device.vala"
		_tmp45_ = _tmp44_;
#line 1820 "Utility/Device.vala"
		_tmp46_ = g_strconcat (_tmp43_, _tmp45_, NULL);
#line 1820 "Utility/Device.vala"
		_g_free0 (tt);
#line 1820 "Utility/Device.vala"
		tt = _tmp46_;
#line 1820 "Utility/Device.vala"
		_g_free0 (_tmp45_);
#line 1823 "Utility/Device.vala"
		if (device_has_parent (self)) {
#line 11277 "Device.c"
			const gchar* _tmp47_;
			Device* _tmp48_;
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
#line 1824 "Utility/Device.vala"
			_tmp47_ = tt;
#line 1824 "Utility/Device.vala"
			_tmp48_ = self->parent;
#line 1824 "Utility/Device.vala"
			_tmp49_ = _tmp48_->device;
#line 1824 "Utility/Device.vala"
			_tmp50_ = g_strdup_printf ("%-15s: %s\n", _ ("Parent Device"), _tmp49_);
#line 1824 "Utility/Device.vala"
			_tmp51_ = _tmp50_;
#line 1824 "Utility/Device.vala"
			_tmp52_ = g_strconcat (_tmp47_, _tmp51_, NULL);
#line 1824 "Utility/Device.vala"
			_g_free0 (tt);
#line 1824 "Utility/Device.vala"
			tt = _tmp52_;
#line 1824 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 11302 "Device.c"
		}
#line 1826 "Utility/Device.vala"
		_tmp53_ = tt;
#line 1826 "Utility/Device.vala"
		_tmp54_ = self->uuid;
#line 1826 "Utility/Device.vala"
		_tmp55_ = g_strdup_printf ("%-15s: %s\n", _ ("UUID"), _tmp54_);
#line 1826 "Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1826 "Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp53_, _tmp56_, NULL);
#line 1826 "Utility/Device.vala"
		_g_free0 (tt);
#line 1826 "Utility/Device.vala"
		tt = _tmp57_;
#line 1826 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1827 "Utility/Device.vala"
		_tmp58_ = tt;
#line 1827 "Utility/Device.vala"
		_tmp59_ = self->type;
#line 1827 "Utility/Device.vala"
		_tmp60_ = g_strdup_printf ("%-15s: %s\n", _ ("Type"), _tmp59_);
#line 1827 "Utility/Device.vala"
		_tmp61_ = _tmp60_;
#line 1827 "Utility/Device.vala"
		_tmp62_ = g_strconcat (_tmp58_, _tmp61_, NULL);
#line 1827 "Utility/Device.vala"
		_g_free0 (tt);
#line 1827 "Utility/Device.vala"
		tt = _tmp62_;
#line 1827 "Utility/Device.vala"
		_g_free0 (_tmp61_);
#line 1828 "Utility/Device.vala"
		_tmp63_ = tt;
#line 1828 "Utility/Device.vala"
		_tmp64_ = self->fstype;
#line 1828 "Utility/Device.vala"
		_tmp65_ = g_strdup_printf ("%-15s: %s\n", _ ("Filesystem"), _tmp64_);
#line 1828 "Utility/Device.vala"
		_tmp66_ = _tmp65_;
#line 1828 "Utility/Device.vala"
		_tmp67_ = g_strconcat (_tmp63_, _tmp66_, NULL);
#line 1828 "Utility/Device.vala"
		_g_free0 (tt);
#line 1828 "Utility/Device.vala"
		tt = _tmp67_;
#line 1828 "Utility/Device.vala"
		_g_free0 (_tmp66_);
#line 1829 "Utility/Device.vala"
		_tmp68_ = tt;
#line 1829 "Utility/Device.vala"
		_tmp69_ = self->label;
#line 1829 "Utility/Device.vala"
		_tmp70_ = g_strdup_printf ("%-15s: %s\n", _ ("Label"), _tmp69_);
#line 1829 "Utility/Device.vala"
		_tmp71_ = _tmp70_;
#line 1829 "Utility/Device.vala"
		_tmp72_ = g_strconcat (_tmp68_, _tmp71_, NULL);
#line 1829 "Utility/Device.vala"
		_g_free0 (tt);
#line 1829 "Utility/Device.vala"
		tt = _tmp72_;
#line 1829 "Utility/Device.vala"
		_g_free0 (_tmp71_);
#line 1832 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11370 "Device.c"
			gchar* _tmp74_;
#line 1832 "Utility/Device.vala"
			_tmp74_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1832 "Utility/Device.vala"
			_g_free0 (_tmp73_);
#line 1832 "Utility/Device.vala"
			_tmp73_ = _tmp74_;
#line 11378 "Device.c"
		} else {
			gchar* _tmp75_;
#line 1832 "Utility/Device.vala"
			_tmp75_ = g_strdup ("N/A");
#line 1832 "Utility/Device.vala"
			_g_free0 (_tmp73_);
#line 1832 "Utility/Device.vala"
			_tmp73_ = _tmp75_;
#line 11387 "Device.c"
		}
#line 1831 "Utility/Device.vala"
		_tmp76_ = tt;
#line 1831 "Utility/Device.vala"
		_tmp77_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp73_);
#line 1831 "Utility/Device.vala"
		_tmp78_ = _tmp77_;
#line 1831 "Utility/Device.vala"
		_tmp79_ = g_strconcat (_tmp76_, _tmp78_, NULL);
#line 1831 "Utility/Device.vala"
		_g_free0 (tt);
#line 1831 "Utility/Device.vala"
		tt = _tmp79_;
#line 1831 "Utility/Device.vala"
		_g_free0 (_tmp78_);
#line 1835 "Utility/Device.vala"
		if (self->used_bytes > ((guint64) 0)) {
#line 11405 "Device.c"
			gchar* _tmp81_;
#line 1835 "Utility/Device.vala"
			_tmp81_ = tee_jee_file_system_format_file_size (self->used_bytes, FALSE, "", TRUE, 1);
#line 1835 "Utility/Device.vala"
			_g_free0 (_tmp80_);
#line 1835 "Utility/Device.vala"
			_tmp80_ = _tmp81_;
#line 11413 "Device.c"
		} else {
			gchar* _tmp82_;
#line 1835 "Utility/Device.vala"
			_tmp82_ = g_strdup ("N/A");
#line 1835 "Utility/Device.vala"
			_g_free0 (_tmp80_);
#line 1835 "Utility/Device.vala"
			_tmp80_ = _tmp82_;
#line 11422 "Device.c"
		}
#line 1834 "Utility/Device.vala"
		_tmp83_ = tt;
#line 1834 "Utility/Device.vala"
		_tmp84_ = g_strdup_printf ("%-15s: %s\n", _ ("Used"), _tmp80_);
#line 1834 "Utility/Device.vala"
		_tmp85_ = _tmp84_;
#line 1834 "Utility/Device.vala"
		_tmp86_ = g_strconcat (_tmp83_, _tmp85_, NULL);
#line 1834 "Utility/Device.vala"
		_g_free0 (tt);
#line 1834 "Utility/Device.vala"
		tt = _tmp86_;
#line 1834 "Utility/Device.vala"
		_g_free0 (_tmp85_);
#line 1837 "Utility/Device.vala"
		_tmp87_ = tt;
#line 1837 "Utility/Device.vala"
		_tmp88_ = self->dist_info;
#line 1837 "Utility/Device.vala"
		_tmp89_ = g_strdup_printf ("%-15s: %s\n", _ ("System"), _tmp88_);
#line 1837 "Utility/Device.vala"
		_tmp90_ = _tmp89_;
#line 1837 "Utility/Device.vala"
		_tmp91_ = g_strconcat (_tmp87_, _tmp90_, NULL);
#line 1837 "Utility/Device.vala"
		_g_free0 (tt);
#line 1837 "Utility/Device.vala"
		tt = _tmp91_;
#line 1837 "Utility/Device.vala"
		_g_free0 (_tmp90_);
#line 1809 "Utility/Device.vala"
		_g_free0 (_tmp80_);
#line 1809 "Utility/Device.vala"
		_g_free0 (_tmp73_);
#line 1809 "Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 11460 "Device.c"
	}
#line 1840 "Utility/Device.vala"
	_tmp92_ = tt;
#line 1840 "Utility/Device.vala"
	_tmp93_ = g_strdup_printf ("<tt>%s</tt>", _tmp92_);
#line 1840 "Utility/Device.vala"
	result = _tmp93_;
#line 1840 "Utility/Device.vala"
	_g_free0 (tt);
#line 1840 "Utility/Device.vala"
	return result;
#line 11472 "Device.c"
}

static gchar*
device_display_name (Device* self,
                     gboolean short_name,
                     gboolean show_label,
                     gboolean show_parent,
                     gboolean show_alias)
{
	gchar* result = NULL;
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
#line 1843 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1845 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1845 "Utility/Device.vala"
	txt = _tmp0_;
#line 1847 "Utility/Device.vala"
	if (short_name) {
#line 11494 "Device.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 1848 "Utility/Device.vala"
		_tmp1_ = txt;
#line 1848 "Utility/Device.vala"
		_tmp2_ = self->kname;
#line 1848 "Utility/Device.vala"
		_tmp3_ = g_strconcat (_tmp1_, _tmp2_, NULL);
#line 1848 "Utility/Device.vala"
		_g_free0 (txt);
#line 1848 "Utility/Device.vala"
		txt = _tmp3_;
#line 11508 "Device.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 1851 "Utility/Device.vala"
		_tmp4_ = txt;
#line 1851 "Utility/Device.vala"
		_tmp5_ = self->device;
#line 1851 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp4_, _tmp5_, NULL);
#line 1851 "Utility/Device.vala"
		_g_free0 (txt);
#line 1851 "Utility/Device.vala"
		txt = _tmp6_;
#line 11523 "Device.c"
	}
#line 1854 "Utility/Device.vala"
	_tmp7_ = self->type;
#line 1854 "Utility/Device.vala"
	if (g_strcmp0 (_tmp7_, "disk") == 0) {
#line 11529 "Device.c"
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		const gchar* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 1855 "Utility/Device.vala"
		_tmp8_ = self->vendor;
#line 1855 "Utility/Device.vala"
		_tmp9_ = strlen (_tmp8_);
#line 1855 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1855 "Utility/Device.vala"
		if (_tmp10_ > 0) {
#line 11544 "Device.c"
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 1856 "Utility/Device.vala"
			_tmp11_ = txt;
#line 1856 "Utility/Device.vala"
			_tmp12_ = self->vendor;
#line 1856 "Utility/Device.vala"
			_tmp13_ = g_strconcat (" ", _tmp12_, NULL);
#line 1856 "Utility/Device.vala"
			_tmp14_ = _tmp13_;
#line 1856 "Utility/Device.vala"
			_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 1856 "Utility/Device.vala"
			_g_free0 (txt);
#line 1856 "Utility/Device.vala"
			txt = _tmp15_;
#line 1856 "Utility/Device.vala"
			_g_free0 (_tmp14_);
#line 11566 "Device.c"
		}
#line 1858 "Utility/Device.vala"
		_tmp16_ = self->model;
#line 1858 "Utility/Device.vala"
		_tmp17_ = strlen (_tmp16_);
#line 1858 "Utility/Device.vala"
		_tmp18_ = _tmp17_;
#line 1858 "Utility/Device.vala"
		if (_tmp18_ > 0) {
#line 11576 "Device.c"
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 1859 "Utility/Device.vala"
			_tmp19_ = txt;
#line 1859 "Utility/Device.vala"
			_tmp20_ = self->model;
#line 1859 "Utility/Device.vala"
			_tmp21_ = g_strconcat (" ", _tmp20_, NULL);
#line 1859 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1859 "Utility/Device.vala"
			_tmp23_ = g_strconcat (_tmp19_, _tmp22_, NULL);
#line 1859 "Utility/Device.vala"
			_g_free0 (txt);
#line 1859 "Utility/Device.vala"
			txt = _tmp23_;
#line 1859 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 11598 "Device.c"
		}
#line 1861 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11602 "Device.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			gboolean _tmp29_;
#line 1862 "Utility/Device.vala"
			_tmp24_ = txt;
#line 1862 "Utility/Device.vala"
			_tmp25_ = string_strip (_tmp24_);
#line 1862 "Utility/Device.vala"
			_tmp26_ = _tmp25_;
#line 1862 "Utility/Device.vala"
			_tmp27_ = strlen (_tmp26_);
#line 1862 "Utility/Device.vala"
			_tmp28_ = _tmp27_;
#line 1862 "Utility/Device.vala"
			_tmp29_ = _tmp28_ == 0;
#line 1862 "Utility/Device.vala"
			_g_free0 (_tmp26_);
#line 1862 "Utility/Device.vala"
			if (_tmp29_) {
#line 11625 "Device.c"
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 1863 "Utility/Device.vala"
				_tmp30_ = txt;
#line 1863 "Utility/Device.vala"
				_tmp31_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1863 "Utility/Device.vala"
				_tmp32_ = _tmp31_;
#line 1863 "Utility/Device.vala"
				_tmp33_ = g_strdup_printf ("%s Device", _tmp32_);
#line 1863 "Utility/Device.vala"
				_tmp34_ = _tmp33_;
#line 1863 "Utility/Device.vala"
				_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
#line 1863 "Utility/Device.vala"
				_g_free0 (txt);
#line 1863 "Utility/Device.vala"
				txt = _tmp35_;
#line 1863 "Utility/Device.vala"
				_g_free0 (_tmp34_);
#line 1863 "Utility/Device.vala"
				_g_free0 (_tmp32_);
#line 11652 "Device.c"
			} else {
				const gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
#line 1866 "Utility/Device.vala"
				_tmp36_ = txt;
#line 1866 "Utility/Device.vala"
				_tmp37_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1866 "Utility/Device.vala"
				_tmp38_ = _tmp37_;
#line 1866 "Utility/Device.vala"
				_tmp39_ = g_strdup_printf (" (%s)", _tmp38_);
#line 1866 "Utility/Device.vala"
				_tmp40_ = _tmp39_;
#line 1866 "Utility/Device.vala"
				_tmp41_ = g_strconcat (_tmp36_, _tmp40_, NULL);
#line 1866 "Utility/Device.vala"
				_g_free0 (txt);
#line 1866 "Utility/Device.vala"
				txt = _tmp41_;
#line 1866 "Utility/Device.vala"
				_g_free0 (_tmp40_);
#line 1866 "Utility/Device.vala"
				_g_free0 (_tmp38_);
#line 11680 "Device.c"
			}
		}
	} else {
		gboolean _tmp42_ = FALSE;
		gboolean _tmp51_ = FALSE;
		gboolean _tmp52_ = FALSE;
		gboolean _tmp60_ = FALSE;
#line 1871 "Utility/Device.vala"
		if (show_label) {
#line 11690 "Device.c"
			const gchar* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
#line 1871 "Utility/Device.vala"
			_tmp43_ = self->label;
#line 1871 "Utility/Device.vala"
			_tmp44_ = strlen (_tmp43_);
#line 1871 "Utility/Device.vala"
			_tmp45_ = _tmp44_;
#line 1871 "Utility/Device.vala"
			_tmp42_ = _tmp45_ > 0;
#line 11702 "Device.c"
		} else {
#line 1871 "Utility/Device.vala"
			_tmp42_ = FALSE;
#line 11706 "Device.c"
		}
#line 1871 "Utility/Device.vala"
		if (_tmp42_) {
#line 11710 "Device.c"
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
#line 1872 "Utility/Device.vala"
			_tmp46_ = txt;
#line 1872 "Utility/Device.vala"
			_tmp47_ = self->label;
#line 1872 "Utility/Device.vala"
			_tmp48_ = g_strdup_printf ("(%s)", _tmp47_);
#line 1872 "Utility/Device.vala"
			_tmp49_ = _tmp48_;
#line 1872 "Utility/Device.vala"
			_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 1872 "Utility/Device.vala"
			_g_free0 (txt);
#line 1872 "Utility/Device.vala"
			txt = _tmp50_;
#line 1872 "Utility/Device.vala"
			_g_free0 (_tmp49_);
#line 11732 "Device.c"
		}
#line 1874 "Utility/Device.vala"
		if (show_parent) {
#line 1874 "Utility/Device.vala"
			_tmp52_ = device_has_parent (self);
#line 11738 "Device.c"
		} else {
#line 1874 "Utility/Device.vala"
			_tmp52_ = FALSE;
#line 11742 "Device.c"
		}
#line 1874 "Utility/Device.vala"
		if (_tmp52_) {
#line 11746 "Device.c"
			Device* _tmp53_;
			const gchar* _tmp54_;
#line 1874 "Utility/Device.vala"
			_tmp53_ = self->parent;
#line 1874 "Utility/Device.vala"
			_tmp54_ = _tmp53_->type;
#line 1874 "Utility/Device.vala"
			_tmp51_ = g_strcmp0 (_tmp54_, "part") == 0;
#line 11755 "Device.c"
		} else {
#line 1874 "Utility/Device.vala"
			_tmp51_ = FALSE;
#line 11759 "Device.c"
		}
#line 1874 "Utility/Device.vala"
		if (_tmp51_) {
#line 11763 "Device.c"
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
#line 1875 "Utility/Device.vala"
			_tmp55_ = txt;
#line 1875 "Utility/Device.vala"
			_tmp56_ = self->pkname;
#line 1875 "Utility/Device.vala"
			_tmp57_ = g_strdup_printf ("(%s)", _tmp56_);
#line 1875 "Utility/Device.vala"
			_tmp58_ = _tmp57_;
#line 1875 "Utility/Device.vala"
			_tmp59_ = g_strconcat (_tmp55_, _tmp58_, NULL);
#line 1875 "Utility/Device.vala"
			_g_free0 (txt);
#line 1875 "Utility/Device.vala"
			txt = _tmp59_;
#line 1875 "Utility/Device.vala"
			_g_free0 (_tmp58_);
#line 11785 "Device.c"
		}
#line 1877 "Utility/Device.vala"
		if (show_alias) {
#line 11789 "Device.c"
			const gchar* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
#line 1877 "Utility/Device.vala"
			_tmp61_ = self->mapped_name;
#line 1877 "Utility/Device.vala"
			_tmp62_ = strlen (_tmp61_);
#line 1877 "Utility/Device.vala"
			_tmp63_ = _tmp62_;
#line 1877 "Utility/Device.vala"
			_tmp60_ = _tmp63_ > 0;
#line 11801 "Device.c"
		} else {
#line 1877 "Utility/Device.vala"
			_tmp60_ = FALSE;
#line 11805 "Device.c"
		}
#line 1877 "Utility/Device.vala"
		if (_tmp60_) {
#line 11809 "Device.c"
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
#line 1878 "Utility/Device.vala"
			_tmp64_ = txt;
#line 1878 "Utility/Device.vala"
			_tmp65_ = self->mapped_name;
#line 1878 "Utility/Device.vala"
			_tmp66_ = g_strdup_printf ("(%s)", _tmp65_);
#line 1878 "Utility/Device.vala"
			_tmp67_ = _tmp66_;
#line 1878 "Utility/Device.vala"
			_tmp68_ = g_strconcat (_tmp64_, _tmp67_, NULL);
#line 1878 "Utility/Device.vala"
			_g_free0 (txt);
#line 1878 "Utility/Device.vala"
			txt = _tmp68_;
#line 1878 "Utility/Device.vala"
			_g_free0 (_tmp67_);
#line 11831 "Device.c"
		}
	}
#line 1882 "Utility/Device.vala"
	result = txt;
#line 1882 "Utility/Device.vala"
	return result;
#line 11838 "Device.c"
}

void
device_test_all (void)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
#line 1888 "Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 1888 "Utility/Device.vala"
	list = _tmp0_;
#line 1889 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_block_devices_using_lsblk()", FALSE);
#line 1890 "Utility/Device.vala"
	_tmp1_ = list;
#line 1890 "Utility/Device.vala"
	device_print_device_list (_tmp1_);
#line 1892 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1898 "Utility/Device.vala"
	_tmp2_ = device_get_mounted_filesystems_using_mtab ();
#line 1898 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1898 "Utility/Device.vala"
	list = _tmp2_;
#line 1899 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_mounted_filesystems_using_mtab()", FALSE);
#line 1900 "Utility/Device.vala"
	_tmp3_ = list;
#line 1900 "Utility/Device.vala"
	device_print_device_mounts (_tmp3_);
#line 1902 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1904 "Utility/Device.vala"
	_tmp4_ = device_get_disk_space_using_df ("");
#line 1904 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1904 "Utility/Device.vala"
	list = _tmp4_;
#line 1905 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_disk_space_using_df()", FALSE);
#line 1906 "Utility/Device.vala"
	_tmp5_ = list;
#line 1906 "Utility/Device.vala"
	device_print_device_disk_space (_tmp5_);
#line 1908 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1910 "Utility/Device.vala"
	_tmp6_ = device_get_filesystems (TRUE, TRUE);
#line 1910 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1910 "Utility/Device.vala"
	list = _tmp6_;
#line 1911 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_filesystems()", FALSE);
#line 1912 "Utility/Device.vala"
	_tmp7_ = list;
#line 1912 "Utility/Device.vala"
	device_print_device_list (_tmp7_);
#line 1913 "Utility/Device.vala"
	_tmp8_ = list;
#line 1913 "Utility/Device.vala"
	device_print_device_mounts (_tmp8_);
#line 1914 "Utility/Device.vala"
	_tmp9_ = list;
#line 1914 "Utility/Device.vala"
	device_print_device_disk_space (_tmp9_);
#line 1916 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 1887 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 11919 "Device.c"
}

void
device_print_device_list (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1919 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 1921 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 1923 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", "device", "pkname", "kname", "uuid", "mapped_name");
#line 1923 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1923 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 1923 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1930 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 1930 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1930 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1930 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 11949 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		gint _dev_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _dev_index = 0;
#line 1932 "Utility/Device.vala"
		_tmp4_ = _g_object_ref0 (list);
#line 1932 "Utility/Device.vala"
		_dev_list = _tmp4_;
#line 1932 "Utility/Device.vala"
		_tmp5_ = _dev_list;
#line 1932 "Utility/Device.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 1932 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1932 "Utility/Device.vala"
		_dev_size = _tmp7_;
#line 1932 "Utility/Device.vala"
		_dev_index = -1;
#line 1932 "Utility/Device.vala"
		while (TRUE) {
#line 11974 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			Device* _tmp10_;
			const gchar* _tmp11_;
			Device* _tmp12_;
			const gchar* _tmp13_;
			Device* _tmp14_;
			const gchar* _tmp15_;
			Device* _tmp16_;
			const gchar* _tmp17_;
			Device* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 1932 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1932 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 1932 "Utility/Device.vala"
				break;
#line 11996 "Device.c"
			}
#line 1932 "Utility/Device.vala"
			_tmp8_ = _dev_list;
#line 1932 "Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_index);
#line 1932 "Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 1933 "Utility/Device.vala"
			_tmp10_ = dev;
#line 1933 "Utility/Device.vala"
			_tmp11_ = _tmp10_->device;
#line 1933 "Utility/Device.vala"
			_tmp12_ = dev;
#line 1933 "Utility/Device.vala"
			_tmp13_ = _tmp12_->pkname;
#line 1933 "Utility/Device.vala"
			_tmp14_ = dev;
#line 1933 "Utility/Device.vala"
			_tmp15_ = _tmp14_->kname;
#line 1933 "Utility/Device.vala"
			_tmp16_ = dev;
#line 1933 "Utility/Device.vala"
			_tmp17_ = _tmp16_->uuid;
#line 1933 "Utility/Device.vala"
			_tmp18_ = dev;
#line 1933 "Utility/Device.vala"
			_tmp19_ = _tmp18_->mapped_name;
#line 1933 "Utility/Device.vala"
			_tmp20_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", _tmp11_, _tmp13_, _tmp15_, _tmp17_, _tmp19_);
#line 1933 "Utility/Device.vala"
			_tmp21_ = _tmp20_;
#line 1933 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp21_);
#line 1933 "Utility/Device.vala"
			_g_free0 (_tmp21_);
#line 1932 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 12034 "Device.c"
		}
#line 1932 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 12038 "Device.c"
	}
#line 1942 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 12042 "Device.c"
}

void
device_print_device_mounts (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1995 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 1997 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 1999 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %s", "device", "> mount_points (mount_options)");
#line 1999 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1999 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 1999 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2005 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2005 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2005 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2005 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 12072 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		gint _dev_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _dev_index = 0;
#line 2007 "Utility/Device.vala"
		_tmp4_ = _g_object_ref0 (list);
#line 2007 "Utility/Device.vala"
		_dev_list = _tmp4_;
#line 2007 "Utility/Device.vala"
		_tmp5_ = _dev_list;
#line 2007 "Utility/Device.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 2007 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 2007 "Utility/Device.vala"
		_dev_size = _tmp7_;
#line 2007 "Utility/Device.vala"
		_dev_index = -1;
#line 2007 "Utility/Device.vala"
		while (TRUE) {
#line 12097 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			gchar* mps = NULL;
			gchar* _tmp10_;
			Device* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 2007 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2007 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 2007 "Utility/Device.vala"
				break;
#line 12114 "Device.c"
			}
#line 2007 "Utility/Device.vala"
			_tmp8_ = _dev_list;
#line 2007 "Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_index);
#line 2007 "Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 2009 "Utility/Device.vala"
			_tmp10_ = g_strdup ("");
#line 2009 "Utility/Device.vala"
			mps = _tmp10_;
#line 12126 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp11_;
				GeeArrayList* _tmp12_;
				GeeArrayList* _tmp13_;
				gint _mp_size = 0;
				GeeArrayList* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _mp_index = 0;
#line 2010 "Utility/Device.vala"
				_tmp11_ = dev;
#line 2010 "Utility/Device.vala"
				_tmp12_ = _tmp11_->mount_points;
#line 2010 "Utility/Device.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 2010 "Utility/Device.vala"
				_mp_list = _tmp13_;
#line 2010 "Utility/Device.vala"
				_tmp14_ = _mp_list;
#line 2010 "Utility/Device.vala"
				_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 2010 "Utility/Device.vala"
				_tmp16_ = _tmp15_;
#line 2010 "Utility/Device.vala"
				_mp_size = _tmp16_;
#line 2010 "Utility/Device.vala"
				_mp_index = -1;
#line 2010 "Utility/Device.vala"
				while (TRUE) {
#line 12157 "Device.c"
					MountEntry* mp = NULL;
					GeeArrayList* _tmp17_;
					gpointer _tmp18_;
					const gchar* _tmp19_;
					MountEntry* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					MountEntry* _tmp25_;
					const gchar* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
#line 2010 "Utility/Device.vala"
					_mp_index = _mp_index + 1;
#line 2010 "Utility/Device.vala"
					if (!(_mp_index < _mp_size)) {
#line 2010 "Utility/Device.vala"
						break;
#line 12177 "Device.c"
					}
#line 2010 "Utility/Device.vala"
					_tmp17_ = _mp_list;
#line 2010 "Utility/Device.vala"
					_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _mp_index);
#line 2010 "Utility/Device.vala"
					mp = (MountEntry*) _tmp18_;
#line 2011 "Utility/Device.vala"
					_tmp19_ = mps;
#line 2011 "Utility/Device.vala"
					_tmp20_ = mp;
#line 2011 "Utility/Device.vala"
					_tmp21_ = _tmp20_->mount_point;
#line 2011 "Utility/Device.vala"
					_tmp22_ = g_strdup_printf ("\n    %s -> ", _tmp21_);
#line 2011 "Utility/Device.vala"
					_tmp23_ = _tmp22_;
#line 2011 "Utility/Device.vala"
					_tmp24_ = g_strconcat (_tmp19_, _tmp23_, NULL);
#line 2011 "Utility/Device.vala"
					_g_free0 (mps);
#line 2011 "Utility/Device.vala"
					mps = _tmp24_;
#line 2011 "Utility/Device.vala"
					_g_free0 (_tmp23_);
#line 2012 "Utility/Device.vala"
					_tmp25_ = mp;
#line 2012 "Utility/Device.vala"
					_tmp26_ = _tmp25_->mount_options;
#line 2012 "Utility/Device.vala"
					_tmp27_ = strlen (_tmp26_);
#line 2012 "Utility/Device.vala"
					_tmp28_ = _tmp27_;
#line 2012 "Utility/Device.vala"
					if (_tmp28_ > 0) {
#line 12213 "Device.c"
						const gchar* _tmp29_;
						MountEntry* _tmp30_;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
#line 2013 "Utility/Device.vala"
						_tmp29_ = mps;
#line 2013 "Utility/Device.vala"
						_tmp30_ = mp;
#line 2013 "Utility/Device.vala"
						_tmp31_ = _tmp30_->mount_options;
#line 2013 "Utility/Device.vala"
						_tmp32_ = g_strdup_printf (" %s", _tmp31_);
#line 2013 "Utility/Device.vala"
						_tmp33_ = _tmp32_;
#line 2013 "Utility/Device.vala"
						_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 2013 "Utility/Device.vala"
						_g_free0 (mps);
#line 2013 "Utility/Device.vala"
						mps = _tmp34_;
#line 2013 "Utility/Device.vala"
						_g_free0 (_tmp33_);
#line 12238 "Device.c"
					}
#line 2010 "Utility/Device.vala"
					_g_object_unref0 (mp);
#line 12242 "Device.c"
				}
#line 2010 "Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 12246 "Device.c"
			}
#line 2017 "Utility/Device.vala"
			_tmp35_ = dev;
#line 2017 "Utility/Device.vala"
			_tmp36_ = _tmp35_->device;
#line 2017 "Utility/Device.vala"
			_tmp37_ = mps;
#line 2017 "Utility/Device.vala"
			_tmp38_ = g_strdup_printf ("%-15s %s", _tmp36_, _tmp37_);
#line 2017 "Utility/Device.vala"
			_tmp39_ = _tmp38_;
#line 2017 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp39_);
#line 2017 "Utility/Device.vala"
			_g_free0 (_tmp39_);
#line 2007 "Utility/Device.vala"
			_g_free0 (mps);
#line 2007 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 12266 "Device.c"
		}
#line 2007 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 12270 "Device.c"
	}
#line 2025 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 12274 "Device.c"
}

void
device_print_device_disk_space (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2028 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2029 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2031 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", "device", "fstype", "size", "used", "available", "used_percent");
#line 2031 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2031 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2031 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2040 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2040 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2040 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2040 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 12304 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		gint _dev_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _dev_index = 0;
#line 2042 "Utility/Device.vala"
		_tmp4_ = _g_object_ref0 (list);
#line 2042 "Utility/Device.vala"
		_dev_list = _tmp4_;
#line 2042 "Utility/Device.vala"
		_tmp5_ = _dev_list;
#line 2042 "Utility/Device.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 2042 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 2042 "Utility/Device.vala"
		_dev_size = _tmp7_;
#line 2042 "Utility/Device.vala"
		_dev_index = -1;
#line 2042 "Utility/Device.vala"
		while (TRUE) {
#line 12329 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			Device* _tmp10_;
			const gchar* _tmp11_;
			Device* _tmp12_;
			const gchar* _tmp13_;
			Device* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			Device* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			Device* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			Device* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 2042 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2042 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 2042 "Utility/Device.vala"
				break;
#line 12356 "Device.c"
			}
#line 2042 "Utility/Device.vala"
			_tmp8_ = _dev_list;
#line 2042 "Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_index);
#line 2042 "Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 2043 "Utility/Device.vala"
			_tmp10_ = dev;
#line 2043 "Utility/Device.vala"
			_tmp11_ = _tmp10_->device;
#line 2043 "Utility/Device.vala"
			_tmp12_ = dev;
#line 2043 "Utility/Device.vala"
			_tmp13_ = _tmp12_->fstype;
#line 2043 "Utility/Device.vala"
			_tmp14_ = dev;
#line 2043 "Utility/Device.vala"
			_tmp15_ = tee_jee_file_system_format_file_size (_tmp14_->size_bytes, TRUE, "", TRUE, 1);
#line 2043 "Utility/Device.vala"
			_tmp16_ = _tmp15_;
#line 2043 "Utility/Device.vala"
			_tmp17_ = dev;
#line 2043 "Utility/Device.vala"
			_tmp18_ = tee_jee_file_system_format_file_size (_tmp17_->used_bytes, TRUE, "", TRUE, 1);
#line 2043 "Utility/Device.vala"
			_tmp19_ = _tmp18_;
#line 2043 "Utility/Device.vala"
			_tmp20_ = dev;
#line 2043 "Utility/Device.vala"
			_tmp21_ = tee_jee_file_system_format_file_size (_tmp20_->available_bytes, TRUE, "", TRUE, 1);
#line 2043 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 2043 "Utility/Device.vala"
			_tmp23_ = dev;
#line 2043 "Utility/Device.vala"
			_tmp24_ = _tmp23_->used_percent;
#line 2043 "Utility/Device.vala"
			_tmp25_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", _tmp11_, _tmp13_, _tmp16_, _tmp19_, _tmp22_, _tmp24_);
#line 2043 "Utility/Device.vala"
			_tmp26_ = _tmp25_;
#line 2043 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp26_);
#line 2043 "Utility/Device.vala"
			_g_free0 (_tmp26_);
#line 2043 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 2043 "Utility/Device.vala"
			_g_free0 (_tmp19_);
#line 2043 "Utility/Device.vala"
			_g_free0 (_tmp16_);
#line 2042 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 12410 "Device.c"
		}
#line 2042 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 12414 "Device.c"
	}
#line 2053 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 12418 "Device.c"
}

guint64
device_get_free_bytes (Device* self)
{
	guint64 result;
	guint64 _tmp0_ = 0ULL;
#line 121 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 122 "Utility/Device.vala"
	if (self->used_bytes == ((guint64) 0)) {
#line 122 "Utility/Device.vala"
		_tmp0_ = (guint64) 0;
#line 12432 "Device.c"
	} else {
#line 122 "Utility/Device.vala"
		_tmp0_ = self->size_bytes - self->used_bytes;
#line 12436 "Device.c"
	}
#line 122 "Utility/Device.vala"
	result = _tmp0_;
#line 122 "Utility/Device.vala"
	return result;
#line 12442 "Device.c"
}

gchar*
device_get_size (Device* self)
{
	gchar* result;
#line 127 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "Utility/Device.vala"
	if (((gdouble) self->size_bytes) < device_GB) {
#line 12453 "Device.c"
		gchar* _tmp0_;
#line 129 "Utility/Device.vala"
		_tmp0_ = g_strdup_printf ("%.1f MB", self->size_bytes / device_MB);
#line 129 "Utility/Device.vala"
		result = _tmp0_;
#line 129 "Utility/Device.vala"
		return result;
#line 12461 "Device.c"
	} else {
#line 131 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12465 "Device.c"
			gchar* _tmp1_;
#line 132 "Utility/Device.vala"
			_tmp1_ = g_strdup_printf ("%.1f GB", self->size_bytes / device_GB);
#line 132 "Utility/Device.vala"
			result = _tmp1_;
#line 132 "Utility/Device.vala"
			return result;
#line 12473 "Device.c"
		} else {
			gchar* _tmp2_;
#line 135 "Utility/Device.vala"
			_tmp2_ = g_strdup ("");
#line 135 "Utility/Device.vala"
			result = _tmp2_;
#line 135 "Utility/Device.vala"
			return result;
#line 12482 "Device.c"
		}
	}
}

gchar*
device_get_used (Device* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 141 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "Utility/Device.vala"
	if (self->used_bytes == ((guint64) 0)) {
#line 12496 "Device.c"
		gchar* _tmp1_;
#line 142 "Utility/Device.vala"
		_tmp1_ = g_strdup ("");
#line 142 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "Utility/Device.vala"
		_tmp0_ = _tmp1_;
#line 12504 "Device.c"
	} else {
		gchar* _tmp2_;
#line 142 "Utility/Device.vala"
		_tmp2_ = g_strdup_printf ("%.1f GB", self->used_bytes / device_GB);
#line 142 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "Utility/Device.vala"
		_tmp0_ = _tmp2_;
#line 12513 "Device.c"
	}
#line 142 "Utility/Device.vala"
	result = _tmp0_;
#line 142 "Utility/Device.vala"
	return result;
#line 12519 "Device.c"
}

gchar*
device_get_free (Device* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	guint64 _tmp2_;
#line 147 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "Utility/Device.vala"
	_tmp1_ = device_get_free_bytes (self);
#line 148 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 148 "Utility/Device.vala"
	if (_tmp2_ == ((guint64) 0)) {
#line 12537 "Device.c"
		gchar* _tmp3_;
#line 148 "Utility/Device.vala"
		_tmp3_ = g_strdup ("");
#line 148 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "Utility/Device.vala"
		_tmp0_ = _tmp3_;
#line 12545 "Device.c"
	} else {
		guint64 _tmp4_;
		guint64 _tmp5_;
		gchar* _tmp6_;
#line 148 "Utility/Device.vala"
		_tmp4_ = device_get_free_bytes (self);
#line 148 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 148 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("%.1f GB", _tmp5_ / device_GB);
#line 148 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "Utility/Device.vala"
		_tmp0_ = _tmp6_;
#line 12560 "Device.c"
	}
#line 148 "Utility/Device.vala"
	result = _tmp0_;
#line 148 "Utility/Device.vala"
	return result;
#line 12566 "Device.c"
}

gboolean
device_get_is_mounted (Device* self)
{
	gboolean result;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 153 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "Utility/Device.vala"
	_tmp0_ = self->mount_points;
#line 154 "Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 154 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 154 "Utility/Device.vala"
	result = _tmp2_ > 0;
#line 154 "Utility/Device.vala"
	return result;
#line 12588 "Device.c"
}

gchar*
device_get_full_name_with_alias (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1632 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1633 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1633 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1633 "Utility/Device.vala"
	text = _tmp1_;
#line 1634 "Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1634 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1634 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1634 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 12617 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1635 "Utility/Device.vala"
		_tmp5_ = text;
#line 1635 "Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1635 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1635 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1635 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1635 "Utility/Device.vala"
		_g_free0 (text);
#line 1635 "Utility/Device.vala"
		text = _tmp9_;
#line 1635 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 12639 "Device.c"
	}
#line 1637 "Utility/Device.vala"
	result = text;
#line 1637 "Utility/Device.vala"
	return result;
#line 12645 "Device.c"
}

gchar*
device_get_full_name_with_parent (Device* self)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1642 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1643 "Utility/Device.vala"
	_tmp0_ = device_get_device_name_with_parent (self);
#line 1643 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1643 "Utility/Device.vala"
	result = _tmp1_;
#line 1643 "Utility/Device.vala"
	return result;
#line 12664 "Device.c"
}

gchar*
device_get_short_name_with_alias (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1648 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1649 "Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1649 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1649 "Utility/Device.vala"
	text = _tmp1_;
#line 1650 "Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1650 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1650 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1650 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 12693 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1651 "Utility/Device.vala"
		_tmp5_ = text;
#line 1651 "Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1651 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1651 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1651 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1651 "Utility/Device.vala"
		_g_free0 (text);
#line 1651 "Utility/Device.vala"
		text = _tmp9_;
#line 1651 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 12715 "Device.c"
	}
#line 1653 "Utility/Device.vala"
	result = text;
#line 1653 "Utility/Device.vala"
	return result;
#line 12721 "Device.c"
}

gchar*
device_get_short_name_with_parent (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1658 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1659 "Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1659 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1659 "Utility/Device.vala"
	text = _tmp1_;
#line 1661 "Utility/Device.vala"
	if (device_has_parent (self)) {
#line 12742 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
#line 1661 "Utility/Device.vala"
		_tmp3_ = self->parent;
#line 1661 "Utility/Device.vala"
		_tmp4_ = _tmp3_->type;
#line 1661 "Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "part") == 0;
#line 12751 "Device.c"
	} else {
#line 1661 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 12755 "Device.c"
	}
#line 1661 "Utility/Device.vala"
	if (_tmp2_) {
#line 12759 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1662 "Utility/Device.vala"
		_tmp5_ = text;
#line 1662 "Utility/Device.vala"
		_tmp6_ = self->pkname;
#line 1662 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1662 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1662 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1662 "Utility/Device.vala"
		_g_free0 (text);
#line 1662 "Utility/Device.vala"
		text = _tmp9_;
#line 1662 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 12781 "Device.c"
	}
#line 1665 "Utility/Device.vala"
	result = text;
#line 1665 "Utility/Device.vala"
	return result;
#line 12787 "Device.c"
}

gchar*
device_get_device_name_with_parent (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1670 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1671 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1671 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1671 "Utility/Device.vala"
	text = _tmp1_;
#line 1673 "Utility/Device.vala"
	if (device_has_parent (self)) {
#line 12808 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
#line 1673 "Utility/Device.vala"
		_tmp3_ = self->parent;
#line 1673 "Utility/Device.vala"
		_tmp4_ = _tmp3_->type;
#line 1673 "Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "part") == 0;
#line 12817 "Device.c"
	} else {
#line 1673 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 12821 "Device.c"
	}
#line 1673 "Utility/Device.vala"
	if (_tmp2_) {
#line 12825 "Device.c"
		const gchar* _tmp5_;
		Device* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1674 "Utility/Device.vala"
		_tmp5_ = text;
#line 1674 "Utility/Device.vala"
		_tmp6_ = self->parent;
#line 1674 "Utility/Device.vala"
		_tmp7_ = _tmp6_->kname;
#line 1674 "Utility/Device.vala"
		_tmp8_ = g_strdup_printf (" (%s)", _tmp7_);
#line 1674 "Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1674 "Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp5_, _tmp9_, NULL);
#line 1674 "Utility/Device.vala"
		_g_free0 (text);
#line 1674 "Utility/Device.vala"
		text = _tmp10_;
#line 1674 "Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 12850 "Device.c"
	}
#line 1677 "Utility/Device.vala"
	result = text;
#line 1677 "Utility/Device.vala"
	return result;
#line 12856 "Device.c"
}

static void
device_class_init (DeviceClass * klass,
                   gpointer klass_data)
{
	gchar* _tmp0_;
#line 32 "Utility/Device.vala"
	device_parent_class = g_type_class_peek_parent (klass);
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_device_get_property;
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = device_finalize;
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_BYTES_PROPERTY, device_properties[DEVICE_FREE_BYTES_PROPERTY] = g_param_spec_uint64 ("free-bytes", "free-bytes", "free-bytes", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SIZE_PROPERTY, device_properties[DEVICE_SIZE_PROPERTY] = g_param_spec_string ("size", "size", "size", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_USED_PROPERTY, device_properties[DEVICE_USED_PROPERTY] = g_param_spec_string ("used", "used", "used", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_PROPERTY, device_properties[DEVICE_FREE_PROPERTY] = g_param_spec_string ("free", "free", "free", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_IS_MOUNTED_PROPERTY, device_properties[DEVICE_IS_MOUNTED_PROPERTY] = g_param_spec_boolean ("is-mounted", "is-mounted", "is-mounted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("full-name-with-alias", "full-name-with-alias", "full-name-with-alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("full-name-with-parent", "full-name-with-parent", "full-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("short-name-with-alias", "short-name-with-alias", "short-name-with-alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("short-name-with-parent", "short-name-with-parent", "short-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("device-name-with-parent", "device-name-with-parent", "device-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "Utility/Device.vala"
	device_MB = 1000 * device_KB;
#line 38 "Utility/Device.vala"
	device_GB = 1000 * device_MB;
#line 41 "Utility/Device.vala"
	device_MiB = 1024 * device_KiB;
#line 42 "Utility/Device.vala"
	device_GiB = 1024 * device_MiB;
#line 89 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 89 "Utility/Device.vala"
	device_lsblk_version = _tmp0_;
#line 12902 "Device.c"
}

static void
device_instance_init (Device * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 44 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 44 "Utility/Device.vala"
	self->device = _tmp0_;
#line 45 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 45 "Utility/Device.vala"
	self->name = _tmp1_;
#line 46 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 46 "Utility/Device.vala"
	self->kname = _tmp2_;
#line 47 "Utility/Device.vala"
	_tmp3_ = g_strdup ("");
#line 47 "Utility/Device.vala"
	self->pkname = _tmp3_;
#line 48 "Utility/Device.vala"
	_tmp4_ = g_strdup ("");
#line 48 "Utility/Device.vala"
	self->pkname_toplevel = _tmp4_;
#line 49 "Utility/Device.vala"
	_tmp5_ = g_strdup ("");
#line 49 "Utility/Device.vala"
	self->mapped_name = _tmp5_;
#line 50 "Utility/Device.vala"
	_tmp6_ = g_strdup ("");
#line 50 "Utility/Device.vala"
	self->uuid = _tmp6_;
#line 51 "Utility/Device.vala"
	_tmp7_ = g_strdup ("");
#line 51 "Utility/Device.vala"
	self->label = _tmp7_;
#line 52 "Utility/Device.vala"
	_tmp8_ = g_strdup ("");
#line 52 "Utility/Device.vala"
	self->partuuid = _tmp8_;
#line 53 "Utility/Device.vala"
	_tmp9_ = g_strdup ("");
#line 53 "Utility/Device.vala"
	self->partlabel = _tmp9_;
#line 55 "Utility/Device.vala"
	self->major = -1;
#line 56 "Utility/Device.vala"
	self->minor = -1;
#line 58 "Utility/Device.vala"
	_tmp10_ = g_strdup ("");
#line 58 "Utility/Device.vala"
	self->device_mapper = _tmp10_;
#line 59 "Utility/Device.vala"
	_tmp11_ = g_strdup ("");
#line 59 "Utility/Device.vala"
	self->device_by_uuid = _tmp11_;
#line 60 "Utility/Device.vala"
	_tmp12_ = g_strdup ("");
#line 60 "Utility/Device.vala"
	self->device_by_label = _tmp12_;
#line 61 "Utility/Device.vala"
	_tmp13_ = g_strdup ("");
#line 61 "Utility/Device.vala"
	self->device_by_partuuid = _tmp13_;
#line 62 "Utility/Device.vala"
	_tmp14_ = g_strdup ("");
#line 62 "Utility/Device.vala"
	self->device_by_partlabel = _tmp14_;
#line 64 "Utility/Device.vala"
	_tmp15_ = g_strdup ("");
#line 64 "Utility/Device.vala"
	self->type = _tmp15_;
#line 65 "Utility/Device.vala"
	_tmp16_ = g_strdup ("");
#line 65 "Utility/Device.vala"
	self->fstype = _tmp16_;
#line 67 "Utility/Device.vala"
	self->order = -1;
#line 69 "Utility/Device.vala"
	_tmp17_ = g_strdup ("");
#line 69 "Utility/Device.vala"
	self->vendor = _tmp17_;
#line 70 "Utility/Device.vala"
	_tmp18_ = g_strdup ("");
#line 70 "Utility/Device.vala"
	self->model = _tmp18_;
#line 71 "Utility/Device.vala"
	_tmp19_ = g_strdup ("");
#line 71 "Utility/Device.vala"
	self->serial = _tmp19_;
#line 72 "Utility/Device.vala"
	_tmp20_ = g_strdup ("");
#line 72 "Utility/Device.vala"
	self->revision = _tmp20_;
#line 74 "Utility/Device.vala"
	self->removable = FALSE;
#line 75 "Utility/Device.vala"
	self->read_only = FALSE;
#line 77 "Utility/Device.vala"
	self->size_bytes = (guint64) 0;
#line 78 "Utility/Device.vala"
	self->used_bytes = (guint64) 0;
#line 79 "Utility/Device.vala"
	self->available_bytes = (guint64) 0;
#line 81 "Utility/Device.vala"
	_tmp21_ = g_strdup ("");
#line 81 "Utility/Device.vala"
	self->used_percent = _tmp21_;
#line 82 "Utility/Device.vala"
	_tmp22_ = g_strdup ("");
#line 82 "Utility/Device.vala"
	self->dist_info = _tmp22_;
#line 86 "Utility/Device.vala"
	self->parent = NULL;
#line 87 "Utility/Device.vala"
	self->children = NULL;
#line 13044 "Device.c"
}

static void
device_finalize (GObject * obj)
{
	Device * self;
#line 32 "Utility/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE, Device);
#line 44 "Utility/Device.vala"
	_g_free0 (self->device);
#line 45 "Utility/Device.vala"
	_g_free0 (self->name);
#line 46 "Utility/Device.vala"
	_g_free0 (self->kname);
#line 47 "Utility/Device.vala"
	_g_free0 (self->pkname);
#line 48 "Utility/Device.vala"
	_g_free0 (self->pkname_toplevel);
#line 49 "Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 50 "Utility/Device.vala"
	_g_free0 (self->uuid);
#line 51 "Utility/Device.vala"
	_g_free0 (self->label);
#line 52 "Utility/Device.vala"
	_g_free0 (self->partuuid);
#line 53 "Utility/Device.vala"
	_g_free0 (self->partlabel);
#line 58 "Utility/Device.vala"
	_g_free0 (self->device_mapper);
#line 59 "Utility/Device.vala"
	_g_free0 (self->device_by_uuid);
#line 60 "Utility/Device.vala"
	_g_free0 (self->device_by_label);
#line 61 "Utility/Device.vala"
	_g_free0 (self->device_by_partuuid);
#line 62 "Utility/Device.vala"
	_g_free0 (self->device_by_partlabel);
#line 64 "Utility/Device.vala"
	_g_free0 (self->type);
#line 65 "Utility/Device.vala"
	_g_free0 (self->fstype);
#line 69 "Utility/Device.vala"
	_g_free0 (self->vendor);
#line 70 "Utility/Device.vala"
	_g_free0 (self->model);
#line 71 "Utility/Device.vala"
	_g_free0 (self->serial);
#line 72 "Utility/Device.vala"
	_g_free0 (self->revision);
#line 81 "Utility/Device.vala"
	_g_free0 (self->used_percent);
#line 82 "Utility/Device.vala"
	_g_free0 (self->dist_info);
#line 83 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 84 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 86 "Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 87 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (device_parent_class)->finalize (obj);
#line 13109 "Device.c"
}

GType
device_get_type (void)
{
	static volatile gsize device_type_id__volatile = 0;
	if (g_once_init_enter (&device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Device), 0, (GInstanceInitFunc) device_instance_init, NULL };
		GType device_type_id;
		device_type_id = g_type_register_static (G_TYPE_OBJECT, "Device", &g_define_type_info, 0);
		g_once_init_leave (&device_type_id__volatile, device_type_id);
	}
	return device_type_id__volatile;
}

static void
_vala_device_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Device * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE, Device);
#line 32 "Utility/Device.vala"
	switch (property_id) {
#line 32 "Utility/Device.vala"
		case DEVICE_FREE_BYTES_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_set_uint64 (value, device_get_free_bytes (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SIZE_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_size (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_USED_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_used (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FREE_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_free (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_IS_MOUNTED_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_set_boolean (value, device_get_is_mounted (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_alias (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_alias (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_device_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 13195 "Device.c"
		default:
#line 32 "Utility/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "Utility/Device.vala"
		break;
#line 13201 "Device.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

