/* TeeJee.FileSystem.c generated by valac 0.43.91, the Vala compiler
 * generated from TeeJee.FileSystem.vala, do not modify */

/*
 * TeeJee.FileSystem.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_checksum_free0(var) ((var == NULL) ? NULL : (var = (g_checksum_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define TEE_JEE_FILE_SYSTEM_KB ((gint64) 1000)
#define TEE_JEE_FILE_SYSTEM_MB (1000 * TEE_JEE_FILE_SYSTEM_KB)
#define TEE_JEE_FILE_SYSTEM_GB (1000 * TEE_JEE_FILE_SYSTEM_MB)
#define TEE_JEE_FILE_SYSTEM_TB (1000 * TEE_JEE_FILE_SYSTEM_GB)
#define TEE_JEE_FILE_SYSTEM_KiB ((gint64) 1024)
#define TEE_JEE_FILE_SYSTEM_MiB (1024 * TEE_JEE_FILE_SYSTEM_KiB)
#define TEE_JEE_FILE_SYSTEM_GiB (1024 * TEE_JEE_FILE_SYSTEM_MiB)
#define TEE_JEE_FILE_SYSTEM_TiB (1024 * TEE_JEE_FILE_SYSTEM_GiB)
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gchar* tee_jee_file_system_file_basename (const gchar* file_path);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gchar* tee_jee_file_system_remove_trailing_slash (const gchar* path);
gboolean tee_jee_file_system_file_or_dir_exists (const gchar* item_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gboolean tee_jee_file_system_file_exists_regular (const gchar* file_path);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gboolean tee_jee_file_system_file_move_to_trash (const gchar* file_path);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gboolean tee_jee_file_system_file_shred (const gchar* file_path);
gint64 tee_jee_file_system_file_line_count (const gchar* file_path);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean tee_jee_file_system_file_copy (const gchar* src_file,
                                        const gchar* dest_file);
void tee_jee_file_system_file_move (const gchar* src_file,
                                    const gchar* dest_file);
gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
gboolean tee_jee_file_system_file_gzip (const gchar* src_file);
gboolean tee_jee_file_system_file_gunzip (const gchar* src_file);
gchar* tee_jee_file_system_file_resolve_executable_path (const gchar* file_path);
gint64 tee_jee_file_system_file_get_size (const gchar* file_path);
GDateTime* tee_jee_file_system_file_get_modified_date (const gchar* file_path);
gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean tee_jee_file_system_dir_delete (const gchar* dir_path,
                                         gboolean show_message);
void tee_jee_logging_log_debug (const gchar* message);
gboolean tee_jee_file_system_dir_move_to_trash (const gchar* dir_path);
gboolean tee_jee_file_system_dir_is_empty (const gchar* dir_path);
gboolean tee_jee_file_system_filesystem_supports_hardlinks (const gchar* path,
                                                            gboolean* is_readonly);
gchar* tee_jee_misc_random_string (gint length,
                                   const gchar* charset);
GeeArrayList* tee_jee_file_system_dir_list_names (const gchar* path);
static gint __lambda18_ (const gchar* a,
                  const gchar* b);
static gint ___lambda18__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
gboolean tee_jee_file_system_dir_tar (const gchar* src_dir,
                                      const gchar* tar_file,
                                      gboolean recursion);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gboolean tee_jee_file_system_dir_untar (const gchar* tar_file,
                                        const gchar* dst_dir);
gboolean tee_jee_file_system_chown (const gchar* dir_path,
                                    const gchar* user,
                                    const gchar* group);
glong tee_jee_file_system_dir_count (const gchar* path);
glong tee_jee_file_system_dir_size (const gchar* path);
glong tee_jee_file_system_dir_size_kb (const gchar* path);
gboolean tee_jee_file_system_file_tar_encrypt (const gchar* src_file,
                                               const gchar* dst_file,
                                               const gchar* password);
gchar* tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file,
                                                    const gchar* password);
gboolean tee_jee_file_system_decrypt_and_untar (const gchar* src_file,
                                                const gchar* dst_file,
                                                const gchar* password);
gchar* tee_jee_file_system_hash_md5 (const gchar* path);
gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
gint tee_jee_file_system_chmod (const gchar* file,
                                const gchar* permission);
gchar* tee_jee_file_system_resolve_relative_path (const gchar* filePath);
gint tee_jee_file_system_rsync (const gchar* sourceDirectory,
                                const gchar* destDirectory,
                                gboolean updateExisting,
                                gboolean deleteExtra);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

gchar*
tee_jee_file_system_file_parent (const gchar* file_path)
{
	gchar* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 45 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_parent (_tmp1_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp3_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	result = _tmp5_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 186 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_basename (const gchar* file_path)
{
	gchar* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 49 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_basename (_tmp1_);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 50 "Utility/TeeJee.FileSystem.vala"
	result = _tmp3_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 213 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_path_combine (const gchar* path1,
                                  const gchar* path2)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 53 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path1 != NULL, NULL);
#line 53 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path2 != NULL, NULL);
#line 54 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_build_path ("/", path1, path2, NULL);
#line 54 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 54 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 232 "TeeJee.FileSystem.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
#line 1425 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1426 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1426 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1426 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1427 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1428 "glib-2.0.vapi"
		start = string_length + start;
#line 259 "TeeJee.FileSystem.c"
	}
#line 1430 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1431 "glib-2.0.vapi"
		end = string_length + end;
#line 265 "TeeJee.FileSystem.c"
	}
#line 1433 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1433 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 271 "TeeJee.FileSystem.c"
	} else {
#line 1433 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 275 "TeeJee.FileSystem.c"
	}
#line 1433 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1434 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1434 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 283 "TeeJee.FileSystem.c"
	} else {
#line 1434 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 287 "TeeJee.FileSystem.c"
	}
#line 1434 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1435 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1436 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1436 "glib-2.0.vapi"
	result = _tmp4_;
#line 1436 "glib-2.0.vapi"
	return result;
#line 299 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_remove_trailing_slash (const gchar* path)
{
	gchar* result = NULL;
#line 57 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 58 "Utility/TeeJee.FileSystem.vala"
	if (g_str_has_suffix (path, "/")) {
#line 310 "TeeJee.FileSystem.c"
		gint _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = strlen (path);
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = string_slice (path, (glong) 0, (glong) (_tmp1_ - 1));
#line 59 "Utility/TeeJee.FileSystem.vala"
		result = _tmp2_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 324 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp3_;
#line 62 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup (path);
#line 62 "Utility/TeeJee.FileSystem.vala"
		result = _tmp3_;
#line 62 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 333 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_file_or_dir_exists (const gchar* item_path)
{
	gboolean result = FALSE;
	GFile* item = NULL;
	GFile* _tmp0_;
#line 68 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (item_path != NULL, FALSE);
#line 72 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_parse_name (item_path);
#line 72 "Utility/TeeJee.FileSystem.vala"
	item = _tmp0_;
#line 73 "Utility/TeeJee.FileSystem.vala"
	result = g_file_query_exists (item, NULL);
#line 73 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (item);
#line 73 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 355 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_exists (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 76 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 78 "Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 79 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = !g_file_test (file_path, G_FILE_TEST_IS_DIR);
#line 369 "TeeJee.FileSystem.c"
	} else {
#line 78 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 373 "TeeJee.FileSystem.c"
	}
#line 78 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 78 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 379 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_exists_regular (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 82 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 84 "Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 85 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (file_path, G_FILE_TEST_IS_REGULAR);
#line 393 "TeeJee.FileSystem.c"
	} else {
#line 84 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 397 "TeeJee.FileSystem.c"
	}
#line 84 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 84 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 403 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_delete (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 88 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 414 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 93 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 93 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 94 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 94 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 427 "TeeJee.FileSystem.c"
			GFile* _tmp2_;
#line 95 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 95 "Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp2_, NULL, &_inner_error0_);
#line 95 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 437 "TeeJee.FileSystem.c"
				goto __catch64_g_error;
			}
		}
#line 97 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 97 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 97 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 447 "TeeJee.FileSystem.c"
	}
	goto __finally64;
	__catch64_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 92 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 92 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 99 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = e;
#line 99 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_->message;
#line 99 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_strdup_printf (": %s", file_path);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 100 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strconcat (_ ("Failed to delete file"), _tmp6_, NULL);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 100 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp6_);
#line 101 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 101 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 101 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 489 "TeeJee.FileSystem.c"
	}
	__finally64:
#line 92 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 92 "Utility/TeeJee.FileSystem.vala"
	return _tmp9_;
#line 498 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_move_to_trash (const gchar* file_path)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 105 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 109 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 109 "Utility/TeeJee.FileSystem.vala"
	file = _tmp0_;
#line 110 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = file;
#line 110 "Utility/TeeJee.FileSystem.vala"
	if (g_file_query_exists (_tmp1_, NULL)) {
#line 518 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 111 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (file_path);
#line 111 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 111 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("gvfs-trash '%s'", _tmp3_);
#line 111 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 111 "Utility/TeeJee.FileSystem.vala"
		system (_tmp5_);
#line 111 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 111 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 537 "TeeJee.FileSystem.c"
	}
#line 113 "Utility/TeeJee.FileSystem.vala"
	result = TRUE;
#line 113 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (file);
#line 113 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 545 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_shred (const gchar* file_path)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 116 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 120 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 120 "Utility/TeeJee.FileSystem.vala"
	file = _tmp0_;
#line 121 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = file;
#line 121 "Utility/TeeJee.FileSystem.vala"
	if (g_file_query_exists (_tmp1_, NULL)) {
#line 565 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 122 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (file_path);
#line 122 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 122 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("shred -u '%s'", _tmp3_);
#line 122 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 122 "Utility/TeeJee.FileSystem.vala"
		system (_tmp5_);
#line 122 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 122 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 584 "TeeJee.FileSystem.c"
	}
#line 124 "Utility/TeeJee.FileSystem.vala"
	result = TRUE;
#line 124 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (file);
#line 124 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 592 "TeeJee.FileSystem.c"
}

static glong
long_parse (const gchar* str)
{
	glong result = 0L;
#line 269 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0L);
#line 270 "glib-2.0.vapi"
	result = strtol (str, NULL, (guint) 0);
#line 270 "glib-2.0.vapi"
	return result;
#line 605 "TeeJee.FileSystem.c"
}

gint64
tee_jee_file_system_file_line_count (const gchar* file_path)
{
	gint64 result = 0LL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gint64 _tmp10_;
#line 127 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 129 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file_path);
#line 129 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 129 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("wc -l '%s'", _tmp1_);
#line 129 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 129 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 129 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 131 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 131 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 131 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 131 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 131 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 132 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 132 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 132 "Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 132 "Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 132 "Utility/TeeJee.FileSystem.vala"
	_tmp10_ = (gint64) long_parse (_tmp9_);
#line 132 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 132 "Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 132 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 132 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 132 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 132 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 673 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_read (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* txt = NULL;
	gsize size = 0UL;
	GError* _inner_error0_ = NULL;
#line 135 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 685 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_ = NULL;
		gsize _tmp1_ = 0UL;
#line 143 "Utility/TeeJee.FileSystem.vala"
		g_file_get_contents (file_path, &_tmp0_, &_tmp1_, &_inner_error0_);
#line 143 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 143 "Utility/TeeJee.FileSystem.vala"
		txt = _tmp0_;
#line 143 "Utility/TeeJee.FileSystem.vala"
		size = _tmp1_;
#line 143 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 699 "TeeJee.FileSystem.c"
			goto __catch65_g_error;
		}
#line 144 "Utility/TeeJee.FileSystem.vala"
		result = txt;
#line 144 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 706 "TeeJee.FileSystem.c"
	}
	goto __finally65;
	__catch65_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 142 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 142 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 147 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = e;
#line 147 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_->message;
#line 147 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp3_, FALSE, FALSE);
#line 148 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf (": %s", file_path);
#line 148 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 148 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_strconcat (_ ("Failed to read file"), _tmp5_, NULL);
#line 148 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = _tmp6_;
#line 148 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 148 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp7_);
#line 148 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 142 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 744 "TeeJee.FileSystem.c"
	}
	__finally65:
#line 142 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 142 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 142 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 757 "TeeJee.FileSystem.c"
	}
#line 151 "Utility/TeeJee.FileSystem.vala"
	result = NULL;
#line 151 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (txt);
#line 151 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 765 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_write (const gchar* file_path,
                                const gchar* contents)
{
	gboolean result = FALSE;
	gboolean _tmp17_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 154 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 154 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (contents != NULL, FALSE);
#line 779 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* file = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp5_;
		GFileOutputStream* _tmp6_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp7_;
		GDataOutputStream* _tmp8_;
		GDataOutputStream* _tmp9_;
		GDataOutputStream* _tmp10_;
#line 160 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (file_path);
#line 160 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 160 "Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_dir_create (_tmp1_, FALSE);
#line 160 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp1_);
#line 162 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = g_file_new_for_path (file_path);
#line 162 "Utility/TeeJee.FileSystem.vala"
		file = _tmp2_;
#line 163 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = file;
#line 163 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp3_, NULL)) {
#line 810 "TeeJee.FileSystem.c"
			GFile* _tmp4_;
#line 164 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file;
#line 164 "Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp4_, NULL, &_inner_error0_);
#line 164 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 820 "TeeJee.FileSystem.c"
				goto __catch66_g_error;
			}
		}
#line 167 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = file;
#line 167 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_file_create (_tmp5_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 167 "Utility/TeeJee.FileSystem.vala"
		file_stream = _tmp6_;
#line 167 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 834 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 168 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = file_stream;
#line 168 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_data_output_stream_new ((GOutputStream*) _tmp7_);
#line 168 "Utility/TeeJee.FileSystem.vala"
		data_stream = _tmp8_;
#line 169 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = data_stream;
#line 169 "Utility/TeeJee.FileSystem.vala"
		g_data_output_stream_put_string (_tmp9_, contents, NULL, &_inner_error0_);
#line 169 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 169 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 169 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 855 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 170 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = data_stream;
#line 170 "Utility/TeeJee.FileSystem.vala"
		g_output_stream_close ((GOutputStream*) _tmp10_, NULL, &_inner_error0_);
#line 170 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 170 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 170 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 870 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 171 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 171 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (data_stream);
#line 171 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_stream);
#line 171 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 171 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 883 "TeeJee.FileSystem.c"
	}
	goto __finally66;
	__catch66_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 158 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 158 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 174 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = e;
#line 174 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_->message;
#line 174 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp12_, FALSE, FALSE);
#line 175 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", file_path);
#line 175 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 175 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("Failed to write file"), _tmp14_, NULL);
#line 175 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 175 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 175 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 175 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 176 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 176 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 176 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 925 "TeeJee.FileSystem.c"
	}
	__finally66:
#line 158 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 158 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 158 "Utility/TeeJee.FileSystem.vala"
	return _tmp17_;
#line 934 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_copy (const gchar* src_file,
                               const gchar* dest_file)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 180 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 180 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dest_file != NULL, FALSE);
#line 947 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 182 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 182 "Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 183 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 183 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 960 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 184 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 184 "Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 185 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 185 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 185 "Utility/TeeJee.FileSystem.vala"
			g_file_copy (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 185 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 185 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 981 "TeeJee.FileSystem.c"
				goto __catch67_g_error;
			}
#line 186 "Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 186 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 186 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_src);
#line 186 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 992 "TeeJee.FileSystem.c"
		}
#line 181 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 996 "TeeJee.FileSystem.c"
	}
	goto __finally67;
	__catch67_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 181 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 181 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 190 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 190 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 190 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 191 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 191 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 191 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_ ("Failed to copy file"), _tmp8_, NULL);
#line 191 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 191 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 191 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 191 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 181 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1034 "TeeJee.FileSystem.c"
	}
	__finally67:
#line 181 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1039 "TeeJee.FileSystem.c"
		gboolean _tmp11_ = FALSE;
#line 181 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 181 "Utility/TeeJee.FileSystem.vala"
		return _tmp11_;
#line 1047 "TeeJee.FileSystem.c"
	}
#line 194 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 194 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1053 "TeeJee.FileSystem.c"
}

void
tee_jee_file_system_file_move (const gchar* src_file,
                               const gchar* dest_file)
{
	GError* _inner_error0_ = NULL;
#line 197 "Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (src_file != NULL);
#line 197 "Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (dest_file != NULL);
#line 1065 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 199 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 199 "Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 200 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 200 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1078 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 201 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 201 "Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 202 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 202 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 202 "Utility/TeeJee.FileSystem.vala"
			g_file_move (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 202 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 202 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 1099 "TeeJee.FileSystem.c"
				goto __catch68_g_error;
			}
#line 200 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 1104 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 205 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_strdup_printf (": '%s'", src_file);
#line 205 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 205 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = g_strconcat (_ ("File not found"), _tmp6_, NULL);
#line 205 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp7_;
#line 205 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 205 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp8_);
#line 205 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp6_);
#line 1124 "TeeJee.FileSystem.c"
		}
#line 198 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 1128 "TeeJee.FileSystem.c"
	}
	goto __finally68;
	__catch68_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 198 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 198 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 209 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = e;
#line 209 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_->message;
#line 209 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 210 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 210 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 210 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strconcat (_ ("Failed to move file"), _tmp12_, NULL);
#line 210 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 210 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp14_, FALSE, FALSE);
#line 210 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 210 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 198 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1166 "TeeJee.FileSystem.c"
	}
	__finally68:
#line 198 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 198 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 198 "Utility/TeeJee.FileSystem.vala"
		return;
#line 1177 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_file_is_symlink (const gchar* file_path)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 214 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 1188 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 217 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 217 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 219 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 219 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1201 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFileType file_type = 0;
			GFileInfo* _tmp7_;
			GFileType _tmp8_;
#line 221 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 221 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 221 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 221 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_query_info (_tmp2_, _tmp4_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 221 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 221 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 221 "Utility/TeeJee.FileSystem.vala"
			info = _tmp6_;
#line 221 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 1229 "TeeJee.FileSystem.c"
				goto __catch69_g_error;
			}
#line 223 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = info;
#line 223 "Utility/TeeJee.FileSystem.vala"
			file_type = g_file_info_get_file_type (_tmp7_);
#line 225 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = file_type;
#line 225 "Utility/TeeJee.FileSystem.vala"
			result = _tmp8_ == G_FILE_TYPE_SYMBOLIC_LINK;
#line 225 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 225 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 225 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1246 "TeeJee.FileSystem.c"
		}
#line 216 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 1250 "TeeJee.FileSystem.c"
	}
	goto __finally69;
	__catch69_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 216 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 216 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 229 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = e;
#line 229 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_->message;
#line 229 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 216 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1270 "TeeJee.FileSystem.c"
	}
	__finally69:
#line 216 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1275 "TeeJee.FileSystem.c"
		gboolean _tmp11_ = FALSE;
#line 216 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 216 "Utility/TeeJee.FileSystem.vala"
		return _tmp11_;
#line 1283 "TeeJee.FileSystem.c"
	}
#line 232 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 232 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1289 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_gzip (const gchar* src_file)
{
	gboolean result = FALSE;
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 235 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 237 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strconcat (src_file, ".gz", NULL);
#line 237 "Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 238 "Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 240 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 240 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 240 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gzip '%s'", _tmp2_);
#line 240 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 240 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 240 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 242 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 242 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 242 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 242 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 242 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 244 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 244 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 244 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 244 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 244 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 244 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1349 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_gunzip (const gchar* src_file)
{
	gboolean result = FALSE;
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 247 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 249 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup (src_file);
#line 249 "Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 250 "Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 252 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 252 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 252 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gunzip '%s'", _tmp2_);
#line 252 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 252 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 252 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 254 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 254 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 254 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 254 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 254 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 256 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 256 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 256 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 256 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 256 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 256 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1409 "TeeJee.FileSystem.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 1428 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_resolve_executable_path (const gchar* file_path)
{
	gchar* result = NULL;
#line 259 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 261 "Utility/TeeJee.FileSystem.vala"
	if (g_str_has_prefix (file_path, "/")) {
#line 1439 "TeeJee.FileSystem.c"
		gchar* _tmp0_;
#line 262 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_strdup (file_path);
#line 262 "Utility/TeeJee.FileSystem.vala"
		result = _tmp0_;
#line 262 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1447 "TeeJee.FileSystem.c"
	} else {
#line 264 "Utility/TeeJee.FileSystem.vala"
		if (!string_contains (file_path, "/")) {
#line 1451 "TeeJee.FileSystem.c"
			gchar* _tmp1_;
#line 265 "Utility/TeeJee.FileSystem.vala"
			_tmp1_ = g_find_program_in_path (file_path);
#line 265 "Utility/TeeJee.FileSystem.vala"
			result = _tmp1_;
#line 265 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1459 "TeeJee.FileSystem.c"
		} else {
#line 267 "Utility/TeeJee.FileSystem.vala"
			if (g_str_has_prefix (file_path, "./")) {
#line 1463 "TeeJee.FileSystem.c"
				gchar* _tmp2_;
				gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 268 "Utility/TeeJee.FileSystem.vala"
				_tmp2_ = g_get_current_dir ();
#line 268 "Utility/TeeJee.FileSystem.vala"
				_tmp3_ = _tmp2_;
#line 268 "Utility/TeeJee.FileSystem.vala"
				_tmp4_ = strlen (file_path);
#line 268 "Utility/TeeJee.FileSystem.vala"
				_tmp5_ = _tmp4_;
#line 268 "Utility/TeeJee.FileSystem.vala"
				_tmp6_ = string_slice (file_path, (glong) 2, (glong) _tmp5_);
#line 268 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp6_;
#line 268 "Utility/TeeJee.FileSystem.vala"
				_tmp8_ = tee_jee_file_system_path_combine (_tmp3_, _tmp7_);
#line 268 "Utility/TeeJee.FileSystem.vala"
				_tmp9_ = _tmp8_;
#line 268 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp7_);
#line 268 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp3_);
#line 268 "Utility/TeeJee.FileSystem.vala"
				result = _tmp9_;
#line 268 "Utility/TeeJee.FileSystem.vala"
				return result;
#line 1496 "TeeJee.FileSystem.c"
			} else {
#line 270 "Utility/TeeJee.FileSystem.vala"
				if (g_str_has_prefix (file_path, "../")) {
#line 1500 "TeeJee.FileSystem.c"
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp10_ = g_get_current_dir ();
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp11_ = _tmp10_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp12_ = tee_jee_file_system_file_parent (_tmp11_);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp13_ = _tmp12_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp14_ = strlen (file_path);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp15_ = _tmp14_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp16_ = string_slice (file_path, (glong) 3, (glong) _tmp15_);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp17_ = _tmp16_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp18_ = tee_jee_file_system_path_combine (_tmp13_, _tmp17_);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp19_ = _tmp18_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp17_);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp13_);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp11_);
#line 271 "Utility/TeeJee.FileSystem.vala"
					result = _tmp19_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					return result;
#line 1541 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 274 "Utility/TeeJee.FileSystem.vala"
					_tmp20_ = g_get_current_dir ();
#line 274 "Utility/TeeJee.FileSystem.vala"
					_tmp21_ = _tmp20_;
#line 274 "Utility/TeeJee.FileSystem.vala"
					_tmp22_ = tee_jee_file_system_path_combine (_tmp21_, file_path);
#line 274 "Utility/TeeJee.FileSystem.vala"
					_tmp23_ = _tmp22_;
#line 274 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp21_);
#line 274 "Utility/TeeJee.FileSystem.vala"
					result = _tmp23_;
#line 274 "Utility/TeeJee.FileSystem.vala"
					return result;
#line 1561 "TeeJee.FileSystem.c"
				}
			}
		}
	}
}

gint64
tee_jee_file_system_file_get_size (const gchar* file_path)
{
	gint64 result = 0LL;
	GError* _inner_error0_ = NULL;
#line 280 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 1575 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 284 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 284 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 286 "Utility/TeeJee.FileSystem.vala"
		if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 1585 "TeeJee.FileSystem.c"
			gboolean _tmp1_ = FALSE;
#line 288 "Utility/TeeJee.FileSystem.vala"
			if (g_file_test (file_path, G_FILE_TEST_IS_REGULAR)) {
#line 289 "Utility/TeeJee.FileSystem.vala"
				_tmp1_ = !g_file_test (file_path, G_FILE_TEST_IS_SYMLINK);
#line 1591 "TeeJee.FileSystem.c"
			} else {
#line 288 "Utility/TeeJee.FileSystem.vala"
				_tmp1_ = FALSE;
#line 1595 "TeeJee.FileSystem.c"
			}
#line 288 "Utility/TeeJee.FileSystem.vala"
			if (_tmp1_) {
#line 1599 "TeeJee.FileSystem.c"
				GFileInfo* _tmp2_ = NULL;
				GFile* _tmp3_;
				GFileInfo* _tmp4_;
#line 291 "Utility/TeeJee.FileSystem.vala"
				_tmp3_ = file;
#line 291 "Utility/TeeJee.FileSystem.vala"
				_tmp4_ = g_file_query_info (_tmp3_, "standard::size", 0, NULL, &_inner_error0_);
#line 291 "Utility/TeeJee.FileSystem.vala"
				_tmp2_ = _tmp4_;
#line 291 "Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (file);
#line 1613 "TeeJee.FileSystem.c"
					goto __catch70_g_error;
				}
#line 291 "Utility/TeeJee.FileSystem.vala"
				result = g_file_info_get_size (_tmp2_);
#line 291 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp2_);
#line 291 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 291 "Utility/TeeJee.FileSystem.vala"
				return result;
#line 1624 "TeeJee.FileSystem.c"
			}
		}
#line 282 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 1629 "TeeJee.FileSystem.c"
	}
	goto __finally70;
	__catch70_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 282 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 282 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 296 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 296 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 296 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 282 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1649 "TeeJee.FileSystem.c"
	}
	__finally70:
#line 282 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1654 "TeeJee.FileSystem.c"
		gint64 _tmp7_ = -1LL;
#line 282 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 282 "Utility/TeeJee.FileSystem.vala"
		return _tmp7_;
#line 1662 "TeeJee.FileSystem.c"
	}
#line 299 "Utility/TeeJee.FileSystem.vala"
	result = (gint64) -1;
#line 299 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1668 "TeeJee.FileSystem.c"
}

GDateTime*
tee_jee_file_system_file_get_modified_date (const gchar* file_path)
{
	GDateTime* result = NULL;
	GDateTime* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 302 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1679 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 305 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 305 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 306 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 306 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1693 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GTimeVal _tmp10_ = {0};
			GDateTime* _tmp11_;
			GDateTime* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error0_);
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 307 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 307 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 307 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 307 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1727 "TeeJee.FileSystem.c"
				goto __catch71_g_error;
			}
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 307 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 307 "Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 308 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 308 "Utility/TeeJee.FileSystem.vala"
			g_file_info_get_modification_time (_tmp9_, &_tmp10_);
#line 308 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_date_time_new_from_timeval_utc (&_tmp10_);
#line 308 "Utility/TeeJee.FileSystem.vala"
			_tmp12_ = _tmp11_;
#line 308 "Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_date_time_to_local (_tmp12_);
#line 308 "Utility/TeeJee.FileSystem.vala"
			_tmp14_ = _tmp13_;
#line 308 "Utility/TeeJee.FileSystem.vala"
			_g_date_time_unref0 (_tmp12_);
#line 308 "Utility/TeeJee.FileSystem.vala"
			result = _tmp14_;
#line 308 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 308 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 308 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 308 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1762 "TeeJee.FileSystem.c"
		}
#line 303 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 303 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1768 "TeeJee.FileSystem.c"
	}
	goto __finally71;
	__catch71_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 303 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 303 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 312 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = e;
#line 312 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_->message;
#line 312 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 303 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1788 "TeeJee.FileSystem.c"
	}
	__finally71:
#line 303 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 303 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 303 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 303 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1799 "TeeJee.FileSystem.c"
	}
#line 315 "Utility/TeeJee.FileSystem.vala"
	_tmp17_ = g_date_time_new_from_unix_utc ((gint64) 0);
#line 315 "Utility/TeeJee.FileSystem.vala"
	result = _tmp17_;
#line 315 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1807 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_get_symlink_target (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 318 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1818 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 321 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 321 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 322 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 322 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1832 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error0_);
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 323 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 323 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1863 "TeeJee.FileSystem.c"
				goto __catch72_g_error;
			}
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 323 "Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 324 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 324 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = g_file_info_get_symlink_target (_tmp9_);
#line 324 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 324 "Utility/TeeJee.FileSystem.vala"
			result = _tmp11_;
#line 324 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 324 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 324 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 324 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1890 "TeeJee.FileSystem.c"
		}
#line 319 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 319 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1896 "TeeJee.FileSystem.c"
	}
	goto __finally72;
	__catch72_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 319 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 319 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 328 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 328 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 328 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 319 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1916 "TeeJee.FileSystem.c"
	}
	__finally72:
#line 319 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 319 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 319 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 319 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1927 "TeeJee.FileSystem.c"
	}
#line 331 "Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strdup ("");
#line 331 "Utility/TeeJee.FileSystem.vala"
	result = _tmp14_;
#line 331 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1935 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_exists (const gchar* dir_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 336 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 338 "Utility/TeeJee.FileSystem.vala"
	if (g_file_test (dir_path, G_FILE_TEST_EXISTS)) {
#line 338 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (dir_path, G_FILE_TEST_IS_DIR);
#line 1949 "TeeJee.FileSystem.c"
	} else {
#line 338 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 1953 "TeeJee.FileSystem.c"
	}
#line 338 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 338 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1959 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_create (const gchar* dir_path,
                                gboolean show_message)
{
	gboolean result = FALSE;
	gboolean _tmp17_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 341 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 1971 "TeeJee.FileSystem.c"
	{
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 346 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 346 "Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 347 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 347 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL) == FALSE) {
#line 1984 "TeeJee.FileSystem.c"
			gboolean ok = FALSE;
			GFile* _tmp2_;
#line 348 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 348 "Utility/TeeJee.FileSystem.vala"
			ok = g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error0_);
#line 348 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 1995 "TeeJee.FileSystem.c"
				goto __catch73_g_error;
			}
#line 349 "Utility/TeeJee.FileSystem.vala"
			if (show_message) {
#line 350 "Utility/TeeJee.FileSystem.vala"
				if (ok) {
#line 2002 "TeeJee.FileSystem.c"
					gchar* _tmp3_;
					gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
#line 351 "Utility/TeeJee.FileSystem.vala"
					_tmp3_ = g_strdup_printf (": %s", dir_path);
#line 351 "Utility/TeeJee.FileSystem.vala"
					_tmp4_ = _tmp3_;
#line 351 "Utility/TeeJee.FileSystem.vala"
					_tmp5_ = g_strconcat (_ ("Created directory"), _tmp4_, NULL);
#line 351 "Utility/TeeJee.FileSystem.vala"
					_tmp6_ = _tmp5_;
#line 351 "Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_msg (_tmp6_, FALSE);
#line 351 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp6_);
#line 351 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp4_);
#line 2021 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 354 "Utility/TeeJee.FileSystem.vala"
					_tmp7_ = g_strdup_printf (": %s", dir_path);
#line 354 "Utility/TeeJee.FileSystem.vala"
					_tmp8_ = _tmp7_;
#line 354 "Utility/TeeJee.FileSystem.vala"
					_tmp9_ = g_strconcat (_ ("Failed to create directory"), _tmp8_, NULL);
#line 354 "Utility/TeeJee.FileSystem.vala"
					_tmp10_ = _tmp9_;
#line 354 "Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 354 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp10_);
#line 354 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp8_);
#line 2041 "TeeJee.FileSystem.c"
				}
			}
		}
#line 358 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 358 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 358 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 2051 "TeeJee.FileSystem.c"
	}
	goto __finally73;
	__catch73_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 345 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 345 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 361 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = e;
#line 361 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_->message;
#line 361 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp12_, FALSE, FALSE);
#line 362 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", dir_path);
#line 362 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 362 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("Failed to create directory"), _tmp14_, NULL);
#line 362 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 362 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 362 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 362 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 363 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 363 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 363 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 2093 "TeeJee.FileSystem.c"
	}
	__finally73:
#line 345 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 345 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 345 "Utility/TeeJee.FileSystem.vala"
	return _tmp17_;
#line 2102 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_delete (const gchar* dir_path,
                                gboolean show_message)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gint _tmp8_;
#line 367 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 371 "Utility/TeeJee.FileSystem.vala"
	if (!tee_jee_file_system_dir_exists (dir_path)) {
#line 372 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 372 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 2131 "TeeJee.FileSystem.c"
	}
#line 375 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 375 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 375 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("rm -rf '%s'", _tmp1_);
#line 375 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 375 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 375 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 376 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 376 "Utility/TeeJee.FileSystem.vala"
	tee_jee_logging_log_debug (_tmp4_);
#line 378 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 378 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_process_helper_exec_sync (_tmp5_, &_tmp6_, &_tmp7_);
#line 378 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 378 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp6_;
#line 378 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 378 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp7_;
#line 378 "Utility/TeeJee.FileSystem.vala"
	status = _tmp8_;
#line 379 "Utility/TeeJee.FileSystem.vala"
	if (show_message) {
#line 380 "Utility/TeeJee.FileSystem.vala"
		if (status == 0) {
#line 2167 "TeeJee.FileSystem.c"
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 381 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = g_strdup_printf (": %s", dir_path);
#line 381 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = _tmp9_;
#line 381 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_strconcat (_ ("Deleted directory"), _tmp10_, NULL);
#line 381 "Utility/TeeJee.FileSystem.vala"
			_tmp12_ = _tmp11_;
#line 381 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp12_, FALSE);
#line 381 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp12_);
#line 381 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp10_);
#line 2186 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
#line 384 "Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_strdup_printf (": %s", dir_path);
#line 384 "Utility/TeeJee.FileSystem.vala"
			_tmp14_ = _tmp13_;
#line 384 "Utility/TeeJee.FileSystem.vala"
			_tmp15_ = g_strconcat (_ ("Failed to delete directory"), _tmp14_, NULL);
#line 384 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = _tmp15_;
#line 384 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 384 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp16_);
#line 384 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp14_);
#line 385 "Utility/TeeJee.FileSystem.vala"
			_tmp17_ = std_out;
#line 385 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 386 "Utility/TeeJee.FileSystem.vala"
			_tmp18_ = std_err;
#line 386 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 2216 "TeeJee.FileSystem.c"
		}
	}
#line 390 "Utility/TeeJee.FileSystem.vala"
	result = status == 0;
#line 390 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 390 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 390 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 390 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2229 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_move_to_trash (const gchar* dir_path)
{
	gboolean result = FALSE;
#line 393 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 394 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_move_to_trash (dir_path);
#line 394 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2242 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_is_empty (const gchar* dir_path)
{
	gboolean result = FALSE;
	gboolean _tmp14_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 397 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 2253 "TeeJee.FileSystem.c"
	{
		gboolean is_empty = FALSE;
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 402 "Utility/TeeJee.FileSystem.vala"
		is_empty = TRUE;
#line 403 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 403 "Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 404 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 404 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 2269 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFileEnumerator* enu = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileEnumerator* _tmp5_;
			GFileEnumerator* _tmp6_;
#line 406 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 406 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 406 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 406 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error0_);
#line 406 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 406 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 406 "Utility/TeeJee.FileSystem.vala"
			enu = _tmp6_;
#line 406 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 406 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 406 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 2297 "TeeJee.FileSystem.c"
				goto __catch74_g_error;
			}
#line 407 "Utility/TeeJee.FileSystem.vala"
			while (TRUE) {
#line 2302 "TeeJee.FileSystem.c"
				GFileInfo* _tmp7_ = NULL;
				GFileEnumerator* _tmp8_;
				GFileInfo* _tmp9_;
				GFileInfo* _tmp10_;
				GFileInfo* _tmp11_;
#line 407 "Utility/TeeJee.FileSystem.vala"
				_tmp8_ = enu;
#line 407 "Utility/TeeJee.FileSystem.vala"
				_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 407 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp9_;
#line 407 "Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 407 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (enu);
#line 407 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (info);
#line 407 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (dir);
#line 2322 "TeeJee.FileSystem.c"
					goto __catch74_g_error;
				}
#line 407 "Utility/TeeJee.FileSystem.vala"
				_tmp10_ = _tmp7_;
#line 407 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = NULL;
#line 407 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 407 "Utility/TeeJee.FileSystem.vala"
				info = _tmp10_;
#line 407 "Utility/TeeJee.FileSystem.vala"
				_tmp11_ = info;
#line 407 "Utility/TeeJee.FileSystem.vala"
				if (!(_tmp11_ != NULL)) {
#line 407 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (_tmp7_);
#line 407 "Utility/TeeJee.FileSystem.vala"
					break;
#line 2341 "TeeJee.FileSystem.c"
				}
#line 408 "Utility/TeeJee.FileSystem.vala"
				is_empty = FALSE;
#line 409 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 409 "Utility/TeeJee.FileSystem.vala"
				break;
#line 2349 "TeeJee.FileSystem.c"
			}
#line 404 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (enu);
#line 404 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 2355 "TeeJee.FileSystem.c"
		}
#line 412 "Utility/TeeJee.FileSystem.vala"
		result = is_empty;
#line 412 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 412 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 2363 "TeeJee.FileSystem.c"
	}
	goto __finally74;
	__catch74_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 401 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 401 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 415 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 415 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 415 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 416 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 416 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 416 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 2387 "TeeJee.FileSystem.c"
	}
	__finally74:
#line 401 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 401 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 401 "Utility/TeeJee.FileSystem.vala"
	return _tmp14_;
#line 2396 "TeeJee.FileSystem.c"
}

static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar* * unparsed)
{
	gint64 _vala__result_ = 0LL;
	const gchar* _vala_unparsed = NULL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 727 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 729 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, (guint) 0);
#line 729 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 729 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 730 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 730 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 730 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 730 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 731 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 732 "glib-2.0.vapi"
		result = TRUE;
#line 732 "glib-2.0.vapi"
		if (_result_) {
#line 732 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2437 "TeeJee.FileSystem.c"
		}
#line 732 "glib-2.0.vapi"
		if (unparsed) {
#line 732 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2443 "TeeJee.FileSystem.c"
		}
#line 732 "glib-2.0.vapi"
		return result;
#line 2447 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp5_;
#line 734 "glib-2.0.vapi"
		_tmp5_ = endptr;
#line 734 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 735 "glib-2.0.vapi"
		result = FALSE;
#line 735 "glib-2.0.vapi"
		if (_result_) {
#line 735 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2460 "TeeJee.FileSystem.c"
		}
#line 735 "glib-2.0.vapi"
		if (unparsed) {
#line 735 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2466 "TeeJee.FileSystem.c"
		}
#line 735 "glib-2.0.vapi"
		return result;
#line 2470 "TeeJee.FileSystem.c"
	}
#line 727 "glib-2.0.vapi"
	if (_result_) {
#line 727 "glib-2.0.vapi"
		*_result_ = _vala__result_;
#line 2476 "TeeJee.FileSystem.c"
	}
#line 727 "glib-2.0.vapi"
	if (unparsed) {
#line 727 "glib-2.0.vapi"
		*unparsed = _vala_unparsed;
#line 2482 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_filesystem_supports_hardlinks (const gchar* path,
                                                   gboolean* is_readonly)
{
	gboolean _vala_is_readonly = FALSE;
	gboolean result = FALSE;
	gboolean supports_hardlinks = FALSE;
	gchar* test_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
#line 420 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 421 "Utility/TeeJee.FileSystem.vala"
	supports_hardlinks = FALSE;
#line 422 "Utility/TeeJee.FileSystem.vala"
	_vala_is_readonly = FALSE;
#line 424 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 424 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 424 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strconcat (_tmp1_, "~", NULL);
#line 424 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 424 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = tee_jee_file_system_path_combine (path, _tmp3_);
#line 424 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 424 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp3_);
#line 424 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 424 "Utility/TeeJee.FileSystem.vala"
	test_file = _tmp5_;
#line 426 "Utility/TeeJee.FileSystem.vala"
	_tmp6_ = test_file;
#line 426 "Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_write (_tmp6_, "")) {
#line 2529 "TeeJee.FileSystem.c"
		gchar* test_file2 = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* cmd = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gint status = 0;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* std_out = NULL;
		gchar* std_err = NULL;
		const gchar* _tmp28_;
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
		gint _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gint64 count = 0LL;
		const gchar* _tmp35_;
		gint64 _tmp36_ = 0LL;
		gboolean _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
#line 428 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 428 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 428 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_tmp8_, "~", NULL);
#line 428 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 428 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_path_combine (path, _tmp10_);
#line 428 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 428 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 428 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 428 "Utility/TeeJee.FileSystem.vala"
		test_file2 = _tmp12_;
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = test_file;
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = test_file2;
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_file_system_escape_single_quote (_tmp16_);
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf ("ln '%s' '%s'", _tmp15_, _tmp18_);
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 430 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 430 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 430 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp20_;
#line 434 "Utility/TeeJee.FileSystem.vala"
		_tmp21_ = cmd;
#line 434 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp21_);
#line 436 "Utility/TeeJee.FileSystem.vala"
		_tmp22_ = cmd;
#line 436 "Utility/TeeJee.FileSystem.vala"
		status = tee_jee_process_helper_exec_sync (_tmp22_, NULL, NULL);
#line 438 "Utility/TeeJee.FileSystem.vala"
		_tmp23_ = test_file;
#line 438 "Utility/TeeJee.FileSystem.vala"
		_tmp24_ = tee_jee_file_system_escape_single_quote (_tmp23_);
#line 438 "Utility/TeeJee.FileSystem.vala"
		_tmp25_ = _tmp24_;
#line 438 "Utility/TeeJee.FileSystem.vala"
		_tmp26_ = g_strdup_printf ("stat --printf '%%h' '%s'", _tmp25_);
#line 438 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 438 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp26_;
#line 438 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp25_);
#line 441 "Utility/TeeJee.FileSystem.vala"
		_tmp27_ = cmd;
#line 441 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp27_);
#line 444 "Utility/TeeJee.FileSystem.vala"
		_tmp28_ = cmd;
#line 444 "Utility/TeeJee.FileSystem.vala"
		_tmp31_ = tee_jee_process_helper_exec_sync (_tmp28_, &_tmp29_, &_tmp30_);
#line 444 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 444 "Utility/TeeJee.FileSystem.vala"
		std_out = _tmp29_;
#line 444 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 444 "Utility/TeeJee.FileSystem.vala"
		std_err = _tmp30_;
#line 444 "Utility/TeeJee.FileSystem.vala"
		status = _tmp31_;
#line 445 "Utility/TeeJee.FileSystem.vala"
		_tmp32_ = std_out;
#line 445 "Utility/TeeJee.FileSystem.vala"
		_tmp33_ = g_strdup_printf ("stdout: %s", _tmp32_);
#line 445 "Utility/TeeJee.FileSystem.vala"
		_tmp34_ = _tmp33_;
#line 445 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp34_);
#line 445 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp34_);
#line 447 "Utility/TeeJee.FileSystem.vala"
		count = (gint64) 0;
#line 448 "Utility/TeeJee.FileSystem.vala"
		_tmp35_ = std_out;
#line 448 "Utility/TeeJee.FileSystem.vala"
		_tmp37_ = int64_try_parse (_tmp35_, &_tmp36_, NULL);
#line 448 "Utility/TeeJee.FileSystem.vala"
		count = _tmp36_;
#line 448 "Utility/TeeJee.FileSystem.vala"
		if (_tmp37_) {
#line 449 "Utility/TeeJee.FileSystem.vala"
			if (count > ((gint64) 1)) {
#line 450 "Utility/TeeJee.FileSystem.vala"
				supports_hardlinks = TRUE;
#line 2673 "TeeJee.FileSystem.c"
			}
		}
#line 454 "Utility/TeeJee.FileSystem.vala"
		_tmp38_ = test_file2;
#line 454 "Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_file_delete (_tmp38_);
#line 455 "Utility/TeeJee.FileSystem.vala"
		_tmp39_ = test_file;
#line 455 "Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_file_delete (_tmp39_);
#line 426 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 426 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 426 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 426 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (test_file2);
#line 2692 "TeeJee.FileSystem.c"
	} else {
#line 458 "Utility/TeeJee.FileSystem.vala"
		_vala_is_readonly = TRUE;
#line 2696 "TeeJee.FileSystem.c"
	}
#line 461 "Utility/TeeJee.FileSystem.vala"
	result = supports_hardlinks;
#line 461 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (test_file);
#line 461 "Utility/TeeJee.FileSystem.vala"
	if (is_readonly) {
#line 461 "Utility/TeeJee.FileSystem.vala"
		*is_readonly = _vala_is_readonly;
#line 2706 "TeeJee.FileSystem.c"
	}
#line 461 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2710 "TeeJee.FileSystem.c"
}

static gint
__lambda18_ (const gchar* a,
             const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
#line 482 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 482 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 483 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 483 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_ (a, b);
#line 483 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2729 "TeeJee.FileSystem.c"
}

static gint
___lambda18__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda18_ ((const gchar*) a, (const gchar*) b);
#line 482 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2741 "TeeJee.FileSystem.c"
}

GeeArrayList*
tee_jee_file_system_dir_list_names (const gchar* path)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GCompareDataFunc entry_compare = NULL;
	gpointer entry_compare_target;
	GDestroyNotify entry_compare_target_destroy_notify;
	GeeArrayList* _tmp19_;
	GCompareDataFunc _tmp20_;
	gpointer _tmp20__target;
	GDestroyNotify _tmp20__target_destroy_notify;
	GError* _inner_error0_ = NULL;
#line 464 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 465 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 465 "Utility/TeeJee.FileSystem.vala"
	list = _tmp0_;
#line 2764 "TeeJee.FileSystem.c"
	{
		GFile* f_home = NULL;
		GFile* _tmp1_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileEnumerator* _tmp6_;
		GFileInfo* file = NULL;
#line 469 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = g_file_new_for_path (path);
#line 469 "Utility/TeeJee.FileSystem.vala"
		f_home = _tmp1_;
#line 470 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = f_home;
#line 470 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 470 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 470 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error0_);
#line 470 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 470 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 470 "Utility/TeeJee.FileSystem.vala"
		enumerator = _tmp6_;
#line 470 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 470 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (f_home);
#line 2797 "TeeJee.FileSystem.c"
			goto __catch75_g_error;
		}
#line 472 "Utility/TeeJee.FileSystem.vala"
		while (TRUE) {
#line 2802 "TeeJee.FileSystem.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			gchar* name = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GeeArrayList* _tmp15_;
			const gchar* _tmp16_;
#line 472 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = enumerator;
#line 472 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 472 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp9_;
#line 472 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 472 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 472 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (enumerator);
#line 472 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (f_home);
#line 2828 "TeeJee.FileSystem.c"
				goto __catch75_g_error;
			}
#line 472 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = _tmp7_;
#line 472 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = NULL;
#line 472 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 472 "Utility/TeeJee.FileSystem.vala"
			file = _tmp10_;
#line 472 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = file;
#line 472 "Utility/TeeJee.FileSystem.vala"
			if (!(_tmp11_ != NULL)) {
#line 472 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 472 "Utility/TeeJee.FileSystem.vala"
				break;
#line 2847 "TeeJee.FileSystem.c"
			}
#line 473 "Utility/TeeJee.FileSystem.vala"
			_tmp12_ = file;
#line 473 "Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 473 "Utility/TeeJee.FileSystem.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 473 "Utility/TeeJee.FileSystem.vala"
			name = _tmp14_;
#line 474 "Utility/TeeJee.FileSystem.vala"
			_tmp15_ = list;
#line 474 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = name;
#line 474 "Utility/TeeJee.FileSystem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 472 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (name);
#line 472 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp7_);
#line 2867 "TeeJee.FileSystem.c"
		}
#line 467 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 467 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (enumerator);
#line 467 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (f_home);
#line 2875 "TeeJee.FileSystem.c"
	}
	goto __finally75;
	__catch75_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 467 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 467 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 478 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = e;
#line 478 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_->message;
#line 478 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 467 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 2895 "TeeJee.FileSystem.c"
	}
	__finally75:
#line 467 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 467 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (list);
#line 467 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 467 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 467 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 2908 "TeeJee.FileSystem.c"
	}
#line 482 "Utility/TeeJee.FileSystem.vala"
	entry_compare = ___lambda18__gcompare_data_func;
#line 482 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 482 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 485 "Utility/TeeJee.FileSystem.vala"
	_tmp19_ = list;
#line 485 "Utility/TeeJee.FileSystem.vala"
	_tmp20_ = entry_compare;
#line 485 "Utility/TeeJee.FileSystem.vala"
	_tmp20__target = entry_compare_target;
#line 485 "Utility/TeeJee.FileSystem.vala"
	_tmp20__target_destroy_notify = entry_compare_target_destroy_notify;
#line 485 "Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 485 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 485 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 485 "Utility/TeeJee.FileSystem.vala"
	gee_list_sort ((GeeList*) _tmp19_, _tmp20_, _tmp20__target, _tmp20__target_destroy_notify);
#line 487 "Utility/TeeJee.FileSystem.vala"
	result = list;
#line 487 "Utility/TeeJee.FileSystem.vala"
	(entry_compare_target_destroy_notify == NULL) ? NULL : (entry_compare_target_destroy_notify (entry_compare_target), NULL);
#line 487 "Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 487 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 487 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 487 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2944 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_tar (const gchar* src_dir,
                             const gchar* tar_file,
                             gboolean recursion)
{
	gboolean result = FALSE;
#line 490 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_dir != NULL, FALSE);
#line 490 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (tar_file != NULL, FALSE);
#line 491 "Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_dir_exists (src_dir)) {
#line 2959 "TeeJee.FileSystem.c"
		gchar* src_parent = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_ = NULL;
		gchar* cmd = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp14_;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gint _tmp17_;
#line 493 "Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (tar_file)) {
#line 494 "Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (tar_file);
#line 2988 "TeeJee.FileSystem.c"
		}
#line 497 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_dir);
#line 497 "Utility/TeeJee.FileSystem.vala"
		src_parent = _tmp0_;
#line 498 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_dir);
#line 498 "Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 502 "Utility/TeeJee.FileSystem.vala"
		if (recursion) {
#line 502 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = "";
#line 3002 "TeeJee.FileSystem.c"
		} else {
#line 502 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = "no-";
#line 3006 "TeeJee.FileSystem.c"
		}
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = tee_jee_file_system_escape_single_quote (tar_file);
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = src_parent;
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = tee_jee_file_system_escape_single_quote (_tmp5_);
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = _tmp6_;
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = src_name;
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = tee_jee_file_system_escape_single_quote (_tmp8_);
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strdup_printf ("tar cvf '%s' --overwrite --%srecursion -C '%s' '%s'\n", _tmp4_, _tmp2_, _tmp7_, _tmp10_);
#line 500 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 500 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 500 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp7_);
#line 500 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 500 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp12_;
#line 506 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = cmd;
#line 506 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp13_);
#line 509 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = cmd;
#line 509 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_process_helper_exec_script_sync (_tmp14_, &_tmp15_, &_tmp16_, FALSE, FALSE, TRUE, FALSE);
#line 509 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 509 "Utility/TeeJee.FileSystem.vala"
		stdout = _tmp15_;
#line 509 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 509 "Utility/TeeJee.FileSystem.vala"
		stderr = _tmp16_;
#line 509 "Utility/TeeJee.FileSystem.vala"
		status = _tmp17_;
#line 510 "Utility/TeeJee.FileSystem.vala"
		if (status == 0) {
#line 511 "Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 511 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 511 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 511 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 511 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 511 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_parent);
#line 511 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 3070 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp18_;
#line 514 "Utility/TeeJee.FileSystem.vala"
			_tmp18_ = stderr;
#line 514 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp18_, FALSE);
#line 3077 "TeeJee.FileSystem.c"
		}
#line 491 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 491 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 491 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 491 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 491 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_parent);
#line 3089 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 518 "Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf (": %s", src_dir);
#line 518 "Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 518 "Utility/TeeJee.FileSystem.vala"
		_tmp21_ = g_strconcat (_ ("Dir not found"), _tmp20_, NULL);
#line 518 "Utility/TeeJee.FileSystem.vala"
		_tmp22_ = _tmp21_;
#line 518 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 518 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp22_);
#line 518 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp20_);
#line 3109 "TeeJee.FileSystem.c"
	}
#line 521 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 521 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3115 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_untar (const gchar* tar_file,
                               const gchar* dst_dir)
{
	gboolean result = FALSE;
#line 524 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (tar_file != NULL, FALSE);
#line 524 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_dir != NULL, FALSE);
#line 525 "Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (tar_file)) {
#line 3129 "TeeJee.FileSystem.c"
		gchar* cmd = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gint _tmp10_;
#line 527 "Utility/TeeJee.FileSystem.vala"
		if (!tee_jee_file_system_dir_exists (dst_dir)) {
#line 528 "Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_dir_create (dst_dir, FALSE);
#line 3149 "TeeJee.FileSystem.c"
		}
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_escape_single_quote (tar_file);
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (dst_dir);
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("tar xvf '%s' --overwrite --same-permissions -C '%s'\n", _tmp1_, _tmp3_);
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 531 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 531 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp1_);
#line 531 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp5_;
#line 535 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = cmd;
#line 535 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp6_);
#line 538 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = cmd;
#line 538 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tee_jee_process_helper_exec_script_sync (_tmp7_, &_tmp8_, &_tmp9_, FALSE, FALSE, TRUE, FALSE);
#line 538 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 538 "Utility/TeeJee.FileSystem.vala"
		stdout = _tmp8_;
#line 538 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 538 "Utility/TeeJee.FileSystem.vala"
		stderr = _tmp9_;
#line 538 "Utility/TeeJee.FileSystem.vala"
		status = _tmp10_;
#line 539 "Utility/TeeJee.FileSystem.vala"
		if (status == 0) {
#line 540 "Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 540 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 540 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 540 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 540 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 3199 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp11_;
#line 543 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = stderr;
#line 543 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp11_, FALSE);
#line 3206 "TeeJee.FileSystem.c"
		}
#line 525 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 525 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 525 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 3214 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 547 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = g_strdup_printf (": %s", tar_file);
#line 547 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_;
#line 547 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = g_strconcat (_ ("File not found"), _tmp13_, NULL);
#line 547 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 547 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 547 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 547 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp13_);
#line 3234 "TeeJee.FileSystem.c"
	}
#line 550 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 550 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3240 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_chown (const gchar* dir_path,
                           const gchar* user,
                           const gchar* group)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint status = 0;
#line 553 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 553 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (user != NULL, FALSE);
#line 553 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 554 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 554 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 554 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chown %s:%s -R '%s'", user, group, _tmp1_);
#line 554 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 554 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 554 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 555 "Utility/TeeJee.FileSystem.vala"
	status = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 556 "Utility/TeeJee.FileSystem.vala"
	result = status == 0;
#line 556 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 556 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3281 "TeeJee.FileSystem.c"
}

glong
tee_jee_file_system_dir_count (const gchar* path)
{
	glong result = 0L;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
#line 562 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 566 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup ("");
#line 566 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp0_;
#line 571 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (path);
#line 571 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 571 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("find '%s' | wc -l", _tmp2_);
#line 571 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 571 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 571 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 572 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 572 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = tee_jee_process_helper_exec_script_sync (_tmp4_, &_tmp5_, &_tmp6_, FALSE, FALSE, TRUE, FALSE);
#line 572 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 572 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 572 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 572 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 572 "Utility/TeeJee.FileSystem.vala"
	ret_val = _tmp7_;
#line 573 "Utility/TeeJee.FileSystem.vala"
	result = long_parse (std_out);
#line 573 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 573 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 573 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 573 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3342 "TeeJee.FileSystem.c"
}

glong
tee_jee_file_system_dir_size (const gchar* path)
{
	glong result = 0L;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	glong _tmp10_;
#line 577 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 581 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (path);
#line 581 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 581 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("du -s -b '%s'", _tmp1_);
#line 581 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 581 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 581 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 583 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 583 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 583 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 583 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 583 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 584 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 584 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 584 "Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 584 "Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 584 "Utility/TeeJee.FileSystem.vala"
	_tmp10_ = long_parse (_tmp9_);
#line 584 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 584 "Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 584 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 584 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 584 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 584 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3410 "TeeJee.FileSystem.c"
}

glong
tee_jee_file_system_dir_size_kb (const gchar* path)
{
	glong result = 0L;
#line 588 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 592 "Utility/TeeJee.FileSystem.vala"
	result = (glong) (tee_jee_file_system_dir_size (path) / 1024.0);
#line 592 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3423 "TeeJee.FileSystem.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 3447 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 3455 "TeeJee.FileSystem.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 3461 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_file_tar_encrypt (const gchar* src_file,
                                      const gchar* dst_file,
                                      const gchar* password)
{
	gboolean result = FALSE;
#line 598 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 598 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_file != NULL, FALSE);
#line 598 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, FALSE);
#line 599 "Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3479 "TeeJee.FileSystem.c"
		gchar* src_dir = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		gchar* dst_dir = NULL;
		gchar* _tmp2_;
		gchar* dst_name = NULL;
		gchar* _tmp3_;
		gchar* tar_name = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* tar_file = NULL;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* cmd = NULL;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp38_;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_ = NULL;
		gint _tmp41_;
#line 600 "Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (dst_file)) {
#line 601 "Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (dst_file);
#line 3536 "TeeJee.FileSystem.c"
		}
#line 604 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_file);
#line 604 "Utility/TeeJee.FileSystem.vala"
		src_dir = _tmp0_;
#line 605 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_file);
#line 605 "Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 607 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_file_parent (dst_file);
#line 607 "Utility/TeeJee.FileSystem.vala"
		dst_dir = _tmp2_;
#line 608 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = tee_jee_file_system_file_basename (dst_file);
#line 608 "Utility/TeeJee.FileSystem.vala"
		dst_name = _tmp3_;
#line 609 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = dst_name;
#line 609 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = dst_name;
#line 609 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = string_slice (_tmp4_, (glong) 0, (glong) string_index_of (_tmp5_, ".gpg", 0));
#line 609 "Utility/TeeJee.FileSystem.vala"
		tar_name = _tmp6_;
#line 610 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = dst_dir;
#line 610 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = tar_name;
#line 610 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strdup_printf ("%s/%s", _tmp7_, _tmp8_);
#line 610 "Utility/TeeJee.FileSystem.vala"
		tar_file = _tmp9_;
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tar_file;
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_escape_single_quote (_tmp10_);
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = src_dir;
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = src_name;
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_file_system_escape_single_quote (_tmp16_);
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf ("tar cvf '%s' --overwrite -C '%s' '%s'\n", _tmp12_, _tmp15_, _tmp18_);
#line 612 "Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 612 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 612 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 612 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 612 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp20_;
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp21_ = cmd;
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp22_ = tee_jee_file_system_escape_single_quote (dst_file);
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp23_ = _tmp22_;
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp24_ = tar_file;
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp25_ = tee_jee_file_system_escape_single_quote (_tmp24_);
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp26_ = _tmp25_;
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp27_ = g_strdup_printf ("gpg --passphrase '%s' -o '%s' --symmetric '%s'\n", password, _tmp23_, _tmp26_);
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp28_ = _tmp27_;
#line 617 "Utility/TeeJee.FileSystem.vala"
		_tmp29_ = g_strconcat (_tmp21_, _tmp28_, NULL);
#line 617 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 617 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp29_;
#line 617 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp28_);
#line 617 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp26_);
#line 617 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp23_);
#line 622 "Utility/TeeJee.FileSystem.vala"
		_tmp30_ = cmd;
#line 622 "Utility/TeeJee.FileSystem.vala"
		_tmp31_ = tar_file;
#line 622 "Utility/TeeJee.FileSystem.vala"
		_tmp32_ = tee_jee_file_system_escape_single_quote (_tmp31_);
#line 622 "Utility/TeeJee.FileSystem.vala"
		_tmp33_ = _tmp32_;
#line 622 "Utility/TeeJee.FileSystem.vala"
		_tmp34_ = g_strdup_printf ("rm -f '%s'\n", _tmp33_);
#line 622 "Utility/TeeJee.FileSystem.vala"
		_tmp35_ = _tmp34_;
#line 622 "Utility/TeeJee.FileSystem.vala"
		_tmp36_ = g_strconcat (_tmp30_, _tmp35_, NULL);
#line 622 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 622 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp36_;
#line 622 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp35_);
#line 622 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp33_);
#line 624 "Utility/TeeJee.FileSystem.vala"
		_tmp37_ = cmd;
#line 624 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp37_);
#line 627 "Utility/TeeJee.FileSystem.vala"
		_tmp38_ = cmd;
#line 627 "Utility/TeeJee.FileSystem.vala"
		_tmp41_ = tee_jee_process_helper_exec_script_sync (_tmp38_, &_tmp39_, &_tmp40_, FALSE, FALSE, TRUE, FALSE);
#line 627 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 627 "Utility/TeeJee.FileSystem.vala"
		stdout = _tmp39_;
#line 627 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 627 "Utility/TeeJee.FileSystem.vala"
		stderr = _tmp40_;
#line 627 "Utility/TeeJee.FileSystem.vala"
		status = _tmp41_;
#line 628 "Utility/TeeJee.FileSystem.vala"
		if (status == 0) {
#line 629 "Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (dst_name);
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (dst_dir);
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 629 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 629 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 3692 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp42_;
#line 632 "Utility/TeeJee.FileSystem.vala"
			_tmp42_ = stderr;
#line 632 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp42_, FALSE);
#line 3699 "TeeJee.FileSystem.c"
		}
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_file);
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_name);
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (dst_name);
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (dst_dir);
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 599 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_dir);
#line 3719 "TeeJee.FileSystem.c"
	}
#line 636 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 636 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3725 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file,
                                             const gchar* password)
{
	gchar* result = NULL;
	gchar* _tmp22_;
#line 640 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, NULL);
#line 640 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 642 "Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3740 "TeeJee.FileSystem.c"
		gchar* cmd = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* std_out = NULL;
		gchar* std_err = NULL;
		gint status = 0;
		const gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gint _tmp15_;
#line 649 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_strdup ("");
#line 649 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp0_;
#line 651 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = cmd;
#line 651 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (src_file);
#line 651 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 651 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("gpg --quiet --no-verbose --passphrase '%s' -o- --decrypt '%s'", password, _tmp3_);
#line 651 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 651 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_strconcat (_tmp1_, _tmp5_, NULL);
#line 651 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 651 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp6_;
#line 651 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 651 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 655 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = cmd;
#line 655 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_strconcat (_tmp7_, " | tar xf - --to-stdout 2>/dev/null\n", NULL);
#line 655 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 655 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp8_;
#line 656 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = cmd;
#line 656 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = g_strconcat (_tmp9_, "exit $?\n", NULL);
#line 656 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 656 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp10_;
#line 658 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = cmd;
#line 658 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp11_);
#line 661 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = cmd;
#line 661 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = tee_jee_process_helper_exec_script_sync (_tmp12_, &_tmp13_, &_tmp14_, FALSE, FALSE, TRUE, FALSE);
#line 661 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 661 "Utility/TeeJee.FileSystem.vala"
		std_out = _tmp13_;
#line 661 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 661 "Utility/TeeJee.FileSystem.vala"
		std_err = _tmp14_;
#line 661 "Utility/TeeJee.FileSystem.vala"
		status = _tmp15_;
#line 662 "Utility/TeeJee.FileSystem.vala"
		if (status == 0) {
#line 663 "Utility/TeeJee.FileSystem.vala"
			result = std_out;
#line 663 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_err);
#line 663 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 663 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 3829 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 666 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = std_err;
#line 666 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 667 "Utility/TeeJee.FileSystem.vala"
			_tmp17_ = g_strdup ("");
#line 667 "Utility/TeeJee.FileSystem.vala"
			result = _tmp17_;
#line 667 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_err);
#line 667 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_out);
#line 667 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 667 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 3849 "TeeJee.FileSystem.c"
		}
#line 642 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 642 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 642 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 3857 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 671 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = g_strdup_printf (": %s", src_file);
#line 671 "Utility/TeeJee.FileSystem.vala"
		_tmp19_ = _tmp18_;
#line 671 "Utility/TeeJee.FileSystem.vala"
		_tmp20_ = g_strconcat (_ ("File is missing"), _tmp19_, NULL);
#line 671 "Utility/TeeJee.FileSystem.vala"
		_tmp21_ = _tmp20_;
#line 671 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp21_, FALSE, FALSE);
#line 671 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp21_);
#line 671 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp19_);
#line 3877 "TeeJee.FileSystem.c"
	}
#line 674 "Utility/TeeJee.FileSystem.vala"
	_tmp22_ = g_strdup ("");
#line 674 "Utility/TeeJee.FileSystem.vala"
	result = _tmp22_;
#line 674 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3885 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_decrypt_and_untar (const gchar* src_file,
                                       const gchar* dst_file,
                                       const gchar* password)
{
	gboolean result = FALSE;
#line 678 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 678 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_file != NULL, FALSE);
#line 678 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, FALSE);
#line 679 "Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3902 "TeeJee.FileSystem.c"
		gchar* src_dir = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		gchar* tar_name = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* tar_file = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* cmd = NULL;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp46_;
		gchar* _tmp47_ = NULL;
		gchar* _tmp48_ = NULL;
		gint _tmp49_;
#line 680 "Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (dst_file)) {
#line 681 "Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (dst_file);
#line 3965 "TeeJee.FileSystem.c"
		}
#line 684 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_file);
#line 684 "Utility/TeeJee.FileSystem.vala"
		src_dir = _tmp0_;
#line 685 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_file);
#line 685 "Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 686 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = src_name;
#line 686 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = src_name;
#line 686 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = string_slice (_tmp2_, (glong) 0, (glong) string_index_of (_tmp3_, ".gpg", 0));
#line 686 "Utility/TeeJee.FileSystem.vala"
		tar_name = _tmp4_;
#line 687 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = src_dir;
#line 687 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = tar_name;
#line 687 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strdup_printf ("%s/%s", _tmp5_, _tmp6_);
#line 687 "Utility/TeeJee.FileSystem.vala"
		tar_file = _tmp7_;
#line 689 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_strdup ("");
#line 689 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp8_;
#line 692 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = cmd;
#line 692 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tar_file;
#line 692 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_escape_single_quote (_tmp10_);
#line 692 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 692 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf ("rm -f '%s'\n", _tmp12_);
#line 692 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 692 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_tmp9_, _tmp14_, NULL);
#line 692 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 692 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp15_;
#line 692 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 692 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = cmd;
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tar_file;
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = tee_jee_file_system_escape_single_quote (_tmp17_);
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp19_ = _tmp18_;
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp20_ = tee_jee_file_system_escape_single_quote (src_file);
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp21_ = _tmp20_;
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp22_ = g_strdup_printf ("gpg --passphrase '%s' -o '%s' --decrypt '%s'\n", password, _tmp19_, _tmp21_);
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp23_ = _tmp22_;
#line 694 "Utility/TeeJee.FileSystem.vala"
		_tmp24_ = g_strconcat (_tmp16_, _tmp23_, NULL);
#line 694 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 694 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp24_;
#line 694 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp23_);
#line 694 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp21_);
#line 694 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp19_);
#line 699 "Utility/TeeJee.FileSystem.vala"
		_tmp25_ = cmd;
#line 699 "Utility/TeeJee.FileSystem.vala"
		_tmp26_ = g_strconcat (_tmp25_, "status=$?; if [ $status -ne 0 ]; then exit $status; fi\n", NULL);
#line 699 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 699 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp26_;
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp27_ = cmd;
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp28_ = tar_file;
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp29_ = tee_jee_file_system_escape_single_quote (_tmp28_);
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp30_ = _tmp29_;
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp31_ = tee_jee_file_system_file_parent (dst_file);
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp32_ = _tmp31_;
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp33_ = tee_jee_file_system_escape_single_quote (_tmp32_);
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp34_ = _tmp33_;
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp35_ = g_strdup_printf ("tar xvf '%s' --overwrite --same-permissions -C '%s'\n", _tmp30_, _tmp34_);
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp36_ = _tmp35_;
#line 701 "Utility/TeeJee.FileSystem.vala"
		_tmp37_ = g_strconcat (_tmp27_, _tmp36_, NULL);
#line 701 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 701 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp37_;
#line 701 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp36_);
#line 701 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp34_);
#line 701 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp32_);
#line 701 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp30_);
#line 705 "Utility/TeeJee.FileSystem.vala"
		_tmp38_ = cmd;
#line 705 "Utility/TeeJee.FileSystem.vala"
		_tmp39_ = tar_file;
#line 705 "Utility/TeeJee.FileSystem.vala"
		_tmp40_ = tee_jee_file_system_escape_single_quote (_tmp39_);
#line 705 "Utility/TeeJee.FileSystem.vala"
		_tmp41_ = _tmp40_;
#line 705 "Utility/TeeJee.FileSystem.vala"
		_tmp42_ = g_strdup_printf ("rm -f '%s'\n", _tmp41_);
#line 705 "Utility/TeeJee.FileSystem.vala"
		_tmp43_ = _tmp42_;
#line 705 "Utility/TeeJee.FileSystem.vala"
		_tmp44_ = g_strconcat (_tmp38_, _tmp43_, NULL);
#line 705 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 705 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp44_;
#line 705 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp43_);
#line 705 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp41_);
#line 707 "Utility/TeeJee.FileSystem.vala"
		_tmp45_ = cmd;
#line 707 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp45_);
#line 710 "Utility/TeeJee.FileSystem.vala"
		_tmp46_ = cmd;
#line 710 "Utility/TeeJee.FileSystem.vala"
		_tmp49_ = tee_jee_process_helper_exec_script_sync (_tmp46_, &_tmp47_, &_tmp48_, FALSE, FALSE, TRUE, FALSE);
#line 710 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 710 "Utility/TeeJee.FileSystem.vala"
		stdout = _tmp47_;
#line 710 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 710 "Utility/TeeJee.FileSystem.vala"
		stderr = _tmp48_;
#line 710 "Utility/TeeJee.FileSystem.vala"
		status = _tmp49_;
#line 711 "Utility/TeeJee.FileSystem.vala"
		if (status == 0) {
#line 712 "Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 712 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 712 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 712 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 712 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 712 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 712 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 712 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 712 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 4147 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp50_;
#line 715 "Utility/TeeJee.FileSystem.vala"
			_tmp50_ = stderr;
#line 715 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp50_, FALSE, FALSE);
#line 716 "Utility/TeeJee.FileSystem.vala"
			result = FALSE;
#line 716 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 716 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 716 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 716 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 716 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 716 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 716 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 716 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 4172 "TeeJee.FileSystem.c"
		}
#line 679 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 679 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 679 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 679 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_file);
#line 679 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_name);
#line 679 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 679 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_dir);
#line 4188 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
#line 720 "Utility/TeeJee.FileSystem.vala"
		_tmp51_ = g_strdup_printf (": %s", src_file);
#line 720 "Utility/TeeJee.FileSystem.vala"
		_tmp52_ = _tmp51_;
#line 720 "Utility/TeeJee.FileSystem.vala"
		_tmp53_ = g_strconcat (_ ("File is missing"), _tmp52_, NULL);
#line 720 "Utility/TeeJee.FileSystem.vala"
		_tmp54_ = _tmp53_;
#line 720 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp54_, FALSE, FALSE);
#line 720 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp54_);
#line 720 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp52_);
#line 4208 "TeeJee.FileSystem.c"
	}
#line 723 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 723 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 4214 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_hash_md5 (const gchar* path)
{
	gchar* result = NULL;
	GChecksum* checksum = NULL;
	GChecksum* _tmp0_;
	FILE* stream = NULL;
	FILE* _tmp1_;
	guint8 fbuf[100] = {0};
	gsize size = 0UL;
	const gchar* digest = NULL;
	GChecksum* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
#line 728 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 729 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_checksum_new (G_CHECKSUM_MD5);
#line 729 "Utility/TeeJee.FileSystem.vala"
	checksum = _tmp0_;
#line 730 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = g_fopen (path, "rb");
#line 730 "Utility/TeeJee.FileSystem.vala"
	stream = _tmp1_;
#line 734 "Utility/TeeJee.FileSystem.vala"
	while (TRUE) {
#line 4243 "TeeJee.FileSystem.c"
		FILE* _tmp2_;
		GChecksum* _tmp3_;
#line 734 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = stream;
#line 734 "Utility/TeeJee.FileSystem.vala"
		size = fread (fbuf, (gsize) 1, (gint) 100, _tmp2_);
#line 734 "Utility/TeeJee.FileSystem.vala"
		if (!(size > ((gsize) 0))) {
#line 734 "Utility/TeeJee.FileSystem.vala"
			break;
#line 4254 "TeeJee.FileSystem.c"
		}
#line 735 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = checksum;
#line 735 "Utility/TeeJee.FileSystem.vala"
		g_checksum_update (_tmp3_, fbuf, size);
#line 4260 "TeeJee.FileSystem.c"
	}
#line 738 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = checksum;
#line 738 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = g_checksum_get_string (_tmp4_);
#line 738 "Utility/TeeJee.FileSystem.vala"
	digest = _tmp5_;
#line 740 "Utility/TeeJee.FileSystem.vala"
	_tmp6_ = g_strdup (digest);
#line 740 "Utility/TeeJee.FileSystem.vala"
	result = _tmp6_;
#line 740 "Utility/TeeJee.FileSystem.vala"
	_fclose0 (stream);
#line 740 "Utility/TeeJee.FileSystem.vala"
	_g_checksum_free0 (checksum);
#line 740 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 4278 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_format_file_size (guint64 size,
                                      gboolean binary_units,
                                      const gchar* unit,
                                      gboolean show_units,
                                      gint decimals)
{
	gchar* result = NULL;
	gint _tmp0_ = 0;
	guint64 unit_k = 0ULL;
	guint64 _tmp1_ = 0ULL;
	guint64 unit_m = 0ULL;
	guint64 _tmp2_ = 0ULL;
	guint64 unit_g = 0ULL;
	guint64 _tmp3_ = 0ULL;
	guint64 unit_t = 0ULL;
	gchar* txt = NULL;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 745 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (unit != NULL, NULL);
#line 749 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 749 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1024;
#line 4306 "TeeJee.FileSystem.c"
	} else {
#line 749 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1000;
#line 4310 "TeeJee.FileSystem.c"
	}
#line 749 "Utility/TeeJee.FileSystem.vala"
	unit_k = (guint64) _tmp0_;
#line 750 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 750 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1024 * unit_k;
#line 4318 "TeeJee.FileSystem.c"
	} else {
#line 750 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1000 * unit_k;
#line 4322 "TeeJee.FileSystem.c"
	}
#line 750 "Utility/TeeJee.FileSystem.vala"
	unit_m = _tmp1_;
#line 751 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 751 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = 1024 * unit_m;
#line 4330 "TeeJee.FileSystem.c"
	} else {
#line 751 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = 1000 * unit_m;
#line 4334 "TeeJee.FileSystem.c"
	}
#line 751 "Utility/TeeJee.FileSystem.vala"
	unit_g = _tmp2_;
#line 752 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 752 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = 1024 * unit_g;
#line 4342 "TeeJee.FileSystem.c"
	} else {
#line 752 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = 1000 * unit_g;
#line 4346 "TeeJee.FileSystem.c"
	}
#line 752 "Utility/TeeJee.FileSystem.vala"
	unit_t = _tmp3_;
#line 756 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = g_strdup ("");
#line 756 "Utility/TeeJee.FileSystem.vala"
	txt = _tmp4_;
#line 758 "Utility/TeeJee.FileSystem.vala"
	if (size > unit_t) {
#line 4356 "TeeJee.FileSystem.c"
		gboolean _tmp6_ = FALSE;
		gint _tmp7_;
		gint _tmp8_;
#line 758 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = strlen (unit);
#line 758 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 758 "Utility/TeeJee.FileSystem.vala"
		if (_tmp8_ == 0) {
#line 758 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = TRUE;
#line 4368 "TeeJee.FileSystem.c"
		} else {
#line 758 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_strcmp0 (unit, "t") == 0;
#line 4372 "TeeJee.FileSystem.c"
		}
#line 758 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp6_;
#line 4376 "TeeJee.FileSystem.c"
	} else {
#line 758 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = FALSE;
#line 4380 "TeeJee.FileSystem.c"
	}
#line 758 "Utility/TeeJee.FileSystem.vala"
	if (_tmp5_) {
#line 4384 "TeeJee.FileSystem.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 759 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = txt;
#line 759 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = g_strdup_printf ("%%'0.%df", decimals);
#line 759 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = _tmp10_;
#line 759 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = g_strdup_printf (_tmp11_, size / (1.0 * unit_t));
#line 759 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_;
#line 759 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = g_strconcat (_tmp9_, _tmp13_, NULL);
#line 759 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 759 "Utility/TeeJee.FileSystem.vala"
		txt = _tmp14_;
#line 759 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp13_);
#line 759 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp11_);
#line 760 "Utility/TeeJee.FileSystem.vala"
		if (show_units) {
#line 4413 "TeeJee.FileSystem.c"
			const gchar* _tmp15_ = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 761 "Utility/TeeJee.FileSystem.vala"
			if (binary_units) {
#line 761 "Utility/TeeJee.FileSystem.vala"
				_tmp15_ = "Ti";
#line 4423 "TeeJee.FileSystem.c"
			} else {
#line 761 "Utility/TeeJee.FileSystem.vala"
				_tmp15_ = "T";
#line 4427 "TeeJee.FileSystem.c"
			}
#line 761 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = txt;
#line 761 "Utility/TeeJee.FileSystem.vala"
			_tmp17_ = g_strdup_printf (" %sB", _tmp15_);
#line 761 "Utility/TeeJee.FileSystem.vala"
			_tmp18_ = _tmp17_;
#line 761 "Utility/TeeJee.FileSystem.vala"
			_tmp19_ = g_strconcat (_tmp16_, _tmp18_, NULL);
#line 761 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 761 "Utility/TeeJee.FileSystem.vala"
			txt = _tmp19_;
#line 761 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp18_);
#line 4443 "TeeJee.FileSystem.c"
		}
	} else {
		gboolean _tmp20_ = FALSE;
#line 764 "Utility/TeeJee.FileSystem.vala"
		if (size > unit_g) {
#line 4449 "TeeJee.FileSystem.c"
			gboolean _tmp21_ = FALSE;
			gint _tmp22_;
			gint _tmp23_;
#line 764 "Utility/TeeJee.FileSystem.vala"
			_tmp22_ = strlen (unit);
#line 764 "Utility/TeeJee.FileSystem.vala"
			_tmp23_ = _tmp22_;
#line 764 "Utility/TeeJee.FileSystem.vala"
			if (_tmp23_ == 0) {
#line 764 "Utility/TeeJee.FileSystem.vala"
				_tmp21_ = TRUE;
#line 4461 "TeeJee.FileSystem.c"
			} else {
#line 764 "Utility/TeeJee.FileSystem.vala"
				_tmp21_ = g_strcmp0 (unit, "g") == 0;
#line 4465 "TeeJee.FileSystem.c"
			}
#line 764 "Utility/TeeJee.FileSystem.vala"
			_tmp20_ = _tmp21_;
#line 4469 "TeeJee.FileSystem.c"
		} else {
#line 764 "Utility/TeeJee.FileSystem.vala"
			_tmp20_ = FALSE;
#line 4473 "TeeJee.FileSystem.c"
		}
#line 764 "Utility/TeeJee.FileSystem.vala"
		if (_tmp20_) {
#line 4477 "TeeJee.FileSystem.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
#line 765 "Utility/TeeJee.FileSystem.vala"
			_tmp24_ = txt;
#line 765 "Utility/TeeJee.FileSystem.vala"
			_tmp25_ = g_strdup_printf ("%%'0.%df", decimals);
#line 765 "Utility/TeeJee.FileSystem.vala"
			_tmp26_ = _tmp25_;
#line 765 "Utility/TeeJee.FileSystem.vala"
			_tmp27_ = g_strdup_printf (_tmp26_, size / (1.0 * unit_g));
#line 765 "Utility/TeeJee.FileSystem.vala"
			_tmp28_ = _tmp27_;
#line 765 "Utility/TeeJee.FileSystem.vala"
			_tmp29_ = g_strconcat (_tmp24_, _tmp28_, NULL);
#line 765 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 765 "Utility/TeeJee.FileSystem.vala"
			txt = _tmp29_;
#line 765 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp28_);
#line 765 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp26_);
#line 766 "Utility/TeeJee.FileSystem.vala"
			if (show_units) {
#line 4506 "TeeJee.FileSystem.c"
				const gchar* _tmp30_ = NULL;
				const gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
#line 767 "Utility/TeeJee.FileSystem.vala"
				if (binary_units) {
#line 767 "Utility/TeeJee.FileSystem.vala"
					_tmp30_ = "Gi";
#line 4516 "TeeJee.FileSystem.c"
				} else {
#line 767 "Utility/TeeJee.FileSystem.vala"
					_tmp30_ = "G";
#line 4520 "TeeJee.FileSystem.c"
				}
#line 767 "Utility/TeeJee.FileSystem.vala"
				_tmp31_ = txt;
#line 767 "Utility/TeeJee.FileSystem.vala"
				_tmp32_ = g_strdup_printf (" %sB", _tmp30_);
#line 767 "Utility/TeeJee.FileSystem.vala"
				_tmp33_ = _tmp32_;
#line 767 "Utility/TeeJee.FileSystem.vala"
				_tmp34_ = g_strconcat (_tmp31_, _tmp33_, NULL);
#line 767 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 767 "Utility/TeeJee.FileSystem.vala"
				txt = _tmp34_;
#line 767 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp33_);
#line 4536 "TeeJee.FileSystem.c"
			}
		} else {
			gboolean _tmp35_ = FALSE;
#line 770 "Utility/TeeJee.FileSystem.vala"
			if (size > unit_m) {
#line 4542 "TeeJee.FileSystem.c"
				gboolean _tmp36_ = FALSE;
				gint _tmp37_;
				gint _tmp38_;
#line 770 "Utility/TeeJee.FileSystem.vala"
				_tmp37_ = strlen (unit);
#line 770 "Utility/TeeJee.FileSystem.vala"
				_tmp38_ = _tmp37_;
#line 770 "Utility/TeeJee.FileSystem.vala"
				if (_tmp38_ == 0) {
#line 770 "Utility/TeeJee.FileSystem.vala"
					_tmp36_ = TRUE;
#line 4554 "TeeJee.FileSystem.c"
				} else {
#line 770 "Utility/TeeJee.FileSystem.vala"
					_tmp36_ = g_strcmp0 (unit, "m") == 0;
#line 4558 "TeeJee.FileSystem.c"
				}
#line 770 "Utility/TeeJee.FileSystem.vala"
				_tmp35_ = _tmp36_;
#line 4562 "TeeJee.FileSystem.c"
			} else {
#line 770 "Utility/TeeJee.FileSystem.vala"
				_tmp35_ = FALSE;
#line 4566 "TeeJee.FileSystem.c"
			}
#line 770 "Utility/TeeJee.FileSystem.vala"
			if (_tmp35_) {
#line 4570 "TeeJee.FileSystem.c"
				const gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
#line 771 "Utility/TeeJee.FileSystem.vala"
				_tmp39_ = txt;
#line 771 "Utility/TeeJee.FileSystem.vala"
				_tmp40_ = g_strdup_printf ("%%'0.%df", decimals);
#line 771 "Utility/TeeJee.FileSystem.vala"
				_tmp41_ = _tmp40_;
#line 771 "Utility/TeeJee.FileSystem.vala"
				_tmp42_ = g_strdup_printf (_tmp41_, size / (1.0 * unit_m));
#line 771 "Utility/TeeJee.FileSystem.vala"
				_tmp43_ = _tmp42_;
#line 771 "Utility/TeeJee.FileSystem.vala"
				_tmp44_ = g_strconcat (_tmp39_, _tmp43_, NULL);
#line 771 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 771 "Utility/TeeJee.FileSystem.vala"
				txt = _tmp44_;
#line 771 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp43_);
#line 771 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp41_);
#line 772 "Utility/TeeJee.FileSystem.vala"
				if (show_units) {
#line 4599 "TeeJee.FileSystem.c"
					const gchar* _tmp45_ = NULL;
					const gchar* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					gchar* _tmp49_;
#line 773 "Utility/TeeJee.FileSystem.vala"
					if (binary_units) {
#line 773 "Utility/TeeJee.FileSystem.vala"
						_tmp45_ = "Mi";
#line 4609 "TeeJee.FileSystem.c"
					} else {
#line 773 "Utility/TeeJee.FileSystem.vala"
						_tmp45_ = "M";
#line 4613 "TeeJee.FileSystem.c"
					}
#line 773 "Utility/TeeJee.FileSystem.vala"
					_tmp46_ = txt;
#line 773 "Utility/TeeJee.FileSystem.vala"
					_tmp47_ = g_strdup_printf (" %sB", _tmp45_);
#line 773 "Utility/TeeJee.FileSystem.vala"
					_tmp48_ = _tmp47_;
#line 773 "Utility/TeeJee.FileSystem.vala"
					_tmp49_ = g_strconcat (_tmp46_, _tmp48_, NULL);
#line 773 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 773 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp49_;
#line 773 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp48_);
#line 4629 "TeeJee.FileSystem.c"
				}
			} else {
				gboolean _tmp50_ = FALSE;
#line 776 "Utility/TeeJee.FileSystem.vala"
				if (size > unit_k) {
#line 4635 "TeeJee.FileSystem.c"
					gboolean _tmp51_ = FALSE;
					gint _tmp52_;
					gint _tmp53_;
#line 776 "Utility/TeeJee.FileSystem.vala"
					_tmp52_ = strlen (unit);
#line 776 "Utility/TeeJee.FileSystem.vala"
					_tmp53_ = _tmp52_;
#line 776 "Utility/TeeJee.FileSystem.vala"
					if (_tmp53_ == 0) {
#line 776 "Utility/TeeJee.FileSystem.vala"
						_tmp51_ = TRUE;
#line 4647 "TeeJee.FileSystem.c"
					} else {
#line 776 "Utility/TeeJee.FileSystem.vala"
						_tmp51_ = g_strcmp0 (unit, "k") == 0;
#line 4651 "TeeJee.FileSystem.c"
					}
#line 776 "Utility/TeeJee.FileSystem.vala"
					_tmp50_ = _tmp51_;
#line 4655 "TeeJee.FileSystem.c"
				} else {
#line 776 "Utility/TeeJee.FileSystem.vala"
					_tmp50_ = FALSE;
#line 4659 "TeeJee.FileSystem.c"
				}
#line 776 "Utility/TeeJee.FileSystem.vala"
				if (_tmp50_) {
#line 4663 "TeeJee.FileSystem.c"
					const gchar* _tmp54_;
					gchar* _tmp55_;
					gchar* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
#line 777 "Utility/TeeJee.FileSystem.vala"
					_tmp54_ = txt;
#line 777 "Utility/TeeJee.FileSystem.vala"
					_tmp55_ = g_strdup_printf ("%%'0.%df", decimals);
#line 777 "Utility/TeeJee.FileSystem.vala"
					_tmp56_ = _tmp55_;
#line 777 "Utility/TeeJee.FileSystem.vala"
					_tmp57_ = g_strdup_printf (_tmp56_, size / (1.0 * unit_k));
#line 777 "Utility/TeeJee.FileSystem.vala"
					_tmp58_ = _tmp57_;
#line 777 "Utility/TeeJee.FileSystem.vala"
					_tmp59_ = g_strconcat (_tmp54_, _tmp58_, NULL);
#line 777 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 777 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp59_;
#line 777 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp58_);
#line 777 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp56_);
#line 778 "Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 4692 "TeeJee.FileSystem.c"
						const gchar* _tmp60_ = NULL;
						const gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						gchar* _tmp64_;
#line 779 "Utility/TeeJee.FileSystem.vala"
						if (binary_units) {
#line 779 "Utility/TeeJee.FileSystem.vala"
							_tmp60_ = "Ki";
#line 4702 "TeeJee.FileSystem.c"
						} else {
#line 779 "Utility/TeeJee.FileSystem.vala"
							_tmp60_ = "K";
#line 4706 "TeeJee.FileSystem.c"
						}
#line 779 "Utility/TeeJee.FileSystem.vala"
						_tmp61_ = txt;
#line 779 "Utility/TeeJee.FileSystem.vala"
						_tmp62_ = g_strdup_printf (" %sB", _tmp60_);
#line 779 "Utility/TeeJee.FileSystem.vala"
						_tmp63_ = _tmp62_;
#line 779 "Utility/TeeJee.FileSystem.vala"
						_tmp64_ = g_strconcat (_tmp61_, _tmp63_, NULL);
#line 779 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 779 "Utility/TeeJee.FileSystem.vala"
						txt = _tmp64_;
#line 779 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (_tmp63_);
#line 4722 "TeeJee.FileSystem.c"
					}
				} else {
					const gchar* _tmp65_;
					gchar* _tmp66_;
					gchar* _tmp67_;
					gchar* _tmp68_;
#line 783 "Utility/TeeJee.FileSystem.vala"
					_tmp65_ = txt;
#line 783 "Utility/TeeJee.FileSystem.vala"
					_tmp66_ = g_strdup_printf ("%'0lld", size);
#line 783 "Utility/TeeJee.FileSystem.vala"
					_tmp67_ = _tmp66_;
#line 783 "Utility/TeeJee.FileSystem.vala"
					_tmp68_ = g_strconcat (_tmp65_, _tmp67_, NULL);
#line 783 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 783 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp68_;
#line 783 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp67_);
#line 784 "Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 4745 "TeeJee.FileSystem.c"
						const gchar* _tmp69_;
						gchar* _tmp70_;
#line 785 "Utility/TeeJee.FileSystem.vala"
						_tmp69_ = txt;
#line 785 "Utility/TeeJee.FileSystem.vala"
						_tmp70_ = g_strconcat (_tmp69_, " B", NULL);
#line 785 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 785 "Utility/TeeJee.FileSystem.vala"
						txt = _tmp70_;
#line 4756 "TeeJee.FileSystem.c"
					}
				}
			}
		}
	}
#line 791 "Utility/TeeJee.FileSystem.vala"
	result = txt;
#line 791 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 4766 "TeeJee.FileSystem.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 4788 "TeeJee.FileSystem.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 4792 "TeeJee.FileSystem.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 4798 "TeeJee.FileSystem.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 4802 "TeeJee.FileSystem.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 4806 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 4814 "TeeJee.FileSystem.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4842 "TeeJee.FileSystem.c"
				goto __catch76_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 4851 "TeeJee.FileSystem.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4865 "TeeJee.FileSystem.c"
				goto __catch76_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 4876 "TeeJee.FileSystem.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 4890 "TeeJee.FileSystem.c"
	}
	goto __finally76;
	__catch76_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 4904 "TeeJee.FileSystem.c"
	}
	__finally76:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 4915 "TeeJee.FileSystem.c"
	}
}

gchar*
tee_jee_file_system_escape_single_quote (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 794 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 795 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = string_replace (file_path, "'", "'\\''");
#line 795 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 795 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 4932 "TeeJee.FileSystem.c"
}

gint
tee_jee_file_system_chmod (const gchar* file,
                           const gchar* permission)
{
	gint result = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 800 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 800 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (permission != NULL, 0);
#line 803 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file);
#line 803 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 803 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chmod %s '%s'", permission, _tmp1_);
#line 803 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 803 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 803 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 804 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 804 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 804 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 4967 "TeeJee.FileSystem.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 4991 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_resolve_relative_path (const gchar* filePath)
{
	gchar* result = NULL;
	gchar* filePath2 = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 808 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (filePath != NULL, NULL);
#line 812 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup (filePath);
#line 812 "Utility/TeeJee.FileSystem.vala"
	filePath2 = _tmp0_;
#line 813 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = filePath2;
#line 813 "Utility/TeeJee.FileSystem.vala"
	if (g_str_has_prefix (_tmp1_, "~")) {
#line 5012 "TeeJee.FileSystem.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = g_get_home_dir ();
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = filePath2;
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = filePath2;
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = strlen (_tmp6_);
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = string_slice (_tmp5_, (glong) 2, (glong) _tmp8_);
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 814 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strconcat (_tmp4_, _tmp10_, NULL);
#line 814 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (filePath2);
#line 814 "Utility/TeeJee.FileSystem.vala"
		filePath2 = _tmp11_;
#line 814 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 814 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 5051 "TeeJee.FileSystem.c"
	}
	{
		gchar* output = NULL;
		gchar* _tmp12_;
		gchar* cmd = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
#line 818 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = g_strdup ("");
#line 818 "Utility/TeeJee.FileSystem.vala"
		output = _tmp12_;
#line 819 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = filePath2;
#line 819 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 819 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 819 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = g_strdup_printf ("realpath '%s'", _tmp15_);
#line 819 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = _tmp16_;
#line 819 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 819 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp17_;
#line 820 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = cmd;
#line 820 "Utility/TeeJee.FileSystem.vala"
		g_spawn_command_line_sync (_tmp18_, &_tmp19_, NULL, NULL, &_inner_error0_);
#line 820 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 820 "Utility/TeeJee.FileSystem.vala"
		output = _tmp19_;
#line 820 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 820 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 820 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (output);
#line 5099 "TeeJee.FileSystem.c"
			goto __catch77_g_error;
		}
#line 821 "Utility/TeeJee.FileSystem.vala"
		_tmp20_ = output;
#line 821 "Utility/TeeJee.FileSystem.vala"
		_tmp21_ = string_strip (_tmp20_);
#line 821 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 821 "Utility/TeeJee.FileSystem.vala"
		output = _tmp21_;
#line 822 "Utility/TeeJee.FileSystem.vala"
		_tmp22_ = output;
#line 822 "Utility/TeeJee.FileSystem.vala"
		if (g_file_test (_tmp22_, G_FILE_TEST_EXISTS)) {
#line 823 "Utility/TeeJee.FileSystem.vala"
			result = output;
#line 823 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 823 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (filePath2);
#line 823 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 5122 "TeeJee.FileSystem.c"
		}
#line 817 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 817 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 5128 "TeeJee.FileSystem.c"
	}
	goto __finally77;
	__catch77_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 817 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 817 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 827 "Utility/TeeJee.FileSystem.vala"
		_tmp23_ = e;
#line 827 "Utility/TeeJee.FileSystem.vala"
		_tmp24_ = _tmp23_->message;
#line 827 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp24_, FALSE, FALSE);
#line 817 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 5148 "TeeJee.FileSystem.c"
	}
	__finally77:
#line 817 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 817 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (filePath2);
#line 817 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 817 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 817 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 5161 "TeeJee.FileSystem.c"
	}
#line 830 "Utility/TeeJee.FileSystem.vala"
	result = filePath2;
#line 830 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 5167 "TeeJee.FileSystem.c"
}

gint
tee_jee_file_system_rsync (const gchar* sourceDirectory,
                           const gchar* destDirectory,
                           gboolean updateExisting,
                           gboolean deleteExtra)
{
	gint result = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
#line 833 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (sourceDirectory != NULL, 0);
#line 833 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (destDirectory != NULL, 0);
#line 837 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup ("rsync -avh");
#line 837 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp0_;
#line 838 "Utility/TeeJee.FileSystem.vala"
	if (updateExisting) {
#line 838 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = "";
#line 5212 "TeeJee.FileSystem.c"
	} else {
#line 838 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = " --ignore-existing";
#line 5216 "TeeJee.FileSystem.c"
	}
#line 838 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = cmd;
#line 838 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strconcat (_tmp2_, _tmp1_, NULL);
#line 838 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 838 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 839 "Utility/TeeJee.FileSystem.vala"
	if (deleteExtra) {
#line 839 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = " --delete";
#line 5230 "TeeJee.FileSystem.c"
	} else {
#line 839 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = "";
#line 5234 "TeeJee.FileSystem.c"
	}
#line 839 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 839 "Utility/TeeJee.FileSystem.vala"
	_tmp6_ = g_strconcat (_tmp5_, _tmp4_, NULL);
#line 839 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 839 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp6_;
#line 840 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = cmd;
#line 840 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_file_system_escape_single_quote (sourceDirectory);
#line 840 "Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_;
#line 840 "Utility/TeeJee.FileSystem.vala"
	_tmp10_ = g_strconcat (_tmp9_, "//", NULL);
#line 840 "Utility/TeeJee.FileSystem.vala"
	_tmp11_ = _tmp10_;
#line 840 "Utility/TeeJee.FileSystem.vala"
	_tmp12_ = g_strdup_printf (" '%s'", _tmp11_);
#line 840 "Utility/TeeJee.FileSystem.vala"
	_tmp13_ = _tmp12_;
#line 840 "Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strconcat (_tmp7_, _tmp13_, NULL);
#line 840 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 840 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp14_;
#line 840 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp13_);
#line 840 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp11_);
#line 840 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp9_);
#line 841 "Utility/TeeJee.FileSystem.vala"
	_tmp15_ = cmd;
#line 841 "Utility/TeeJee.FileSystem.vala"
	_tmp16_ = tee_jee_file_system_escape_single_quote (destDirectory);
#line 841 "Utility/TeeJee.FileSystem.vala"
	_tmp17_ = _tmp16_;
#line 841 "Utility/TeeJee.FileSystem.vala"
	_tmp18_ = g_strdup_printf (" '%s'", _tmp17_);
#line 841 "Utility/TeeJee.FileSystem.vala"
	_tmp19_ = _tmp18_;
#line 841 "Utility/TeeJee.FileSystem.vala"
	_tmp20_ = g_strconcat (_tmp15_, _tmp19_, NULL);
#line 841 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 841 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp20_;
#line 841 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp19_);
#line 841 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp17_);
#line 842 "Utility/TeeJee.FileSystem.vala"
	_tmp21_ = cmd;
#line 842 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_process_helper_exec_sync (_tmp21_, NULL, NULL);
#line 842 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 842 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 5298 "TeeJee.FileSystem.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

